-- Address decode logic for ipbus fabric
-- 
-- This file has been AUTOGENERATED from the address table - do not hand edit
-- 
-- We assume the synthesis tool is clever enough to recognise exclusive conditions
-- in the if statement.
-- 
-- Dave Newbold, February 2011

library IEEE;
use IEEE.STD_LOGIC_1164.all;
use ieee.numeric_std.all;

package ipbus_decode_ltu_logic_v5 is

  constant IPBUS_SEL_WIDTH: positive := 6;
  subtype ipbus_sel_t is std_logic_vector(IPBUS_SEL_WIDTH - 1 downto 0);
  function ipbus_sel_ltu_logic_v5(addr : in std_logic_vector(31 downto 0)) return ipbus_sel_t;

-- START automatically  generated VHDL the Tue Jul 31 13:18:02 2018 
  constant N_SLV_CTRL: integer := 0;
  constant N_SLV_ICAP: integer := 1;
  constant N_SLV_GBT: integer := 2;
  constant N_SLV_CTPEMU: integer := 3;
  constant N_SLV_I2CMAINTTC: integer := 4;
  constant N_SLV_SPIADC: integer := 5;
  constant N_SLV_I2CPLL: integer := 6;
  constant N_SLV_I2CFMCSFP: integer := 7;
  constant N_SLV_SSM: integer := 8;
  constant N_SLV_SSMCTRL: integer := 9;
  constant N_SLV_TDG: integer := 10;
  constant N_SLV_TDGCTRL: integer := 11;
  constant N_SLV_TTCPONONU_C: integer := 12;
  constant N_SLV_TTCPONONU_U: integer := 13;
  constant N_SLV_TTCPONOLT_U1: integer := 14;
  constant N_SLV_TTCPONOLT_U2: integer := 15;
  constant N_SLV_TTCPONOLT_U3: integer := 16;
  constant N_SLV_TTCPONOLT_U4: integer := 17;
  constant N_SLV_TTCPONOLT_U5: integer := 18;
  constant N_SLV_TTCPONOLT_U6: integer := 19;
  constant N_SLV_TTCPONOLT_U7: integer := 20;
  constant N_SLV_TTCPONOLT_U8: integer := 21;
  constant N_SLV_TTCPONOLT_U9: integer := 22;
  constant N_SLV_TTCPONOLT_C1: integer := 23;
  constant N_SLV_TTCPONOLT_C2: integer := 24;
  constant N_SLV_TTCPONOLT_C3: integer := 25;
  constant N_SLV_TTCPONOLT_C4: integer := 26;
  constant N_SLV_TTCPONOLT_C5: integer := 27;
  constant N_SLV_TTCPONOLT_C6: integer := 28;
  constant N_SLV_TTCPONOLT_C7: integer := 29;
  constant N_SLV_TTCPONOLT_C8: integer := 30;
  constant N_SLV_TTCPONOLT_C9: integer := 31;
  constant N_SLV_FLASH_SPI_RAM_0: integer := 32;
  constant N_SLV_FLASH_SPI_RAM_1: integer := 33;
  constant N_SLV_OUTCNTS: integer := 34;
  constant N_SLAVES: integer := 35;
-- END automatically generated VHDL

    
end ipbus_decode_ltu_logic_v5;

package body ipbus_decode_ltu_logic_v5 is

  function ipbus_sel_ltu_logic_v5(addr : in std_logic_vector(31 downto 0)) return ipbus_sel_t is
    variable sel: ipbus_sel_t;
  begin

-- START automatically  generated VHDL the Tue Jul 31 13:18:02 2018 
    if    std_match(addr, "------------------0000000000----") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_CTRL, IPBUS_SEL_WIDTH)); -- ctrl / base 0x00000000 / mask 0x00003ff0
    elsif std_match(addr, "------------------000001000000--") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_ICAP, IPBUS_SEL_WIDTH)); -- icap / base 0x00000100 / mask 0x00003ffc
    elsif std_match(addr, "------------------000001000001--") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_GBT, IPBUS_SEL_WIDTH)); -- gbt / base 0x00000104 / mask 0x00003ffc
    elsif std_match(addr, "------------------010000000-----") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_CTPEMU, IPBUS_SEL_WIDTH)); -- ctpemu / base 0x00001000 / mask 0x00003fe0
    elsif std_match(addr, "------------------100000000000--") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_I2CMAINTTC, IPBUS_SEL_WIDTH)); -- i2cmainttc / base 0x00002000 / mask 0x00003ffc
    elsif std_match(addr, "------------------10000000101---") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_SPIADC, IPBUS_SEL_WIDTH)); -- spiadc / base 0x00002028 / mask 0x00003ff8
    elsif std_match(addr, "------------------10000000110---") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_I2CPLL, IPBUS_SEL_WIDTH)); -- i2cpll / base 0x00002030 / mask 0x00003ff8
    elsif std_match(addr, "------------------10000000111---") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_I2CFMCSFP, IPBUS_SEL_WIDTH)); -- i2cfmcsfp / base 0x00002038 / mask 0x00003ff8
    elsif std_match(addr, "------------------1000000100----") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_SSM, IPBUS_SEL_WIDTH)); -- ssm / base 0x00002040 / mask 0x00003ff0
    elsif std_match(addr, "------------------10000001010---") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_SSMCTRL, IPBUS_SEL_WIDTH)); -- ssmctrl / base 0x00002050 / mask 0x00003ff8
    elsif std_match(addr, "------------------1000000110----") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_TDG, IPBUS_SEL_WIDTH)); -- tdg / base 0x00002060 / mask 0x00003ff0
    elsif std_match(addr, "------------------10000001110---") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_TDGCTRL, IPBUS_SEL_WIDTH)); -- tdgctrl / base 0x00002070 / mask 0x00003ff8
    elsif std_match(addr, "------------------100001--------") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_TTCPONONU_C, IPBUS_SEL_WIDTH)); -- ttcpononu_c / base 0x00002100 / mask 0x00003f00
    elsif std_match(addr, "------------------100010--------") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_TTCPONONU_U, IPBUS_SEL_WIDTH)); -- ttcpononu_u / base 0x00002200 / mask 0x00003f00
    elsif std_match(addr, "------------------100011--------") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_TTCPONOLT_U1, IPBUS_SEL_WIDTH)); -- ttcponolt_u1 / base 0x00002300 / mask 0x00003f00
    elsif std_match(addr, "------------------100100--------") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_TTCPONOLT_U2, IPBUS_SEL_WIDTH)); -- ttcponolt_u2 / base 0x00002400 / mask 0x00003f00
    elsif std_match(addr, "------------------100101--------") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_TTCPONOLT_U3, IPBUS_SEL_WIDTH)); -- ttcponolt_u3 / base 0x00002500 / mask 0x00003f00
    elsif std_match(addr, "------------------100110--------") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_TTCPONOLT_U4, IPBUS_SEL_WIDTH)); -- ttcponolt_u4 / base 0x00002600 / mask 0x00003f00
    elsif std_match(addr, "------------------100111--------") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_TTCPONOLT_U5, IPBUS_SEL_WIDTH)); -- ttcponolt_u5 / base 0x00002700 / mask 0x00003f00
    elsif std_match(addr, "------------------101000--------") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_TTCPONOLT_U6, IPBUS_SEL_WIDTH)); -- ttcponolt_u6 / base 0x00002800 / mask 0x00003f00
    elsif std_match(addr, "------------------101001--------") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_TTCPONOLT_U7, IPBUS_SEL_WIDTH)); -- ttcponolt_u7 / base 0x00002900 / mask 0x00003f00
    elsif std_match(addr, "------------------101010--------") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_TTCPONOLT_U8, IPBUS_SEL_WIDTH)); -- ttcponolt_u8 / base 0x00002a00 / mask 0x00003f00
    elsif std_match(addr, "------------------101011--------") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_TTCPONOLT_U9, IPBUS_SEL_WIDTH)); -- ttcponolt_u9 / base 0x00002b00 / mask 0x00003f00
    elsif std_match(addr, "------------------1011000-------") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_TTCPONOLT_C1, IPBUS_SEL_WIDTH)); -- ttcponolt_c1 / base 0x00002c00 / mask 0x00003f80
    elsif std_match(addr, "------------------1011001-------") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_TTCPONOLT_C2, IPBUS_SEL_WIDTH)); -- ttcponolt_c2 / base 0x00002c80 / mask 0x00003f80
    elsif std_match(addr, "------------------1011010-------") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_TTCPONOLT_C3, IPBUS_SEL_WIDTH)); -- ttcponolt_c3 / base 0x00002d00 / mask 0x00003f80
    elsif std_match(addr, "------------------1011011-------") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_TTCPONOLT_C4, IPBUS_SEL_WIDTH)); -- ttcponolt_c4 / base 0x00002d80 / mask 0x00003f80
    elsif std_match(addr, "------------------1011100-------") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_TTCPONOLT_C5, IPBUS_SEL_WIDTH)); -- ttcponolt_c5 / base 0x00002e00 / mask 0x00003f80
    elsif std_match(addr, "------------------1011101-------") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_TTCPONOLT_C6, IPBUS_SEL_WIDTH)); -- ttcponolt_c6 / base 0x00002e80 / mask 0x00003f80
    elsif std_match(addr, "------------------1011110-------") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_TTCPONOLT_C7, IPBUS_SEL_WIDTH)); -- ttcponolt_c7 / base 0x00002f00 / mask 0x00003f80
    elsif std_match(addr, "------------------1011111-------") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_TTCPONOLT_C8, IPBUS_SEL_WIDTH)); -- ttcponolt_c8 / base 0x00002f80 / mask 0x00003f80
    elsif std_match(addr, "------------------1100000-------") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_TTCPONOLT_C9, IPBUS_SEL_WIDTH)); -- ttcponolt_c9 / base 0x00003000 / mask 0x00003f80
    elsif std_match(addr, "------------------11001---------") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_FLASH_SPI_RAM_0, IPBUS_SEL_WIDTH)); -- FLASH_SPI_Ram_0 / base 0x00003200 / mask 0x00003e00
    elsif std_match(addr, "------------------11010---------") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_FLASH_SPI_RAM_1, IPBUS_SEL_WIDTH)); -- FLASH_SPI_Ram_1 / base 0x00003400 / mask 0x00003e00
    elsif std_match(addr, "------------------110110000-----") then
      sel := ipbus_sel_t(to_unsigned(N_SLV_OUTCNTS, IPBUS_SEL_WIDTH)); -- outcnts / base 0x00003600 / mask 0x00003fe0
-- END automatically generated VHDL

    else
        sel := ipbus_sel_t(to_unsigned(N_SLAVES, IPBUS_SEL_WIDTH));
    end if;

    return sel;

  end function ipbus_sel_ltu_logic_v5;

end ipbus_decode_ltu_logic_v5;

