#!/usr/bin/python3
import grpc

import hewo_pb2 as hewo__pb2


class HelloWorldStub(object):
    """was Greeter 
    """

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.SayHello = channel.unary_unary(
                '/helloworld.HelloWorld/SayHello',
                request_serializer=hewo__pb2.HelloRequest.SerializeToString,
                response_deserializer=hewo__pb2.HelloReply.FromString,
                )
        self.Stop = channel.unary_unary(
                '/helloworld.HelloWorld/Stop',
                request_serializer=hewo__pb2.Empty.SerializeToString,
                response_deserializer=hewo__pb2.HelloReply.FromString,
                )


class HelloWorldServicer(object):
    """was Greeter 
    """

    def SayHello(self, request, context):
        """Missing associated documentation comment in .proto file"""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def Stop(self, request, context):
        """Missing associated documentation comment in .proto file"""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')


def add_HelloWorldServicer_to_server(servicer, server):
    rpc_method_handlers = {
            'SayHello': grpc.unary_unary_rpc_method_handler(
                    servicer.SayHello,
                    request_deserializer=hewo__pb2.HelloRequest.FromString,
                    response_serializer=hewo__pb2.HelloReply.SerializeToString,
            ),
            'Stop': grpc.unary_unary_rpc_method_handler(
                    servicer.Stop,
                    request_deserializer=hewo__pb2.Empty.FromString,
                    response_serializer=hewo__pb2.HelloReply.SerializeToString,
            ),
    }
    generic_handler = grpc.method_handlers_generic_handler(
            'helloworld.HelloWorld', rpc_method_handlers)
    server.add_generic_rpc_handlers((generic_handler,))


 # This class is part of an EXPERIMENTAL API.
class HelloWorld(object):
    """was Greeter 
    """

    @staticmethod
    def SayHello(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/helloworld.HelloWorld/SayHello',
            hewo__pb2.HelloRequest.SerializeToString,
            hewo__pb2.HelloReply.FromString,
            options, channel_credentials,
            call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def Stop(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/helloworld.HelloWorld/Stop',
            hewo__pb2.Empty.SerializeToString,
            hewo__pb2.HelloReply.FromString,
            options, channel_credentials,
            call_credentials, compression, wait_for_ready, timeout, metadata)
