#!/usr/libexec/platform-python

#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
"""
python -m grpc_tools.protoc -I../../protos --python_out=. --grpc_python_out=. ../../protos/hewo.proto
"""

from concurrent import futures
import os,time,random,threading,string,sys,traceback
import grpc
import hewo_pb2
import hewo_pb2_grpc
from grpc_reflection.v1alpha import reflection
import pdb

from hw_client import HEWO_grpc
_ONE_DAY_IN_SECONDS = 60 * 60 * 24

server= None

def checkport(port):
  #cmd= "ss -tap |grep ':%d'"%port
  cmd= "ss -tap |grep ':%d' |grep '^LISTEN'"%port
  # not reliable for afs. 'fuser port/tcp -fine for trigger, not for afs'
  rc= os.popen(cmd).read()
  #print "action",rc,":",len(rc)
  return rc

class HelloWorld(hewo_pb2_grpc.HelloWorldServicer):
  def __init__(self, portn):
    self.portn= portn
    self.finish= None
    self.pid= os.getpid()
    self.monsleep= 10
    print("PID thread:%d %s"%(self.pid,self.getthreadid()))
    self.ltuds= {}   # ltud stubs (1 port - 1 stub) 
  def SayHello(self, request, context):
    """ 2 request types:
1. cport%d_cpid%d 
   identifying client, 
   action: -wait 8secs 
           -reply
2. forward portN cport%d_cpid%d
   action: -forward cport%d_cpid%d part of the message to a server portN
           -wait for response
           -reply
           portN -can be sent even to itself (without forward of course)
"""
    tokens= request.name.split()
    #mythread= str(threading.current_thread().ident)
    mythread= self.getthreadid()
    print("thr %s request tokens:"%mythread, tokens)
    if tokens[0]=="forward":
      # send+wait response
      fto= tokens[1]
      if fto in self.ltuds:
        fstub= self.ltuds[fto].stub
      else:
        print("new forwarding:",fto)
        newstub= HEWO_grpc(int(fto))
        # todo: critical section (access to a shared dict)
        self.ltuds[fto]= newstub
        fstub= newstub.stub
      fmsg= " ".join(tokens[2:])
      print("forwarding to %s:"%fto, fmsg)
      response= fstub.SayHello(hewo_pb2.HelloRequest(name=fmsg))
      print(response) 
      message= response.message
    else:
      response= request.name
      deadtime=8
      print "request:",request, "sleeping %d s..."%deadtime
      time.sleep(deadtime)
      message= 'Hello %s from %d/%s.' %(request.name, self.portn,mythread)
    print("echoing %s:"%mythread+message)
    return hewo_pb2.HelloReply(message=message)
  def killme(self):
    #sys.exit(8)
    os.system("kill %d"%self.pid)
  def Stop(self, request, context):
    global server
    self.finish= "Stop cmd received."
    threading.Timer(2.0, self.killme).start()
    server.stop(1)   # 1s grace period, 
    #server does not respond to any client from now (but
    # it does not finish when not killed)
    #raise ValueError("stopping ltud...")
    print "stopping..."
    return hewo_pb2.HelloReply(message='stop.')
  def getthreadid(self):
    #return str(threading.current_thread().ident)
    return str(threading.current_thread().getName())
    #getName(), .ident unique number?
def serve(portn):
  global server
  # HelloWorld() instantiated here once when server starts
  #portn= 9090
  # check if portn already taken:
  rc= checkport(portn)
  if len(rc)>0:
    print "hewo server (port:%d) already active.\n%s"%(portn,rc)
    return
  hewo_server= HelloWorld(portn)
  max_workers= 8  # use 1 for ltud, i.e. _lock/_unlock of ATB resources not involved
  #if max_workers>1:
  #  print "grpc.server,max.workers:%d, exiting."%max_workers
  #  return
  server = grpc.server(futures.ThreadPoolExecutor(max_workers=max_workers))
  #print "grpc.server add..."
  hewo_pb2_grpc.add_HelloWorldServicer_to_server(hewo_server, server)
  SERVICE_NAMES = (
    hewo_pb2.DESCRIPTOR.services_by_name['HelloWorld'].full_name,
    reflection.SERVICE_NAME,
  )
  reflection.enable_server_reflection(SERVICE_NAMES, server)
  try:
    server.add_insecure_port('[::]:%d'%portn)
    #print "rc:",rc
  except:
    print "Can't bind to %d"%portn
    return
  try:
    server.start()
    print "server [::]:%d started, maxworkers:%d."%(portn,max_workers)
    while True:
      #time.sleep(_ONE_DAY_IN_SECONDS)
      time.sleep(hewo_server.monsleep*3)
  #except KeyboardInterrupt:
  except:
    print "Error:"+str(sys.exc_info())
    traceback.print_exc(file=sys.stdout)
    server.stop(0)
if __name__ == '__main__':
  if len(sys.argv)<2:
    print("""
./hw_server.py [portn]      (9090)

""")
    sys.exit()
  serve(int(sys.argv[1]))
