#!/usr/libexec/platform-python

#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3

from __future__ import print_function
from builtins import input
import string,time,os,sys,readline,atexit,setsyspath
import grpc
#!/usr/bin/python3
setsyspath.add("ccm/protos")
import ctpd_pb2
import ctpd_pb2_grpc

ecscmds= ("rload","rs","rstop","rlist","rstatus","rconfig")
grpc_channels= {"ctp":50060}
def grpc_server_on(channel):
  TIMEOUT_SEC = 2
  try:
    grpc.channel_ready_future(channel).result(timeout=TIMEOUT_SEC)
    return True
  except grpc.FutureTimeoutError:
    return False
class TRG_grpc:
  def __init__(self, detname="ctp"):
    # NOTE(gRPC Python Team): .close() is possible on a channel and should be
    # used in circumstances in which the with statement does not fit the needs
    # of the code.
    self.stub= None
    self.channel= None   # connection NOT ACTIVE/CLOSED
    self.detname= None
    self.host= os.getenv('CTP3_SERVER')
    if self.host==None:
      print("CTP3_SERVER env. variable not defined")
      return
    if not (detname in grpc_channels):
      print("{} not known, only allowed: {}".format(detname, grpc_channels.keys()))
      return
    self.detname= detname
    #host= "localhost"
    #with grpc.insecure_channel('localhost:50051') as channel:
    #with grpc.insecure_channel('acsl:50051') as channel:
    msg= self.openchannel()
    print('tri_grpc: insecure_channel({}:{}) {} {}'.\
      format(self.host,grpc_channels[detname],detname, msg))
    #pdb.set_trace()
  def openchannel(self):
    was= str((self.channel,self.stub))
    self.channel= grpc.insecure_channel('{}:{}'.format(self.host,grpc_channels[self.detname]))
    #if self.channel== None: return   # !=None even when server not available
    if grpc_server_on(self.channel):
      self.stub = ctpd_pb2_grpc.CTPdStub(self.channel)
      msg= (0,was)
    else:
      #print("Channel {} not on".format(detname))
      msg= (8,was)
      self.channel= None
    return msg
  def close(self):
    if self.channel== None: return
    self.channel.close()
    self.channel= None

RUNDEFDIR= os.path.join(os.getenv("CTP3_CONFIG_DIRECTORY"),"rundefs")

def printHelp(topic=None):
  print("""Commands:
q           quit
h           this help text
qs          quit ctpd
Status

ecs cmds: available here temporarily, see ecs_client.py
""")
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
def ecsExec(stub, cmd):
  """  send ecs request/response to/from ctpd
This is obsolete: the latest ecs client is in ecs_client.py
rc: 0: ok
   >=8: not executed
"""
  allltus=("cpv", "emc", "ft0", "fv0", "fdd", "hmp", "its", "mch", "mft",
    "mid", "phs", "tof", "tpc", "trd", "zdc")
  grc= 0
  if cmd[0]=='rs':
    pars="""PH_bc 100 inf
"""
    if len(cmd)<2: 
      print("detector (stdalone run start) or run number (global run start) missing")
      grc=8; return grc
    allpars= {}
    if cmd[1].isdigit():   # global run
      allpars["runn"]= int(cmd[1])
    else:
      if not cmd[2].isdigit():   # global run
        print(cmd[2]+" -stdalone run number expected")
        grc=8; return grc
      allpars["detector"]= cmd[1]
      allpars["runn"]= int(cmd[2])
      if len(cmd)==3: 
        print("config fname not supplied, i.e. default config")
      else:   
        fname= cmd[3]
        if fname=='""':
          allpars["config"]=""
        elif not os.path.exists(os.path.join(RUNDEFDIR,fname)):
          print("config file {} does not exist in {}".format(fname, RUNDEFDIR))
          # todo: try consul (also on server's side)... allpars["config"]= "consul blabla"
          grc=8; return grc
        else:
          allpars["config"]= open(os.path.join(RUNDEFDIR,fname),'r').read()
        if len(cmd)>4: 
          # rs runn fname p1 val1 p2 val2...
          fieldnames= [field.name for field in ctpd_pb2.RunStartRequest.DESCRIPTOR.fields]
          print("fieldnames:",fieldnames)
          for ixp in range(4,len(cmd)):
            if (ixp%2)==0:
              pname= cmd[ixp]
            else:
              pval=  cmd[ixp]
              if pname in fieldnames[2:]:
                print("pname:{0}= {1}".format(pname, pval))
                #allpars[pname]= float(pval)
                allpars[pname]= pval
              else:
                print("pname:{0} ignored.".format(pname))
    rc = stub.RunStart(ctpd_pb2.RunStartRequest(**allpars))
    print("rc:{}\n{}".format(rc.rc, rc.msg))
  elif cmd[0]=='rload':
    if len(cmd)<3: 
      print("expected: rload runn fname [list of available detectors]")
    else:
      runn= int(cmd[1])
      config= cmd[2]
      if config[-3:]==".pd": config= config[:-3]
      fname= config+".pd"
      if os.path.exists(os.path.join(RUNDEFDIR,fname)):
        config= open(os.path.join(RUNDEFDIR,fname),'r').read()
        print("config {} taken from {}".format(fname, RUNDEFDIR))
      else:
        #allpars["config"]= "consul blabla"
        print("config file {} does not exist in {}, trying server db...".format(fname, RUNDEFDIR))
      if len(cmd)>3:
        detectors= " ".join(cmd[3:])
      else:
        detectors= ""
      rc = stub.RunLoad(ctpd_pb2.RunLoadRequest(runn=runn,config=config,detectors=detectors))
      print("rc:{}\n{}".format(rc.rc, rc.msg))
  elif cmd[0]=="rstop":
    if len(cmd)<2: 
      print("runn  or detector name missing")
      grc= 8
    else:
      sr= ctpd_pb2.RunStopRequest()
      if cmd[1].isdigit():
        sr.runn= int(cmd[1])
      else:
        if cmd[1] in allltus:
          sr.detector= cmd[1]
        else:
          print("{} -incorrect detector name".format(cmd[1]))
          sr= None
    if sr!=None:
      rc = stub.RunStop(sr)
      print("rc:{}\n{}".format(rc.rc, rc.msg))
  elif cmd[0]=="rlist":
    rc = stub.RunList(ctpd_pb2.Empty())
    print("rc:{}\n{}".format(rc.rc, rc.msg))
  elif cmd[0]=="rstatus":
    if len(cmd)<2: 
      print("runn missing")
    else:
      runn= int(cmd[1])
      rc = stub.RunStatus(ctpd_pb2.RunStatusRequest(runn=runn))
      print("rc:{}\n{}".format(rc.rc, rc.msg))
  elif cmd[0]=="rconfig":
    if len(cmd)<2: 
      print("runn missing")
    else:
      runn= int(cmd[1])
      rc = stub.RunConfig(ctpd_pb2.RunStopRequest(runn=runn))
      print("rc:{}\n{}".format(rc.rc, rc.msg))
  else:
    grc= 8
  return grc
def history(histfilen):
  histfile= os.path.join(os.getenv("CTP3_WORK_DIRECTORY"),histfilen)
  if os.path.exists(histfile):
    try:
      readline.read_history_file(histfile)
      readline.set_history_length(100) #lines
    except IOError:
      print(traceback.format_exc())
  else:
    print("Commands history not available ({} in working directory)".format(histfile))
  atexit.register(readline.write_history_file, histfile)

if __name__ == '__main__':
  netname= "ctp"
  if len(sys.argv)>1:
    print("args:",sys.argv)
  history(".ctp_hist")
  mystub= TRG_grpc()
  if mystub.channel==None: sys.exit(8)
  stub= mystub.stub
  if len(sys.argv)>1:
    print("args:",sys.argv)
    if sys.argv[1]=='qs':
      response= stub.Stop(ctpd_pb2.Empty())
      print(response) # 'stop'
      sys.exit()
  #print(" h: help", stub)
  prompt="{}>".format(netname)
  while True:
    line= input(prompt); 
    if line=="": continue
    #cmd= string.split(line)
    cmd= line.split()
    if cmd[0]=='h':
      printHelp()
    elif cmd[0]=='q':
      break
    elif cmd[0]=='qs':
      response= stub.Stop(ctpd_pb2.Empty())
      print(response) # 'stop'
    elif cmd[0]=='Status':
      response= stub.Status(ctpd_pb2.Empty())
      print("{:3} {:6} {:2} {:6} {}\n".format("det", "inrun", "sg", "lturun","ltumsg"))
      print("rc:{}\n{}".format(response.rc,response.msg))
    elif cmd[0] in ecscmds:
      rc= ecsExec(stub, cmd)
    else:
      print("bad cmd: {}".format(line))
      printHelp()
  mystub.close()
