#!/usr/libexec/platform-python

#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3

from __future__ import print_function
from builtins import input
import string,time,os,sys,readline,atexit
import grpc
#!/usr/bin/python3
import ctpecs_pb2
import ctpecs_pb2_grpc

grpc_channels= {"ctp":50060}
allltus=("cpv", "emc", "ft0", "fv0", "fdd", "hmp", "its", "mch", "mft",
  "mid", "phs", "tof", "tpc", "trd", "zdc")
accname= None   # (login,hostname)

def grpc_server_on(channel):
  TIMEOUT_SEC = 2
  try:
    grpc.channel_ready_future(channel).result(timeout=TIMEOUT_SEC)
    return True
  except grpc.FutureTimeoutError:
    return False
class TRG_grpc:
  def __init__(self, detname="ctp"):
    # NOTE(gRPC Python Team): .close() is possible on a channel and should be
    # used in circumstances in which the with statement does not fit the needs
    # of the code.
    self.stub= None
    self.channel= None   # connection NOT ACTIVE/CLOSED
    self.detname= None
    self.host= os.getenv('CTP3_SERVER')
    if self.host==None:
      print("CTP3_SERVER env. variable not defined")
      return
    if not (detname in grpc_channels):
      print("{} not known, only allowed: {}".format(detname, grpc_channels.keys()))
      return
    self.detname= detname
    #host= "localhost"
    #with grpc.insecure_channel('localhost:50051') as channel:
    #with grpc.insecure_channel('acsl:50051') as channel:
    msg= self.openchannel()
    #print('tri_grpc: insecure_channel({}:{}) {} {}'.\
    #  format(self.host,grpc_channels[detname],detname, msg))
    if msg[0]!=0:
      okerr= "cannot connect"
    else:
      okerr= "ok"
    print("tri_grpc: insecure_channel {}:{} ({}) {}".format(self.host,grpc_channels[detname],detname,okerr))
    #pdb.set_trace()
  def openchannel(self):
    was= str((self.channel,self.stub))
    self.channel= grpc.insecure_channel('{}:{}'.format(self.host,grpc_channels[self.detname]))
    #if self.channel== None: return   # !=None even when server not available
    if grpc_server_on(self.channel):
      if self.detname=="ctp":
          import ctpecs_pb2
          import ctpecs_pb2_grpc
          self.stub = ctpecs_pb2_grpc.CTPdStub(self.channel)
      msg= (0,was)
    else:
      #print("Channel {} not on".format(detname))
      msg= (8,was)
      self.channel= None
    return msg
  def close(self):
    if self.channel== None: return
    self.channel.close()
    self.channel= None

RUNDEFDIR= os.path.join(os.getenv("CTP3_CONFIG_DIRECTORY"),"rundefs")
DBCTPDIR= os.path.join(os.getenv("CTP3_DBCTP"),"pd")

def printHelp(topic="ecs"):
  if topic=="ecs":
    allowedpars= [field.name for field in ctpecs_pb2.RunStartRequest.DESCRIPTOR.fields]
    allowedpars.remove("runn")
    allowedpars.remove("config")
    print("""ECS commands:
=== GLobal runs:
rload N fname  load config for global run N
               fname: if not in local $CTP3_DBCTP/pd/fname.pd,
                      global definition 'fname' in CTPd site is taken
rs N           start global run N (has to be loaded before)

=== GLobal or Standalone runs:
list        -list of local files (definitions for global/stdalone runs)
rlist       -list of active runs
rstop [N]   -stop global or Stdalone run
rstatus N
rconfig N

=== Standalone run:
rs detector N fname                    load+start run N
   detector: tpc, hmp, ft0, fv0,...
   fname: the name of the run definition file in CFG/rundefs/fname

   Example starting run 3, using run definition from CFG/rundefs/example.par
   rs fv0 3 example.par

rstop                                  stop run N
rstop N                                stop run N (ECS only)

=== Also possible, but discouraged:
rs detector N "" [par value]...     load+start run N
          "" -no file given, parameters only on cmdline
   par value: optional parameters overriding fname values.
              Allowed optional parameters: {0}
 
   Minimal example (no file, default TRIG mode, 2.5khz PH_bc triggerring):
   rs fv0 3 "" ph_bc 2.5khz

rstop detector                         forced CTP emulation stop (experts only)

""".format(allowedpars))
    # fieldnames= [field.name for field in ctpecs_pb2.RunStartRequest.DESCRIPTOR.fields]
  else:
    print("""Commands:
q           quit
h           this help text
""")
def checkuid(cmduname="", truemsg="std"):
  """
rc: True if not allowed
    False if cmd allowed for cmduname
"""
  global accname
  if accname==None:
    accname= []
    accname.append(os.getlogin())
    accname.append(os.getenv("HOSTNAME").split('.')[0])
  if accname[1]!="alio2-cr1-flp163":
    return False   # allow if not in P2
  else:
    if accname[0]=="ecs": return False   # allow ecs,trigger,test
    if accname[0]=="trigger": return False
    if accname[0]=="test": return False
    print("checkuid: {} {} accname:{}".format(cmduname,truemsg,accname))
    if accname[0]==cmduname: return False
  if truemsg==None:
    pass
  elif truemsg=="std":
    print("cmd not allowed for account "+accname[0])
  else:
    print(truemsg)
  return True
def ecsExec(stub, cmd):
  """  send to/receive from ctpd
Done only: rstatus
rc: 0: ok
   >=8: not executed
"""
  grc= 0
  if cmd[0]=='rs':   # rs det 333 file.par
    pars="""PH_bc 100 inf
"""
    if len(cmd)<2: 
      print("detector (stdalone run start) or run number (global run start) missing")
      grc=8; return grc
    allpars= {}
    if cmd[1].isdigit():   # global run
      if checkuid(): return 8   # not allowed for detector's account
      allpars["runn"]= int(cmd[1])
    else:
      if checkuid(cmd[1]): return 8
      if not cmd[2].isdigit():
        print(cmd[2]+" -stdalone run number expected")
        grc=8; return grc
      allpars["detector"]= cmd[1]
      allpars["runn"]= int(cmd[2])
      if len(cmd)==3: 
        print("config fname not supplied, i.e. default config")
      else:                      # stdalone
        fname= cmd[3]
        if fname=='""':
          allpars["config"]=""
        elif not os.path.exists(os.path.join(RUNDEFDIR,fname)):
          print("config file {} does not exist in {}".format(fname, RUNDEFDIR))
          # todo: try consul (also on server's side)... allpars["config"]= "consul blabla"
          grc=8; return grc
        else:
          allpars["config"]= open(os.path.join(RUNDEFDIR,fname),'r').read()
        if len(cmd)>4: 
          # rs runn fname p1 val1 p2 val2...
          fieldnames= [field.name for field in ctpecs_pb2.RunStartRequest.DESCRIPTOR.fields]
          print("fieldnames:",fieldnames)
          for ixp in range(4,len(cmd)):
            if (ixp%2)==0:
              pname= cmd[ixp]
            else:
              pval=  cmd[ixp]
              if pname in fieldnames[2:]:
                print("pname:{0}= {1}".format(pname, pval))
                #allpars[pname]= float(pval)
                allpars[pname]= pval
              else:
                print("pname:{0} ignored.".format(pname))
    rc = stub.RunStart(ctpecs_pb2.RunStartRequest(**allpars))
    print("rc:{}\n{}".format(rc.rc, rc.msg))
  elif cmd[0]=="rload":
    if checkuid(): return 8
    if len(cmd)<3: 
      print("expected: rload runn fname [list of available detectors]")
    else:
      if not cmd[1].isdigit():
        print("int expected")
        return 8
      runn= int(cmd[1])
      config= cmd[2]
      if config[-3:]==".pd": config= config[:-3]
      fname= config+".pd"
      if os.path.exists(os.path.join(DBCTPDIR,fname)):
        config= open(os.path.join(DBCTPDIR,fname),'r').read()
        print("config {} taken from {}".format(fname, DBCTPDIR))
      else:
        #allpars["config"]= "consul blabla"
        print("config file {} does not exist in {}, trying server db...".format(fname, DBCTPDIR))
      if len(cmd)>3:
        detectors= " ".join(cmd[3:])
      else:
        detectors= ""
      rc = stub.RunLoad(ctpecs_pb2.RunLoadRequest(runn=runn,config=config,detectors=detectors))
      print("rc:{}\n{}".format(rc.rc, rc.msg))
  elif cmd[0]=="rstop":
    sr= ctpecs_pb2.RunStopRequest()
    if len(cmd)<2: 
      if checkuid("",None)==False:
        print("give a run number or detector name... ")
        grc= 8 ; sr= None
      else:
        sr.detector= accname[0]
    else:
      if cmd[1].isdigit():
        if checkuid():
          grc= 8; sr= None   # only ecs account allowed
        else:
          sr.runn= int(cmd[1])
      else:
        if cmd[1] in allltus:
          if checkuid(cmd[1]):
            grc= 8 ; sr= None
          else:
            sr.detector= cmd[1]
        else:
          print("{} -incorrect detector name".format(cmd[1]))
          grc= 8 ;sr= None
    if sr!=None:
      rc = stub.RunStop(sr)
      print("rc:{}\n{}".format(rc.rc, rc.msg))
  elif cmd[0]=="rlist":
    rc = stub.RunList(ctpecs_pb2.Empty())
    print("rc:{}\n{}".format(rc.rc, rc.msg))
  elif cmd[0]=="list":
    if len(cmd)<2: 
      if os.path.exists(RUNDEFDIR):
        print("Standalone Run Configs in {}:".format(RUNDEFDIR))
        print(os.system('%s %s' % ('ls -lth', RUNDEFDIR)))
      if os.path.exists(DBCTPDIR):
        print("Global Run Configs in {}:".format(DBCTPDIR))
        print(os.system('%s %s' % ('ls -lth', DBCTPDIR)))
    elif len(cmd)==2:
        if cmd[1]=="s":
          if os.path.exists(RUNDEFDIR):
            print("Standalone Run Configs in {}:".format(RUNDEFDIR))
            print(os.system('%s %s' % ('ls -lth', RUNDEFDIR)))
          else:
            print("{} does not exist!".format(RUNDEFDIR))
        elif cmd[1]=="g":
          if os.path.exists(DBCTPDIR):
            print("Global Run Configs in {}:".format(DBCTPDIR))
            print(os.system('%s %s' % ('ls -lth', DBCTPDIR)))
          else:
            print("{} does not exist!".format(DBCTPDIR))
        elif cmd[1]=="h":
          print("""Usage:
          list                 list standalone + global config files
          list g               list global config files
          list s               list standlone config files
          list <filename>      display config file contents
          list h               show this help text

          Example:
          list example.par
          """)
        elif len(cmd[1])>3:
          fname=cmd[1]
          if os.path.exists(os.path.join(RUNDEFDIR,fname)):
            fname=os.path.join(RUNDEFDIR,fname)
            with open(fname, 'r') as fout:
              print(fout.read(), end="")          
          elif os.path.exists(os.path.join(DBCTPDIR,fname)):
            fname=os.path.join(DBCTPDIR,fname)
            with open(fname, 'r') as fout:
              print(fout.read(), end="")
          else:
            print("Config file {} does not exist in {} or {} ! See 'list h' for usage.".format(fname, RUNDEFDIR, DBCTPDIR))
        else:
          print("Invalid usage -- {}. Try 'list h' for more information.".format(cmd))
    else:
          print("Invalid usage -- {}. Try 'list h' for more information.".format(cmd))

  elif cmd[0]=="rstatus":
    if (len(cmd)<2) or (not cmd[1].isdigit()):
      #rc = stub.RunStatus(ctpecs_pb2.Empty())   # Empty: must for empty msg
      print("runn missing or not integer")
    else:
      runn= int(cmd[1])
      rc = stub.RunStatus(ctpecs_pb2.RunStatusRequest(runn=runn))
      print("rc:{}\n{}".format(rc.rc, rc.msg))
  elif cmd[0]=="rconfig":
    if (len(cmd)<2) or (not cmd[1].isdigit()):
      print("runn missing or not integer")
    else:
      runn= int(cmd[1])
      rc = stub.RunConfig(ctpecs_pb2.RunStopRequest(runn=runn))
      print("rc:{}\n{}".format(rc.rc, rc.msg))
  else:
    print("bad cmd: {}, see 'h'".format(" ".join(cmd)))
    grc= 8
  return grc
def history(histfilen):
  histfile= os.path.join(os.getenv("CTP3_WORK_DIRECTORY"),histfilen)
  if os.path.exists(histfile):
    try:
      readline.read_history_file(histfile)
      readline.set_history_length(100) #lines
    except IOError:
      print(traceback.format_exc())
  else:
    print("Commands history not available ({} in working directory)".format(histfile))
  atexit.register(readline.write_history_file, histfile)

if __name__ == '__main__':
  netname= "ctp"
  if len(sys.argv)>1:
    netname= sys.argv[1]
  history(".ecs_hist")
  mystub= TRG_grpc()
  if mystub.channel==None: sys.exit(8)
  stub= mystub.stub
  print(" h: help")
  prompt="ecsc>"
  while True:
    line= input(prompt); 
    if line=="": continue
    #cmd= string.split(line)
    cmd= line.split()
    if cmd[0]=='h':
      printHelp()
    elif cmd[0]=='q':
      break
    else:
      if netname=="ctp":
        rc= ecsExec(stub, cmd)
      #if rc!=0:
      #  print("bad cmd: {}, see 'h'".format(line))
  mystub.close()
