#!/usr/libexec/platform-python

#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
"""The Python implementation of the GRPC ltud.LTUd."""
from __future__ import print_function
from builtins import input
import string,time,os,sys,readline,atexit
import tri_grpcs
import grpc
import ltud_pb2
import ltud_pb2_grpc

RUNDEFDIR= os.path.join(os.getenv("CTP3_CONFIG_DIRECTORY"),"rundefs")

def printHelp(topic="ecs"):
  if topic=="ecs":
    allowedpars= [field.name for field in ltud_pb2.RunStartRequest.DESCRIPTOR.fields]
    allowedpars.remove("runn")
    allowedpars.remove("config")
    print("""ECS commands:
rs N fname [par value]...              start run N
          fname: the name of the run definition file in CFG/rundefs/ directory
                 "" -no file, parameters only on cmdline
          par value: optional parameters overriding file values.
                     Allowed optional parameters: {0}
          Examples:
          1. minimal example (no file parameters, default TRIG mode):
          rs 3 "" ph_bc 2.5khz
          2. using run parameters from ~/CFG/rundefs/example.par
          rs 3 example.par
rstop
rstatus
rconfig
""".format(allowedpars))
    # fieldnames= [field.name for field in ltud_pb2.RunStartRequest.DESCRIPTOR.fields]
  else:
    print("""Commands:
q           quit
h           this help text
""")
def ecsltuExec(stub, cmd):
  """ 
rc: 0: ok
   >=8: not executed
"""
  grc= 0
  if cmd[0]=='rs':
    pars="""PH_bc 100 inf
"""
    if len(cmd)<2: 
      print("run number missing")
      grc=8; return grc
    if not cmd[1].isdigit():
      print(cmd[1]+" -incorrect run number")
      grc=8; return grc
    allpars= {}
    allpars["runn"]= int(cmd[1])
    if len(cmd)==2: 
      print("config fname not supplied, i.e. default config")
    else:   
      fname= cmd[2]
      if fname=='""':
        allpars["config"]=""
      elif not os.path.exists(os.path.join(RUNDEFDIR,fname)):
        print("config file {} does not exist in {}".format(fname, RUNDEFDIR))
        allpars["config"]= "consul blabla"
      else:
        allpars["config"]= open(os.path.join(RUNDEFDIR,fname),'r').read()
      if len(cmd)>3: 
        # rs runn fname p1 val1 p2 val2...
        fieldnames= [field.name for field in ltud_pb2.RunStartRequest.DESCRIPTOR.fields]
        #print(fieldnames)
        for ixp in range(3,len(cmd)):
          if (ixp%2)==1:
            pname= cmd[ixp]
          else:
            pval=  cmd[ixp]
            if pname in fieldnames[2:]:
              print("pname:{0}= {1}".format(pname, pval))
              #allpars[pname]= float(pval)
              allpars[pname]= pval
            else:
              print("pname:{0} ignored.".format(pname))
    rc = stub.RunStart(ltud_pb2.RunStartRequest(**allpars))
    print("rc:{}\n{}".format(rc.rc, rc.msg))
  elif cmd[0]=="rstop":
    if (len(cmd)==2 and (not cmd[1].isdigit())) or (len(cmd)==1):
      print(cmd[0]+" N (N: run number expected)")
      grc=8; return grc
    runn= int(cmd[1])
    rc = stub.RunStop(ltud_pb2.RunStopRequest(runn==runn))
    print("rc:{}\n{}".format(rc.rc, rc.msg))
  elif cmd[0]=="rstatus":
    if (len(cmd)==2 and (not cmd[1].isdigit())) or (len(cmd)==1):
      print(cmd[0]+" N (N: run number expected)")
      grc=8; return grc
    runn= int(cmd[1])
    rc = stub.RunStatus(ltud_pb2.RunStatusRequest(runn=runn))
    print("rc:{}\n{}".format(rc.rc, rc.msg))
  elif cmd[0]=="rconfig":
    if (len(cmd)==2 and (not cmd[1].isdigit())) or (len(cmd)==1):
      print(cmd[0]+" N (N: run number expected)")
      grc=8; return grc
    rc = stub.RunConfig(ltud_pb2.RunStopRequest(runn=runn))
    #rc = stub.RunConfig(ltud_pb2.Empty())   # Empty: must for empty msg
    print("rc:{}\n{}".format(rc.rc, rc.msg))
  else:
    grc= 8
    return grc
  print("rc:{}\n{}".format(rc.rc, rc.msg))
  return grc
def history(histfilen):
  histfile= os.path.join(os.getenv("CTP3_WORK_DIRECTORY"),histfilen)
  if os.path.exists(histfile):
    try:
      readline.read_history_file(histfile)
      readline.set_history_length(100) #lines
    except IOError:
      print(traceback.format_exc())
  else:
    print("Commands history not available ({} in working directory)".format(histfile))
  atexit.register(readline.write_history_file, histfile)

if __name__ == '__main__':
  print(""""ecsltu_client.py: obsolete (will be removed), use instead:
./ecs_client.py   -used by ECS
./ltu_client.py ctp   - only qs +ecs commands tested (29.4.2021)
./ltu_client.py det   - debug ltud_server.py

For now only available cmdline client for ctpd is ecs_client.
Todo:
separate ctp_client.py (preferred) or use ltud_client (less preferred)
"""
  sys.exit(8)
  if len(sys.argv)>1:
    netname= sys.argv[1]
    mystub= tri_grpcs.TRG_grpc(netname)
    if mystub.channel==None: sys.exit(8)
    stub= mystub.stub
    history(".ecs_hist")
    print(" h: help")
    prompt="{}>".format(netname)
    while True:
      line= input(prompt); 
      if line=="": continue
      #cmd= string.split(line)
      cmd= line.split()
      if cmd[0]=='h':
        printHelp()
      elif cmd[0]=='q':
        break
      else:
        rc= ecsExec(stub, cmd)
        if rc!=0:
          print("bad cmd: {}".format(line))
          printHelp()
    mystub.close()
  else:
    print("arg1 (netname) missing...")
