#!/usr/libexec/platform-python

#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
"""The Python implementation of the GRPC ltud.LTUd."""
from __future__ import print_function
from builtins import input
import string,time,os,sys,time,atexit,setsyspath
from cmdlhistory import history
#!/usr/bin/python3
import tri_grpcs # ,ecs_client
import grpc
import ltud_pb2
import ltud_pb2_grpc
#!/usr/bin/python3

def printHelp(topic=None):
  if topic=="cmd":
    print("""cmd N string
N      {0} 
string: INIT_OLTS, INIT_ONUS, FULLCAL: OLT numbers (1..9) separated by space

unlock  -forced Unlock request (i.e. user "None")  todo
""".format(ltud_pb2.CmdRequest.CmdN.items()))
  #elif topic=="ecs":
  #  ecs_client.printHelp()
  else:
    print("""Commands: q(quit), qs(stop server)   -also ctp
s secs [N] [json]  sleep secs on server (requesting Sleep service), repeat request N times
            json: ->json->protobuf demonstration
sr          stream response test
ows         reopen ltud.ws-> awmtors (after awmd restart), followed
            by 'force'
force       WS_FORCE_UPDATE: resend down to http clients last measured status of all ONUs
            without touching hw. Sent automaticaly in 'ows' 
monstat     show mondbg (True/False) +
            ONU statuses (i.e. values to be sent with 'force')
mondbg      toggle dbg mode (ONUs' states changed +1 instead of real state)
monc [N]    send MonCycle request N (def:1) times, spacing 5s
ocget[i|n|1] OutCntsGet[Inc]    ocgetn: get names   ocget1: 2xInc, 1s apart

TFOrbit     get TF Orbit
SetMode     s | g
Status      LtuStatus service

Other:
lu l|u user Lock/Unlock request. Use 'lu u None' to force unlock
pdb         enter pdb
h           this help text
h cmd       help on service cmds (CmdRequest)
""")
#!/usr/bin/python3
def run(netname):
  def cmdarg(n, default=""):
    if len(cmd)>n: 
      return(cmd[n])
    else:
      return(default)
  pid= os.getpid()
  myid= "%s (clientpid:%d)"%(netname,pid)
  mystub= tri_grpcs.TRG_grpc(netname)
  #if mystub.channel==None: return
  stub= mystub.stub
  if stub==None: return
  if netname!='ctp':
    try:
      #response = stub.SayHello(ltud_pb2.HelloRequest(name=myid))
      cnames = stub.OutCntsGetNames(ltud_pb2.Empty())
    except:
      #print("Cannot send hello.")
      print("Cannot get cnames")
      #return
  #print("Sent:%s, received:%s"%(myid,response.message))
  if len(sys.argv)>2:
    if sys.argv[2]=="qs":
      try:
        response= stub.Stop(ltud_pb2.Empty())
      except:
        e = sys.exc_info()[0]
        print( "Error: %s" % e )
      else:
        print(response)
      return
  if netname=='ctp':
    print("With ctp, only 'ltud_client.py ctp qs' allowed, exiting")
    return
  history(".ltuc_hist")
  prompt="{}>".format(netname)
  while True:
    #line= raw_input(prompt); 
    line= input(prompt); 
    if line=="": continue
    cmd= line.split()   # cmd cmdname a1
    if cmd[0]=='pdb': 
      pdb.set_trace()
      continue
    if cmd[0]=='h':
      printHelp(cmdarg(1))
    elif cmd[0]=='q': break
    elif cmd[0]=='qs':
      response= stub.Stop(ltud_pb2.Empty())
      print(response) # 'stop'
    elif cmd[0]=='s':
      mysecs= 0.0
      if len(cmd)>1: mysecs= eval(cmd[1])
      nrep= 1
      if len(cmd)>2: nrep= int(cmd[2])
      for ix in range(nrep):
        response = stub.Sleep(ltud_pb2.HelloRequest(name=myid, floatn=mysecs))
        #print("%d: %.2f "%(ix, response.secs), response.message, response.dyna, type(response.dyna))
        # [888L, 62L, 67L] <type 'google.protobuf.pyext._message.RepeatedScalarContainer'>
        print("%d: %.2f "%(ix, response.secs), response.message, response.dyna)
      if len(cmd)>3 and cmd[3]=='json':
        # https://googleapis.dev/python/protobuf/latest/google/protobuf/json_format.html
        import google.protobuf.json_format as json_format
        respjs= json_format.MessageToJson(response)
        print("Last msg as json:", respjs)
        resppb= json_format.Parse(respjs, ltud_pb2.HelloReply())
        print("Last msg as protobuf:", resppb)
    elif cmd[0]=='sr':
      strr = stub.StreamResp(ltud_pb2.Empty())
      print(strr)
    elif cmd[0]=='ows':
      strr = stub.Cmd(ltud_pb2.CmdRequest(cmdn=ltud_pb2.CmdRequest.WS_REOPEN))
      print(strr)
    elif cmd[0]=='mondbg':
      strr = stub.Cmd(ltud_pb2.CmdRequest(cmdn=ltud_pb2.CmdRequest.DBG_CHONU))
      print(strr)
    elif cmd[0]=='monstat':
      strr = stub.Cmd(ltud_pb2.CmdRequest(cmdn=ltud_pb2.CmdRequest.WS_ONUSTATS))
      print(strr)
    elif cmd[0]=='force':
      strr = stub.Cmd(ltud_pb2.CmdRequest(cmdn=ltud_pb2.CmdRequest.WS_FORCE_UPDATE))
      print(strr)
    elif cmd[0]=='unlock':
      strr = stub.Unlock(ltud_pb2.LockRequest(user="None"))
      print(strr)
    elif cmd[0]=='cmd':
      #print("cmd keys values:\n{}\n{}".format(ltud_pb2.CmdRequest.CmdN.keys(),
      #  ltud_pb2.CmdRequest.CmdN.values()))
      cmdn_s= cmdarg(1) ; cmdn= None
      if cmdn_s=="":
        printHelp(cmdarg(0))
      elif cmdn_s in ltud_pb2.CmdRequest.CmdN.keys():
        cmdn= ltud_pb2.CmdRequest.CmdN.Value(cmdn_s)
      elif (cmdn_s.isdigit()) and\
        (int(cmdn_s) in ltud_pb2.CmdRequest.CmdN.values()):
        cmdn= int(cmdn_s)
      else:
        print("bad cmd: cmd "+cmdn_s)
      if cmdn!=None:
        strr = stub.Cmd(ltud_pb2.CmdRequest(cmdn=cmdn, cmd=" ".join(cmd[2:])))
        cmdname= ltud_pb2.CmdRequest.CmdN.keys()[cmdn]
        print("{}: {}, {}".format(cmdname,strr.rc, strr.msg))
    elif cmd[0]=='lu':
      user= "nobody"
      if len(cmd)>2: user= cmd[2]
      if cmd[1]=='l':
        rc = stub.Lock(ltud_pb2.LockRequest(user=user))
      elif cmd[1]=='u':
        rc = stub.Unlock(ltud_pb2.LockRequest(user=user))
      else:
        print(" Error: l or u expected")
    elif cmd[0]=='TFOrbit':
      rcmsg = stub.TFOrbit(ltud_pb2.Empty())
      if rcmsg.rc!=None:
        print("0x{:x} started:{:.6f}s {}".format(rcmsg.rc,rcmsg.timestamp,rcmsg.msg))
      else:
        print(rcmsg)
    elif cmd[0]=='SetMode':
      sg= None
      if len(cmd)>1:
        if cmd[1]=='s':
          sg= ltud_pb2.Ltumode.STDALONE
        elif cmd[1]=='g':
          sg= ltud_pb2.Ltumode.GLOBAL
        else:
          pass
      if sg==None:
        sg= ltud_pb2.Ltumode.NULL
        print("SetMode s | g expected to set new mode. Querying...")
      #request = ltud_pb2.SetModeRequest(mode=sg)
      #rcmsg = stub.SetMode(request)
      rcmsg = stub.SetMode(ltud_pb2.SetModeRequest(mode=sg))
      if rcmsg.rc!=None:
        print("{:x} {}".format(rcmsg.rc,rcmsg.msg))
      else:
        print(rcmsg)
    elif cmd[0]=='Status':
      rcmsg= stub.LtuStatus(ltud_pb2.Empty())
      print("LtuStatusReply {}".format(rcmsg))
      #print("Status runn:{} mode:{} msg: {}".format(rcmsg.runn,rcmsg.mode,rcmsg.msg))
    elif cmd[0]=='monc':
      reps= int(cmdarg(1,"1"))
      for rep in range(reps):
        rc = stub.MonCycle(ltud_pb2.Empty())
        print("{}. rc:".format(rep),rc)
        if (rep+1)<reps: time.sleep(5)
    elif cmd[0]=='ocget':
      rc = stub.OutCntsGet(ltud_pb2.Empty())
      #print("OutCntsGet rc:{}".format(rc))
      print("OutCntsGet ts:{} N:{} rc:{}".format(\
        rc.timestamp,len(rc.outcnts),rc.outcnts))
      #print("OutCntsGet str(rc.outcnts):{}".format(str(rc.outcnts)))
    elif (cmd[0]=='ocgeti') or (cmd[0]=='ocget1'):
      if (cmd[0]=='ocget1'):
        rc = stub.OutCntsGetInc(ltud_pb2.Empty())
        print("Sleeping 1s between two OutCntsGetInc requests...")
        time.sleep(1)
      rc = stub.OutCntsGetInc(ltud_pb2.Empty())
      print("OutCntsGetInc time diff:{:.6}s N:{} rc:{}".format(\
        rc.timestamp,len(rc.outcnts),rc.outcnts))
      line= "" ; inline= 0
      for ix in range(len(rc.outcnts)):
        if cnames.names[ix]!="":
          #line= line+"%8s:%10d    "%(cnames.names[ix], rc.outcnts[ix])
          line= line+"{:>8}:{:<10} ".format(cnames.names[ix], rc.outcnts[ix])
          inline= inline+1
        if (inline==5) or (ix==(len(rc.outcnts)-1) and (line!="")):
          print(line) ; line="" ; inline= 0
    elif cmd[0]=='ocgetn':
      rc = stub.OutCntsGetNames(ltud_pb2.Empty())
      print("OutCntsGetNames: {} {}".format(len(rc.names),rc))
    else:
      rc= 1 #ecs_client.ecsExec(stub, cmd)
      if rc!=0:
        print("bad cmd: {}".format(line))
        #printHelp()
  mystub.close()

if __name__ == '__main__':
  if len(sys.argv)>1:
    run(sys.argv[1])
  else:
    print("arg1 (netname) missing...")
