#!/usr/libexec/platform-python

#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
"""
python -m grpc_tools.protoc -I../../protos --python_out=. --grpc_python_out=. ../../protos/ltud.proto
"""

from concurrent import futures
import os,time,random,threading,string,sys,traceback
import auxfuns,ilogger,tri_grpcs,ttcpon.ttcponnet
#!/usr/bin/python3
import grpc
#!/usr/bin/python3
#!/usr/bin/python3
import ltud_pb2
import ltud_pb2_grpc
from grpc_reflection.v1alpha import reflection
import pdb

_ONE_DAY_IN_SECONDS = 60 * 60 * 24

server= None


#!/usr/bin/python3

class LTUd(ltud_pb2_grpc.LTUdServicer):
  GlobalNoRun= 0xffffffff
  def __init__(self, netname, init=None, dummy=False):
    self.myN= 0   # number of Sleep() requests
    self.finish= None     # or string giving a reason finishing
    self.montimestamp= 0  # the time of last monitoring 
    self.monsleep= 10.0   # monitoring interval [s]
    self.lockedfor= None  # userid if locked for somebody
    if netname=="ctp":
      print("Only ltu nets allowed here...")
      return
    self.portn= tri_grpcs.grpc_channels[netname]
    self.logger=  ilogger.ilogger("ltud_%s.log"%netname)
    # following moved to main:
    #if netname in tri_grpcs.grpc_channels:
    #else:
    #  self.finish= "Unknown netname:%s"%netname
    #  self.logger.critical(self.finish)
    #  #sys.exit(8)
    #  return
    # check if portn already taken:
    #rc= tri_grpcs.checkport(self.portn)
    #if len(rc)>0:
    #  self.finish="ltud for %s already active. %s"%(netname,rc)
    #  return
    self.pid= os.getpid()
    print("PID:",self.pid)
    self.mutex= threading.Lock()
    if dummy:
      self.tpnet= ttcpon.ttcponnet.TtcPonNetDummy(self.logger, netname,
      server=True, init=init)
    else:
      self.tpnet= ttcpon.ttcponnet.TtcPonNet(self.logger, netname,
      server=True, init=init)
    #print("ltud waserror:", self.tpnet.waserror)
    if self.tpnet.waserror:
      # sys.exit(8)
      self.finish= "Cannot join ttcpon network %s. init:"%netname+str(init)
      return
    self.fpga= self.tpnet.oltboard.findDevice("fpga")
    self.fpga.fpgainit()
    self.ctpemu= self.tpnet.oltboard.findDevice("emu")
    if self.ctpemu==None:
      self.finish= "emu device not found"
      return
    self.tdg= self.tpnet.oltboard.findDevice("tdg")
    self.outcnts= self.tpnet.oltboard.findDevice("outcnts")
    self.ctpemu.status()
    self.tpnet.measureConfig()
    # self.outcnts.last: raw counters read when ltud started
    # self.outcnts.lasttime: the time of reading
    #todo: check ctrl.pid_1 (expected: 0 after ltud start). 
    #      Possibly joining stdalone/global run?
    #if init=="init":
    self.runnumber(0)  # i.e. run not active (stdalone neither global)
  def printN(self, label=None):
    print("LTUd myN:%d"%self.myN, label)
  def SayHello(self, request, context):
    return ltud_pb2.HelloReply(message='Hello %s %f.' %(request.name,
      request.floatn))
  def StreamResp(self, request, context):
    print("StreamResp 2...")
    sr= ltud_pb2.HelloReply()
    for ix in range(2):
      #time.sleep(4)
      sr.dyna.append(ix)
    sr.message='StreamResp %d myN:%d.'%(ix, self.myN)
    sr.secs= ix
    yield sr
  def killme(self):
    #sys.exit(8)
    os.system("kill %d"%self.pid)
  def Stop(self, request, context):
    global server
    self.finish= "Stop cmd received."
    self.tpnet.Stop()
    #orc= self.tpnet.awmc.ws_close()   # is in tpnet.Stop()
    self.fpga.setDport(0x0)   # i.e. ltud not active
    threading.Timer(2.0, self.killme).start()
    server.stop(1)   # 1s grace period, 
    #server does not respond to any client from now (but it does not finish)
    #raise ValueError("stopping ltud...")
    print("stopping...")
    return ltud_pb2.HelloReply(message='stop.')
  def getthreadid(self):
    #return str(threading.current_thread().ident)
    return threading.current_thread().getName()
    #getName(), .ident unique number?
  def Sleep(self, request, context):
    print("Sleep: %s %s"%(request.name, self.getthreadid()))
    #newn= self.myN= self.myN+1
    # deliberately put sleep time between read and update of self.myN: 
    #self._lock()
    newn= self.myN
    if request.floatn>0.0: time.sleep(request.floatn)
    newn= newn+1 ; self.myN= newn
    #self._unlock()
    rsecs= request.floatn; msg= "ok"
    r= ltud_pb2.HelloReply()
    r.message='Sleep newn:%d %ds, %s!'%(newn, request.floatn,msg)
    r.secs= rsecs
    r.dyna.append(888)
    n= random.randint(0,4)
    for ix in range(n):
      r.dyna.append(random.randint(1,100))
    print(r)
    return r
  def Cmd(self, req, context):
    if int(req.cmdn) in ltud_pb2.CmdRequest.CmdN.values():
      cmdname= ltud_pb2.CmdRequest.CmdN.keys()[req.cmdn]
      err= False
    else:
      cmdname= ""
      err= True
    #print("Cmd:  {0}/{1}...".format(req.cmdn, cmdname))
    if err:
      print("Cmd: bad command: {0} == {1}".format(req.cmdn,
        ltud_pb2.CmdRequest.CmdN.Name(1)))
      orc=(1,"bad cmd: %d"%req.cmdn)
    elif req.cmdn==ltud_pb2.CmdRequest.WS_REOPEN:
      #req.cmdn==ltud_pb2.CmdRequest.CmdN.Value("WS_REOPEN"):  works also
      #req.cmdn==ltud_pb2.CmdRequest.CmdN.Name(1):  works also
      #(Pdb) ltud_pb2.CmdRequest.DESCRIPTOR.fields_by_name.keys()
      #['cmdn', 'cmd']
      orc= self.tpnet.awmc.ws_open()
      time.sleep(0.4)
      if orc[0]<=4:
        print("starting forceupdate after WS_REOPEN")
        orc= self.tpnet.awmc.forceupdate()
      else:
        print("forceupdate not started after WS_REOPEN (rc>4)")
      #
      #r= ltud_pb2.CmdReply(*orc)   no positional args allowed
      #r= ltud_pb2.CmdReply(orc[0], orc[1])   # no positional args allowed
    elif req.cmdn==ltud_pb2.CmdRequest.WS_CLOSE:
      orc= self.tpnet.awmc.ws_close()
    elif req.cmdn==ltud_pb2.CmdRequest.WS_FORCE_UPDATE:
      orc= self.tpnet.awmc.forceupdate()
    elif req.cmdn==ltud_pb2.CmdRequest.WS_ONUSTATS:
      orc= self.tpnet.awmc.get_statuses()
    elif req.cmdn==ltud_pb2.CmdRequest.DBG_CHONU:
      orc= self.tpnet.awmc.set_dbgchonu()
    elif req.cmdn==ltud_pb2.CmdRequest.INIT_OLTS:
      orc= self.tpnet.INIT_OLTS(req.cmd)
    elif req.cmdn==ltud_pb2.CmdRequest.INIT_ONUS:
      orc= self.tpnet.INIT_ONUS(req.cmd)
    elif req.cmdn==ltud_pb2.CmdRequest.FULLCAL:
      orc= self.tpnet.FULLCAL(req.cmd)
    elif req.cmdn==ltud_pb2.CmdRequest.HEALTH:
      orc= self.tpnet.HEALTH(req.cmd)
    elif req.cmdn==ltud_pb2.CmdRequest.LTUD_STATUS:
      orc= (0, "monsleep:{} montimestamp:{} ".format(self.monsleep,self.montimestamp))
    elif req.cmdn==ltud_pb2.CmdRequest.LTUD_INIT:
      self.runnumber(0)
      orc= self.fpga.fpgainit()
    else:
      orc=(1,"cmd %d not implemented in ltud yet"%req.cmdn)
    self.logger.info("Cmd:  {0}/{1} orc:{2}".format(req.cmdn,cmdname, str(orc)))
    #return(ltud_pb2.CmdReply(rc=orc[0], msg=orc[1])) nebavi
    #r= ltud_pb2.CmdReply(rc=orc[0], msg=orc[1])) nebavi
    r= ltud_pb2.CmdReply()
    r.rc= orc[0]
    r.msg=orc[1] # r.rc not seen in client if 0, otherwise ok
    return r
  def SetMode(self, req, context):
    sg= req.mode
    runn= req.runn
    print("%s mode:%d runn:%d"%(sys._getframe().f_code.co_name, sg,runn))
    self.logger.info("%s sg:%d runn:%d"%("SetMode:", sg, runn))
    rr= ltud_pb2.CmdReply()
    #if sg==ltud_pb2.SetModeRequest.Ltumode.STDALONE:
    if sg==ltud_pb2.Ltumode.STDALONE:
      # calculate AfterEOX-BeforeSOX counts at the end of global run
      # done before switch to stdalone (triggers are already stopped in ctpd)
      counts_report= self.outcnts.readRawxox('E')
      self.logger.info(counts_report)
      rr.rc,msg= self.fpga.setStdaloneMode()
      rr.msg= counts_report
    elif sg==ltud_pb2.Ltumode.GLOBAL:
      if runn==0:
        runn= self.GlobalNoRun   # runn not provided, ltud ON
      rr.rc,rr.msg= self.fpga.setGlobalMode(runn)
      counts_report= self.outcnts.readRawxox('S')
      self.logger.info(counts_report)
    elif sg==ltud_pb2.Ltumode.NULL:
      ltumode,msg= self.fpga.getMode()
      if msg=="":
        rr.rc= ltumode+1
        rr.msg= "current mode: "+ ("stdalone","global")[ltumode]
    else:
      rr.rc,rr.msg=(12,"SetMode, bad mode: {}".format(sg))
    print("rr.rc:{} rr.msg:{}".format(rr.rc,rr.msg))
    return rr
  def LtuStatus(self, req, context):
    print("%s %s"%(sys._getframe().f_code.co_name, self.getthreadid()))
    rr= ltud_pb2.LtuStatusReply()
    ltumode,ltumsg= self.fpga.getMode()   # 0,1 (ok, errmsg:"") 8: errmsg
    rr.msg= ltumsg
    dport= self.fpga.getDport()
    if dport==self.GlobalNoRun:
      rr.runn= 0
    else:
      rr.runn= dport
    if ltumode<=1:
      rr.mode= ltumode+1
    else:
      rr.mode= 0   # error found in ltu registers
    print("LtuStatus rc:{}. ".format(rr))
    return rr
  def runnumber(self, runn=None):
    """runn: None: return ctrl.pid_1
!=None:
0: set 0xffffffff (=self.GlobalNoRun) in ctrl.pid_1
[sg]etDport(): works with ctrl.pid_1 board register (see fpga.setDport())

N: stdalone or global run: set N in ctrl.pid_1 which keeps:
   -N loaded/started in CTP, this ltu is participating in the run
   -N standalone started on this ltu
0xffffffff and 0x0: -corresponds to run 0. 0:ltud OFF 0xffffffff: ltud ON
"""
    if runn!=None:
      if runn==0: runn= self.GlobalNoRun
      self.fpga.setDport(runn)
    else:
      runn= self.fpga.getDport()
      if runn==self.GlobalNoRun:
        runn= 0
      return runn
  def RunStatus(self, req, context):
    print("%s %s"%("RunStatus:", self.getthreadid()))
    # status..
    #print(req, dir(context))
    rr= ltud_pb2.RunReply()
    rr.rc= 0
    rr.msg="Active run: {}".format(self.runnumber())
    return rr
  def RunStart(self, req, context):
    print("%s %s"%("RunStart:", self.getthreadid()))
    reqrunn= req.runn
    # todo: apply default config:
    #pdb.set_trace()  
    rr= ltud_pb2.RunReply()
    self.logger.info("%s runn:%d"%("RunStart:", reqrunn))
    runnumber= self.runnumber()
    self.logger.info("%s runn:%d active:%d"%("RunStart:", reqrunn, runnumber))
    if runnumber != 0:
      rr.rc= 3
      rr.msg= "Run {0} already active.".format(runnumber)
      return rr 
    ltumode,rr.msg= self.fpga.getMode()
    if ltumode!=0:
      rr.rc= 4
      rr.msg= "Run {} cannot start, ltu not in stdalone mode.".format(reqrunn)
      return r 
    self.ctpemu.clearemu()
    rc= 0 ; emsg= None
    lines= req.config.split('\n')
    if len(lines)==0:
      print("no config")
    elif lines[0].find("consul")>=0:
      print("RunStart consul line[0]:{}:".format(lines[0]))
    #todo: consul or global config file read in
    else:   # direct config string
      for line in lines:
        if (len(line)>0) and (line[0]!='#'):
          print("RunsStart executing:{}:".format(line))
          rc= self.ctpemu.excmdBatch(["emu"]+line.split())
        else:
          continue
        if rc>0: 
          emsg= "Incorrect line: "+line
          break
    if rc>0:
      self.ctpemu.clearemu()
    else:
      # apply optional parameters and start run:
      fieldnames= [field.name for field in req.DESCRIPTOR.fields]
      print("ph_bc:",req.ph_bc)
      for par in fieldnames:
        if par in ("runn", "config"): continue
        val= eval("req.{0}".format(par))
        print("req.{0}:{1}".format(par, val))
        # apply... (if defined in request)
        if val:   # i.e. val!=0 and val!=""
          if par in ("ph_bc", "ph_rnd"):
            # todo: float val to int BCs
            cmd1= [{"ph_bc":"PH_bc", "ph_rnd":"PH_rnd"}[par], val, "inf"] 
          elif par=="detector":
            print("detector:{} val:{}".format(par,val))
            continue
          elif par=="mode":
            cmd1= [("null","trig","cont")[val]]
          else:
            rc=8;   # bad optional parameter
          if rc==0:
            rc= self.ctpemu.excmdBatch(["emu"]+cmd1)
            if rc>0: emsg= "error in cmd: emu "+string.join(cmd1)
      counts_report= self.outcnts.readRawxox('S')
      self.logger.info(counts_report)
      rcmsg= self.ctpemu.start()
      rc= rcmsg[0] ; emsg= rcmsg[1]
    # rc: 0, 4: run started, rc>8: run not started    emsg:!=None: warning or error message 
    rr.rc= rc
    if rc>4:
      if emsg==None:
        emsg= "Error when setting up CTPemu"
      rr.msg= emsg
    else:
      self.runnumber(reqrunn)
      if emsg==None or emsg=="": 
        rr.msg="Run {} started".format(self.runnumber())
      else:
        rr.msg="{}\nRun {} started".format(emsg,self.runnumber())
    return rr
  def RunStop(self, req, context):
    reqrunn= req.runn
    runactive= self.runnumber()
    print("{} {} run:{} activerun:{}".format("RunStop:", self.getthreadid(), 
      reqrunn, runactive))
    self.logger.info("%s runn:%d active:%d"%("RunStop:", reqrunn, runactive))
    rr= ltud_pb2.RunReply()
    ltumode,msg= self.fpga.getMode()
    if msg=="" and ltumode==1:   # global mode
      #rr.rc= ltumode+1
      rr.rc= 8
      rr.msg= "Current LTU mode: global, can't stop stdalone run {}".format(reqrunn)
    elif msg!="":
      rr.rc= 8
      rr.msg= "Cannot get current LTU mode to stop {}, active run: {}. {}".format(reqrunn,runactive, msg)
    elif reqrunn==0:   # forced stop (seems emu was started from qtltu/atb)
      print("RunStop forced...")
      self.ctpemu.stop()
      self.ctpemu.clearemu()
      self.runnumber(0)
      rr.rc= 0
      rr.msg= "RunStop forced for active run {}".format(runactive)
    else:
      print("RunStop {}, run active:{}".format(reqrunn, runactive))
      self.ctpemu.stop()
      # calculate AfterEOX-BeforeSOX counts for stdalone run
      counts_report= self.outcnts.readRawxox('E')
      self.logger.info(counts_report)
      self.ctpemu.clearemu()
      self.runnumber(0)
      if reqrunn!=runactive:
        rr.rc= 4
        rr.msg="Run {} stopped (but request for {})".format(runactive,reqrunn)
      else:
        rr.rc= 0
        rr.msg="ok. Run {} stopped".format(reqrunn)
      rr.msg= rr.msg+'\n'+counts_report
    return rr
  def RunConfig(self, req, context):
    print("%s %s"%("RunConfig:", self.getthreadid()))
    # stop run ...
    r= ltud_pb2.RunReply()
    if self.runnumber()>0:
      print("RunConfig:",req.runn)
      rr.msg= self.ctpemu.trigs_config()
      rr.rc= 0
    else:
      rr.rc= 8
      rr.msg="No active run, no action"
    return rr
  def MonCycle(self, req, context):
    rc= self.tpnet.measureSlow()
    self.montimestamp= rc[0]
    #print("MonCycle measureSlow rc:", rc)
    return ltud_pb2.Empty()
  def OutCntsGet(self, request, context):
    ocm= ltud_pb2.OutCntsReply()
    #for ix in range(7): ocm.outcnts.append(2**ix)
    oc=self.outcnts.readRaw(grpcreply=ocm)
    #print("OutCntsGet rc:",oc, ocm.timestamp)
    return ocm
  def OutCntsGetInc(self, request, context):
    ocm= ltud_pb2.OutCntsReply()
    #for ix in range(7): ocm.outcnts.append(2**ix)
    oc=self.outcnts.readInc(grpcreply=ocm)
    #print("OutCntsGet rc:",oc)
    return ocm
  def OutCntsGetNames(self, request, context):
    ocm= ltud_pb2.OutCntsNamesReply()
    self.outcnts.getnames(grpcreply=ocm)
    return ocm
  def Lock(self, req, context):
    """ From: awmtors onl
"""
    if (self.lockedfor!= None):   # and (req.user=="None"):
      #self.logger.warning("Lock from %s, but was locked for %s"%(req.user,self.lockedfor))
      print("Lock from %s, but was locked for %s"%(req.user,self.lockedfor))
      action= "lockother"
    else:
      self.lockedfor= req.user
      print("Lock by "+req.user)
      action= "lockme"
    return ltud_pb2.LockReply(lockaction=action)
  def Unlock(self, req, context):
    """ From: awmtors or ltud_client ("None" request)
"""
    if (req.user!= self.lockedfor) and (req.user!="None"):
      #self.logger.error("Unlock from %s, but was locked for %s"%(req.user,self.lockedfor))
      print("Unlock from %s, but was locked for %s"%(req.user,self.lockedfor))
      action= "lockother"
    else:
      if req.user=="None":
        # forced unlock request from ltud_client.
        # wsup-msg to awm from where sent further to all ws clients:
        orc= self.tpnet.awmc.forceunlock()
      print("Unlock by {} (was {}).".format(req.user, self.lockedfor))
      self.lockedfor= None
      action= "unlockme"
    return ltud_pb2.LockReply(lockaction=action)
  def TFOrbit(self, req, context):
    """ find TF Orbit number. Meaningfull only when LTU in global mode
so let's switch to global if not in global before measurement.
For quick usage, this service should be initiated in all ltuds in parallel
Operation:
if stdalone:
  if run active: 
    return (0,"Run %d active")
  else: 
    switch to global
orc= ddr3_lftf()
if was stdalone: switch to stdalone
return orc

rc: rc.msg:""   -rc.rc is TFOrbit measured in global
    rc.msg:!="" -rc.rc not valid (TFOrbit not measured)
"""
    rr= ltud_pb2.UintReply()
    ltumode,msg= self.fpga.getMode()
    if ltumode==0:   
      wasstdalone= True
      if self.ctpemu.emuactive():
        rr.rc= 0; rr.msg= "Run {} active".format(self.runnumber())
        return r
      else:
        orc= self.fpga.setGlobalMode(self.GlobalNoRun)
        if orc[0]!=0:
          rr.rc= 0; rr.msg= "Cannot set global mode"
          return r
    else:
      wasstdalone= False
    tfrc= self.tdg.ddr3_lftf()   # orbit, timest, msg
    if wasstdalone:
      orc= self.fpga.setStdaloneMode()
    if tfrc[0]==None:
      rr.rc= 0
    else:
      rr.rc= tfrc[0]
    rr.timestamp= tfrc[1]
    rr.msg=tfrc[2]
    return rr
  def _lock(self):
    #rc= fcntlflock.acquire("LTUd", -1)  does not work for threads
    #print("_lock:", rc)
    self.mutex.acquire()   # ok for threads
  def _unlock(self):
    #rc= fcntlflock.release("LTUd")
    #print("_unlock:", rc)
    self.mutex.release()
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
def Register_ctpd(netname):
    """ rc: >4: registration failed
"""
    #register myself in ctpd:
    ctpd= tri_grpcs.TRG_grpc("ctp")
    if ctpd.channel:
      print("CTPd ok")
      import ctpd_pb2
      import ctpd_pb2_grpc
      # following: status = StatusCode.UNIMPLEMENTED
      #            details = "Method not found!"
      # was caused by ctpd_pb2*.pyc files in ccm/ctpd/ ! (when removed ok)
      rc= 8; maxix= 1 ; ix= 1   # maxix>1: does not help
      try:
       while ix<=maxix:
        stubrc=ctpd.stub.LTUHello(ctpd_pb2.SRequest(name=netname))
        print("Register_ctpd {}. stubrc:{} msg:\n{}".format(ix, stubrc.rc, stubrc.msg))
        rc= stubrc.rc
        if stubrc.rc<=4: break
        time.sleep(1)
        ix= ix +1
      except:
        ix= maxix+1
      if ix>maxix:
        print("Cannot register with ctpd")
      # following ok:
      #rc=ctpd.stub.SayHello(ctpd_pb2.HelloRequest(name=netname))
      #print("Register_ctpd rc:{}\n{}".format(rc.message, rc.secs))
      ctpd.close()
    else:
      print("CTPd dead") ; rc= 12
    return rc
def monStub(server):
  threadid= threading.current_thread().getName()
  iloop= 0
  channel= grpc.insecure_channel('localhost:%d'%server.portn)
  if channel== None:
    print("monStub error.")
    return
  ltustub = ltud_pb2_grpc.LTUdStub(channel)
  while True:
    if server.finish: break
    iloop= iloop+1
    rc = ltustub.MonCycle(ltud_pb2.Empty())
    if (iloop<3) or ((iloop%100)==1):
      server.printN("monStub %d thread:%s rc:%s"%(iloop, str(threadid), str(rc)))
    time.sleep(server.monsleep)
  print("monStub finishing...")
def serve():
  global server
  netname= auxfuns.getarg1()
  if netname=="":
    print("""
ltud netname [start | kill ] [init] [mon] [dummy]
where:
netname  $CTP3_CONFIG_DIRECTORY/nets/netname.net
         must exist. One of: {0} 
start
kill     kill running daemon (to be used only in case 'ltudc netname qs'
         does not work)

init     initialise the net (master board(PLL)+INIT_OLTS)
         Without this, ttcpon net is expected to be active
mon      start monitoring thread in addition to the ltud thread
dummy    no ipbus operation (only .net file read + monitor operation).
         requires:   
         /opt/cactus/bin/uhal/tests/DummyHardwareTcp.exe -p 50003 -v 2 &
         and
         a master board in .net file must be defined in alice_cf.xml as:
         <connection id="dummyhw" uri="ipbustcp-2.0://localhost:50003" address_table="file://minimal.xml"/>

""".format(str(tri_grpcs.grpc_channels.keys())))
    return
  # LTUd() instantiated here once when server starts
  startserver= False
  init= None
  dummy= False
  for iarg in range(2, len(sys.argv)):
    arg= sys.argv[iarg]
    if arg == "start":
      if iarg!=2: 
        print("start allowed only after netname")
      else:
        startserver= True
    elif arg == "init":
      init= "init"
    elif arg == "dummy":
      dummy= True
    elif arg == "mon":
      pass
    else:
      print("Bad arg:", arg)
      return
  #if auxfuns.isinargs("init"): init= "init"
  #if auxfuns.isinargs("dummy"): dummy= True
  if netname in tri_grpcs.grpc_channels:
    portn= tri_grpcs.grpc_channels[netname]
  else:
    print("Unknown netname (not in tri_grpcs.grpc_channels):%s"%netname)
    return
  # check if portn already taken:
  rc= tri_grpcs.checkport(portn)
  if len(rc)>0:
    print("ltud for %s already active.\n%s"%(netname,rc))
    return
  ltuserver= LTUd(netname, init, dummy)
  if ltuserver.finish:
    print("ltud not started.", ltuserver.finish)
    return
  portn= ltuserver.portn
  max_workers= 1  # we use this, i.e. _lock/_unlock of ATB resources not involved
  if max_workers>1:
    print("grpc.server,max.workers:%d. LTUd class is not written for such case, exiting."%max_workers)
    return
  server= grpc.server(futures.ThreadPoolExecutor(max_workers=max_workers))
  #print("grpc.server add...")
  ltud_pb2_grpc.add_LTUdServicer_to_server(ltuserver, server)
  SERVICE_NAMES= (
    ltud_pb2.DESCRIPTOR.services_by_name['LTUd'].full_name,
    reflection.SERVICE_NAME,
  )
  reflection.enable_server_reflection(SERVICE_NAMES, server)
  try:
    server.add_insecure_port('[::]:%d'%portn)
    #print("rc:",rc)
  except:
    print("Can't bind to %d"%portn)
    return
  #server.start()
  mon_t= None
  if startserver==False: return
  try:
    server.start()
    print("server [::]:%d started."%portn)
    if auxfuns.isinargs("mon"):
      # optionA: using max_workers>=1 with _lock/_unlock 
      #mon_t= threading.Thread(target= monThread, args=(ltuserver,), name= "mon_t")
      # optionB: max_workers:1, no _lock/_unlock
      mon_t= threading.Thread(target= monStub, args=(ltuserver,), name= "mon_t")
      print("Starting mon_t...")
      ltuserver.logger.info("Starting mon_t...")
      # Note: measureConfig already done (when server instantiated).
      mon_t.start()
    #for ix in range(60):
    #  print("checport({}) rc:{}".format(portn, tri_grpcs.checkport(portn)))
    #  #ok from very 1st check.
    #  time.sleep(0.1)   # allow ltud to start
    ix=1 ; maxix= 3
    while ix<=maxix:
      rc= Register_ctpd(netname)
      if rc<=4:break
      ix= ix+1
    if ix>maxix:
      print("Can't register with ctpd")
    ixmon= 0
    while True:
      #time.sleep(_ONE_DAY_IN_SECONDS) -instead of wait, monitor if mon_t is active:
      time.sleep(ltuserver.monsleep*3)
      ixmon= ixmon+1
      if (mon_t!= None):
        montalive= mon_t.isAlive()
        if not montalive:
          print("mon_t isAlive():False")
          if ixmon>3:
            ltuserver.finish= "monitoring test failed too many times."
  #except KeyboardInterrupt:
  except:
    print("Error:"+str(sys.exc_info()))
    traceback.print_exc(file=sys.stdout)
    server.stop(0)
if __name__ == '__main__':
  auxfuns.cdworkdir()
  #logging.basicConfig()
  serve()
