#!/usr/bin/python3
import grpc

import ltud_pb2 as ltud__pb2


class LTUdStub(object):
  """option java_multiple_files = true;
  option java_package = "io.grpc.examples.helloworld";
  option java_outer_classname = "HelloWorldProto";
  option objc_class_prefix = "HLW";

  package ltud;  ignorovane v pythone

  Service definition.
  """

  def __init__(self, channel):
    """Constructor.

    Args:
      channel: A grpc.Channel.
    """
    self.SayHello = channel.unary_unary(
        '/LTUd/SayHello',
        request_serializer=ltud__pb2.HelloRequest.SerializeToString,
        response_deserializer=ltud__pb2.HelloReply.FromString,
        )
    self.StreamResp = channel.unary_stream(
        '/LTUd/StreamResp',
        request_serializer=ltud__pb2.Empty.SerializeToString,
        response_deserializer=ltud__pb2.HelloReply.FromString,
        )
    self.Stop = channel.unary_unary(
        '/LTUd/Stop',
        request_serializer=ltud__pb2.Empty.SerializeToString,
        response_deserializer=ltud__pb2.HelloReply.FromString,
        )
    self.Sleep = channel.unary_unary(
        '/LTUd/Sleep',
        request_serializer=ltud__pb2.HelloRequest.SerializeToString,
        response_deserializer=ltud__pb2.HelloReply.FromString,
        )
    self.Cmd = channel.unary_unary(
        '/LTUd/Cmd',
        request_serializer=ltud__pb2.CmdRequest.SerializeToString,
        response_deserializer=ltud__pb2.CmdReply.FromString,
        )
    self.MonCycle = channel.unary_unary(
        '/LTUd/MonCycle',
        request_serializer=ltud__pb2.Empty.SerializeToString,
        response_deserializer=ltud__pb2.Empty.FromString,
        )
    self.Status = channel.unary_unary(
        '/LTUd/Status',
        request_serializer=ltud__pb2.Empty.SerializeToString,
        response_deserializer=ltud__pb2.StatusReply.FromString,
        )
    self.Health = channel.unary_unary(
        '/LTUd/Health',
        request_serializer=ltud__pb2.Empty.SerializeToString,
        response_deserializer=ltud__pb2.HealthReply.FromString,
        )
    self.OutCntsGet = channel.unary_unary(
        '/LTUd/OutCntsGet',
        request_serializer=ltud__pb2.Empty.SerializeToString,
        response_deserializer=ltud__pb2.OutCntsReply.FromString,
        )
    self.OutCntsGetInc = channel.unary_unary(
        '/LTUd/OutCntsGetInc',
        request_serializer=ltud__pb2.Empty.SerializeToString,
        response_deserializer=ltud__pb2.OutCntsReply.FromString,
        )
    self.OutCntsGetNames = channel.unary_unary(
        '/LTUd/OutCntsGetNames',
        request_serializer=ltud__pb2.Empty.SerializeToString,
        response_deserializer=ltud__pb2.OutCntsNamesReply.FromString,
        )
    self.Lock = channel.unary_unary(
        '/LTUd/Lock',
        request_serializer=ltud__pb2.LockRequest.SerializeToString,
        response_deserializer=ltud__pb2.LockReply.FromString,
        )
    self.Unlock = channel.unary_unary(
        '/LTUd/Unlock',
        request_serializer=ltud__pb2.LockRequest.SerializeToString,
        response_deserializer=ltud__pb2.LockReply.FromString,
        )
    self.RunStatus = channel.unary_unary(
        '/LTUd/RunStatus',
        request_serializer=ltud__pb2.Empty.SerializeToString,
        response_deserializer=ltud__pb2.RunReply.FromString,
        )
    self.RunStart = channel.unary_unary(
        '/LTUd/RunStart',
        request_serializer=ltud__pb2.RunStartRequest.SerializeToString,
        response_deserializer=ltud__pb2.RunReply.FromString,
        )
    self.RunStop = channel.unary_unary(
        '/LTUd/RunStop',
        request_serializer=ltud__pb2.RunStopRequest.SerializeToString,
        response_deserializer=ltud__pb2.RunReply.FromString,
        )
    self.RunConfig = channel.unary_unary(
        '/LTUd/RunConfig',
        request_serializer=ltud__pb2.RunStopRequest.SerializeToString,
        response_deserializer=ltud__pb2.RunReply.FromString,
        )


class LTUdServicer(object):
  """option java_multiple_files = true;
  option java_package = "io.grpc.examples.helloworld";
  option java_outer_classname = "HelloWorldProto";
  option objc_class_prefix = "HLW";

  package ltud;  ignorovane v pythone

  Service definition.
  """

  def SayHello(self, request, context):
    """debug/development services:
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def StreamResp(self, request, context):
    # missing associated documentation comment in .proto file
    pass
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def Stop(self, request, context):
    # missing associated documentation comment in .proto file
    pass
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def Sleep(self, request, context):
    # missing associated documentation comment in .proto file
    pass
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def Cmd(self, request, context):
    # missing associated documentation comment in .proto file
    pass
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def MonCycle(self, request, context):
    # missing associated documentation comment in .proto file
    pass
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def Status(self, request, context):
    """Status: ctpd/ltud, i.e. reading only master ATB board (OLTs)? 
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def Health(self, request, context):
    """health: ltud only(i.e. for CRUs). 
    If ctpd, the TTCPON slow control functions not used, suggestion:
    - slow control used only for CRUs
    - LTUs monitored directly by ltud, remote SLC from CTP not used
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def OutCntsGet(self, request, context):
    """ttcpon raw counters:
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def OutCntsGetInc(self, request, context):
    """ttcpon raw counters increments from last reading:
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def OutCntsGetNames(self, request, context):
    # missing associated documentation comment in .proto file
    pass
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def Lock(self, request, context):
    """
    Lock/Unlock a master board driver all ttcpon nets (from awmtors)
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def Unlock(self, request, context):
    # missing associated documentation comment in .proto file
    pass
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def RunStatus(self, request, context):
    """
    ECS services:
    """
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def RunStart(self, request, context):
    # missing associated documentation comment in .proto file
    pass
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def RunStop(self, request, context):
    # missing associated documentation comment in .proto file
    pass
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')

  def RunConfig(self, request, context):
    # missing associated documentation comment in .proto file
    pass
    context.set_code(grpc.StatusCode.UNIMPLEMENTED)
    context.set_details('Method not implemented!')
    raise NotImplementedError('Method not implemented!')


def add_LTUdServicer_to_server(servicer, server):
  rpc_method_handlers = {
      'SayHello': grpc.unary_unary_rpc_method_handler(
          servicer.SayHello,
          request_deserializer=ltud__pb2.HelloRequest.FromString,
          response_serializer=ltud__pb2.HelloReply.SerializeToString,
      ),
      'StreamResp': grpc.unary_stream_rpc_method_handler(
          servicer.StreamResp,
          request_deserializer=ltud__pb2.Empty.FromString,
          response_serializer=ltud__pb2.HelloReply.SerializeToString,
      ),
      'Stop': grpc.unary_unary_rpc_method_handler(
          servicer.Stop,
          request_deserializer=ltud__pb2.Empty.FromString,
          response_serializer=ltud__pb2.HelloReply.SerializeToString,
      ),
      'Sleep': grpc.unary_unary_rpc_method_handler(
          servicer.Sleep,
          request_deserializer=ltud__pb2.HelloRequest.FromString,
          response_serializer=ltud__pb2.HelloReply.SerializeToString,
      ),
      'Cmd': grpc.unary_unary_rpc_method_handler(
          servicer.Cmd,
          request_deserializer=ltud__pb2.CmdRequest.FromString,
          response_serializer=ltud__pb2.CmdReply.SerializeToString,
      ),
      'MonCycle': grpc.unary_unary_rpc_method_handler(
          servicer.MonCycle,
          request_deserializer=ltud__pb2.Empty.FromString,
          response_serializer=ltud__pb2.Empty.SerializeToString,
      ),
      'Status': grpc.unary_unary_rpc_method_handler(
          servicer.Status,
          request_deserializer=ltud__pb2.Empty.FromString,
          response_serializer=ltud__pb2.StatusReply.SerializeToString,
      ),
      'Health': grpc.unary_unary_rpc_method_handler(
          servicer.Health,
          request_deserializer=ltud__pb2.Empty.FromString,
          response_serializer=ltud__pb2.HealthReply.SerializeToString,
      ),
      'OutCntsGet': grpc.unary_unary_rpc_method_handler(
          servicer.OutCntsGet,
          request_deserializer=ltud__pb2.Empty.FromString,
          response_serializer=ltud__pb2.OutCntsReply.SerializeToString,
      ),
      'OutCntsGetInc': grpc.unary_unary_rpc_method_handler(
          servicer.OutCntsGetInc,
          request_deserializer=ltud__pb2.Empty.FromString,
          response_serializer=ltud__pb2.OutCntsReply.SerializeToString,
      ),
      'OutCntsGetNames': grpc.unary_unary_rpc_method_handler(
          servicer.OutCntsGetNames,
          request_deserializer=ltud__pb2.Empty.FromString,
          response_serializer=ltud__pb2.OutCntsNamesReply.SerializeToString,
      ),
      'Lock': grpc.unary_unary_rpc_method_handler(
          servicer.Lock,
          request_deserializer=ltud__pb2.LockRequest.FromString,
          response_serializer=ltud__pb2.LockReply.SerializeToString,
      ),
      'Unlock': grpc.unary_unary_rpc_method_handler(
          servicer.Unlock,
          request_deserializer=ltud__pb2.LockRequest.FromString,
          response_serializer=ltud__pb2.LockReply.SerializeToString,
      ),
      'RunStatus': grpc.unary_unary_rpc_method_handler(
          servicer.RunStatus,
          request_deserializer=ltud__pb2.Empty.FromString,
          response_serializer=ltud__pb2.RunReply.SerializeToString,
      ),
      'RunStart': grpc.unary_unary_rpc_method_handler(
          servicer.RunStart,
          request_deserializer=ltud__pb2.RunStartRequest.FromString,
          response_serializer=ltud__pb2.RunReply.SerializeToString,
      ),
      'RunStop': grpc.unary_unary_rpc_method_handler(
          servicer.RunStop,
          request_deserializer=ltud__pb2.RunStopRequest.FromString,
          response_serializer=ltud__pb2.RunReply.SerializeToString,
      ),
      'RunConfig': grpc.unary_unary_rpc_method_handler(
          servicer.RunConfig,
          request_deserializer=ltud__pb2.RunStopRequest.FromString,
          response_serializer=ltud__pb2.RunReply.SerializeToString,
      ),
  }
  generic_handler = grpc.method_handlers_generic_handler(
      'LTUd', rpc_method_handlers)
  server.add_generic_rpc_handlers((generic_handler,))
