#!/usr/bin/python3
"""Client and server classes corresponding to protobuf-defined services."""
import grpc

import ltud_pb2 as ltud__pb2


class LTUdStub(object):
    """Service definition.
    """

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.SetMode = channel.unary_unary(
                '/ltud.LTUd/SetMode',
                request_serializer=ltud__pb2.SetModeRequest.SerializeToString,
                response_deserializer=ltud__pb2.CmdReply.FromString,
                )
        self.SayHello = channel.unary_unary(
                '/ltud.LTUd/SayHello',
                request_serializer=ltud__pb2.HelloRequest.SerializeToString,
                response_deserializer=ltud__pb2.HelloReply.FromString,
                )
        self.StreamResp = channel.unary_stream(
                '/ltud.LTUd/StreamResp',
                request_serializer=ltud__pb2.Empty.SerializeToString,
                response_deserializer=ltud__pb2.HelloReply.FromString,
                )
        self.Stop = channel.unary_unary(
                '/ltud.LTUd/Stop',
                request_serializer=ltud__pb2.Empty.SerializeToString,
                response_deserializer=ltud__pb2.HelloReply.FromString,
                )
        self.Sleep = channel.unary_unary(
                '/ltud.LTUd/Sleep',
                request_serializer=ltud__pb2.HelloRequest.SerializeToString,
                response_deserializer=ltud__pb2.HelloReply.FromString,
                )
        self.Cmd = channel.unary_unary(
                '/ltud.LTUd/Cmd',
                request_serializer=ltud__pb2.CmdRequest.SerializeToString,
                response_deserializer=ltud__pb2.CmdReply.FromString,
                )
        self.MonCycle = channel.unary_unary(
                '/ltud.LTUd/MonCycle',
                request_serializer=ltud__pb2.Empty.SerializeToString,
                response_deserializer=ltud__pb2.Empty.FromString,
                )
        self.LtuStatus = channel.unary_unary(
                '/ltud.LTUd/LtuStatus',
                request_serializer=ltud__pb2.Empty.SerializeToString,
                response_deserializer=ltud__pb2.LtuStatusReply.FromString,
                )
        self.Health = channel.unary_unary(
                '/ltud.LTUd/Health',
                request_serializer=ltud__pb2.Empty.SerializeToString,
                response_deserializer=ltud__pb2.HealthReply.FromString,
                )
        self.TFOrbit = channel.unary_unary(
                '/ltud.LTUd/TFOrbit',
                request_serializer=ltud__pb2.Empty.SerializeToString,
                response_deserializer=ltud__pb2.UintReply.FromString,
                )
        self.OutCntsGet = channel.unary_unary(
                '/ltud.LTUd/OutCntsGet',
                request_serializer=ltud__pb2.Empty.SerializeToString,
                response_deserializer=ltud__pb2.OutCntsReply.FromString,
                )
        self.OutCntsGetInc = channel.unary_unary(
                '/ltud.LTUd/OutCntsGetInc',
                request_serializer=ltud__pb2.Empty.SerializeToString,
                response_deserializer=ltud__pb2.OutCntsReply.FromString,
                )
        self.OutCntsGetNames = channel.unary_unary(
                '/ltud.LTUd/OutCntsGetNames',
                request_serializer=ltud__pb2.Empty.SerializeToString,
                response_deserializer=ltud__pb2.OutCntsNamesReply.FromString,
                )
        self.Lock = channel.unary_unary(
                '/ltud.LTUd/Lock',
                request_serializer=ltud__pb2.LockRequest.SerializeToString,
                response_deserializer=ltud__pb2.LockReply.FromString,
                )
        self.Unlock = channel.unary_unary(
                '/ltud.LTUd/Unlock',
                request_serializer=ltud__pb2.LockRequest.SerializeToString,
                response_deserializer=ltud__pb2.LockReply.FromString,
                )
        self.RunStatus = channel.unary_unary(
                '/ltud.LTUd/RunStatus',
                request_serializer=ltud__pb2.RunStatusRequest.SerializeToString,
                response_deserializer=ltud__pb2.RunReply.FromString,
                )
        self.RunStart = channel.unary_unary(
                '/ltud.LTUd/RunStart',
                request_serializer=ltud__pb2.RunStartRequest.SerializeToString,
                response_deserializer=ltud__pb2.RunReply.FromString,
                )
        self.RunStop = channel.unary_unary(
                '/ltud.LTUd/RunStop',
                request_serializer=ltud__pb2.RunStopRequest.SerializeToString,
                response_deserializer=ltud__pb2.RunReply.FromString,
                )
        self.RunConfig = channel.unary_unary(
                '/ltud.LTUd/RunConfig',
                request_serializer=ltud__pb2.RunStopRequest.SerializeToString,
                response_deserializer=ltud__pb2.RunReply.FromString,
                )


class LTUdServicer(object):
    """Service definition.
    """

    def SetMode(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def SayHello(self, request, context):
        """debug/development services:
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def StreamResp(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def Stop(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def Sleep(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def Cmd(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def MonCycle(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def LtuStatus(self, request, context):
        """Status: ctpd/ltud, i.e. reading only master ATB board (OLTs)? 
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def Health(self, request, context):
        """health: ltud only(i.e. for CRUs). 
        If ctpd, the TTCPON slow control functions not used, suggestion:
        - slow control used only for CRUs
        - LTUs monitored directly by ltud, remote SLC from CTP not used
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def TFOrbit(self, request, context):
        """get an orbit number of a TF (used to check if all dets in global TF in sync)
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def OutCntsGet(self, request, context):
        """ttcpon raw counters:
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def OutCntsGetInc(self, request, context):
        """ttcpon raw counters increments from last reading:
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def OutCntsGetNames(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def Lock(self, request, context):
        """
        Lock/Unlock a master board driver all ttcpon nets (from awmtors)
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def Unlock(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def RunStatus(self, request, context):
        """
        ECS services used by ctpd:
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def RunStart(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def RunStop(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def RunConfig(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')


def add_LTUdServicer_to_server(servicer, server):
    rpc_method_handlers = {
            'SetMode': grpc.unary_unary_rpc_method_handler(
                    servicer.SetMode,
                    request_deserializer=ltud__pb2.SetModeRequest.FromString,
                    response_serializer=ltud__pb2.CmdReply.SerializeToString,
            ),
            'SayHello': grpc.unary_unary_rpc_method_handler(
                    servicer.SayHello,
                    request_deserializer=ltud__pb2.HelloRequest.FromString,
                    response_serializer=ltud__pb2.HelloReply.SerializeToString,
            ),
            'StreamResp': grpc.unary_stream_rpc_method_handler(
                    servicer.StreamResp,
                    request_deserializer=ltud__pb2.Empty.FromString,
                    response_serializer=ltud__pb2.HelloReply.SerializeToString,
            ),
            'Stop': grpc.unary_unary_rpc_method_handler(
                    servicer.Stop,
                    request_deserializer=ltud__pb2.Empty.FromString,
                    response_serializer=ltud__pb2.HelloReply.SerializeToString,
            ),
            'Sleep': grpc.unary_unary_rpc_method_handler(
                    servicer.Sleep,
                    request_deserializer=ltud__pb2.HelloRequest.FromString,
                    response_serializer=ltud__pb2.HelloReply.SerializeToString,
            ),
            'Cmd': grpc.unary_unary_rpc_method_handler(
                    servicer.Cmd,
                    request_deserializer=ltud__pb2.CmdRequest.FromString,
                    response_serializer=ltud__pb2.CmdReply.SerializeToString,
            ),
            'MonCycle': grpc.unary_unary_rpc_method_handler(
                    servicer.MonCycle,
                    request_deserializer=ltud__pb2.Empty.FromString,
                    response_serializer=ltud__pb2.Empty.SerializeToString,
            ),
            'LtuStatus': grpc.unary_unary_rpc_method_handler(
                    servicer.LtuStatus,
                    request_deserializer=ltud__pb2.Empty.FromString,
                    response_serializer=ltud__pb2.LtuStatusReply.SerializeToString,
            ),
            'Health': grpc.unary_unary_rpc_method_handler(
                    servicer.Health,
                    request_deserializer=ltud__pb2.Empty.FromString,
                    response_serializer=ltud__pb2.HealthReply.SerializeToString,
            ),
            'TFOrbit': grpc.unary_unary_rpc_method_handler(
                    servicer.TFOrbit,
                    request_deserializer=ltud__pb2.Empty.FromString,
                    response_serializer=ltud__pb2.UintReply.SerializeToString,
            ),
            'OutCntsGet': grpc.unary_unary_rpc_method_handler(
                    servicer.OutCntsGet,
                    request_deserializer=ltud__pb2.Empty.FromString,
                    response_serializer=ltud__pb2.OutCntsReply.SerializeToString,
            ),
            'OutCntsGetInc': grpc.unary_unary_rpc_method_handler(
                    servicer.OutCntsGetInc,
                    request_deserializer=ltud__pb2.Empty.FromString,
                    response_serializer=ltud__pb2.OutCntsReply.SerializeToString,
            ),
            'OutCntsGetNames': grpc.unary_unary_rpc_method_handler(
                    servicer.OutCntsGetNames,
                    request_deserializer=ltud__pb2.Empty.FromString,
                    response_serializer=ltud__pb2.OutCntsNamesReply.SerializeToString,
            ),
            'Lock': grpc.unary_unary_rpc_method_handler(
                    servicer.Lock,
                    request_deserializer=ltud__pb2.LockRequest.FromString,
                    response_serializer=ltud__pb2.LockReply.SerializeToString,
            ),
            'Unlock': grpc.unary_unary_rpc_method_handler(
                    servicer.Unlock,
                    request_deserializer=ltud__pb2.LockRequest.FromString,
                    response_serializer=ltud__pb2.LockReply.SerializeToString,
            ),
            'RunStatus': grpc.unary_unary_rpc_method_handler(
                    servicer.RunStatus,
                    request_deserializer=ltud__pb2.RunStatusRequest.FromString,
                    response_serializer=ltud__pb2.RunReply.SerializeToString,
            ),
            'RunStart': grpc.unary_unary_rpc_method_handler(
                    servicer.RunStart,
                    request_deserializer=ltud__pb2.RunStartRequest.FromString,
                    response_serializer=ltud__pb2.RunReply.SerializeToString,
            ),
            'RunStop': grpc.unary_unary_rpc_method_handler(
                    servicer.RunStop,
                    request_deserializer=ltud__pb2.RunStopRequest.FromString,
                    response_serializer=ltud__pb2.RunReply.SerializeToString,
            ),
            'RunConfig': grpc.unary_unary_rpc_method_handler(
                    servicer.RunConfig,
                    request_deserializer=ltud__pb2.RunStopRequest.FromString,
                    response_serializer=ltud__pb2.RunReply.SerializeToString,
            ),
    }
    generic_handler = grpc.method_handlers_generic_handler(
            'ltud.LTUd', rpc_method_handlers)
    server.add_generic_rpc_handlers((generic_handler,))


 # This class is part of an EXPERIMENTAL API.
class LTUd(object):
    """Service definition.
    """

    @staticmethod
    def SetMode(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ltud.LTUd/SetMode',
            ltud__pb2.SetModeRequest.SerializeToString,
            ltud__pb2.CmdReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def SayHello(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ltud.LTUd/SayHello',
            ltud__pb2.HelloRequest.SerializeToString,
            ltud__pb2.HelloReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def StreamResp(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_stream(request, target, '/ltud.LTUd/StreamResp',
            ltud__pb2.Empty.SerializeToString,
            ltud__pb2.HelloReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def Stop(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ltud.LTUd/Stop',
            ltud__pb2.Empty.SerializeToString,
            ltud__pb2.HelloReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def Sleep(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ltud.LTUd/Sleep',
            ltud__pb2.HelloRequest.SerializeToString,
            ltud__pb2.HelloReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def Cmd(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ltud.LTUd/Cmd',
            ltud__pb2.CmdRequest.SerializeToString,
            ltud__pb2.CmdReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def MonCycle(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ltud.LTUd/MonCycle',
            ltud__pb2.Empty.SerializeToString,
            ltud__pb2.Empty.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def LtuStatus(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ltud.LTUd/LtuStatus',
            ltud__pb2.Empty.SerializeToString,
            ltud__pb2.LtuStatusReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def Health(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ltud.LTUd/Health',
            ltud__pb2.Empty.SerializeToString,
            ltud__pb2.HealthReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def TFOrbit(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ltud.LTUd/TFOrbit',
            ltud__pb2.Empty.SerializeToString,
            ltud__pb2.UintReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def OutCntsGet(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ltud.LTUd/OutCntsGet',
            ltud__pb2.Empty.SerializeToString,
            ltud__pb2.OutCntsReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def OutCntsGetInc(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ltud.LTUd/OutCntsGetInc',
            ltud__pb2.Empty.SerializeToString,
            ltud__pb2.OutCntsReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def OutCntsGetNames(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ltud.LTUd/OutCntsGetNames',
            ltud__pb2.Empty.SerializeToString,
            ltud__pb2.OutCntsNamesReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def Lock(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ltud.LTUd/Lock',
            ltud__pb2.LockRequest.SerializeToString,
            ltud__pb2.LockReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def Unlock(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ltud.LTUd/Unlock',
            ltud__pb2.LockRequest.SerializeToString,
            ltud__pb2.LockReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def RunStatus(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ltud.LTUd/RunStatus',
            ltud__pb2.RunStatusRequest.SerializeToString,
            ltud__pb2.RunReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def RunStart(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ltud.LTUd/RunStart',
            ltud__pb2.RunStartRequest.SerializeToString,
            ltud__pb2.RunReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def RunStop(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ltud.LTUd/RunStop',
            ltud__pb2.RunStopRequest.SerializeToString,
            ltud__pb2.RunReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def RunConfig(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ltud.LTUd/RunConfig',
            ltud__pb2.RunStopRequest.SerializeToString,
            ltud__pb2.RunReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)
