#!/usr/bin/python3
"""Client and server classes corresponding to protobuf-defined services."""
import grpc

import ctpd_pb2 as ctpd__pb2


class CTPdStub(object):
    """Service definition.
    """

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.SayHello = channel.unary_unary(
                '/ctpd.CTPd/SayHello',
                request_serializer=ctpd__pb2.HelloRequest.SerializeToString,
                response_deserializer=ctpd__pb2.HelloReply.FromString,
                )
        self.Stop = channel.unary_unary(
                '/ctpd.CTPd/Stop',
                request_serializer=ctpd__pb2.Empty.SerializeToString,
                response_deserializer=ctpd__pb2.HelloReply.FromString,
                )
        self.Sleep = channel.unary_unary(
                '/ctpd.CTPd/Sleep',
                request_serializer=ctpd__pb2.HelloRequest.SerializeToString,
                response_deserializer=ctpd__pb2.HelloReply.FromString,
                )
        self.MonCycle = channel.unary_unary(
                '/ctpd.CTPd/MonCycle',
                request_serializer=ctpd__pb2.Empty.SerializeToString,
                response_deserializer=ctpd__pb2.Empty.FromString,
                )
        self.Status = channel.unary_unary(
                '/ctpd.CTPd/Status',
                request_serializer=ctpd__pb2.Empty.SerializeToString,
                response_deserializer=ctpd__pb2.SReply.FromString,
                )
        self.LTUHello = channel.unary_unary(
                '/ctpd.CTPd/LTUHello',
                request_serializer=ctpd__pb2.SRequest.SerializeToString,
                response_deserializer=ctpd__pb2.SReply.FromString,
                )
        self.Lock = channel.unary_unary(
                '/ctpd.CTPd/Lock',
                request_serializer=ctpd__pb2.LockRequest.SerializeToString,
                response_deserializer=ctpd__pb2.LockReply.FromString,
                )
        self.Unlock = channel.unary_unary(
                '/ctpd.CTPd/Unlock',
                request_serializer=ctpd__pb2.LockRequest.SerializeToString,
                response_deserializer=ctpd__pb2.LockReply.FromString,
                )
        self.RunStatus = channel.unary_unary(
                '/ctpd.CTPd/RunStatus',
                request_serializer=ctpd__pb2.RunStatusRequest.SerializeToString,
                response_deserializer=ctpd__pb2.RunReply.FromString,
                )
        self.RunList = channel.unary_unary(
                '/ctpd.CTPd/RunList',
                request_serializer=ctpd__pb2.Empty.SerializeToString,
                response_deserializer=ctpd__pb2.RunReply.FromString,
                )
        self.RunStart = channel.unary_unary(
                '/ctpd.CTPd/RunStart',
                request_serializer=ctpd__pb2.RunStartRequest.SerializeToString,
                response_deserializer=ctpd__pb2.RunReply.FromString,
                )
        self.RunStop = channel.unary_unary(
                '/ctpd.CTPd/RunStop',
                request_serializer=ctpd__pb2.RunStopRequest.SerializeToString,
                response_deserializer=ctpd__pb2.RunReply.FromString,
                )
        self.RunConfig = channel.unary_unary(
                '/ctpd.CTPd/RunConfig',
                request_serializer=ctpd__pb2.RunStopRequest.SerializeToString,
                response_deserializer=ctpd__pb2.RunReply.FromString,
                )
        self.RunLoad = channel.unary_unary(
                '/ctpd.CTPd/RunLoad',
                request_serializer=ctpd__pb2.RunLoadRequest.SerializeToString,
                response_deserializer=ctpd__pb2.RunReply.FromString,
                )


class CTPdServicer(object):
    """Service definition.
    """

    def SayHello(self, request, context):
        """- throw out unnecessary in following lines:
        debug/development services:
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def Stop(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def Sleep(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def MonCycle(self, request, context):
        """rpc Cmd (CmdRequest) returns (CmdReply) {}   
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def Status(self, request, context):
        """Status: of all LTUs
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def LTUHello(self, request, context):
        """Accept hello message when an LTU becomes alive
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def Lock(self, request, context):
        """Lock/Unlock a master board driver all ttcpon nets (from awmtors)
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def Unlock(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def RunStatus(self, request, context):
        """
        ECS services (stdalone and global):
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def RunList(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def RunStart(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def RunStop(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def RunConfig(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def RunLoad(self, request, context):
        """global run:
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')


def add_CTPdServicer_to_server(servicer, server):
    rpc_method_handlers = {
            'SayHello': grpc.unary_unary_rpc_method_handler(
                    servicer.SayHello,
                    request_deserializer=ctpd__pb2.HelloRequest.FromString,
                    response_serializer=ctpd__pb2.HelloReply.SerializeToString,
            ),
            'Stop': grpc.unary_unary_rpc_method_handler(
                    servicer.Stop,
                    request_deserializer=ctpd__pb2.Empty.FromString,
                    response_serializer=ctpd__pb2.HelloReply.SerializeToString,
            ),
            'Sleep': grpc.unary_unary_rpc_method_handler(
                    servicer.Sleep,
                    request_deserializer=ctpd__pb2.HelloRequest.FromString,
                    response_serializer=ctpd__pb2.HelloReply.SerializeToString,
            ),
            'MonCycle': grpc.unary_unary_rpc_method_handler(
                    servicer.MonCycle,
                    request_deserializer=ctpd__pb2.Empty.FromString,
                    response_serializer=ctpd__pb2.Empty.SerializeToString,
            ),
            'Status': grpc.unary_unary_rpc_method_handler(
                    servicer.Status,
                    request_deserializer=ctpd__pb2.Empty.FromString,
                    response_serializer=ctpd__pb2.SReply.SerializeToString,
            ),
            'LTUHello': grpc.unary_unary_rpc_method_handler(
                    servicer.LTUHello,
                    request_deserializer=ctpd__pb2.SRequest.FromString,
                    response_serializer=ctpd__pb2.SReply.SerializeToString,
            ),
            'Lock': grpc.unary_unary_rpc_method_handler(
                    servicer.Lock,
                    request_deserializer=ctpd__pb2.LockRequest.FromString,
                    response_serializer=ctpd__pb2.LockReply.SerializeToString,
            ),
            'Unlock': grpc.unary_unary_rpc_method_handler(
                    servicer.Unlock,
                    request_deserializer=ctpd__pb2.LockRequest.FromString,
                    response_serializer=ctpd__pb2.LockReply.SerializeToString,
            ),
            'RunStatus': grpc.unary_unary_rpc_method_handler(
                    servicer.RunStatus,
                    request_deserializer=ctpd__pb2.RunStatusRequest.FromString,
                    response_serializer=ctpd__pb2.RunReply.SerializeToString,
            ),
            'RunList': grpc.unary_unary_rpc_method_handler(
                    servicer.RunList,
                    request_deserializer=ctpd__pb2.Empty.FromString,
                    response_serializer=ctpd__pb2.RunReply.SerializeToString,
            ),
            'RunStart': grpc.unary_unary_rpc_method_handler(
                    servicer.RunStart,
                    request_deserializer=ctpd__pb2.RunStartRequest.FromString,
                    response_serializer=ctpd__pb2.RunReply.SerializeToString,
            ),
            'RunStop': grpc.unary_unary_rpc_method_handler(
                    servicer.RunStop,
                    request_deserializer=ctpd__pb2.RunStopRequest.FromString,
                    response_serializer=ctpd__pb2.RunReply.SerializeToString,
            ),
            'RunConfig': grpc.unary_unary_rpc_method_handler(
                    servicer.RunConfig,
                    request_deserializer=ctpd__pb2.RunStopRequest.FromString,
                    response_serializer=ctpd__pb2.RunReply.SerializeToString,
            ),
            'RunLoad': grpc.unary_unary_rpc_method_handler(
                    servicer.RunLoad,
                    request_deserializer=ctpd__pb2.RunLoadRequest.FromString,
                    response_serializer=ctpd__pb2.RunReply.SerializeToString,
            ),
    }
    generic_handler = grpc.method_handlers_generic_handler(
            'ctpd.CTPd', rpc_method_handlers)
    server.add_generic_rpc_handlers((generic_handler,))


 # This class is part of an EXPERIMENTAL API.
class CTPd(object):
    """Service definition.
    """

    @staticmethod
    def SayHello(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ctpd.CTPd/SayHello',
            ctpd__pb2.HelloRequest.SerializeToString,
            ctpd__pb2.HelloReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def Stop(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ctpd.CTPd/Stop',
            ctpd__pb2.Empty.SerializeToString,
            ctpd__pb2.HelloReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def Sleep(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ctpd.CTPd/Sleep',
            ctpd__pb2.HelloRequest.SerializeToString,
            ctpd__pb2.HelloReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def MonCycle(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ctpd.CTPd/MonCycle',
            ctpd__pb2.Empty.SerializeToString,
            ctpd__pb2.Empty.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def Status(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ctpd.CTPd/Status',
            ctpd__pb2.Empty.SerializeToString,
            ctpd__pb2.SReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def LTUHello(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ctpd.CTPd/LTUHello',
            ctpd__pb2.SRequest.SerializeToString,
            ctpd__pb2.SReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def Lock(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ctpd.CTPd/Lock',
            ctpd__pb2.LockRequest.SerializeToString,
            ctpd__pb2.LockReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def Unlock(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ctpd.CTPd/Unlock',
            ctpd__pb2.LockRequest.SerializeToString,
            ctpd__pb2.LockReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def RunStatus(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ctpd.CTPd/RunStatus',
            ctpd__pb2.RunStatusRequest.SerializeToString,
            ctpd__pb2.RunReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def RunList(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ctpd.CTPd/RunList',
            ctpd__pb2.Empty.SerializeToString,
            ctpd__pb2.RunReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def RunStart(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ctpd.CTPd/RunStart',
            ctpd__pb2.RunStartRequest.SerializeToString,
            ctpd__pb2.RunReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def RunStop(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ctpd.CTPd/RunStop',
            ctpd__pb2.RunStopRequest.SerializeToString,
            ctpd__pb2.RunReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def RunConfig(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ctpd.CTPd/RunConfig',
            ctpd__pb2.RunStopRequest.SerializeToString,
            ctpd__pb2.RunReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def RunLoad(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ctpd.CTPd/RunLoad',
            ctpd__pb2.RunLoadRequest.SerializeToString,
            ctpd__pb2.RunReply.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)
