#!/usr/bin/python3
import grpc

import ctpecs_pb2 as ctpecs__pb2


class CTPdStub(object):
    """ctpd interface for ECS
    """

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.RunLoad = channel.unary_unary(
                '/ctpd.CTPd/RunLoad',
                request_serializer=ctpecs__pb2.RunLoadRequest.SerializeToString,
                response_deserializer=ctpecs__pb2.RunReply.FromString,
                )
        self.RunStart = channel.unary_unary(
                '/ctpd.CTPd/RunStart',
                request_serializer=ctpecs__pb2.RunStartRequest.SerializeToString,
                response_deserializer=ctpecs__pb2.RunReply.FromString,
                )
        self.RunStatus = channel.unary_unary(
                '/ctpd.CTPd/RunStatus',
                request_serializer=ctpecs__pb2.RunStatusRequest.SerializeToString,
                response_deserializer=ctpecs__pb2.RunReply.FromString,
                )
        self.RunList = channel.unary_unary(
                '/ctpd.CTPd/RunList',
                request_serializer=ctpecs__pb2.Empty.SerializeToString,
                response_deserializer=ctpecs__pb2.RunReply.FromString,
                )
        self.RunStop = channel.unary_unary(
                '/ctpd.CTPd/RunStop',
                request_serializer=ctpecs__pb2.RunStopRequest.SerializeToString,
                response_deserializer=ctpecs__pb2.RunReply.FromString,
                )
        self.RunConfig = channel.unary_unary(
                '/ctpd.CTPd/RunConfig',
                request_serializer=ctpecs__pb2.RunStopRequest.SerializeToString,
                response_deserializer=ctpecs__pb2.RunReply.FromString,
                )


class CTPdServicer(object):
    """ctpd interface for ECS
    """

    def RunLoad(self, request, context):
        """global run:
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def RunStart(self, request, context):
        """stdalone and global runs:
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def RunStatus(self, request, context):
        """Missing associated documentation comment in .proto file"""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def RunList(self, request, context):
        """Missing associated documentation comment in .proto file"""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def RunStop(self, request, context):
        """Missing associated documentation comment in .proto file"""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def RunConfig(self, request, context):
        """Missing associated documentation comment in .proto file"""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')


def add_CTPdServicer_to_server(servicer, server):
    rpc_method_handlers = {
            'RunLoad': grpc.unary_unary_rpc_method_handler(
                    servicer.RunLoad,
                    request_deserializer=ctpecs__pb2.RunLoadRequest.FromString,
                    response_serializer=ctpecs__pb2.RunReply.SerializeToString,
            ),
            'RunStart': grpc.unary_unary_rpc_method_handler(
                    servicer.RunStart,
                    request_deserializer=ctpecs__pb2.RunStartRequest.FromString,
                    response_serializer=ctpecs__pb2.RunReply.SerializeToString,
            ),
            'RunStatus': grpc.unary_unary_rpc_method_handler(
                    servicer.RunStatus,
                    request_deserializer=ctpecs__pb2.RunStatusRequest.FromString,
                    response_serializer=ctpecs__pb2.RunReply.SerializeToString,
            ),
            'RunList': grpc.unary_unary_rpc_method_handler(
                    servicer.RunList,
                    request_deserializer=ctpecs__pb2.Empty.FromString,
                    response_serializer=ctpecs__pb2.RunReply.SerializeToString,
            ),
            'RunStop': grpc.unary_unary_rpc_method_handler(
                    servicer.RunStop,
                    request_deserializer=ctpecs__pb2.RunStopRequest.FromString,
                    response_serializer=ctpecs__pb2.RunReply.SerializeToString,
            ),
            'RunConfig': grpc.unary_unary_rpc_method_handler(
                    servicer.RunConfig,
                    request_deserializer=ctpecs__pb2.RunStopRequest.FromString,
                    response_serializer=ctpecs__pb2.RunReply.SerializeToString,
            ),
    }
    generic_handler = grpc.method_handlers_generic_handler(
            'ctpd.CTPd', rpc_method_handlers)
    server.add_generic_rpc_handlers((generic_handler,))


 # This class is part of an EXPERIMENTAL API.
class CTPd(object):
    """ctpd interface for ECS
    """

    @staticmethod
    def RunLoad(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ctpd.CTPd/RunLoad',
            ctpecs__pb2.RunLoadRequest.SerializeToString,
            ctpecs__pb2.RunReply.FromString,
            options, channel_credentials,
            call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def RunStart(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ctpd.CTPd/RunStart',
            ctpecs__pb2.RunStartRequest.SerializeToString,
            ctpecs__pb2.RunReply.FromString,
            options, channel_credentials,
            call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def RunStatus(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ctpd.CTPd/RunStatus',
            ctpecs__pb2.RunStatusRequest.SerializeToString,
            ctpecs__pb2.RunReply.FromString,
            options, channel_credentials,
            call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def RunList(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ctpd.CTPd/RunList',
            ctpecs__pb2.Empty.SerializeToString,
            ctpecs__pb2.RunReply.FromString,
            options, channel_credentials,
            call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def RunStop(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ctpd.CTPd/RunStop',
            ctpecs__pb2.RunStopRequest.SerializeToString,
            ctpecs__pb2.RunReply.FromString,
            options, channel_credentials,
            call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def RunConfig(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/ctpd.CTPd/RunConfig',
            ctpecs__pb2.RunStopRequest.SerializeToString,
            ctpecs__pb2.RunReply.FromString,
            options, channel_credentials,
            call_credentials, compression, wait_for_ready, timeout, metadata)
