#!/usr/libexec/platform-python
#!/usr/bin/python3
"""
ipbus generic interface:
aboard.py boardname
History:
12.10.2016 readline (edit cmdline + history) added
13.10. hexdump, colors added
15.10. 'l' 'h' improved
"""
from __future__ import print_function
from builtins import hex
from builtins import input
from builtins import str
from builtins import map
from builtins import range
from builtins import object
import sys,string,os,readline,traceback,atexit, time
import ipbuswrap,extinput, atbwrap
import ttcponfmc   #,specdevs
import i2c
import spi as spi
#!/usr/bin/python3
import hexdump, colors, atb.ddrmem
from auxfuns import isinargs,ltucfgpars
from atb.gbt import Gbt

#!/usr/bin/python3

#!/usr/bin/python3
histfile = ".aboard_hist"   # working directory i.e. 2 instances clash less likely


#!/usr/bin/python3
#!/usr/bin/python3

CP_LO= 0      # Clock Prescale lo-byte
CP_HI= 1      #                hi-byte
CTRL= 2       # control
DATA= 3       # transmit/receive
CMD_STAT= 4   # Command/Status
STATUS_BITS= ("IF", "TIP", "R2", "R3", "R4", "AL", "BSY", "RxACK")
READ_CMD= 0x20
ACK_CMD=0x8
def list_randuint32s(length):
  randInts = []
  for i in range(length):
    #randInts.append( randuint32() )
    randInts.append(i)
  return randInts
def Get_argspllmode(phbname):
  pllmode= None
  for pn in ("pllcheckonly","pllnocheck"):
    if isinargs(pn):
      pllmode= pn ; return pllmode
  for pn in i2c.getpllnames():
    if isinargs(pn): pllmode= pn
  # highest priority in comd line args, if not check ltuIP.cfg:
  if pllmode==None:   
    pllmode= ltucfgpars(phbname, "pllcfg")
  # if neither in ltuIP.cfg leave None, default will be choosen in Si5345()
  return pllmode
  ##if isinargs("pllin0"): pllmode= "global"
  ##elif isinargs("pllin1"): pllmode= "stdalone"
  ##elif isinargs("pllin1lvpecl"): pllmode= "pllin1lvpecl"
  ##elif isinargs("pllnocheck"): pllmode= "pllnocheck"
  ##elif isinargs("pllcheckonly"): pllmode= "pllcheckonly"
  ##else: pllmode=None
  ##return pllmode

class Session(object):
  #vonFW_CTP_LOGIC= 10
  #FW_LTU_LOGIC= 11
  #FW_LTU_ITSMFT_LOGIC= 12
  #FW_TEST_LOGIC= (5,6,7,8,9)
  def __init__(self, board, words=None):
    self.board= board
    # 0 - marian spi; 1 =  richard spi
    allwords= "r Name [offset]", "w Name [offset]",\
    "rb blockName offset N", "wb blockName offset val1 val2 ...",\
    "ex scriptName.sc", "l [topNodeName]",\
    "set dump xd", "set dumpl N"
    if words: allwords= allwords + words
    if os.path.exists(histfile):
      try:
        readline.read_history_file(histfile)
        # default history len is -1 (infinite), which may grow unruly
        readline.set_history_length(100) #lines
        completer = Completer(allwords)
        readline.parse_and_bind("tab: complete")
        readline.set_completer(completer.complete)
      except IOError:
        print(traceback.format_exc())
    else:
      print("Commands history not available (no file %s in working directory)"%histfile)
    atexit.register(readline.write_history_file, histfile)
    #del os, histfile
    print("setting 'sfp' default for all on-board connected GBTs (not done for FSFPs yet)...")
    for gbtname in self.board.fwsfps:   # todo: FSFPs not considered  yet
      #print gbtname,self.board.fwsfps[gbtname],"..."
      sfp= self.board.findDevice(self.board.fwsfps[gbtname])
      if sfp!= None:
        #if any(isinstance(x, my.object.kind) for x in alist)
        # py3 if type(sfp.purpose) == Gbt:
        if isinstance(sfp.purpose, Gbt):
          #print "Gbt:",gbtname,"..."
          sfp.purpose.initdest("sfp")   # default mode of GBTs
        #else:
        #  print type(sfp.purpose)
  def executeScript(self, fn, b, line):
    if os.path.exists(fn):
      rp= fn
      print("Opening %s in WORKING DIRECTORY..."%fn)
    else:
      rp= os.path.join(os.getenv("CTP3_ROOT"),"scripts", fn)
      if os.path.exists(rp):
        print("executing script CTP3_ROOT/scripts/%s...\n"%fn)
      else:
        print("%s not found in CTP3_WORK_DIRECTORY, neither in CTP3_ROOT/scripts directory...\n"%fn)
        return
    exfile= open(rp, "r")   #; cmds= exfile.read(); exfile.close()
    cmd= line
    exec(exfile)   #eval(cmds)
    #varsa= {"cmd":cmd}
    #locs= {"cmd":cmd}
    #execfile(fn)
    exfile.close()
    print("Closed: %s"%fn)
  def printHelp(self, topic=None):
    if topic=="ex":
      print("""
Script is written in python, saved in WORKing directory.
When started, 'b' is defined as an 'ipbus board' object,
which can be accessed through 4 standard methods:

val32= b.Read(name, [offset])            -offset can be used with array of
b.Write(name, val32, [offset])            registers (block)
block= b.ReadBlock(ramname, N, offset)   -block becomes a list of N 32bit values
b.WriteBlock(ramname, block, offset)     -write N values (N: length of the block)

Script examples are in .../ctp3-ipbus/scripts
""")
    elif topic=="fmc":
      print(ttcponfmc.helptext)
    elif topic=="spi":
      print(spi.helptext)
    else:
      print("""\033[0m\033[01m   Single register operations \033[0m
r name [offset]           read register, exapmle: r ctrl.fwinfo
w name value [offset]     write register, exapmle: w ctrl.version 0x45
       offset: handy when accessing one register of the block
    
\033[0m\033[01m   Block operations \033[0m
rb name offset N           read N values from name[offset]
wb name offset v1 v2 ...   write v1,... to name[offset,offset+1,...]
rf name N                 read N values from name (non-incremental node)

l                 show the list of top nodes
l topNodName [sn] show the list of nodes for given top node [sn -show only a subnode]
                  Note: topNodName does not have to be given in r/w commands

\033[0m\033[01m   I2C operations \033[0m
i2c               choose I2C bus (needed for i2c* commands only)
                  dbgon/dbgoff: on/off dbg messages for i2cmainttc slave
i2ci [khz]        i2c init+enable core (khz default: 400) + STO bit
i2cs              status
i2cr addr [N]     read N [1] bytes from slave addr
i2cw addr value   write

i2crm addr memloc N          -read N bytes from memloc EPROM from I2C slave addr
i2cwm addr memloc v1 v2...   -write v1 v2.... to addr:memloc


\033[0m\033[01m   Miscellaneous \033[0m
devs              print list of available devices
devs find devname check if device available
dev XXX cmd pars  execute 'cmd pars' for device XXX

sfps cmd          execute cmd for all SFPX (X=1..), e.g.:
sfps id temp      show all SFPs' Tx/Rx power temp...
sfps mod cnts r   read all SFPs counters

fmc               TTCPON FMC (fmc help)  -tested ONLY with kcu105 board in summer 2017
si ss s01         3 SPI commands (h spi)
bootfpga          boot FPGA from flash memory fm_cfg (IPROG command via ICAP)
                  icap.icap_status reg has to be 0xc0000000 before cmd issued

\033[0m\033[01m   Others \033[0m(debugging/development):
temps             batch measurement of SFP1-12 temp, writing data in WORK/temps.csv file 

\033[0m\033[01m   General \033[0m
Use: up/down (left/right) arrows to browse (edit) commands' history
        Note: history is archived in .aboard_hist file in working directory

q                     Quit application
h [ex | spi]          Display this help text [help on ex or spi commands]
ex scriptname         Execute script (.sc) in working directory
set dump  x | d | xd | dpon 
                      Set the way a dump is shown (now:%s)
set dumpl N           Set the dump line length (now:%d words)

sleep seconds         seconds: sleeping time (integer or float)
fifoin macname        execute commands prepared in $WORK/macname or 
                      in $CTP3_ROOT/scripts/
fifoin                start waiting for cmds from outside (see atb_ cmd)
atb_                  show scheduled command(s) for other boards
atb_N cmd             schedule a command to be executed for atb_N before any
                      cmd for this board. START fifoin in other application
                      'atb N' !
atb_N close           unschedule the command (if exists) for atb_N
atb_N stdin           allow stdin for remote board (keep remote command)
atb_N                 activate. Use this to resume automatic execution after
                      it was suspended by 'stdin' action. 

Substitution in command line:
$1 $2 ... used in cmd is replaced by parameter value ($1 is always board name). E.g.:
aboard proto_1 flash.dump
>dev fm_cfg dump $2
will dump content of fm_cfg to WORK/flash.dump file
 
"""%(hexdump.dumptype, hexdump.linlen))
  def setoffsetN(self, cmd):
    offset= 0 ; N= 1
    if len(cmd) >= 3:
      offset= int(cmd[2])
    if len(cmd) >= 4:
      N= eval(cmd[3])
    return offset,N
  def execcmdl_u(self, cmd):
    #print "execcmdl_u:",cmd," ignored"
    return False   # True: processing ok, False: unknown command
  def execcmdl(self):   #, batchlines=[]):
    batchlines= []   # all args after: ltuctl boardname [all] [pllin0 | pllin1 | pllnocheck]
    pllopts= i2c.getpllnames()
    for ixarg in range(len(sys.argv)):
      if ixarg <= 1: continue   # ignore aboard bname
      if sys.argv[ixarg]=="all": continue
      if sys.argv[ixarg]=="emuinit": continue
      if sys.argv[ixarg]=="pllnocheck": continue
      if sys.argv[ixarg]=="pllcheckonly": continue
      if sys.argv[ixarg] in pllopts: continue
      batchlines.append(sys.argv[ixarg])
    if len(batchlines)>0: batchlines.append("q")
    if False:  #von
      if self.board.bname=="ltukcu":
        # ctpltu: 9 OLT cores in .xml file!
      #if self.board.nodExists("i2c", True):
        # add devices
        self.i2cg.addDevice(i2c.M24C0x(self.i2cg, "eeprom", 0x50, mux=(0x74, 1<<0))) #fmcttcpon
        self.i2cg.addDevice(i2c.Si570(self.i2cg, "si570", 0x55, mux=(0x74, 1<<1)))   #only fmcttcpon
        self.i2cg.addDevice(i2c.Si534x(self.i2cg, "si5344", mux=(0x74, 1<<3), model="5344"))
        self.i2cg.addDevice(i2c.SFP(self.i2cg, "SFP1", mux=(0x74, 0x20)))
        self.i2cg.addDevice(i2c.LEDSttcponfmc(self.i2cg, "leds")) #only kcu
        self.spic[0].addDevice(spi.N25Q(self.spic[0], "fm_cfg", "n25q256"))
        self.spic[1].addDevice(spi.N25Q(self.spic[1], "fm_semip", "n25q256"))
    #
    self.i2cinuse= self.board.i2cinuse
    self.board.printDevices()
    #self.board.FW_CTP_LOGIC
    if self.board.isfiwa(self.board.FW_LTUCTP):
      if self.board.isfiwa(self.board.FW_LTU):
        dname= "ltud"
      else:
        dname= "ctpd"
      pid1= self.board.Read("ctrl.pid_1")
      if pid1==0xffffffff:
        print("{} is running".format(dname))
      elif pid1>0:
        print("{} is running, run {} active)".format(dname,pid1))
      else:
        pass
    remotecmds={}   # remotecmds[atbname]: (fifo_object, cmd_string_no_NL)
    # fifoobject, command to be executed on atbname board
    # the board has to be armed before by starting fifoin
    nodename= ""
    ixbatchline= 0 ; extinp=None
    highlighted= True #False #True
    while True:
      if extinp and (len(extinp.inputsstack)>0):
        line= extinp.readline()
      else:
        if len(batchlines)>0:
          line= batchlines[ixbatchline]
          ixbatchline= ixbatchline+1
        else:
          if self.board.tn_inuse!="":
            tninuse= "."+self.board.tn_inuse
          else:
            tninuse= ""
          prompt= self.board.bname+tninuse+">"
          if highlighted:
            #prompt= "\033[0m%s%s>\033[0m"%(colors.styles['reverse'], tninuse)
            #prompt= "\033[0m%s%s>"%(colors.styles['reverse'], prompt)
            prompt= colors.color(prompt,"bold")
            try:
              line= input(prompt); 
            except EOFError:
              break
              # let's emphasize also user input:
              #sys.stdout.write("\033[0m")  # ok, no NL neither space added
          else:
            line= input(prompt); 
      #print "\033[0m",              # not ok (adds a space)
      #print "dbg:", self.board.tn_inuse
      try:   #if True: #try:
        cmd= line.split()
        if len(cmd) == 0: continue
        if line[0] == '#': 
          print(line)
          continue
        # parameters (given in 'atb N par1 par2') substitution
        # isn't it conflicting with batchlines?
        for ix in range(len(cmd)):
          if cmd[ix][0]=='$':   # aboard.py bname kk -> $0 $1 $2
            arg= cmd[ix][1:]
            if (len(arg)==1) and (arg in string.digits):
              try:
                av= sys.argv[int(arg)]
              except:
                print("exception:", cmd[ix], "args:", sys.argv)
              else:
                print("sustituting:", cmd[ix], "->", av)
                cmd[ix]= av
        if (len(remotecmds)>0) and (len(cmd[0])<4) or ("atb_" != cmd[0][:4]):
          # execute scheduled commands, but 'atb_':
          for atbn in remotecmds:
            fifo= remotecmds[atbn][0]
            if fifo!=None:
              remcmd= remotecmds[atbn][1]
              print("Sending cmd to %s: %s..."%(atbn, remcmd)) 
              extinput.wfifo(fifo, remcmd)
        if (len(cmd[0])>=4) and ("atb_" == cmd[0][:4]):
          # show or schedule the remote command:
          if cmd[0]=="atb_":   # show
            if len(remotecmds)>0:
              print(" Scheduled commands (active boards armed by fifoin):")
              for atbn in remotecmds:
                #fifo= remotecmds[atbn][0]
                remcmd= remotecmds[atbn][1]
                if remotecmds[atbn][0]==None:
                  active= "Susp. "
                else:
                  active= "Active"
                print("%.6s %5s: %s"%(active,atbn, remcmd)) 
            else:
              print("No commands scheduled for other board(s)")
          elif cmd[0] == self.board.bname:
            print("Cannot schedule command for itself, ignored.")
          elif (len(cmd)==1) or\
            ((len(cmd)==2) and (cmd[1] in ("stdin","close"))):
            # atb_N       -activate
            # atb_N close -remove completely
            # atb_N stdin -only 'unschedule', i.e. remeber cmd
            if cmd[0] in remotecmds:
              cors= ""   # activate
              if len(cmd)==2: cors= cmd[1]
              if cors=="":
                # activate with already stored cmd
                if remotecmds[cmd[0]][0]==None:
                  print("Resuming, is fifoin started for %s ?"%cmd[0])
                  fifo= extinput.wopenfifo(cmd[0])
                  remotecmds[cmd[0]][0]= fifo
                else:
                  print("Active %s: %s"%(cmd[0], remotecmds[cmd[0]][1]))
              else:
                fifo= remotecmds[cmd[0]][0]
                remcmd= "stdin"
                print("Sending cmd to %s: %s..."%(cmd[0], remcmd)) 
                extinput.wfifo(fifo, remcmd)
                remotecmds[cmd[0]][0].close() 
                remotecmds[cmd[0]][0]= None
                if cors=='close':
                  print("Unscheduling %s: "%cmd[0], remotecmds[cmd[0]][1])
                  del remotecmds[cmd[0]] 
            else:
              print("Nothing scheduled for", cmd[0])
          else:   # atb_X cmd
            newcmd= " ".join(cmd[1:])
            if cmd[0] in remotecmds:
              print("Changing '%s' to '%s'"%(remotecmds[cmd[0]][1], newcmd))
            else:
              print("Scheduling '%s'. Is fifoin started for %s ?"%\
               (newcmd, cmd[0]))
            fifo= extinput.wopenfifo(cmd[0])
            if fifo==None:
              print("Cmd not scheduled.")
            remotecmds[cmd[0]]= [fifo, newcmd]
            #print "Cmd scheduled."
        elif cmd[0] == 'q':
          break
        elif cmd[0] == 'fifoin':
          if extinp:   # nested fifoin call, check and add on stack
            extinp.fifoin(cmd, self.board.bname)
          else:
            extinp= extinput.ExtInput(cmd, self.board.bname)
            if len(extinp.inputsstack)==0:
              extinp= None
        elif cmd[0] == 'sleep':
          secs= 1
          if len(cmd)>1: secs= eval(cmd[1])
          print("sleep %.4f secs..."%secs)
          time.sleep(secs)
        elif cmd[0] == 'si': # SPI
          if len(cmd)>1:
            #self.spic.config()
            newspicinuse= eval(cmd[1])
            if newspicinuse >= len(self.spic):
              print("provide number,  maximum allowed:%d"%(len(self.spic)-1))
            else:
               self.spicinuse= newspicinuse
          else:
            print("provide number, used for all spi operations, max:%d"%(len(self.spic)-1))
            for ix in range(len(self.spic)):
              self.spic[ix].printDevs(str(ix))
          print("Using spi%d"%self.spicinuse)
        elif cmd[0] == 'ss':
          self.spic[self.spicinuse].status()
        elif cmd[0] == 'ss01':
          if (len(cmd)>1) and ((cmd[1]=='0') or (cmd[1]=='1')):
            self.spic[self.spicinuse].setSS(int(cmd[1]))
          else:
            print("Error. 0 or 1 expected (1 only when accessing device)")
        # FLASH memory
        #elif cmd[0] == 'f':
        #  #flash[self.spicinuse].excmd(cmd)
        #  self.spic[self.spicinuse].connected[0].excmd(cmd)
        # ttcpon fmc:
        elif cmd[0] == 'fmc':
          ttcponfmc.excmd(cmd, self.board.i2cs[self.board.i2cinuse])
        elif cmd[0] == 'devs':
          if len(cmd)==1: self.board.printDevices()
          elif cmd[1]=='find':
            dev= self.board.findDevice(cmd[2])
            if dev==None:
              print("Unknown device %s."%cmd[2])
            else:
              dev.excmd("")
        elif cmd[0] == 'temps':
          nmesmax=72   # 72
          mins= 10  # 10
          print("writing %d measurements every %d mins to temps.csv..."%(nmesmax,mins))
          dfile= open("temps.csv","w")
          for nmes in range(nmesmax):
            lin= "%.1f"%time.time()
            for sfp in range(1,13):
              divajs=self.board.findDevice("SFP%d"%sfp)
              if divajs:
                t= "%.1f"%divajs.gettemp()
              else:
                t= "None"
              lin= lin+","+t
            #print lin
            dfile.write(lin+"\n")
            time.sleep(mins*60)
          dfile.close()
        elif cmd[0] == 'bootfpga':
          status= self.board.Read("icap.icap_status")
          print("bootfpga icap.icap_status:0x%x reloading..."%status)
          if (status & 0xc0000000) != 0xc0000000:
            #0x80000000: ICAPE3 available
            #0x40000000: PRDONE is ok
            print("Error: icap.icap_status:0x%x (expected: 0xc0000000), IPROG command not sent"%status)
          else:
            print("Sending IPROG cmd to reboot fpga...")
            try:
              self.board.Write("icap.iprog_icap", 0xf)
            except:
              print("FPGA booting from flash memory (please wait ~ 10 secs), exiting...")
              sys.exit(0)
            else:
              print("Error: no exception received from ipbus after IPROG cmd")
          #print "cmd:", map(hex,icapbootcmd)
          #print "Status:0x%x"%self.board.Read("icap.icap_status")
        elif cmd[0]== "sfps":
          divajses=self.board.findDeviceSFPS()
          printhdr=False
          if (len(cmd)==3) and (cmd[1]=='id') and (cmd[2]=='temp'):   # sfps id temp
            printhdr=True
          for ix in range(len(divajses)):
            if (ix==0) and printhdr:
              divajses[ix].excmd(("anysfps","idtemphdr"))
              printhdr=False
            divajses[ix].excmd(cmd)
        elif cmd[0] == 'dev':
          if len(cmd)>1:
            divajs=self.board.findDevice(cmd[1])
            if divajs:
              divajs.excmd(cmd[1:])
            else:
              atbwrap.printError(cmd[1]," -unknown device")
          else:
            print("'dev dev_name ...' expected")
        elif cmd[0] == 'i2c':
          newi2cix= None
          av=""
          for ix in range(len(self.board.i2cs)): 
            av= av+self.board.i2cs[ix].i2cslave+" "
          ok= False
          if len(cmd)>1:
            if cmd[1]=="dbgoff" or cmd[1]=="dbgon":
              if cmd[1]=="dbgon":
                self.board.i2cs[self.board.i2cinuse].i2cmaindbg= True
              else:
                self.board.i2cs[self.board.i2cinuse].i2cmaindbg= False
              print("i2cmaindbg:", self.board.i2cs[self.board.i2cinuse].i2cmaindbg)
              ok=True
            else:
              for ix in range(len(self.board.i2cs)): 
                if cmd[1] == self.board.i2cs[ix].i2cslave:
                  self.board.i2cinuse= ix
                  print("Using %s, %d"%(self.board.geti2cinuseslave(), ix))
                  ok=True
          if not ok:
            print("provide one of:", av)
            print("Using %s, %d"%(self.board.geti2cinuseslave(), self.board.i2cinuse))
        elif cmd[0] == 'i2cs':
          if self.board.i2cinuse==None:
            print("i2c not available")
          else:
            print("i2c in use: %s (%d)"%(self.board.i2cs[self.board.i2cinuse].i2cslave, self.board.i2cinuse))
          print(self.board.i2cs[self.board.i2cinuse].getSTATUS())
        elif cmd[0] == 'i2ci':
          khz=400
          if len(cmd)>1: khz= eval(cmd[1])
          self.board.i2cs[self.board.i2cinuse].i2ci(khz)
          #self.dispisin= False
        elif cmd[0] == 'i2cr':
          addr= None; addrtxt=""
          if (len(cmd)== 2) or (len(cmd)== 3):
            blen= 1
            if len(cmd)== 3:
              blen= eval(cmd[2])
            addr= eval(cmd[1])
            addrtxt= "[%d]"%addr
            readval= self.board.i2cs[self.board.i2cinuse].i2cr(addr, blen)
            if readval==None:
              atbwrap.printError(nodename," i2c read error")
            elif blen>1:
              print(cmd[0]+addrtxt,":",readval)
            else:
              print(cmd[0]+addrtxt,":0x%x"%readval)
          else:
            atbwrap.printError(nodename, "addr missing")
        elif cmd[0] == 'i2crm':   # i2crm i2caddr memlocation
          addr= None; addrtxt="" ; blen= 1
          if (len(cmd)== 3) or (len(cmd)== 4):
            if len(cmd)== 4: blen= eval(cmd[3])
            addr= eval(cmd[1])
            memloc= eval(cmd[2])
            addrtxt= "[%d:%d]"%(addr,memloc)
            readval= self.board.i2cs[self.board.i2cinuse].i2crm(addr, memloc, blen)
            try:
              print(cmd[0]+addrtxt,list(map(hex,readval)))
            except:
              print("excp:",cmd[0]+addrtxt,readval)
            print(self.board.i2cs[self.board.i2cinuse].prtSTATUS())
          else:
            atbwrap.printError(nodename, "Expected: 'i2crm i2caddr memlocation'")
        elif cmd[0] == 'i2cw':
          addr= None; addrtxt=""
          if len(cmd)== 3:
            addr= eval(cmd[1])
            addrtxt= "[%d]"%addr
            value= eval(cmd[2])
            self.board.i2cs[self.board.i2cinuse].i2cw(addr, value)
            print(self.board.i2cs[self.board.i2cinuse].prtSTATUS())
          else:
            atbwrap.printError(nodename, "'i2cw addr value' expected")
        elif cmd[0] == 'i2cwm':
          addr= None; addrtxt=""
          if len(cmd)>= 4:
            addr= eval(cmd[1])
            addrtxt= "[%d]"%addr
            memloc= eval(cmd[2])
            values=[]
            for i in range(3,len(cmd)):
              value= eval(cmd[3]) ; values.append(value)
            self.board.i2cs[self.board.i2cinuse].i2cwm(addr, memloc, values)
            print(self.board.i2cs[self.board.i2cinuse].prtSTATUS())
          else:
            atbwrap.printError(nodename, "'i2cw addr memloc v1 v2 ...' expected")
        # i2cttcpon operation:
        elif (cmd[0] == 'i2cwr_delme') or (cmd[0] == 'i2crd1_delme') or (cmd[0] == 'i2crd2_delme'):
            addr= eval(cmd[1])
            mem= eval(cmd[2])
            if len(cmd)==4: val= eval(cmd[3])
            if (cmd[0] == 'i2cwr'):
              val= self.board.i2cs[self.board.i2cinuse].i2cwr(addr, mem, val)
            elif (cmd[0] == 'i2crd1'):
              val= self.board.i2cs[self.board.i2cinuse].i2crd1(addr, mem)
            elif (cmd[0] == 'i2crd2'):
              val= self.board.i2cs[self.board.i2cinuse].i2crd2(addr, mem)
        elif cmd[0] == 'r':
          offset= None; offsettxt=""
          if len(cmd)== 3:
            offset= int(cmd[2])
            offsettxt= "[%d]"%offset
          readval= self.board.Read(cmd[1], offset)
          print(cmd[1]+offsettxt,":", hex(readval), "=", readval)   #, type(readval)
        elif cmd[0] == 'rb':
          offset,N= self.setoffsetN(cmd)
          #print "rb:", cmd[1], offset, N
          block= self.board.ReadBlock(cmd[1],N,offset)
          #print "rb:", len(block), block
          #ipbuswrap.showblock(cmd[1], block, offset, N)
          #hexdump.hd_dump(block, offset, offset+N-1)
          hexdump.hd_dump(block, 0, N-1, offset)
        elif cmd[0] == 'rf':
          N= 1
          if len(cmd) >= 3: N= int(cmd[2])
          #print "rb:", cmd[1], offset, N
          block= self.board.ReadFifo(cmd[1],N)
          #print "rb:", len(block), block
          hexdump.hd_dump(block, 0, N-1)
        elif cmd[0] == 'w':
          offset= None
          if len(cmd)== 4:
            offset= int(cmd[3])
          value= eval(cmd[2])
          self.board.Write(cmd[1], value, offset)
        elif cmd[0] == 'wb':
          offset,N= self.setoffsetN(cmd)
          if len(cmd) < 4:
            atbwrap.printError("wb name offset v1 v2 ... expected")
          else:
            nod= self.board.nodlist[self.board.applyTN(cmd[1])]
            N= len(cmd) - 3
            siz= nod.getSize()
            xx= list_randuint32s(N)
            for ix in range(N):
              value= eval(cmd[3+ix])
              xx[ix]= value
            self.board.WriteBlock(cmd[1],xx, offset)
        elif cmd[0] == 'l':
          if len(cmd)==2:
            legend="%s nodes:"%cmd[1]
            nodename= cmd[1]
          elif len(cmd)==3:
            legend="%s.%s node:"%(cmd[1], cmd[2])
            nodename= cmd[1]
          else:
            legend="Top nodes:"
            nodename= ""
          nnames= self.board.getNodeNames(nodename)
          if len(nnames)==0:
            atbwrap.printError(nodename, "doesn't exist")
            continue
          print(legend)
          #print(legend, nnames)
          for nm in nnames:
            if nodename != "":
              name= nodename+'.'+nm
            else:
              name= nm
            nod= self.board.nodlist[name]
            if str(nod.getMode())=="INCREMENTAL":
              nm= nm+ "[%d]"%nod.getSize()
            if (len(cmd)>2) and (cmd[2] != nm): continue
            print("%20s: %s"%(nm, nod.getDescription()))
        #elif cmd[0] == 'ramblock':
        elif cmd[0] == 'ex':
          self.executeScript(cmd[1], self.board, line)
        elif cmd[0] == 'h':
          if len(cmd)>1: topic= cmd[1]
          else: topic= None
          self.printHelp(topic)
        elif cmd[0] == 'set':
          if cmd[1] == 'dump': hexdump.dumptype= cmd[2]
          if cmd[1] == 'dumpl': hexdump.linlen= int(cmd[2])
        else:
          divajs=self.board.findDevice(cmd[0])
          if divajs:
            divajs.excmd(cmd[0:])
          else:
            if not self.execcmdl_u(cmd):
              atbwrap.printError(line, " -not supported")
      #except:
      except Exception as e:
        #print "Unexpected error:", sys.exc_info()[0]
        #print "Unexpected error:", sys.exc_info()
        #print "Unexpected error:", str(e)
        print(traceback.format_exc())
        #traceback.print_stack()
    # end of cmd loop
    if self.board.nodExists("ctrl.ctrl"):
      #self.board.Write("ctrl.ctrl", 1)   # 0:spi0-enable 1:spi0-disable      
      # was valid only for ltu_logic_v1, not used from _v2
      pass
class Completer(object):
    def __init__(self, words):
        self.words = words
        self.prefix = None
    def complete(self, prefix, index):
        if prefix != self.prefix:
            # we have a new prefix!
            # find all words that start with this prefix
            self.matching_words = [
                w for w in self.words if w.startswith(prefix)
                ]
            self.prefix = prefix
        try:
            return self.matching_words[index]
        except IndexError:
            return None
def main():
  if len(sys.argv) < 2 or (len(sys.argv)==2 and sys.argv[1]=="help"):
    print("""
Usage:
aboard boardname [pllcfg]

pllcfg: an option specifying PLL config. 

aboard pllcfg  -see options for pllcfg


""") #available boards (%s): """%ipbuswrap.ConnectionFN
    cmd=os.path.join(os.getenv('CTP3_ROOT'),"pywrap","checkboards.py")
    from subprocess import call 
    call([cmd, "all"])
    sys.exit()
  if sys.argv[1]=="pllcfg":
    print(i2c.getpllhelp())
    sys.exit()
  print("CTP3_CONFIG_DIRECTORY:", os.getenv("CTP3_CONFIG_DIRECTORY"))
  os.chdir(os.getenv('CTP3_WORK_DIRECTORY'))
  print("working directory:", os.getenv('CTP3_WORK_DIRECTORY'))
  phbname= sys.argv[1]
  #ipbuswrap.Init(phbname)
  ipbuswrap.Init()
  if ipbuswrap.manager == None:
    print("Problem with ipbus Init().")
    return
  #board= ipbuswrap.Board(phbname)
  pllmode= Get_argspllmode(phbname)
  board= atbwrap.OpenATBoard(phbname, atbwrap.ABoard, pllmode=pllmode)
  singles=""
  non_singles=""
  for ix in range(len(board.idslist)):
    node= board.nodlist[board.idslist[ix]]
    mode= str(node.getMode())
    singname= board.idslist[ix]
    if mode=="SINGLE":
      singles= singles+singname+" "
    else:
      non_singles= non_singles+ singname+" "
  #print "\nSingle registers: %s\n not single:%s"%(singles, non_singles)
  #print
  session= Session(board)
  #session.printHelp()
  session.execcmdl()

if __name__ == "__main__":
  main()


