#!/usr/libexec/platform-python
from __future__ import print_function
import string,time
import i2c

helptext="""
AVAILABLE ONLY with TTCPON FMC card -tested only with ltu_kcu105 firmware
on kcu105 board

TTCPON FMC commands:
fmc clockmux [s|c]  -init clock mux (PCA8574APW)  standalone(default) or cascade 
"""
def excmd(cmd, b):   # b: i2cslave instance
  if len(cmd)<=1:
    print(helptext)
    return
  if cmd[1]=='clockmux':
    n= b.i2cw(0x74, 4)   # set mux
    if len(cmd)>2:
      fmcmode= cmd[2]
    else:
      fmcmode= ''
    if fmcmode=='s':
      fmcmode= 0x37   # standalone (not keeping phase)
      print("setting stdalone...")
      n= b.i2cw(0x38, fmcmode)   # Select OUT4=IN4, OUT3=IN3, OUT2=IN4, OUT1=IN1
    elif fmcmode=='c':
      print("setting cascade...")
      fmcmode= 0x36
      n= b.i2cw(0x38, fmcmode)   # Select OUT4=IN4, OUT3=IN3, OUT2=IN4, OUT1=IN1
    else:
      if fmcmode=='':
        print("reading clockmux...")
      else:
        fmcmode= eval(fmcmode)
        print("setting 0x%x..."%fmcmode)
        n= b.i2cw(0x38, fmcmode)
    v= b.i2cr(0x38)
    print("clockmux:0x%x"%v)
  else:
    print(helptext)

