#!/usr/libexec/platform-python
"""
ipbus generic interface:
aboard.py boardname
History:
"""
from __future__ import print_function
from builtins import hex
from builtins import str
from builtins import range
import sys,os,traceback,getpass
username = getpass.getuser()
if username == 'trigger':
 ipbpath= os.path.join(os.path.expanduser("~trigger"),"git/ipbus")
elif username == 'rl':
 ipbpath= os.path.join(os.path.expanduser("~rl"),"ipbus")
else:
 print("Unknown user:", username, " exiting.")
 exit(1)
sys.path.append(os.path.join(ipbpath,"cmdpy/aboard"))
sys.path.append(os.path.join(ipbpath,"cmdpy/bert"))
import ipbuswrap, hexdump, colors
import aboard

class Session(aboard.Session):
  def __init__(self, board):
    """
        There are 2 types of commands:
        - cmds2 writes to pars - no ipbus action. setb writes pars to ipbus
        - cmds1 write to ipbus except of print
    """
    self.cmds2=('Inp','Out','Del','rstT','rstR','rstP')
    self.cmds1=('print','setb','printE','startC')
    print(self.cmds2)
    aboard.Session.__init__(self, board, self.cmds2+self.cmds1)
    self.pars=[0,0,0,0,0,0]
  def printHelp(self, topic=None):
    if topic==None:
      print("""
\033[0m\033[01m   BERT operations \033[0m""",self.cmds2+self.cmds1,"""
""",self.cmds2[0],"""X              choose input number  X (0-255)
""",self.cmds2[1],"""X              choose output number X (0-255)
""",self.cmds2[2],"""X              choose signal delay  X (0-15)
""",self.cmds2[3],"""X             reset transmitter X (0-1)
""",self.cmds2[4],"""X             reset recorder    X (0-1)
""",self.cmds2[5],"""X             reset PLL         X (0-1)
""",self.cmds1[0],"""             print chosen settings
""",self.cmds1[1],"""              write settings to board via ipbus
""",self.cmds1[2],"""            read error count and print
""",self.cmds1[3],"""            startCount
\033[0m\033[01m   Others \033[0m
h aboard          show general (aboard) help text
""")
    else:
      aboard.Session.printHelp(self, topic)
  def parsecmd2(self, cmd):
    """
       parse command consisting of 2 words: first literal, second number
    """
    if len(cmd) != 2: return None
    try:
       return int(cmd[1])
    except ValueError:
       return None    
  def Print(self):
    """
       Print parameters 
    """
    line=""
    for i in range(len(self.cmds2)): 
     line+= self.cmds2[i] +": "+ str(self.pars[i]) + " "
    print(line)
  def execcmdl_u(self, cmd):
    """
       
    """
    i=0
    for icmd in self.cmds2:
      if cmd[0] == icmd:
        par = self.parsecmd2(cmd)
        if par == None: return False
        self.pars[i]=par
        return True
      i+=1    
    if   cmd[0] == self.cmds1[0]:
     # print parameters 
     self.Print()
    elif cmd[0] == self.cmds1[1]:
     word = 0
     word= self.pars[0] +(self.pars[1]<<8)+ (self.pars[2]<<16)
     word += (self.pars[3]<<20)+(self.pars[4]<<21)+(self.pars[5]<<22)
     print('set: write to ipbus: ', hex(word))
     try:
        self.board.Write("bbert.cfg",word)
     except :
        print("Board probably not connected")    
    elif cmd[0] == self.cmds1[2]:
     print('print errors')
     try:
        numofers = self.board.Read("bbert.errorcount")
        print("Number of errors: ",numofers)
     except:
        print("Board probably not connected")    
    elif cmd[0] == self.cmds1[3]:
     try:
        self.board.Write("bbert.startcount",1)
        print('start Count success')
     except:
        print("Board probably not connected")    
    else:
      return False
    return True
def main():
  ipbuswrap.Init()
  if len(sys.argv) < 2 or (len(sys.argv)==2 and sys.argv[1]=="help"):
    print("""
Usage:
bert boardname

available boards (%s): """%ipbuswrap.ConnectionFN)
    import saxipbus
    saxipbus.printConnectionFile(ipbuswrap.ConnectionFN)
    sys.exit()
  board= ipbuswrap.Board(sys.argv[1])
  ibbert=0
  for ix in range(len(board.idslist)):
    #node = board.nodlist[board.idslist[ix]]
    singname= board.idslist[ix]
    if singname.find("bbert") != -1: ibbert+=1
  #print ibbert
  if ibbert==0:
   print("Board ", sys.argv[1] , "has no bbert. Exiting.")
   exit(1)
  session= Session(board)
  session.printHelp()
  session.execcmdl()

if __name__ == "__main__":
  main()


