#!/usr/libexec/platform-python
import sys,os
import ipbuswrap,atbwrap

ticgpll= None
def action(act):
  global ticgpll
  """ act: ramp, rampdown or status
"""
  if act=="ramp":
    ticgpll.ramp(1)
    #ticgpll.ramp(1, 10)
    #print "ramp up..."
    act= "status"
  elif act=="rampdown":
    ticgpll.ramp(2, 0)
    #ticgpll.ramp(2, 10)
    #print "rampdown..."
    act= "status"
  else:   # status always read
    pass
  cmd= "ssh trigger@altri2 '~/rf2ttc/rf2ttc %s'"%act
  rc= os.popen(cmd).read()
  return rc
def main():
  global ticgpll
  if len(sys.argv) < 2 or (len(sys.argv)==2 and sys.argv[1]=="help"):
    print """
Usage:
loltest_atb.py loops
Needs: 1. atb_34 in initial state (ticg_lhcramp.hpy loaded) connected, i.e.
          clock.sh ref
       2. set of ATBs where LOL is checked after each ramp 
loop loops times:
  -ramp up clock (atb_34 action "si5345 ramp up")
  -check LOL in RF2TTC 
  -check LOL on si5345 for a list of ATBs (board numbers in boardns)
  -print a concise info in one line (0:no LOL), count LOLs

Note: for 8 ATBs, 1000 loops:
loops:1000

"""
    sys.exit()
  loops= int(sys.argv[1])
  os.chdir(os.getenv('CTP3_WORK_DIRECTORY'))
  ipbuswrap.Init()
  ticg= atbwrap.OpenATBoard("atb_34")
  ticgpll= ticg.findDevice("si5345")
  #boardns= (13, 16, 32, 34, 35, 61, 62)
  boardns= (13, 61)
  boards=[] ; devs= []
  for bn in boardns:
    phbname= "atb_%d"%bn
    board= atbwrap.OpenATBoard(phbname)
    boards.append(board)
    devs.append(board.findDevice("si5345"))
    #boards[-1].printDevices()
  rf_lols= 0
  atb_lols= 0
  act= "status"
  rf2ttclol= action(act)
  atbslol= ""
  for ix in range(len(devs)):
    rclol= devs[ix].cclosl()[0]
    atbslol= atbslol + str(rclol)+" "
  print "starting with %s: rf2ttc:%s atbs:"%(act, rf2ttclol),atbslol
  for mn in range(loops):
    act= "ramp"
    rf2ttclol= action(act).strip()
    if rf2ttclol=="lol":
      rf_lols= rf_lols+1
    atbslol= ""
    for ix in range(len(devs)):
      try:
        rclol= devs[ix].cclosl()[0]
        if rclol!=0: atb_lols= atb_lols+1
      except:
        rclol=9   # i2c error (appeared once)
      atbslol= atbslol + str(rclol)+" "
    print "%d %s: rf2ttc:%s atbs:"%(mn, act, rf2ttclol),atbslol
    rf2ttclol= action("rampdown").strip()
    # clear sticky after ramp down:
    atbslol= ""
    for ix in range(len(devs)):
      try:
        rclol= devs[ix].cclosl()[0]
        if rclol!=0: atb_lols= atb_lols+1
      except:
        rclol=9   # i2c error (appeared once)
      atbslol= atbslol + str(rclol)+" "
    print "ramp down lol:", rf2ttclol, atbslol
  print "loops:%d rf2ttc LOLs:%d, %d atbs LOLs:%d"%(mn+1,
    rf_lols, len(boardns), atb_lols)
  #cmd= "ls"
  #rc= os.popen(cmd).read()

if __name__ == "__main__":
  main()
