#!/usr/libexec/platform-python
import sys,os
import ipbuswrap,atbwrap,ttcpon.ttcponnet,popen_thread, ilogger
ticgpll= None
def action(act):
  global ticgpll
  """ act: ramp, rampdown or status
"""
  if act=="ramp":
    ticgpll.ramp(1)
    #ticgpll.ramp(1, 10)
    #print "ramp up..."
    act= "status"
  elif act=="rampdown":
    ticgpll.ramp(2, 0)
    #ticgpll.ramp(2, 10)
    #print "rampdown..."
    act= "status"
  else:   # status always read
    pass
  cmd= "ssh trigger@altri2 '~/rf2ttc/rf2ttc %s'"%act
  rc= os.popen(cmd).read()
  return rc

def main():
  global ticgpll
  if len(sys.argv) < 2 or (len(sys.argv)==2 and sys.argv[1]=="help"):
    print """
Usage:
loltest_poncru.py loops

loop loops times:
  -ramp clock (atb_34 must be connected (ref))
  -check LOL in RF2TTC 
  -check LOL on si5345, OLT1 sticky, ONUs sticky (ttcpon slc)
   i.e. 4 numbers: LOL olt1 onu13 onu23
  -check LOL on 2 crus (ssh trg@cru-supermicro aj/check69.sh...)
   cru13/dev6, cru23/dev9 i.e. 2 numbers
  -print a concise info in one line (0:no LOL, >0: sticky bits),
   count 3 types of errors:
     rf2ttc: a number 
     atb: (si5345 olt1 onu13 onu23)
     cru: dev6 dev9
  - NOT DONE yet: if LOL in CRU: #recovery action (stop if not successfull after 2x)
     olt init
     check CRU
   
"""
    sys.exit()
  loops= int(sys.argv[1])
  os.chdir(os.getenv('CTP3_WORK_DIRECTORY'))
  ipbuswrap.Init()
  ticg= atbwrap.OpenATBoard("atb_34")
  ticgpll= ticg.findDevice("si5345")
  ponnet= "ltu13_its"
  logger= ilogger.ilogger("loltest_poncru.log")
  tpnet= ttcpon.ttcponnet.TtcPonNet(logger, ponnet)
  #ast= tpnet.measureSticky()   #measureConfig()
  #print "ast",ast,"exiting..."
  #sys.exit(8)
  crussh= popen_thread.Sshcon(["ssh", "-t","-t", "trg@cru-supermicro", "bash"])
  rc=crussh.excmd("aliswmod enter Readout", 5) #; print("rc:",rc)
  rc=crussh.excmd("ps") ; print "rc:",str(rc)
  rf_lols=0
  atb_lols= 0      # detected in ATB 
  cru_lols= 0      # in CRU (over ssh)
  act= "status" ; rf2ttclol= action(act)
  #
  finalline= ""
  ast= tpnet.measureSticky()   #measureConfig()
  crustk= crussh.excmd("aj/check69.sh")
  print "starting with %s clock: rf2ttc:%s"%(act, rf2ttclol)
  print "  atb sticky:", ast
  print "  cru sticky:", crustk
  for mn in range(loops):
    act= "ramp"
    #act= "noact" ; rf2ttclol= "ok"
    #act="status"
    #act="local"
    rf2ttclol= action(act).strip()
    if rf2ttclol=="lol":
      rf_lols= rf_lols+1
    ast= tpnet.measureSticky()
    #print "ast:",ast
    # [atb_si5345, [olt,cru13,cru23]]
    if (ast[0]!=0) or (ast[1][0]!=0) or\
      (ast[1][1]!=0) or (ast[1][2]!=0): atb_lols= atb_lols+1
    crustk= crussh.excmd("aj/check69.sh")
    # string: U/WD/D cru13_stk U/WD/D cru23_stk
    cs= crustk.strip().split()
    #if rclol!=0: cru_lols= cru_lols+1
    #                         si ol c1 c2 WD  c1  WD  c2
    if (cs[0] != "U") or (cs[2] != "U") or (cs[1] != "0x0") or (cs[3] != "0x0"): 
      cru_lols= cru_lols+1
    finalline= "%2d %s: %3s %d %d %d %d %2s %4s %2s %4s"%\
      (mn, act, rf2ttclol, ast[0], ast[1][0],  ast[1][1], ast[1][2],
       cs[0], cs[1], cs[2], cs[3])
    print finalline
    rf2ttclol= action("rampdown").strip()
    # clear sticky after ramp down:
    ast= tpnet.measureSticky()
    crustk= crussh.excmd("aj/check69.sh")
    # string: U/WD/D cru13_stk U/WD/D cru23_stk
    cs= crustk.strip().split()
    print "ramp down sticky:", ast, cs
    #print "%d ->%s: rf2ttc:%s atbs/cru:"%(mn, act, rf2ttclol), ast,'/',cs
  rc=crussh.excmd("exit") #; print("rc:",rc)   # exit aliswmod
  rc=crussh.excmd("exit") #; print("rc:",rc)   # exit login sh  
  print "loops:%d rf2ttcLOLs:%d ATB sticky:%d CRUs sticky:%d"%(mn+1,
    rf_lols, atb_lols, cru_lols)
  #cmd= "ls"
  #rc= os.popen(cmd).read()

if __name__ == "__main__":
  main()
