#!/usr/libexec/platform-python
import sys,os
import ttcpon.ttcponnet,popen_thread, ilogger
def action(act):
  cmd= "ssh trigger@altri2 '~/rf2ttc/rf2ttc %s'"%act
  rc= os.popen(cmd).read()
  return rc
def action_corde(act):
  """     stdout
s 7 512   7 512 ok
m 7 150   512 662
m 7 -150  662 512
"""
  cmd= "ssh trigger@altri2 '~/rf2ttc/cordel.exe %s'"%act
  rc= os.popen(cmd).read()
  #print rc.strip()
  return rc
def main():
  if len(sys.argv) < 2 or (len(sys.argv)==2 and sys.argv[1]=="help"):
    print """
Usage:
loltest_poncru.py loops [action]

action: switch (default)  -switch between local/beam1 clock
        N                 -change clock shift in CORDE by N*10 ps
                           N: in 10ps unit (e.g. for 500ps use 50)

loop loops times:
  -switch clock (ssh to altri2 switching BCMAIN on RF2TTC BC1/LOCAL),
   and check LOL in RF2TTC 
  -check LOL on si5345, OLT1 sticky, ONUs sticky (ttcpon slc)
   i.e. 4 numbers: LOL olt1 onu13 onu23
  -check LOL on 2 crus (ssh trg@cru-supermicro aj/check69.sh...)
   cru13/dev6, cru23/dev9 i.e. 2 numbers
  -print a concise info in one line (0:no LOL, >0: sticky bits),
   count 3 types of errors:
     rf2ttc: a number 
     atb: (si5345 olt1 onu13 onu23)
     cru: dev6 dev9
  -if LOL in CRU: #recovery action NOT DONE YET
     (stop if not successfull after 2x)
     olt init
     check CRU
   
"""
    sys.exit()
  loops= int(sys.argv[1])
  if len(sys.argv)==3:
    shift10= sys.argv[2]   # action: shift clock
  else:
    shift10= None    # action: switch
  os.chdir(os.getenv('CTP3_WORK_DIRECTORY'))
  ponnet= "ltu13_its"
  logger= ilogger.ilogger("loltest_poncru.log")
  tpnet= ttcpon.ttcponnet.TtcPonNet(logger, ponnet)
  crussh= popen_thread.Sshcon(["ssh", "-t","-t", "trg@cru-supermicro", "bash"])
  rc=crussh.excmd("aliswmod enter Readout", 5) #; print("rc:",rc)
  rc=crussh.excmd("ps") ; print "rc:",str(rc)
  rf_lols={}
  rf_lols['local']= 0
  rf_lols['beam1']= 0
  atb_lols= 0      # detected in ATB 
  cru_lols= 0      # in CRU (over ssh)
  if shift10==None:
    act= "local" ; rf2ttclol= action(act)
  else:
    rc= action_corde("s 7 512")
    act= "beam1" ; rf2ttclol= action(act)   # corde only with beam1
  #
  finalline= ""
  ast= tpnet.measureSticky()   #measureConfig()
  crustk= crussh.excmd("aj/check69.sh")
  print "starting with %s clock: rf2ttc:%s"%(act, rf2ttclol)
  print "  atb sticky:", ast
  print "  cru sticky:", crustk
  for mn in range(loops):
    if shift10==None:
      if act=="local":
        act= "beam1"
      else:
        act= "local"
      #act= "noact" ; rf2ttclol= "ok"
      #act="status"
      #act="local"
      rf2ttclol= action(act).strip()
    else:
      if act=="local":
        act= "beam1"
        rc= action_corde("m 7 -"+shift10)
      else:
        act= "local"
        rc= action_corde("m 7 "+shift10)
      rf2ttclol= action("status").strip()
    if rf2ttclol!="ok":
      rf_lols[act]= rf_lols[act]+1
    ast= tpnet.measureSticky()
    # [atb_si5345, [olt,cru13,cru23]]
    if (ast[0]!=0) or (ast[1][0]!=0) or\
      (ast[1][1]!=0) or (ast[1][2]!=0): atb_lols= atb_lols+1
    crustk= crussh.excmd("aj/check69.sh")
    # string: U/WD/D cru13_stk U/WD/D cru23_stk
    cs= crustk.strip().split()
    #if rclol!=0: cru_lols= cru_lols+1
    #                         si ol c1 c2 WD  c1  WD  c2
    if (cs[0] != "U") or (cs[2] != "U") or (cs[1] != "0x0") or (cs[3] != "0x0"): 
      cru_lols= cru_lols+1
    if shift10==None:
      actX= act
    else:
      if act=="beam1":
        actX="-"+shift10
      else:
        actX=shift10
    finalline= "%2d ->%s: %3s %d %d %d %d %2s %4s %2s %4s"%\
      (mn, actX, rf2ttclol, ast[0], ast[1][0],  ast[1][1], ast[1][2],
       cs[0], cs[1], cs[2], cs[3])
    print finalline
    #print "%d ->%s: rf2ttc:%s atbs/cru:"%(mn, act, rf2ttclol), ast,'/',cs
  rc=crussh.excmd("exit") #; print("rc:",rc)   # exit aliswmod
  rc=crussh.excmd("exit") #; print("rc:",rc)   # exit login sh  
  print "loops:%d rf2ttcLOLs:%d+%d ATB sticky:%d CRUs sticky:%d"%(mn+1,
    rf_lols['local'], rf_lols['beam1'], atb_lols, cru_lols)
  #cmd= "ls"
  #rc= os.popen(cmd).read()

if __name__ == "__main__":
  main()
