#!/usr/libexec/platform-python

from __future__ import print_function
from __future__ import absolute_import
from builtins import str
from builtins import range
from builtins import object
import string, sys, time   # types
#!/usr/bin/python3
from .bcmasktxt import ORBITLENGTH,BCmask

#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
symname= ("PH", "PP", "CAL", "TOF","GAP1","GAP2")
defaults= ("", "", "3009", "", "343", "3016")   # run2 (filling/lhc2ctp.py)
#!/usr/bin/python3

#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3

#!/usr/bin/python3
#!/usr/bin/python3

class BCmasks(object):
  def __init__(self, board):
    """
    Operation: 
    - read all masks into self.bcmasks
"""
    self.board= board
    #read from a board
    #bcmask.data: 3564 words of 12 bits (12 BCmasks)
    msks_ValVector_uint32= self.board.ReadBlock("bcmasks.data", ORBITLENGTH, 0)
    msks= []
    for ix in range(len(msks_ValVector_uint32)):
      msks.append(msks_ValVector_uint32[ix])
    self.bcmasks= msks
    # see ctpemu.py -init only if emu not active
    self.pmsk= []
    print("BCmasks read from hw:")
    for ixmsk in range(len(symname)):
      self.pmsk.append(BCmaskhw(self, ixmsk))
      self.pmsk[-1].prt()
    # following moved to ctpemu.py (alwasy load when emu not active)
    #if self.board.pllwasloaded:
    #  print colors.color("PLL loaded, bcmask.allSetDefaults...","fg_red")
    #  self.allSetDefaults()
  def allSetDefaults(self): #read ltuIP.cfg (or put defaults if not there).HW updated
    print("BCmasks read from ltuIP.cfg and updating in hw...:")
    for ixbcm in range(len(defaults)):
      mname= symname[ixbcm]
      mnamecfg= mname+"_BC_mask"
      bcm= self.pmsk[ixbcm]
      cfgdef= self.board.ltucfgpar(mnamecfg)
      print("allSetDefaults:", mnamecfg, cfgdef,".")
      if cfgdef==None or cfgdef=="":
        mskdef= defaults[ixbcm]
        # Do not update (leave what was read from hw before)
      else:
        mskdef= cfgdef
        bcm.update(mskdef, alsohw=False)   # mskdef -> bcm
      bcm.prt()
    self.updatehw()
  def getbc(self, bc):
    return self.bcmasks[bc]
  def clearbc(self, bc, bitn):
    self.bcmasks[bc]= self.bcmasks[bc] & (~(1<<bitn))
  def setbc(self, bc, bitn):
    self.bcmasks[bc]= self.bcmasks[bc] | (1<<bitn)
  def updatehw(self):
    #print "update bcmasks.data in hw..."
    self.board.WriteBlock("bcmasks.data", self.bcmasks, 0)
  def getbcmstr(self, msknumber):
    #self.bcmasks[msknumber].bcmstr
    return self.pmsk[msknumber].bcmstr
  def excmd(self, cmd):
    # bcm tof show 0
    mskid= 3   # tof
    action= "show" ; ok1= True
    if len(cmd)>1:
      if cmd[1] in symname:
        mskid= symname.index(cmd[1])
      elif cmd[1]=='init':
        action= 'init'
        self.allSetDefaults()
      elif cmd[1]=='*':
        for mskid in range(len(symname)):
          self.pmsk[mskid].prt()
      else:
        print("Bad mask, expected one of:",symname)
        ok1= False
        action="err"
    else:
      self.printHelp()
    if ok1 and len(cmd)>2:
      action= cmd[2]
    if action=='show':
      self.pmsk[mskid].prt()
    elif action=="err" or action=='init':
      pass
    # bcm tof enable emuN       -for ctp (let's use emu bcm name ena/dis)...)
    elif 'enable'.find(action)==0:
      print("Not available here, use emu bcm %s enable"%cmd[1])
    #  self.board.SetBit("ctpemu.BCmask_ena", mskid)
    elif 'disable'.find(action)==0:
      print("Not available here, use emu bcm %s disable"%cmd[1])
    #  self.board.ResetBit("ctpemu.BCmask_ena", mskid)
    else:   # new mask: "4H3560L" or "0 1 2 3000"
      bcmdef= string.join(cmd[2:])
      self.pmsk[mskid].update(bcmdef, alsohw=True)   # definition-> bcm -> hardware
  def printHelp(self):
      print("""\033[0m\033[01m    BC masks \033[0m
bcm init          -init all BCmasks (ltuIP.cfg)
bcm *             -show all masks
bcm TOF
        show      -show (read from a board, default)
        3L2H3559L -new definition (bcmasks.data will be updated in a board)
                   Notes: 'H' -trigger generated
                          'L' -trigger not generated/suppressed
                   Spaces not allowed.
        3 4       -the same mask (3L2H36559L), i.e. only two BCs with BCids 3 
                   and 4 choosen (High). The list of meaningfull BCs separated
                   by spaces

In addition to TOF, following masks available:
%s

Note:
Mask enable/disable/state_whether_enabled is available with 'emu bcm' cmd, e.g.
emu bcm TOF e/d   -enable or disable TOF mask
emu bcm TOF       -show status (i.e. if enabled)

CAL and PP masks are always ENABLED (regardless of the state reported by 'emu bcm')

"""%str(symname))

class BCmaskhw(BCmask):
  def __init__(self,bcmasks,bitname):
    """
    bcmasks: BCmasks instance
    bitname: a bit poosition (i.e. int) in bcmask array 0..11
       0  1  2   3   4    5
       ph pp cal tof gap1 gap2
             seems (in future), gap1/2 wil lbecome global masks, while ph/pp/cal/tof
             will be defined for each emu instance in ctp
    bcmexp: "25L 25(2H2LH 3(23HL))"
          - H/h -> 1  L/l -> 0
          - spaces, new lines are white characters
          - ignore comment lines starting with #
          - max. 3564 bits (warning for less or more)
          : None -> read the content from a board
    Operation: 
    - self.bcmstr contains definition of a mask
    output: self.bcmstr initialised from a board or bcmexp
    """
    BCmask.__init__(self)
    self.bitname= bitname
    self.bcmasks= bcmasks
    self.updatebcmstr()
  def prt(self):
    print("bcmask %s: %s"%(symname[self.bitname], self.bcmstr))
  def updatebcmstr(self):
    """ bcmstr <- self.bcmasks[][self.bitname]
    """
    longbmstr= ""
    if (self.bitname==1) or (self.bitname==2):
      # read PP/CAL: take -4  (or +4 ?)
      for bc in range(ORBITLENGTH):
        if bc<=3:
          bchw= ORBITLENGTH-4+bc
        else:
          bchw= bc-4
        if self.bcmasks.getbc(bchw) & (1<<self.bitname):
          longbmstr= longbmstr+"H"
        else:
          longbmstr= longbmstr+"L"
    else:
      for bc in range(ORBITLENGTH):
        if self.bcmasks.getbc(bc) & (1<<self.bitname):
          longbmstr= longbmstr+"H"
        else:
          longbmstr= longbmstr+"L"
    self.bcmstr= self.shrink(longbmstr)
    #print "bcmstr:", self.bitname, self.bcmstr
  def update(self, bcmexp,alsohw=True):
    if bcmexp == None:
      print("bcmexp None: nothing done.")
      return
    bcmbits= BCmask.update(self,bcmexp)
    if self.errmsg!="":
      print("Bad mask definition,",self.errmsg)
      return
    # update new mask in self.bcmasks reflecting hw:
    if (self.bitname==1) or (self.bitname==2):    # PP,CAL special shift
      # write PP/CAL: -4 i.e. write bit0 -> bit(3564-4)
      for bc in range(len(bcmbits)):
        if bc<=3:
          bchw= ORBITLENGTH-4+bc
        else:
          bchw= bc-4
        if bcmbits[bc]==1:
          self.bcmasks.setbc(bchw, self.bitname)
        else:
          self.bcmasks.clearbc(bchw, self.bitname)
    else:
      for bc in range(len(bcmbits)):
        if bcmbits[bc]==1:
          self.bcmasks.setbc(bc, self.bitname)
        else:
          self.bcmasks.clearbc(bc, self.bitname)
    # recreate bcmstr from self.bcmasks[][self.bitname] -it will reflect
    # the board even in case of errorneous bcmexp
    self.updatebcmstr()
    if alsohw:
      print("updating hw with new bcmstr:",self.bcmstr)
      self.bcmasks.updatehw()
