#!/usr/libexec/platform-python

from __future__ import print_function
from builtins import input
from builtins import str
from builtins import range
from builtins import object
import string, sys, time   # types
#!/usr/bin/python3
ORBITLENGTH=3564

class ST(object):
  RIGHT=1 # bracket
  LEFT=2
  BIT=3   # bit (H or L -value 1 or 0)
  REP=4   # repetitions (int)
  EOM=5   # End Of Mask
  def __init__(self, text):
    """text: "3560L2(HL)"
"""
    self.token=None
    self.value=None
    self.length=0
    self.err=None
    if text=='': 
      self.token=ST.EOM; self.length=0
      #print "ST:EOM"
      return
    while 1:    # skip leading spaces
      if text[self.length]==' ': 
        self.length=self.length+1
        if self.length==len(text):
          self.token=ST.EOM; return
      else: break
    if text[self.length]=='L' or text[self.length]=='l':
      self.token=ST.BIT; self.value=0; self.length=self.length+1
    elif text[self.length]=='H' or text[self.length]=='h':
      self.token=ST.BIT; self.value=1; self.length=self.length+1
    elif text[self.length]=='(':
      self.token=ST.LEFT;  self.length=self.length+1
    elif text[self.length]==')':
      self.token=ST.RIGHT;  self.length=self.length+1
    elif text[self.length] in string.digits:
      self.length=self.length+1
      while 1:
        #print "text:",text, self.length
        if self.length>(len(text)-1): 
          self.err=text+" -premature end of mask definition (,L or H expected"
          break
        if text[self.length] in string.digits:
          self.length=self.length+1
        else: break
      self.token= ST.REP 
      self.value= int(text[:self.length])
    else:
      self.err=" bad string:"+ text
    #print "ST:", self.token, self.length, "val=",self.value

class BCmask(object):
  def __init__(self):
    """
    """
    self.level=0
    self.errmsg= ""
    #self.update(bcmexp)
  def prt(self):
    print("BCmask: %s"%(self.bcmstr))
  def update(self, bcmexp):
    """ 
bcmexp: "3563H1L" or "20 30 40"
output: self.bcmstr initialised from bcmexp
        self.errmsg: "":ok, rc: bcmbits: [0,1,1,..] 3564 ints representing mask
                     "err message" -rc not meaningful
"""
    if bcmexp == None:
      print("bcmexp None: nothing done.")
    else:
      self.errmsg=''
      #print("BCmask.update:",bcmexp)
      if (bcmexp.find("H")>=0) or (bcmexp.find("L")>=0):
        # 3560H4L
        self.newbcmdef= bcmexp
        bcmbits,chars= self.bcm2bits(0)
      else:
        bcmbits= []
        for bc in range(ORBITLENGTH):
          bcmbits.append(0)
        expints= bcmexp.split()   # string.split(bcmexp)
        processed= ""
        for bcn in expints:
          try:
            if bcn.find('0x')==0:
              bcmbits[eval(bcn)]= 1
            else:
              bcmbits[int(bcn)]= 1
          except:
            #PrintError("bad integer or hex (0x...) number:"+str(bcn))
            self.errmsg="bad integer or hex (0x...) number:"+str(bcn)
            continue
          if processed != "": processed= processed+" "
          processed= processed + bcn
        chars= len(processed)
      # bcmbits, chars filled now. ErrorMessage valid if chars != len(bcmbits)
      if len(bcmbits)>ORBITLENGTH:
        #PrintError("Too long BCmask definition (%d BCs)"%len(bcmbits))
        self.errmsg="Too long BCmask definition (%d BCs)"%len(bcmbits)
        del(bcmbits[ORBITLENGTH:])
      elif len(bcmbits)<ORBITLENGTH:
        #PrintError("Warning: short BCmask definition (%d BCs)"%len(bcmbits))
        self.errmsg="Warning: short BCmask definition (%d BCs)"%len(bcmbits)
      else:
        pass
      #if chars != len(self.bcmstr):
      #  print self.errmsg
      if self.errmsg=="":
        self.bcmstr= bcmexp
    return bcmbits
  def getst(self, ix):
    """
    ix -0..  -points to self.newbcmdef
    rc: token,ix   ix -> points just after token
    """
    st= ST(self.newbcmdef[ix:])
    return st
  def bcm2bits(self,ix=0):
    """ input: self.newbcmdef
    bcm2bits(0) returns:
    ([array_of_bits],string_length_of self.newbcmdef)
    """
    self.level= self.level+1
    if self.level>=10:return [2],0
    print("bcm2bitsSTART:",self.level,ix, self.newbcmdef)
    repc=1
    ix1=ix
    bitstr=[]
    while 1:
      st= self.getst(ix1)
      if st.token==ST.BIT:    # push
        for i in range(repc):
          bitstr.append(st.value)
        repc=1
        ix1=ix1+st.length
      elif st.token==ST.REP:
        repc=st.value
        ix1=ix1+st.length
      elif st.token==ST.LEFT:
        ix1=ix1+st.length
        bitstr2,ix2= self.bcm2bits(ix1)
        for i in range(repc):
          bitstr= bitstr+ bitstr2
        repc=1
        ix1=ix1+ix2
      elif st.token==ST.RIGHT:    # pop
        ix1=ix1+st.length
        if self.level<=1:
          #PrintError(") incorrectly placed at"+str(ix))       
          self.errmsg=") incorrectly placed at"+str(ix)
        break
      elif st.token==ST.EOM:    # pop
        ix1=ix1+st.length
        if self.level>1:
          #PrintError(") missing")       
          self.errmsg=") missing"
        break
      else:
        #PrintError("incorrect BC mask")       
        self.errmsg="incorrect BC mask"
        break
    self.level= self.level-1
    #print "bcm2bits:",bitstr,ix1
    return bitstr,ix1-ix
  def setbits_delme(self,lst=None):
    """lst: [pointer to list, bitnumber]
    bitnumber: 0..3
    """
    bcm,procesed=self.bcm2bits(0)
    if len(bcm)>ORBITLENGTH:
      return "Error: Too long BCmask definition\n"
    if procesed== len(self.bcmstr):
      bitmask= 1<<lst[1]
      #print "setbits1:",bitmask,bcm,procesed
      #lst[0][1:2]=[10,11]
      for ix in range(len(bcm)):
        if bcm[ix]==1:
          lst[0][ix]= lst[0][ix] | bitmask
        else:
          lst[0][ix]= lst[0][ix] & (0xf & ~bitmask)
      #print "setbits2:",lst[0][0:9]
      if len(bcm)<ORBITLENGTH:
        if self.errmsg=='':
          return "Warning: %d: short BCmask definition for %s (bits above %d not touched)\n"%(
            len(bcm), self.name, len(bcm))
        else:
          return self.errmsg
      else:
        return None
    else:
      return self.errmsg
  def checkSyntax(self):
    self.ErrorMessage=''
    locmasks=[]; 
    for i in range(ORBITLENGTH):
      locmasks.append(0)
    errmsg= self.setbits([locmasks, 0])
    return errmsg
  def chrep(self, ch, rep):
    if rep==1:
      return ch
    else:
      if len(ch)==1:
        return "%d%s"%(rep, ch)
      else:
        return "%d(%s)"%(rep, ch)
  def shrink(self, msk,width=1,start=0):
    """ correct result only for width=1 with any mask.
    Idea with 'width' seems not applicable:
    H1 -not repeatable, i.e. string must be finished by H, L or )
    in the case of ), the corresponding nmber of ( must match
    examples of good/bad msk:
  
    """
    ix1=start; 
    ous= msk[:start]
    lenmsk=len(msk);
    while ix1<lenmsk:
      ix2= ix1+width; 
      rep=1; 
      if ix2>=lenmsk:
        ch=msk[ix1:]
        ous= ous+self.chrep(ch,rep)
        break
      ch=msk[ix1:ix2]
      #print "bcmask.shrink:%d:ch:"%ix1,ch ; time.sleep(0.1)
      while ix2<lenmsk:
        if ch==msk[ix2:(ix2+width)]:
          rep= rep+1; ix2= ix2+width
          #print "rep:",rep,ix2
        else:
          #ous= ous+self.chrep(ch,rep)
          #ix1=ix2
          break
      ous= ous+self.chrep(ch,rep)
      #print "  ",self.chrep(ch,rep),"ix1:",ix1
      ix1=ix2
    #ous= ous+self.chrep(ch,rep)
    return ous

def main():
  # parted.py partname
  if len(sys.argv) < 2 or (len(sys.argv)==2 and sys.argv[1]=="help"):
    print("""
Usage: bcmask.py maskdef
""")
    sys.exit()    
  bcmexp= sys.argv[1]
  msk= BCmask() ; msk.update(bcmexp)
  print("errmsg:",msk.errmsg)
  while True:
    bcmexp= input(">").strip()
    if bcmexp=='q': break
    msk.update(bcmexp)
    msk.prt()
    print("errmsg:",msk.errmsg)
if __name__ == "__main__":
  main()

