#!/usr/libexec/platform-python
from __future__ import print_function
from __future__ import division
from builtins import str
from builtins import range
from past.utils import old_div
import sys,os,string,colors #,saxipbus
def printError(incolor, msg=""):
  print(colors.color(incolor, "fg_red"), msg)
def parseline(line):
  if len(line)==0: return None
  ixhs= line.find('#')
  if ixhs>-1:
    linenc= line[:ixhs]
  else:
    linenc= line
  rc= linenc.strip().split()
  if len(rc)==0: return None
  return rc
def getfile(fpath, errprint=True):
  try:
    fd= open(fpath,"r") ; netcfg= fd.readlines() ; fd.close()
  except:
    if errprint: printError("%s missing?"%fpath)
    return None
  return netcfg

def find1rand(N):
  primes= (3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61,67,71,
    73,79,83,89,97,101,103,107,109,113,127,131,137,139,149,151,157,163,167,173,
    179,181,191,193,197,199,211,223,227,229,233,239,241,251,257)
  if N>primes[12]:
    nfix=12
  elif N<4:
    return 1 
  else: nfix= 0
  nfirst= primes[nfix]
  while (N % nfirst) == 0: 
    nfix=nfix+1
    nfirst= primes[nfix]
    if nfix>=len(primes):
      print("cannot find right number")
      return None
  print("N:%d nfirst:%d"%(N, nfirst))
  return nfirst
def cdworkdir():
  wkdir= os.getenv('CTP3_WORK_DIRECTORY')
  if not wkdir:
    print("Env. variable CTP3_WORK_DIRECTORY not set.")
    sys.exit(8)
  if not os.path.isdir(wkdir):
    print("Creating work directory:",wkdir,"...")
    os.mkdir(wkdir)
  os.chdir(os.getenv('CTP3_WORK_DIRECTORY'))
def getarg1():
  if len(sys.argv) < 2: return ""
  p1= sys.argv[1].split('.')
  if (len(p1)==2) and (p1[1]=="net"):
    return p1[0]
  else:
    return sys.argv[1]
def cmdarg(n, default=""):
  global cmd
  if len(cmd)>n: 
    return(cmd[n])
  else:
    return(default)
def isinargs(myid):
  for ida in sys.argv[2:]:   # start search after 1st arg (1st arg: name.net or boardN)
    #print "isinargs:", ida
    if ida==myid: return True
  return False
def rmcomment(cmd):
  for ix in range(len(cmd)):
    if cmd[ix][0]=='#':
      del(cmd[ix:])
      break

BCFREQ=40.0785
ORBITL=3564
def hz2khz(hz):
  if hz>100000.:
    rc= "%.2fkhz"%(hz/1000.)
  else:
    rc= "%.2fhz"%(hz)
  return rc
def bc2hz(bcs):
  hz= BCFREQ*1000000./(bcs+1)
  return hz2khz(hz)
def rnd2hz(n):
  hz= old_div(n*(BCFREQ*1000000),0x7fffffff)
  return hz2khz(hz)
def fromms(newval, myfreq=BCFREQ):
  """return: None if syntax error, else: # of BCs between 2 triggers as a string
newval:
string representing 
-rate in: hz khz mhz or 
-period in: s ms us or
-raw value to be written in register (integer or hexa value)

Examples of newval string:
0          -> BC rate (40MHz)
1          -> 40/2 MHz rate
4000       -> generate 1 START signal per 100 micsecs
40000      -> generate 1000 START signals per second
40000000   -> generate 1 START signal per second
0x7fffffff -> generate 1 START signal per 53.7 seconds
n          -> generate 1 START signal per (n+1)/BC micsecs, where
              BC is BC rate (40*10**6)

or use: s  (seconds)  ms  (miliseconds)  us  (micsecroseconds)   for period or
        hz (Hertz)    khz (Kilohertz)    mhz (Megahertz)         for rate:
3s    -   3 seconds
10ms  -  10 miliseconds period
300us - 300 microseconds period
3khz  -   3 kilohertz rate
1mhz  -   1 megahertz rate

  """
  try:
    if newval[-1].lower()=='s':   # period given in s,ms, or us
      #  n= period*BC-1  n->VMEwrite, period[micsecs], BC[MHz]
      retval= newval[:-1]
      mult=1000000
      if retval[-1].lower()=='m':     # milisecs
        retval= retval[:-1]
        mult=1000
      elif retval[-1].lower()=='u':   # micsecs
        retval= retval[:-1]
        mult=1
      retval=str(int(float(retval)*mult*myfreq-1))
    elif newval[-2:].lower()=='hz':   # rate given: hz khz or mhz
      retval= newval[:-2]
      mult=1000000
      if retval[-1].lower()=='m':     # mhz
        retval= retval[:-1]
        mult=1
      elif retval[-1].lower()=='k':   # khz
        retval= retval[:-1]
        mult=1000
      retval=str(int(myfreq*mult/float(retval)-1))
    elif (len(newval)>2) and (newval[:2]=='0x'):  # direct hexa
      #retval=newval
      intrep=eval(newval)
      retval= str(intrep)
    else:     # n given directly as int
      intrep= int(newval)
      retval= str(newval)
  except:
    retval=None
  #print "fromms:",oldval,type(oldval), newval,type(newval),retval
  return retval
def frommsRandom(newval):
  """return: None if syntax error
newval: string ending by
  1. us ms s, i.e. defining period length
  2. hz khz mhz, i.e. defining frequency
  3. integer or hexa number (0x...) giving a raw 31 bits value

Average rate of the randomly generated signals is coded in low 31 bits:
0x7fffffff -maximum rate
n          -the average rate will be set to n*BC/0x7fffffff hz where BC is
            bunch crossing rate (40MHz). I. e. for rate 1000 Hz,
            n= 1000*0x7fffffff/40/10**6 = 53687
For convenience, period can be given in micsecs [us] milisecs [ms]
or rate in megahertz [mhz] kilohertz [khz] or hertz [hz]
or seconds [s]. Examples of newval string:
100us  -average period 100 micseconds
30ms   -average period 30 miliseconds
5s     -average period 5 seconds
3khz  -   3 kilohertz rate
1mhz  -   1 megahertz rate

"""
  try:
    if newval[-1].lower()=='s':   # period given in s,ms, or us
      retval= newval[:-1]
      mult=1000000
      if retval[-1].lower()=='m':     # milisecs
        retval= retval[:-1]
        mult=1000
      elif retval[-1].lower()=='u':   # micsecs
        retval= retval[:-1]
        mult=1
      rate= 1000000./(mult*int(retval))
      #print "frommsRandom:", rate, retval
      retval= str(int(old_div(old_div(0x7fffffff,BCFREQ),10**6) * rate))
    elif newval[-2:].lower()=="hz":
      retval= newval[:-2]
      mult=1
      if retval[-1].lower()=='m':     # mhz
        retval= retval[:-1]
        mult=1000000
      elif retval[-1].lower()=='k':   # khz
        retval= retval[:-1]
        mult=1000
      rate= mult*int(retval)
      retval= str(int(old_div(old_div(0x7fffffff,BCFREQ),10**6) * rate))
    elif (len(newval)>2) and (newval[:2]=='0x'):  # direct hexa
      intrep=eval(newval)
      retval= str(intrep)
    else:                 # n given directly as int
      intrep= int(newval)
      retval= str(newval)
  except:
    retval=None
  return retval
#!/usr/bin/python3
def getseltx(cmd):
  seltx=None 
  if cmd=="prbs7":
    seltx= 0
  elif cmd=="prbs23":
    seltx= 1
  elif cmd=="const":
    seltx= 2
  elif cmd=="count":
    seltx= 3
  elif cmd=="onu":  #toto uz asi nie je platne  (robi sa cisto cez tdimux+tdomux)
    seltx= 4
  else:
    pass
  return seltx

def ltucfgpars(bname, par):
  """ rc: None -not defined, or ltuBOARDIP.cfg file does not exist
          ""   -just name defined (no value given)
          "rest of the line"        e.g. "PARNAME rest of the line
"""
  import saxipbus
  ip= saxipbus.findIP(bname)
  # or from self.board.uri (for opened board):
  #tarid="target="
  #tix= uri.find(tarid)
  #ip= uri[tix+len(tarid):].split(':')[0]
  #
  #if ip==None: ip= "testip"
  if ip==None: return(None)
  #print("ltucfgpars {0} ip:{1}:".format(bname, ip))
  fn= os.path.join(os.getenv("CTP3_CONFIG_DIRECTORY"), "ltu"+ip+".cfg")
  if not os.path.exists(fn): return None
  fp= open(fn, "r")
  rc= None
  for line in fp.readlines():
    ls= line.split()
    if len(ls)==0: continue
    if line[0]=='#': continue
    if ls[0]==par:
      if len(ls)>1:
        rc= " ".join(ls[1:])
      else:
        rc= ""
  fp.close()
  #print("ltucfgpars({},{})={}= ip:{}".format(bname, par, rc, ip))
  return(rc)

def findProcess(process_name="python",ttypid="pid"):
  """ an example of output:
aj        4384 python -u /home/aj/git/ctp3-ipbus/ccm/ltud/ltud_server.py hmp start
aj        4844 python -u /home/aj/git/ctp3-ipbus/ccm/ctpd/ctpd_server.py ctp start
aj        5242 python
aj        5799 python /home/aj/git/ctp3-ipbus/cmdpy/ltu/ltuctl.py 2
aj        6473 python ./findproces.py

"""
  from subprocess import Popen, PIPE
  #process= Popen(['cat', 'test.py'], stdout=PIPE, stderr=PIPE)
  cmd= "ps --columns 120 -C %s h o user,%s,args"%(process_name,ttypid)
  process= Popen(cmd.split(), stdout=PIPE, stderr=PIPE)
  stdout, stderr = process.communicate()
  return stdout
  
def main():
  if len(sys.argv) < 2:
    print("""
./auxfuns.py rate [N]
python auxfuns.py 45.4khz 86*47*53*59
""")
    return
  rate= sys.argv[1]
  bcs= fromms(rate)
  print("rate {0}: {1} BCs between 2 triggers".format(rate, bcs))
  if len(sys.argv) > 2:
    N= eval(sys.argv[2])
    nfirst= find1rand(N)
    print("Checking, should give %d items in a..."%N)
    n= nfirst
    a=[]
    while True:
      a.append(n)
      n=(n+nfirst)%N
      if n==nfirst: break
    #a.sort()
    print(len(a), a)

if __name__ == "__main__":
  main()
