from __future__ import print_function
from builtins import range
from builtins import object
import os,colors
FIFO_PATH = "/tmp/fifo_"
def wopenfifo(atbname):
  fipa= FIFO_PATH+atbname
  if not os.path.exists(fipa):
    os.mkfifo(fipa)
  elif os.access(fipa, os.W_OK):
    pass
  else:
    print("Error: Cannot open", fipa)
    return None
  fifoout= open(fipa, "w")    # w defaults in wt
  if fifoout==None:
    print("Error: Cannot open", fipa)
  return fifoout

def wfifo(fifo, line):   # fifo: opened before wopenfifo()
  fifo.write(line+"\n") ; fifo.flush()
 
class ExtInput(object):
  def __init__(self, cmd, oltname):
    self.inputsstack= [] ; self.inames= []
    #if cmd[0]=="fifoin"
    if len(cmd)>1:   # fifoin scriptname    i.e. inputs from file
      #print "reading from a file not implemented yet"
      self.openfile(cmd[1])
    else:   # fifo
      self.openfifo(oltname)
  def fifoontop(self):
    if self.inames[-1].find("/tmp/fifo_")==0:
      return True
    else:
      return False
  def openfile(self, fname):
    if not os.path.exists(fname):
      print("Error: %s does not exist in working directory, trying CTP3_ROOT/scripts/..."%fname)
      fname_r= os.path.join(os.getenv("CTP3_ROOT"), "scripts", fname)
      if not os.path.exists(fname_r):
        print("Error: %s does not exist."%fname_r)
        return False
    else:
      fname_r= fname
    fifoin= open(fname_r, "r")
    if fifoin:
      self.inputsstack.append(fifoin)
      self.inames.append(fname_r)
      print("reading from %s..."%(fname_r))
      return True
    else:
      print("Error: Cannot open", fname_r)
      return False
  def openfifo(self, oltname):
    for ix in range(len(self.inames)):
      #if self.fifoontop():
      if self.inames[ix].find("/tmp/fifo_")==0:
        print("Error: fifoin nested call not allowed with FIFO")
        return False   
    if not os.path.exists(FIFO_PATH+oltname):
      os.mkfifo(FIFO_PATH+oltname)
    fifoin= open(FIFO_PATH+oltname, "r")
    if fifoin:
      self.inputsstack.append(fifoin)
      self.inames.append(FIFO_PATH+oltname)
      print("reading from %s..."%(FIFO_PATH+oltname))
      return True
    else:
      print("Error: Cannot open", FIFO_PATH+oltname)
      return False
  def fifoin(self, cmd, oltname):
    if len(cmd)==1:   # open fifo
      self.openfifo(oltname)
    else:   # open file
      #print "reading from a file not available yet"
      self.openfile(cmd[1])
  def rmtop(self):
    print("end of %s..."%self.inames[-1])
    self.inputsstack[-1].close()
    del self.inames[-1]
    del self.inputsstack[-1]
  def readline(self):
    fd= self.inputsstack[-1]
    line= fd.readline()
    if line=='':
      if self.fifoontop():
        #special treatment of fifo:
        fd.close()   # print "reading from stdin..." ; fifoin= None
        self.inputsstack[-1]= open(self.inames[-1], "r")
        print("fifoin: empty line received, fifo closed/open. (use stdin to get back stdin mode) ")
      else: #input from file, EOF
        self.rmtop()
    else:
      line= line[:-1]
      #print "fifoin %s:%s"%(self.inames[-1],line)
      basen= os.path.basename(self.inames[-1])
      if len(line)>0 and line[0]=='#':
        linec= colors.color(line,"fg_blue")
      else:
        linec= line
      print(colors.color("fifoin %s:"%basen, "fg_blue"), linec)
      ixcomment= line.find('#')
      if ixcomment>=0:
        line= line[:ixcomment]
      if line=="stdin":
        self.rmtop()
        line= ""
    return line
