#!/usr/libexec/platform-python
import tri_grpcs
import atb.partdef
class LTU_grpcs:
  def __init__(self):
    self.ltus= atb.partdef.LTUS.ltus
    self.ltuds= {}   # dict. of TRG_grpc instances
    for detn in tri_grpcs.grpc_channels.keys():   # all ltu + ctp daemons
      if detn=="ctp": continue
      if not (detn in self.ltus):
        print("{} not in LTUS".format(detn))
        continue
      ltu= self.ltus[detn]
      if ltu == None: continue    # known, but not in ctpboards.cfg
      if ltu.emun == None: continue # not part of ctp.net
      self.makegrpc(detn)
  def makegrpc(self, detn):
    self.ltuds[detn]= tri_grpcs.TRG_grpc(detn)
    if self.ltuds[detn].channel:
      print("ltud:{} active.".format(detn))
    else:
      print("ltud:{}/{}  wired (ctp.net), but grpc connection to ltud failed)."\
        .format(detn, self.ltus[detn].bname))
    return self.ltuds[detn].channel
  def getgrpcs(self):
    return self.ltuds
  def getltustub(self,ltuname, reconnect=False):
    """ rc: (ltustub,"")  -ok, ltustub exists, or
            (None, errmsg)
reconnect: check if ltud ON before returning ltustub
Note: strange: it seems it succeeds only when ltud is ON longer time (minutes?)
"""
    ltustub= None
    msg= "???"
    if ltuname in self.ltuds:
      ltustub= self.ltuds[ltuname].stub
      channel= self.ltuds[ltuname].channel
      if tri_grpcs.grpc_server_on(channel):
        channelon= True
      else:
        channelon= False
      if ltustub and channelon:
        msg= ""
      else:
        if reconnect:
          print("reconnecting {} channelon:{}...".format(ltuname, channelon))
          rc= self.makegrpc(ltuname)
          if rc==None:
            msg= "reconnect did not succeed"
          else:
            msg= "reconnect succeeded"
            ltustub= self.ltuds[ltuname].stub
        else:
          msg= "ltud {}: Dead".format(ltuname)
    else:
      msg= "Unknown ltud {}".format(ltuname)
    return ltustub,msg


