#!/usr/libexec/platform-python
from __future__ import division
from __future__ import print_function
from builtins import str
from builtins import range
from builtins import object
#!/usr/bin/python3
import time,os,string,types,json,sys,signal,random

quit= None
def signal_handler(sig, frame):
  global quit
  print('CTRL+c pressed !')
  if quit==None:
    quit= "q"
  else:
    print("quit:q -CTRL C pressed more times?")
  #sys.exit(0)
  
def round_floats(o):
  # https://stackoverflow.com/questions/1447287/format-floats-with-standard-json-module
  if isinstance(o, float): return round(o, 2)
  if isinstance(o, dict): return {k: round_floats(v) for k, v in list(o.items())}
  if isinstance(o, (list, tuple)): return [round_floats(x) for x in o]
  return o
class MetrDB(object):
  smoothperc= 0.03
  def __init__(self,name):
    self.name= name   #string.split(name,".")[0]
    self.lastdata= {}   # last measured values (different time for each item)
    # they may not be written in DB, i.e. it can happen even bigger
    # change is not registered in DB if it changed in small steps
    # todo: introduce lastdatawritten and use it instead when
    # compared for smoothing
    wrkdir= os.getenv("CTP3_WORK_DIRECTORY")
    dbname= os.path.join(wrkdir,self.name+".mdb")
    # Assuming the metrics are written by only 1 process (1 ltud/net)
    self.mdbf= open(dbname, "a")   # "a+" allow simultaneous add/read
    #
    # following upper (in ttcponnet.py)
    #self.wsup= tri_ws.WSclient(self.name) ; wser= "ok"
    #if self.wsup.ws==None:
    #  wser= "failed"
    print("MetrDB: %s open."%(dbname))
  def Stop(self):
    for ldk in list(self.lastdata.keys()):
      if self.lastdata[ldk]==None:
        del self.lastdata[ldk]
      else:
        self.lastdata[ldk]= None
    ts= time.time()
    #self.mdbf.write("%f %s\n"%(ts, str(self.lastdata)))
    self.myjson(ts, self.lastdata)
    #self.mdbf.write("%f %s\n"%(ts, str(None)))
    self.myjson(ts, None)
    self.mdbf.close()
    #self.wsup.ws_close()
    print('Stop', self.name)
  def myjson(self, ts, dic):
    #self.mdbf.write("%.3f %s\n"%(ts, json.dumps(dic)))
    #self.mdbf.write("%.3f %s\n"%(ts, json.dumps(round_floats(dic))))   # less compact
    self.mdbf.write("%.3f %s\n"%(ts, json.dumps(round_floats(dic),separators=(',',':'))))
  def differs(self, lval, nval):
    if type(lval) != type(nval):
      rc= True
    elif lval==nval:
      rc= False
    elif (type(lval)==float) or (type(lval)==int):
      #perc= old_div(abs(lval-nval),((nval+lval)/2.))
      perc= abs(lval-nval)/((nval+lval)/2.)
      if perc < self.smoothperc:
        #print "metrdb float smoothen %.3f"%perc,lval,nval
        rc= False
      else:
        rc= True
    else:
      rc= True
    return rc
  def Update(self, ts, data):
    """ Unconditional update (no smoothing). Used only for config data.
"""
    #for nkey in self.data.keys():
    #  self.lastdata[nkey]= self.data[nkey]
    self.myjson(ts, data)
    self.mdbf.flush()
  def UpdateSmooth(self, ts, data):
    """self.lastdata should be updated ONLY if different w.r.t. previous value!
If updated always, the data written to DB can drift out of limit, in case
they change in one direction only
"""
    rc= ""
    nkd = dict.fromkeys(list(data.keys()), None)
    dbrec= {}
    # 3 cases when considering previous/new data:
    # last   new
    #A 1     0      0: key not available or value is None
    #B 1     1
    #C 0     1
    for lkey in list(self.lastdata.keys()):
      lval= self.lastdata[lkey]
      nval= None
      if lkey in data:   #B: last and current available
        del nkd[lkey]
        nval= data[lkey]
        if self.differs(lval, nval):
          dbrec[lkey]= nval
          self.lastdata[lkey]= nval
          #print "metrdb:%s"%lkey,lval,nval
        #else:
          #print "metrdb smoothen (<%.3f) %s:"%(self.smoothperc, lkey),lval,nval
      else:                    #A: lkey has just became None, or 2nd time None
        #if self.differs(lval, nval):
        if lval!= None:
          dbrec[lkey]= nval   # just became None (nval is None)
          self.lastdata[lkey]= nval
      #self.lastdata[lkey]= nval   # data can drift out of the limit
    # nkd: keys for new data only (i.e. not available in prev. measurement)
    for nkey in list(nkd.keys()):    #C: new keys (not available before)
      dbrec[nkey]=self.lastdata[nkey]= data[nkey]
    # update on disk
    if dbrec!={}:   # at least one value changed
      #self.mdbf.write("%f %s\n"%(ts, str(dbrec)))
      try:
        self.myjson(ts, dbrec)
        self.mdbf.flush()
      except:   # IOError:
        import sys
        rc= "UpdateSmooth exception: "+ str(ts) + ":"+str(sys.exc_info())
    return rc
    #print ts,dbrec
    #print 'Update done for', self.name
def main():
  if len(sys.argv)<2:
    print("""
metrdb.py netname    -write values to WORK/netname.mdb file
                      values: 3 values, randomly choosen, increased by 1

press CTRL C to stop
""")
    return
  netname= sys.argv[1]
  seqdata= True
  if len(sys.argv)>2:
    if sys.argv[2]=="rnd": seqdata= False
  mymdb= MetrDB(netname)
  # simple configuration (read once, at the start of ltud). netname.net file:
  # atb_24
  # 1 atb_27:2 33
  # gbt1 sfp
  # 
  # i.e. it defines following connections:
  # olt1 ---- ttcpon splitter --- onu1 (in atb_27, address:2)
  #                           --- onu2 (in CRU, address: 33)
  # gbt1
  cfgdata= {}
  #cfgdata["onu"]= "onu_vendor,onu_partnum,onu_serialnum"] -see note for 'onu_...' below
  cfgdata["cfg.atb"]= 27
  cfgdata["cfg.o1.vendor"]= "vendorid"
  cfgdata["cfg.o1.part"]= "partnumber"
  cfgdata["cfg.o1.serial"]= "serialnumber"
  cfgdata["cfg.o1.onu2.vendor"]= "onuvendor1_1"
  cfgdata["cfg.o1.onu2.part"]= "onupart1_1"
  cfgdata["cfg.o1.onu2.atb"]=  27               # LTU (if not in then CRU)
  cfgdata["cfg.o1.onu33.vendor"]= "onuvendor1_1"
  cfgdata["cfg.o1.onu33.part"]= "onupart1_1"
  cfgdata["cfg.o1.onu33.serial"]=  "serial33"
  cfgdata["cfg.g1.vendor"]= "gbt1vendor" 
  cfgdata["cfg.g1.part"]= "gbt1part" 
  cfgdata["cfg.g1.serial"]= "gbt1serial" 
  mymdb.Update(time.time(), cfgdata)
  # initial values (ltud start):
  data= {}
  data["atb.tc74"]= 36   # centigrades
  data["atb.tfpga"]= 50   # centigrades
  # onu - we do not monitor onu on LTU (it is moitored over SLC) ?
  #data["onu_temp"]= 45
  #data["onu_rxpwr"]= -9.8
  #data["onu_txpwr"]= -4.1
  data["olt.o1.temp"]= 45      # centigrades
  data["olt.o1.txpwr"]= -9.8    # dBm
  data["olt.o1.rxpwr"]= -4.5    # dBm
  data["olt.o1.sticky"]= 0
  data["olt.o1.onu2.err8b10b"]= 0
  data["olt.o1.onu33.err8b10b"]= 0
  data["olt.o1.onu2.fineph"]= 3567.67
  data["olt.o1.onu33.fineph"]= 4567.6
  data["gbt.g1.temp"]= 45
  data["olt.g1.txpwr"]= -9.8    # dBm
  data["olt.g1.rxpwr"]= -4.5    # dBm
  data["cnts.PH"]= 5000
  data["cnts.PP"]= 10
  data["cnts.prevts"]= 1614695478.574
  # monitoring
  dts= time.time()
  rcupd= mymdb.UpdateSmooth(dts, data) # update db
  keys= list(data.keys())
  while True:
    changedvals= []
    for ix in range(3):
      changedvals.append(keys[random.randint(0, len(keys)-1)])
    time.sleep(5)
    dts= time.time()
    print(dts)
    if quit!=None: break
    #for mm in data:
    for mm in changedvals:
      if type(data[mm]) == list:
        ix= random.randint(0,len(data[mm])-1)
        data[mm][ix]= data[mm][ix] + 1
      else:
        data[mm]= data[mm] + 1
      #todo: sometimes value(s) becomes unavailable -null passed in this case
      print("  ",mm,":", data[mm])
    #rcupd= mymdb.UpdateSmooth(dts, data) # update db (smoothly)
    rcupd= mymdb.Update(dts, data) # update db unconditionally
  #
  mymdb.Stop()
if __name__ == '__main__':
  signal.signal(signal.SIGINT, signal_handler)
  main()
