#!/usr/libexec/platform-python
from __future__ import print_function
try:
  from builtins import str
except ImportError as e:
  import sys
  print(str(e))
  print("try 'pip install future'")
  sys.exit()
import xml.sax,traceback
import threading,os
from atb.partdef import LTUS

ConnectionFileName= os.path.join(os.getenv("CTP3_CONFIG_DIRECTORY"),"alice_cf.xml")
#!/usr/bin/python3
#!/usr/bin/python3
AliceBoards= os.path.join(os.getenv("CTP3_CONFIG_DIRECTORY"),"alice_boards.xml")

class pingThread (threading.Thread):
  #def __init__(self, threadID, name):
  def __init__(self, ip, name=None, fwcb=None):
      threading.Thread.__init__(self)
      self.ip = ip
      self.name = name
      self.fwcb = fwcb
      self.fwinfo = "???"
      self.fwsubver= 0
      self.onoff = "--"
  def run(self):
    #ping -c 1 -w 1 -n -q => Count:1, Timeout:1sec, Numeric only, Quiet
    #self.response = (os.system("ping -c 1 -w 1 -n -q %s >/dev/null 2>&1"%(self.name)))>>8
    if self.ip.find("500")==0:
      resp= 0
    else:
      resp = (os.system("ping -c 1 -w 1 -n -q %s >/dev/null 2>&1"%(self.ip)))>>8
    if resp==0: 
      self.onoff="on"
      if self.fwcb:
        self.fwinfo, self.fwsubver= self.fwcb(self.name)
    #self.prt()
  def prt(self):
    #print self.ip,":", self.response
    print("prt:", self.name, self.ip,":", self.onoff, self.fwinfo, self. fwsubver)

def  ATBmonclient(atbm_m):   # update in atbmon server
  try:
    import rpyc
    c = rpyc.connect("localhost", 18861)
    c.root.update(str(atbm_m))
    c.close()
    print("atbmon updated")
  except:
    pass #print "cannot connect to atbmon.",traceback.format_exc()
  c= None

class ConnectionHandler( xml.sax.ContentHandler ):
   def __init__(self, fwcb=None):
      self.fwcb= fwcb
      self.currenttag= ""
      self.ids= {}   # atbname:[xmlname, ip,pingThreadinstance]
      self.tagid = ""
      self.address_table = ""
   # Call when an element starts
   def startElement(self, tag, attributes):
      self.currenttag= tag
      if tag == "connection":
         self.tagid = str(attributes["id"])
         #self.ids.append(self.tagid)
         #self.ids[self.tagid]= str(attributes["address_table"])
         #print "*****connection id:", self.tagid,":", attributes.keys()
         #print "*****connection id:", self.tagid,":", attributes["uri"]
         ixmlf= attributes["address_table"].find("file://")
         xmlf= attributes["address_table"][ixmlf+7:]
         ip= self.getip(attributes["uri"])
         #print "*****connection id:", self.tagid, attributes["address_table"],ip
         if ip!="":
           thr= pingThread(ip, self.tagid, self.fwcb) ; thr.start()
         else:
           thr= None
         self.ids[self.tagid]= [xmlf, ip, thr]
   def getip(self, uri):
     target= uri.find("target=")
     #print "getip:", uri, target
     if target>0:
       #ipport= uri[target+7:]   # ip:port
       ip= uri[target+7:].split(":")[0]   # ip only
     elif uri.find("//localhost")>0:   # see pingthread (...find("500") for dummy board
       #ip="localhost"
       ix= uri.find("//localhost:")
       ip= uri[ix+12:]
     else:
       ip= ""
     return ip
   def printAll(self, cfinfo):
     """ cfinfo: { phbname:[addrtable.xml,ip]...}

     """
     print("id         address_table        sv    ip              \ton/off")
     print("---------- -------------------- ----- ----------------\t-----")
     bnames= list(self.ids.keys()) ; bnames.sort()
     #print "bnames:", bnames  #"cfinfo:", cfinfo
     atbm_m= {}   # prepare for atbmon update. atbm_m[bname]= adtable
     cfokerrs= {}
     cfokerrmsgs= {"!":"fwinfo does not correspond to CFG/alice_cf file",
        "?":"fwinfo cannot be read (board not connected)",
        "W":"fwinfo cannot be read, no entry in CFG/alice_cf",
        "E":"board entry missing in CFG/alice_cf"}
     for keyid in bnames:
       adtable= self.ids[keyid][0]   # minimal.xml
       if self.ids[keyid][2]!= None:
         self.ids[keyid][2].join()   # wait till thread finished
         onoff= self.ids[keyid][2].onoff
         subver= "  "
         if self.fwcb and onoff=="on":
           adtable= self.ids[keyid][2].fwinfo   # calculated from fwinfo. no .xml
           if adtable==None:
             adtable= "Unknown"
           else:
             if self.ids[keyid][2].fwsubver>0:
               subver= "%2.2x"%self.ids[keyid][2].fwsubver
             #if adtable.find("ltu_logic_v")==0:   # monitoring only ltu_logic and "ok" boards
             #  atbm_m[keyid]= adtable
         if keyid in cfinfo:
           cfad= cfinfo[keyid][0][:-4]   # cut off .xml
           if cfad == adtable:
             cfok= " "   # ok
             if adtable.find("ltu_logic_v")==0:   # monitoring only ltu_logic and "ok" boards
               atbm_m[keyid]= adtable
           else:
             cfok= "!"   # fwinfo does not correspond to alice_cf
         else:
           cfad= "None"
           cfok= "E"     # board entry missing in alice_cf
       else:
         onoff= "??" ; subver="??"
         if keyid in cfinfo:
           cfad= cfinfo[keyid][0][:-4]   # cut off .xml
           cfok='?'      # fwinfo cannot be read (board not connected)
         else:
           cfok='W'      # fwinfo cannot be read, no entry in alice_cf
       if onoff=='--': continue
       if cfok!=' ':
         onoff= onoff + " " + cfad
         cfokerrs[cfok]=1
       ltu= LTUS.findBN(keyid)
       if ltu:
         ltuctpname= ltu.name
       elif LTUS.ctpbname==keyid:
         ltuctpname= "ctp"
       else:
         ltuctpname= " "
       keyid_detname= "%6s %3s"%(keyid, ltuctpname)
       print("%-10s %c%-20s %2s   %-16s \t%s"%(keyid_detname, cfok,
         adtable, subver, self.ids[keyid][1], onoff))
         #self.ids[keyid][0], self.ids[keyid][1], onoff)
     for err in list(cfokerrs.keys()):
       if err in cfokerrs:
         print("%s -> %s"%(err, cfokerrmsgs[err]))
     #sed "/id=\"atb_61\"/s/_va/_vM/1 ; /id=\"atb_63\"/s/_v3/_vM/1" znc
     ATBmonclient(atbm_m)   # update in atbmon server
   # Call when an elements ends
   #def endElement(self, tag):
   #   if self.currenttag == "connection":
   #      print "address_table:", self.address_table
   #   self.tagid= ""

   # Call when a character is read
   #def characters(self, content):
   #   if self.CurrentData == "address_table":
   #      self.address_table = content
   def printAll2(self):
     print("id          \tip              \ton/off")
     print("------------\t----------------\t-----")
     bnames= list(self.ids.keys()) ; bnames.sort()
     for keyid in bnames:
       if self.ids[keyid][2]!= None:
         self.ids[keyid][2].join()
         onoff= self.ids[keyid][2].onoff
       else:
         onoff= "??"
       print("%-12s \t%-16s \t%s"%(keyid, 
         self.ids[keyid][1], onoff))
def printConnectionFile(at=False, fwcb=None, testatbmon=False):   # at==True: print also address_table
   # create an XMLReader
   parser = xml.sax.make_parser()
   # turn off namepsaces
   parser.setFeature(xml.sax.handler.feature_namespaces, 0)
   # override the default ContextHandler
   Handler = ConnectionHandler(fwcb)
   parser.setContentHandler( Handler )
   parser.parse(AliceBoards)
   #print "allids:",Handler.ids
   if at:
     cfinfo= findAddrTable(None, ConnectionFileName)
     if testatbmon:   # throw out atb_2* boards
       for throwout in ("atb_22","atb_24","atb_29"):
         if throwout in cfinfo:
           print("throwing out %s from the list for atbmon"%throwout)
           del cfinfo[throwout]
     Handler.printAll(cfinfo)
   else:
     Handler.printAll2()

class ATHandler( xml.sax.ContentHandler ):
   def __init__(self):
      self.currenttag= ""
      self.ids= {}   #self.ids[id]: [addrtable, ip]
      #self.tagid = ""
      #self.address_table = ""
   # Call when an element starts
   def startElement(self, tag, attributes):
      self.currenttag= tag
      if tag == "connection":
         self.tagid = str(attributes["id"])
         #self.ids.append(self.tagid)
         #self.ids[self.tagid]= str(attributes["address_table"])
         #print "*****connection id:", self.tagid,":", attributes.keys()
         #print "*****connection id:", self.tagid,":", attributes["uri"]
         ixmlf= attributes["address_table"].find("file://")
         xmlf= attributes["address_table"][ixmlf+7:]
         ip= self.getip(attributes["uri"])
         #print "*****ATconnection id:", self.tagid, attributes["address_table"],ip
         self.ids[self.tagid]= [xmlf, ip]
   def getip(self, uri):
     target= uri.find("target=")
     #print("getip:", uri, target)
     # dummy:
     # getip: ipbustcp-2.0://localhost:50003 -1
     if target>0:
       #ipport= uri[target+7:]   # ip:port
       ip= uri[target+7:].split(":")[0]   # ip only
     elif uri.find("//localhost")>0:
       #ip="localhost"
       ix= uri.find("//localhost:")
       ip= uri[ix+12:]
     else:
       ip= ""
     return ip
   # Call when an elements ends
   #def endElement(self, tag):
   #   if self.currenttag == "connection":
   #      print "address_table:", self.address_table
   #   self.tagid= ""

   #Call when a character is read
   #def characters(self, content):
   #   if self.CurrentData == "address_table":
   #      self.address_table = content
   #      print 
def findAddrTable(phbname, cfn=ConnectionFileName):
   """ phbname: None: return { phbname:[addrtable.xml,ip]...}
                name: return corresponding addrtable found in cfn
                             (None if not found)
   """
   parser = xml.sax.make_parser()
   parser.setFeature(xml.sax.handler.feature_namespaces, 0)
   Handler = ATHandler() ; parser.setContentHandler( Handler )
   parser.parse(cfn)
   #print "allids:",Handler.ids
   #Handler.printAll()
   if phbname==None: return Handler.ids
   if phbname in Handler.ids:
     return Handler.ids[phbname][0]   # addr table
   else:
     return None
def findIP(phbname,cfn=AliceBoards):
   #print "findIP:", phbname
   parser = xml.sax.make_parser()
   parser.setFeature(xml.sax.handler.feature_namespaces, 0)
   Handler = ATHandler() ; parser.setContentHandler( Handler )
   parser.parse(cfn)
   if phbname in Handler.ids:
     #print("findIP: ids[phbname]:", Handler.ids[phbname],'.')
     #dummy:
     # findIP: ids[phbname]: [u'minimal.xml', u'50003'] .
     ip= Handler.ids[phbname][1]   # IP
     #if ip=='localhost':
     return ip
   else:
     return None

if  __name__ == "__main__":
   #printConnectionFile()
   brd= "atb_2" #"atbp_8"
   #print ConnectionFileName,":",findAddrTable(brd)
   print(AliceBoards,":",findIP(brd))

