from __future__ import print_function
from builtins import range
from builtins import object
import time
def prtErr(msg):
  print("ERROR:%s"%msg)
class GenDev(object):
  def __init__(self, b, devname):
    self.b= b
    self.devname= devname
  def getid(self):   # overwritten by device's method
    """ should return None or string composed from something read from device
"""
    return "not implemented"
  def excmd(self,cmd):
    if len(cmd)<=1:
      self.prthelp()
      return
    self.myexcmd(cmd)
class Leds(GenDev):
  def __init__(self, board, devname, ledreg="ctrl.ledenable", nleds=25):
    GenDev.__init__(self, board, devname)
    self.ledreg= ledreg
    self.nleds= nleds
  def getid(self):
    pat= self.b.Read(self.ledreg)
    return "%s:0x%x"%(self.devname, pat)
  def setpat(self, pat):
    if self.ledreg!= None:
      self.b.Write(self.ledreg, pat)
    else:
      prtErr("Leds: %s not available"%self.devname)
    return pat
  def test(self):
    for ix in range(self.nleds+1):
      pat = 1<<ix
      self.setpat(pat)
      time.sleep(0.1)
    for ix in range(self.nleds+1-1,-1,-1):
      pat = 1<<ix
      self.setpat(pat)
      time.sleep(0.2)
  def prthelp(self):
    zerone= "1"
    if self.nleds==24: zerone="0"
    print(""" Available only with test_logic.
id    -get id
test  -test LEDs (on/off one by one)
setpat 0x%cffffff   -%d..0 bits pattern for %d front panel leds
"""%(zerone,self.nleds-1, self.nleds))
  def myexcmd(self,cmd):
    if cmd[1]=='id':
      print(self.devname,": ",self.getid())
    elif cmd[1]=='test':
      self.test()
    elif cmd[1]=='setpat':
      if len(cmd)>2:
        pat= eval(cmd[2])
        self.setpat(pat)
      else:
        print("pattern expected (e.g.: 0xf -4 leds on)")
    else:
      self.prthelp()

