#!/usr/libexec/platform-python
from __future__ import division
from __future__ import print_function
from builtins import str
from builtins import zip
from builtins import hex
from builtins import range
from past.utils import old_div
from builtins import object
from CommonComponents import FlashSpiInterface
from spi import GenDev
import time
import struct

class SPIatlas(object):
    """
    Alice wraper to atlas interface
    Actually not doing much 
    How to deal with stran stuff ?
    """
    def __init__(self):
        #SPIcore.__init__(self,board,spislave)
        #FlashSpiInterface.__init__(self,board)
        self.spislave="FLASH_SPI_Ram"
        self.connected=[]
    def addDevice(self,device):
        """
        """ 
        if len(self.connected)>0:
            print("can't add device:%s (only 1 spi device supported)"%device.devname)
        else: 
            self.connected.append(device)
    def printDevs(self, ix=""):
        """
        """
        #print "spi: SPIatlas(dummy) ",self.spislave, " - spislave in dev"
        if len(self.connected)==1:
            dev= self.connected[0]   # 1 dev only on 1 bus!
            print("%s %s: %s/%s %s (%d, %s)"%(ix, dev.node, 
                dev.devname,   
                dev.model, 
                dev.getid(),
                len(self.connected), self.spislave))
        elif len(self.connected)==0: 
            return
        else:
            print("printDev: internal error, more than 1 dev")
class N25Q(GenDev,FlashSpiInterface):         
    """
    Alice wraper to atlas flash mem
    Alice 
    memorty size 0x1000000   (atlas def=2x bigger)
    sector size  0x  10000
    page size    0x    100
    memory=256*sector = 256*256 *page
    sector=256*page 
    """
    def __init__(self,spi,devname,model,board,node,memsize):
        self.node=node
        GenDev.__init__(self,spi,devname,model)
        FlashSpiInterface.__init__(self,board,node,memsize)
    def getid(self):
        """
        Edited copy of readID() from CommonComponnts with extended output
        rc: None in case of error when reading device id
        """
        input_list = [0]*self.buffer_size

        # send control command
        input_list[0]=0x9f000000
        self.hw_interface.getNode(self.mem_name+".Outgoing").writeBlock(input_list)
        self.hw_interface.getNode(self.mem_name+".Num_Words").write(0x18)
        self.hw_interface.dispatch()
        # flip Do_SPI bit
        try:
          self.toggleDoSPIBit()
        except:
          return None
        # read ID word
        Buffer_readback = self.hw_interface.getNode(self.mem_name+".Incoming").readBlock(self.buffer_size)
        self.hw_interface.dispatch()

       
        #print "readID: ", len(Buffer_readback)
        # shift to get it like in alice (throw away first byte)
        Buffer_return=[]
        for i in range(0,len(Buffer_readback)): Buffer_return.append(Buffer_readback[i])
        Buffer_return[0] = (Buffer_return[0]&0x00ffffff)<<8
        for i in range (0,len(Buffer_readback)-1):
            Buffer_return[i] += (Buffer_return[i+1]&0xff000000)>>24
            Buffer_return[i+1] = (Buffer_return[i+1]&0x00ffffff)<<8
        pout=""
        for i in range(0,5): pout+=str(hex(Buffer_return[i]))+" "
        #print "FlashID:",pout    
        return pout
    def sendCommand(self,code):
        """
        """
        input_list = [0]*self.buffer_size

        input_list[0]=(code<<24)      # control command
        self.hw_interface.getNode(self.mem_name+".Outgoing").writeBlock(input_list)
        self.hw_interface.getNode(self.mem_name+".Num_Words").write(0x1)
        self.hw_interface.dispatch()

        # flip Do_SPI bit
        self.toggleDoSPIBit()

    def readReg(self,regcode,nbytes):
        """
        """
        input_list = [0]*self.buffer_size

        #nw=nbytes/4+2
        nw=nbytes
        input_list[0]=(regcode<<24)       # control command
        self.hw_interface.getNode(self.mem_name+".Outgoing").writeBlock(input_list)
        self.hw_interface.getNode(self.mem_name+".Num_Words").write(nw)
        self.hw_interface.dispatch()

        # flip Do_SPI bit
        self.toggleDoSPIBit()        

        # read back
        Buffer_readback = self.hw_interface.getNode(self.mem_name+".Incoming").readBlock(self.buffer_size)
        self.hw_interface.dispatch()
        #print "code 0x%x 0x%x 0x%x 0x%x"%(regcode,Buffer_readback[0],Buffer_readback[1],Buffer_readback[2])
        return Buffer_readback
    
    def readRegister(self,regcode,nbytes=2):
        
        Buffer_readback = self.readReg(regcode,nbytes)
        
        # I am not sure with this tbc with Richard
        nbytes = old_div(nbytes,2)
        mask=0
        for ii in range(nbytes): mask+=0xff<<(16-ii*8)
        #print hex(mask),hex(Buffer_readback[0]&0xffffff)
        rc = ((Buffer_readback[0]&0xffffff)&mask)>>(16-(nbytes-1)*8)
        return rc 
    def rotp(self):
        """
        This can be done with readRegister
        This is probably wrong: check meaning of nwords
        """
        buffer=self.readReg(0x4b,64)
        ss=""
        for i in range(old_div(64,4)): ss+= str(hex(buffer[i]))+" "
        print("OTP: ",ss)
    def reset(self):
        self.sendCommand(0x66)
        time.sleep(0.000001) # 50 ns required
        self.sendCommand(0x99)
    def wextreg(self,bit):
        #self.writeEnable()
        self.setBankAddressRegister(bit)
    def allstatus(self):
        """
        To be checked
        """
        # p21
        #stf = self.readFLASHStatusRegister()
        st = self.readRegister(0x05)
        # READ_FLAG_STATUS p27
        stf = self.readRegister(0x70)
        # READ_VOLATIL_CONFIGURATION p23
        volcfgr=self.readRegister(0x85)
        #READ_ENHANCED_VOLATILE CONFIGURATION p26
        evolcfgr=self.readRegister(0x65)
        #READ NONVOLATILE CONFIGURATION REGISTER p22
        nvolcfgr=self.readRegister(0xb5,4)
        # Extended Address Register
        ear=self.readRegister(0xc8)
        print("allstatus: st stf vol evol nvol ear:0x%x 0x%x 0x%x 0x%x 0x%x 0x%x"%( st, stf, volcfgr, evolcfgr, nvolcfgr, ear))
        if self.devname=="fm_semip":
          infopage= self.readMemoryPages(65280,1)   # 1st page in last sector: 65280= 256*255
          #print "%s page 65280:"%self.devname, map(hex,infopage[0:4])
          print("%s page 65280:"%self.devname, hex(infopage[0]), "=%s="%time.ctime(infopage[1]), hex(infopage[3]))
    def readBinFile(self,file_name):
        file=open(file_name,"rb")
        byte = file.read(1)
        byte_nr = 1

        word = 0
        word_nr = 0

        data = []

        while byte != '':

            byte_unpacked, = struct.unpack('B',byte)
   
            word = (word << 8) + byte_unpacked

            if byte_nr%4 == 0:
               word_nr += 1
               data.append(word)
               word = 0

 
            byte = file.read(1) 
            byte_nr += 1 

#!/usr/bin/python3

        byte_nr -= 1                    # last byte was empty
        file.close()
        if not (byte_nr%4 == 0):
            print(file_name," size not divisible by 4")
            raise ValueError
        return data

    def rmem2(self,frompage,npages):
        """
        Uses pages. 
        """
        self.printMemoryPages(frompage,npages)
    def rmem(self,fromadd,nbytes,check): 
        """
        ***byte can be addressed***
        memory 0010203040506070....
        command    output
        rmem 0 0 : no output because of first non used word
        rmem 0 1 : no output because of first non used word
        rmem 0 2 : 0x10203 (0x00010203
        --
        same as rmem2 but 
        - prints only part of buffer
        - reads max one page - tbd for more bytes
        - not used anywhere apart debugging
        """
        if nbytes>self.pageSize:
            print("nbytes>",self.pageSize," not implemented")
            return
        memory_content = []
        full_address=fromadd
        input_list = [0]*self.buffer_size
        input_list[0]=0x03000000 + (0xffffff & full_address)   
        # buffer is (64+1) 4byte words, page is 256 bytes, so they are equal
        self.hw_interface.getNode(self.mem_name+".Outgoing").writeBlock(input_list)
        self.hw_interface.getNode(self.mem_name+".Num_Words").write(self.pageSize+4)     # 4 bytes in first (non-used) word
        self.hw_interface.dispatch()

#!/usr/bin/python3
        self.toggleDoSPIBit()
        self.waitTillFLASHReady()     

#!/usr/bin/python3

        Buffer_readback = self.hw_interface.getNode(self.mem_name+".Incoming").readBlock(self.buffer_size)
        self.hw_interface.dispatch()
#!/usr/bin/python3
        #for iii in range(1,len(Buffer_readback)):
        for iii in range(1,old_div((nbytes+3),4)+1):    
          memory_content.append(Buffer_readback[iii])
          print(hex(iii-1+fromadd)," ",hex(Buffer_readback[iii]))   # print as a func of FLASH address

        return memory_content
    def erasesec(self,fromsec,nsecs):
        """
        Full equivalent of old 
        """
        self.clearMemorySectors(fromsec,nsecs)
    def writeMemorySectorsA(self,nFirstSector,nrOfSectors,data):
        print("writeMemorySectorsA: ",nFirstSector," ",nrOfSectors)
        if len(data) != old_div(nrOfSectors*self.sectorSize,4):             # always 4 bytes in one write word
           print("problem with data vector in writeMemorySectors", len(data))
           raise ValueError

        input_list = [0]*self.buffer_size

        self.clearMemorySectors(nFirstSector,nrOfSectors)

        for iSector in range(nFirstSector,nFirstSector+nrOfSectors):
            print(" ... writing into sector nr. ", hex(iSector))
        
            for iPage in range(old_div(self.sectorSize,self.pageSize)):          # loop over pages in each sector

                if self.printTiming:
                  print(" ... writing page nr. ", hex(iPage), " within this sector")

                for iWord in range(old_div(self.pageSize,4)):

                    input_list[iWord+1] = data[old_div((iSector-nFirstSector)*self.sectorSize,4)+old_div(iPage*self.pageSize,4)+iWord]
                    #if (iPage==63) or (iPage==64): print hex(input_list[iWord+1]),hex((iSector-nFirstSector)*self.sectorSize/4+iPage*self.pageSize/4+iWord)

                #print " ... writing page nr. ", hex(iPage), " within this sector"

#!/usr/bin/python3

                full_address = iSector*self.sectorSize + iPage*self.pageSize

                input_list[0]=0x02000000 + (0xffffff & full_address)

                self.writeEnable()

                self.hw_interface.getNode(self.mem_name+".Outgoing").writeBlock(input_list)
                self.hw_interface.getNode(self.mem_name+".Num_Words").write(self.pageSize+4)     
                self.hw_interface.dispatch()

#!/usr/bin/python3
                self.toggleDoSPIBit()

                self.waitTillFLASHReady()
 
    
    def wmems2(self,fromsec,nsecs):
        """
        """
        data=[0]*(old_div(nsecs*self.sectorSize,4))
        for i in range(0,old_div(nsecs*self.sectorSize,4)):
            data[i]=i;
        self.writeMemorySectorsA(fromsec,nsecs,data)    
    def wmems(self,fromsec,nsecs,par=''):
        """
        """
        self.printTiming=0
        data=[0]*(old_div(nsecs*self.sectorSize,4))
        for i in range(0,old_div(nsecs*self.sectorSize,4)):
            for j in range(0,4):
                data[i]+=((4*i+j)&0xff)<<(24-j*8)
        self.writeMemorySectorsA(fromsec,nsecs,data)
    def checkMemoryPages(self, frompage, npages,par=''):
        data=[0]*(old_div(npages*self.pageSize,4))
        for i in range(0,old_div(npages*self.pageSize,4)):
            for j in range(0,4):
                data[i]+=((4*i+j)&0xff)<<(24-j*8)
        nerrors=0
        for iPage in range(frompage,frompage+npages):
            #print " ... loading page nr. ", hex(iPage)
            memory_content = self.readMemoryPages(iPage,1)
            for iword in range (len(memory_content)):
                #print hex(word)
                index=old_div((iPage-frompage)*self.pageSize,4)+iword
                if memory_content[iword] != data[index]:
                    if par=='p':print("Error in Page/word:",iPage,"/",iword," Word read: ",hex(memory_content[iword])," expected:", hex(data[index]))
                    nerrors+=1
        print("Num of errosr: ", nerrors)
    def loadFromFile(self,fromsec,nsecs,file_name):
        """
        Erase before or add erase hear
        """
        data = self.readBinFile(file_name)
        if len(data) != (old_div(nsecs*self.sectorSize,4)):
            print("File size not compatible with nsec:",len(data)," ", end=' ')
            raise ValueError

        self.writeMemorySectorsA(fromsec,nsecs,data)
    def dumpMemoryPages(self,nFirstPage,nrOfPages,file):

        """
        Dump nrOfPages pages from FLASH
        nFirstPage is number of first page (not address!)

        """
        dfile= open(file,"wb")
        if nFirstPage+nrOfPages > self.nPages:
           print("problem in printMemoryPages")
           raise ValueError


        for iPage in range(nFirstPage,nFirstPage+nrOfPages):
            print(" ... loading page nr. ", hex(iPage))
            memory_content = self.readMemoryPages(iPage,1)

            for iii in range(len(memory_content)):
                #print hex(iii)," ", hex(memory_content[iii])   # print as a func of FLASH addre           for ixw in range(len(memory_content)):
                dfile.write(struct.pack('>I',memory_content[iii]))   # >I: big endian, unsigned 4 bytes int
            # >I: big endian i.e. DCBA because .bin file is a big endian and we want to compare
            #(<I would write little endian: ABCD)   
              
        dfile.close()    
    def validateMemoryWithFileP(self,firstPageToRead, nfOfPagesToRead, file_name):
        """
        Comparing only full pages
        """
        data_to_compare = self.readBinFile(file_name)
        
        data_from_FLASH = self.readMemoryPages(firstPageToRead,nfOfPagesToRead)

        differences = [i for i, j in zip(data_from_FLASH, data_to_compare) if not i == j]

#!/usr/bin/python3
#!/usr/bin/python3
        
        #for iii in range(len(differences)):
        #   print hex(differences[iii])

        if len(differences) :
           print("Files are different!")
           return False
        else:
           print("Files are the same!")
           return True
    def prthelp(self):
        print("""
        id      -read ID, i.e. write 0x9e and read back 20 bytes ID (N25Q READ ID cmd)
        status  -read status/flag/volatile/non volatile/enhanced volatile/extended addr regs
        reset   -N25Qxxx reset cmd
        wextreg [bit] - write bit to Write Extended Register, def: 1
        rotp    -read 64 OTP memory bytes
        rmemp [npages [frompage]]  def: 1 0                      
        wmems [nsecs [fromsec]]  -write nsecs  from  fromsec, def: 1 0
                                 -value written: last 8 bits of address
        chckp [npages [frompage [par]]] - checks npages from fromppage expecting format written by wmems
                                  - prints only number of errors unless par='p'
        dump filename [npages [frompage]]  -dump to binary file 
                                           - defaults: npages=1, frompage=0
        load filename [nsecs [fromsec]]    -load from binary file
                                           - NOTE: binary file has to have size compatible with nsecs
        comp filename [npages] [frompage]  - compare file to mem
        erase fromsec [N]   -erase N sectors from sector fromsec  (default N:1 -> cca 0.7s)
        erasebulk           -erase all sectors (BULK ERASE cmd 0x7h), 4 minutes with 128Mb
        help
        """)
        # comment on backward compatibility with other spi bus (e.g. used in afc)
        # rmem exist but it is not finished and can be used for debugging - see comment in function
        #rmem [fromad [N] [c]]  -read N bytes from fromad
        #                         c: check data, written before using wmem
        # wmem is not implemented
    def excmd(self,cmd):
        if len(cmd)<=1:
          self.prthelp()
          return
        if cmd[1]=='id':
          print(self.getid())
        elif cmd[1] == 'wextreg':
          if len(cmd) != 3:
              print("Wrong number of arguments")
          else:
              try:
                bit = eval(cmd[2])
              except:
                print("Wrong parameters:",cmd[2])
              self.wextreg(bit)
        elif cmd[1]=='set':
          if len(cmd)==3:
            l= eval(cmd[2])
            if (l==1) or (l==4) or (l==8) or (l==12) or (l==16):
              self.nb1t= l
              print("nb1t:", l)
        elif cmd[1]=='status':
          self.allstatus()
        elif cmd[1]=='rotp':   # p.65
          self.rotp()
        elif cmd[1]=='rmem':
          print("not implemented")
          return
          fromad= 0; byts= 4; checkdata= False
          if len(cmd) > 2: fromad= eval(cmd[2])
          if len(cmd) > 3: byts= eval(cmd[3])
          if len(cmd) > 4: 
            if cmd[4] == 'c':
              checkdata= True
          self.rmem(fromad, byts,checkdata)
        elif cmd[1]=='rmemp':
          npages=1; frompage=0;
          if len(cmd) > 2: npages= eval(cmd[2])
          if len(cmd) > 3: frompage= eval(cmd[3])
          start = time.time()  
          self.rmem2(frompage, npages)  
          end = time.time()
          print("Duration: ", end-start, " sec")
        elif cmd[1]=='wmem':   # p.53...
          print("not implemented")
          return
          fromad= 0; byts= 2; seed= None
          if len(cmd) > 2: fromad= eval(cmd[2])
          if len(cmd) > 3: byts= eval(cmd[3])
          if len(cmd) > 4: seed= 97
          self.wmem(fromad,byts, seed)
        elif cmd[1]=='wmems':   # juraj...
          fromsec= 0; nsecs= 1; seed= None
          if len(cmd) > 2: nsecs= eval(cmd[2])
          if len(cmd) > 3: fromsec= eval(cmd[3])
          if len(cmd) > 4: seed= 97
          start = time.time()  
          self.wmems(fromsec,nsecs)  
          end = time.time()
          print("Duration: ", end-start, " sec")
        elif cmd[1]=='chckp':
          frompage=0;npages=1;par=''
          if len(cmd) > 2: npages= eval(cmd[2])
          if len(cmd) > 3: frompage = eval(cmd[3])
          if len(cmd) > 4: par = cmd[4]
          self.checkMemoryPages(frompage,npages,par)
        elif cmd[1]=='dump':
          if len(cmd)<3 or len(cmd)>5:
            print("File name missing or Too many arguments")
            return  
          npages=1; frompage=0; fn=""
          if len(cmd) > 2:
            fn= cmd[2]
          if len(cmd) > 3:
            npages= eval(cmd[3])   
          if len(cmd) > 4:
            frompage = eval(cmd[4]) 
          print("Dumping %d pages from %d to %s..."%(npages,frompage, fn))
          start = time.time()  
          self.dumpMemoryPages(frompage,npages,fn)
          end = time.time()
          print("Duration: ", end-start, " sec")
          print("%d pages written to %s"%(npages,fn))
        elif cmd[1]=='load':
          if len(cmd)<3 or len(cmd)>5:
            print("File name missing or Too many arguments")
            return  
          fromsec=0;nsecs=1  
          if len(cmd) > 2:
            filen=cmd[2] 
          if len(cmd) > 3:
            nsecs=eval(cmd[3])
          if len(cmd) > 4:
            fromsec=eval(cmd[4])
          start = time.time()  
          self.loadFromFile(fromsec,nsecs,filen)
          end = time.time()
          print("Duration: ", end-start, " sec")
        elif cmd[1]=='comp':
          if len(cmd)<3 or len(cmd)>5:
            print("File name missing or Too many arguments")
            return  
          frompage=0;npages=1  
          if len(cmd) > 2:
            filen=cmd[2] 
          if len(cmd) > 3:
            npages=eval(cmd[3])
          if len(cmd) > 4:
            frompage=eval(cmd[4])
          self.validateMemoryWithFileP(frompage,npages,filen)
        elif cmd[1]=='erase':
          fromad= 0; nsec= 1
          if len(cmd) > 2: fromad= eval(cmd[2])
          if len(cmd) > 3: nsec= eval(cmd[3])
          self.erasesec(fromad,nsec)
        elif cmd[1]=='erasebulk':
          start = time.time()  
          self.erasesec(0,self.nSectors)
          end = time.time()
          print("Duration: ", end-start, " sec")
        elif cmd[1]=='help':
          self.prthelp()
        elif cmd[1]=='reset':
          self.reset()
        else:
          print("???")
    
if __name__ == "__main__":
    import uhal
    print("Starting SpiInterface test")
    manager = uhal.ConnectionManager("file:///home/trigger/WORK/atb_14.xml")  

    hw = manager.getDevice("atb_14")
    Flash = N25Q(None,"lala","lala",hw)
    print(Flash.getid())
    print(Flash.allstatus())
       
