#!/usr/libexec/platform-python
from __future__ import print_function
from builtins import object
import string  #,time, random

def prtErr(msg):
  print("ERROR:%s"%msg)

class Register(object):
  def __init__(self, name, **kw):
    """ Usage: example with 2 fields: ON (1bit) byte (8bits):
reg= Register("status", ON=0, byte=(1,8))
reg.prtme()  -print definition
reg.prt(value) -print  symb. names of bits/fields of value

name: symbolic reg. name
self.kw["TXneg"]: (bitn, length)   or: bitn
bitn: 0..31 -position (rightmost bit of the field)
length: number of bits in the field 
"""
    self.name= name
    self.kw={}
    for key in list(kw.keys()):
      self.kw[key]= []
      if isinstance(kw[key], tuple) and ((len(kw[key])==1) or (len(kw[key])==2)):
        bitn= kw[key][0]
        if isinstance(bitn, int):
          self.kw[key].append(kw[key][0]) # bit number
        else:
          prtErr("%s=(bit_position[,field_length]) i.e. at least 1 int expected"%key)
        self.kw[key].append(1)         # default length: 1 bit
        if len(kw[key])==2:
          fl= kw[key][1]
          if isinstance(fl, int):
            self.kw[key][1]= fl
          else:
            prtErr("%s=(bit_position[,field_length]) i.e. at least 1 int expected"%key)
      elif isinstance(kw[key], int):   # biname=4  (i.e. single bit)
        self.kw[key].append(kw[key])
        self.kw[key].append(1)
      else:
        prtErr("%s=(bit_position, field_length) expected"%key)
    self.kwsl= sorted(list(self.kw.items()), key=lambda kv: kv[1][0])
  def prtme(self, desc=None):
    # print my definition, i.e. bitname rel_position length
    if desc==None:
      print("%s:"%(self.name))
    else:
      print("%s:"%(desc))
    #for key in self.kw.keys():
    for key in self.kwsl:
      #print key, "=",self.kw[key]
      #v2= ((2**self.kw[key][1])-1) << self.kw[key][0]
      #print "%16s %2d %2d 0x%x"%(key, self.kw[key][0], self.kw[key][1], v2)
      v2= ((2**key[1][1])-1) << key[1][0]
      print("%16s %2d %2d 0x%x"%(key[0], key[1][0], key[1][1], v2))
  def prt(self, val, msg=None):
    # print all bit names only f val[bit] != 0
    if msg: print("\n%s:0x%x"%(self.name,val), msg)
    else: print("\n%s:0x%x"%(self.name, val))
    #for key in self.kwsl.keys():
    for key in self.kwsl:
      #msk= (2**self.kw[key][1])-1
      #v= (val >> self.kw[key][0]) & msk
      #v2= v << self.kw[key][0]
      flen= key[1][1] ; valmorebits= ""
      msk= (2**flen)-1
      v= (val >> key[1][0]) & msk
      if flen>1: valmorebits= " 0x%x"%v
      v2= v << key[1][0]
      #print "dbg:",key, msk, val, v
      if v != 0:
        #print "  %16s:%2d:%2d 0x%8x= 0x%8x"%(key, self.kw[key][0], self.kw[key][1], v, v2)
        print("  %16s:%2d:%2d 0x%8x%s"%(key[0], key[1][0], key[1][1], v2, valmorebits))
    
def main():
  #reg= Register("status", ON=0, byte=(1,8))
  reg = Register("CTRL", ASS=13, IE=12, LSBfirst=11, TXneg=10, RXneg=9,
      GObusy=8, NBITS=(0,7))
  reg.prtme()
  reg.prt(0xfff)
  reg.prt(0xfe)
  reg.prt(1)

if __name__ == "__main__":
  main()


