#!/usr/libexec/platform-python
import setsyspath,os,time
#!/usr/bin/python3
#!/usr/bin/python3
setsyspath.add("ccm/protos")
import grpc
#!/usr/bin/python3
grpc_channels= {"test":50051,
"rl":50052,
"aj":50053,
"mk":50054,
"jk":50055,
"ctp":50060,
"cpv":50061,
"emc":50062,
"ft0":50063,
"fv0":50064,
"fdd":50065,
"hmp":50066,
"its":50067,
"mch":50068,
"mft":50069,
"mid":50070,
"phs":50071,
"tof":50072,
"tpc":50073,
"trd":50074,
"zdc":50075 }
fn= os.path.join(os.getenv("CTP3_DBCTP"), "ctpboards.cfg")
if os.path.exists(fn):
  print("tri_grpc: updating grpc_channels from {}".format(fn))
  fp= open(fn, "r")
  grpc_channels= {}
  for line in fp.readlines():
    if len(line)==0: continue
    if line[0]=='#': continue
    ls= line.split()
    #print(ls)
    if len(ls)<3: continue
    if line[1]=='0': continue   # board not assigned/off
    grpc_channels[ls[0]]= int(ls[2])
  print(grpc_channels.keys())

def checkport(port):
  #cmd= "ss -tap |grep ':%d'"%port
  cmd= "ss -tap |grep ':%d' |grep '^LISTEN'"%port
  # not reliable for afs. 'fuser port/tcp -fine for trigger, not for afs'
  rc= os.popen(cmd).read()
  #print("action",rc,":",len(rc))
  return rc

#!/usr/bin/python3
def grpc_server_on(channel):
  TIMEOUT_SEC = 1
  if channel==None: return False
  try:
    grpc.channel_ready_future(channel).result(timeout=TIMEOUT_SEC)
    return True
  except grpc.FutureTimeoutError:
    return False
class TRG_grpc:
  def __init__(self, detname):
    # NOTE(gRPC Python Team): .close() is possible on a channel and should be
    # used in circumstances in which the with statement does not fit the needs
    # of the code.
    self.stub= None      # used by client grpc requests
    self.channel= None   # connection NOT ACTIVE/CLOSED
    self.detname= None
    self.host= os.getenv('CTP3_SERVER')
    if self.host==None:
      print("CTP3_SERVER env. variable not defined")
      return
    if not (detname in grpc_channels):
      print("{} not known, only allowed: {}".format(detname, grpc_channels.keys()))
      return
    self.detname= detname
    #host= "localhost"
    #with grpc.insecure_channel('localhost:50051') as channel:
    #with grpc.insecure_channel('acsl:50051') as channel:
    msg= self.openchannel()
    #print('tri_grpc: insecure_channel({}:{}) {} {}'.\
    #  format(self.host,grpc_channels[detname],detname, msg))
    if msg[0]!=0:
      okerr= "cannot connect"
    else:
      okerr= "ok"
    print("tri_grpc: insecure_channel {}:{} ({}) {}".format(self.host,grpc_channels[detname],detname,okerr))
    #pdb.set_trace()
  def openchannel(self):
    was= str((self.channel,self.stub))
    self.channel= grpc.insecure_channel('{}:{}'.format(self.host,grpc_channels[self.detname]))
    time.sleep(0.2)   # 0.1s after 'grpc.insecure_channel() call ok, 0.01s not enough
    #if self.channel== None: return   # !=None even when server not available
    # 1st grpc_server_on() call from ltud (when registering with ctpd after restart) fails
    # even when repeated more times...
    ntries= 1 ; maxn= 1
    while ntries<=maxn:
      if grpc_server_on(self.channel):
        if self.detname=="ctp":
          import ctpd_pb2
          import ctpd_pb2_grpc
          self.stub = ctpd_pb2_grpc.CTPdStub(self.channel)
        else:
          import ltud_pb2
          import ltud_pb2_grpc
          self.stub = ltud_pb2_grpc.LTUdStub(self.channel)
        msg= (0,was+" {}. attempt ok".format(ntries))
        break
      else:
        print("Channel {} (attempt:{}) not on".format(self.detname,ntries))
        ntries= ntries+1
    if ntries>maxn:  # did not succeed
      msg= (8,was)
      self.channel= None
    return msg
  def getname(self):
    return self.detname
  def close(self):
    if self.channel== None: return
    self.channel.close()
    self.channel= None
