#!/usr/libexec/platform-python
from __future__ import absolute_import
from __future__ import print_function
#!/usr/bin/python3
import ttcpon.netfile
import os.path
comment=""" Usage in awmtors.py:
      nn={}
      nn['hostname']= os.uname()[1]
      # colspan: 11=2+3+6    (min: 2+1+3)
      nn['netnamespan']= "2"
      nn['netname']= "tpc.net"
      nn['lockspan']= "1"
      nn['datespan']= "8"
      olts=[("olt1",2), ("olt2",3), ("olt3",6)]
      # onus: 1 item/row
      onus= [["1/11","",  "1/21","","",  "1/31","2/32","3/33","","",""]]
      #nn= net.getnn()
      #host={}
      #host['hostname']= os.uname()[1]
      #print("rendering %s %s"%(htname, host))
      #self.render(htname, host=host, net=net)   # in template_path
      self.render('tpnet.html', nn=nn, olts=olts, onus=onus) # in template_path

calculate in my.js:
//          olt1                       olt2           olt3
var onurc= [[[0,0],[0,1],[1,0],[1,1]], [[0,2],[0,3]], [[0,5],[0,6],[0,7],[0,8],[0,9]]];

in tpnet.html:
asi nic

in awmtors.py:
nn
olts
onus
"""
class Net:
  # header
  netnamespan_min= 2
  lockspan_min= 1
  datespan_min= 2
  rowlen_min= netnamespan_min+lockspan_min+datespan_min
  # onus:
  onus_inrmax= 20  # onus in one row. >= 10*onur_oltmin (max. 10 OLT)
  onur_oltmin= 2   # min. number of onus in 1 row /olt
  #onur_oltmax= 20   # max. number of onus in 1 row /olt
  oltsmax= 10      # max. 10 olts
  def __init__(self, netname, logger):   #, allolts):
    self.nf= ttcpon.netfile.NetFile(netname, logger)
    self.waserror= self.nf.waserror
    self.olts= self.nf.getolts()   # [(olt_symname, onuaddr1, onuaddr2,...),...]
    #                           [[oltsymnae]]  -olt without onus
    #self.olts=[("olt1","4 mon", 5), ("olt2","1","2","3"), ("olt3","1","22","33","34","42","43")]
    logger.info("calcnums:"+str(self.olts))
  def calcrowlen1(self,olt,rows):   # onus of 1 olt placed in several rows if necessary
    rl= len(olt)-1
    if rows>1:
      rl= round((rl+0.2)/rows)
      if rl<self.onur_oltmin: rl= self.onur_oltmin
    return rl
  def calcrowlen(self, rows):
    rowlen=0
    for ix in range(len(self.olts)):
      nonus1= self.calcrowlen1(self.olts[ix], rows)
      #nonus1= self.olts[ix][1]
      #if nonus1> nonusmax: 
      #  nonusmax= nonus1    # max. number of onus
      #  nonusmaxix= ix      # for this olt
      rowlen= rowlen+ nonus1
    return rowlen
  def kprop(self, k, mincols):
    rval= round(k*mincols)
    if rval < mincols: rval= mincols   # at least cols
    return int(rval)
  def htmlTable(self):
    """
in: self.olts: array of (olt_symname, onuaddr1, onuaddr2,...) items
html Table:
atbname    Lock    date
olt1  olt2  olt3     olt4
--    ---   --       ------     '-': represents an ONU
--    ---   --       ------

3 parts:
1. 1st row <th> atbname Lock date
2. 2nd row <th> oltX
3. 3rd 4th ... rows <td> representing all ONUs

Constraints:
1.
if nonus> onus_inrmax:  multiple rows

out: 
(oltcols, nn, onurows) ?
"""
    nrows= None
    for ix in range(1,32+1):   # 64/32= 2   10*2=20 (onus_inrmax:20)
      onusinrow= self.calcrowlen(ix)
      if onusinrow <= self.onus_inrmax:
        nrows= ix
        break
    print("nrows:",nrows)
    self.nn= {}
    kk= onusinrow*1.0/self.rowlen_min
    self.nn['masterbn']= self.nf.masterbn
    # 1. row (header):
    self.nn['netnamespan']= self.kprop(kk, self.netnamespan_min)
    self.nn['lockspan']= self.kprop(kk, self.lockspan_min)
    datespan= onusinrow- (self.nn['netnamespan']+self.nn['lockspan'])
    if datespan < self.datespan_min: datespan= self.datespan_min
    self.nn['datespan']= datespan
    # 2. row (header)
    self.oltcols= []   # [["olt_symname", columns],...]
    onusinrow= 0
    for ix in range(len(self.olts)):
      nonus= self.calcrowlen1(self.olts[ix],nrows)
      if ix==(len(self.olts)-1):   # last olt in row
        if (onusinrow+nonus) < self.rowlen_min: nonus= self.rowlen_min- onusinrow
      self.oltcols.append([self.olts[ix][0], nonus])
      onusinrow= onusinrow+nonus
    print("oltcols:",self.oltcols)
    # create onurc[oltN-1][onuN-1]: [row,column]   where
    # row: row (0..) in ONUs rows, column (0..) in this row
    # for all (also non existing) ONUs
    # onurc: used in my.js ABANDONED: using oltcols instead
    #
    # 3.,4.... row (onus)
    # onurows: [ row1, row2, ... ]
    #   rowX: ["onuname1", "onuname2",...]
    #     onunameX: N/ADDR
    #        N: 1,2,...    ADDR: any 1..64
    self.onurows= []
    for ix in range(nrows):
      row= []
      for ixo in range(len(self.olts)):
        #for ixr in range(self.olts[ixo][1]):
        #  row.append("%d/xx"%(ixr+1))
        for ixr in range(1, len(self.olts[ixo])):
          row.append(self.olts[ixo][ixr])
        if ixo == (len(self.olts)-1):
          while len(row)<self.rowlen_min:
            row.append(" ")
      self.onurows.append(row)
    print("onurows:", self.onurows)
    return(self.oltcols, self.nn, self.onurows)
      
if __name__ == "__main__":
  import sys,ilogger
  netname= sys.argv[1].split('.')[0]
  logname= os.path.join(os.getenv("CTP3_WORK_DIRECTORY"),"calcnums_%s.log"%netname)
  logger= ilogger.ilogger(logname, netname)
  net= Net(sys.argv[1], logger)
  rct= net.htmlTable()
  print(rct)
