#!/usr/libexec/platform-python
from __future__ import print_function
from __future__ import absolute_import
from builtins import str
from builtins import range
from builtins import object
import os,os.path,sys,time,atbwrap,metrdb.metrdb,tri_ws
import random
from auxfuns import isinargs,printError
ipbpath= os.getenv("CTP3_ROOT")
p101= os.path.join(ipbpath,"ttcpon","rev101")
if not (p101 in sys.path): sys.path.append(p101)
#!/usr/bin/python3
from atb.gbt import Gbt
import atb.tdomux as tdomux
import atb.cdcscan as cdcscan
from ttcpon_core.ttcpon_alice import OltMlinkExdsgAlice
from ttcpon_core.ttcpon_exdsg import OnuMlinkExdsgAlice
import ttcpon_board_config.pon_fmc_i2c_program as program_fmc
import ttcpon_board_config.init_onu_fmc as init_onu
#!/usr/bin/python3
class TtcPonNetDummy(object):
  def __init__(self, logger, netname, server=False, init=""):
    self.netname= netname
    self.logger= logger
    self.logger.info('TtcPonNetDummy %s %s'%(netname,init))
    atbwrap.Init() #ipbuswrap.Init("alice_cf")
    # following vars filled in by readConfig()
    self.oltboard= None # instance of atbwrap.ATBoard -master of ttcpon net(s)
    self.gbts= []
    #self.allolts= [None]*9  # list of OLTs [ olt1, None, olt3,...,olt9 ]
    #self.allonus= [None]*9  # and corresponding list of remote ONU lists
    #self.onufromctp= None   # is always None (should be deleted )
    self.waserror= False
    self.readConfig(netname)
    if self.waserror: return
    self.awmc= tri_ws.AWMclient(netname)
    if self.awmc.ws: 
      print("AWM for dummy ok")
    else:
      print("AWM for dummy not ok")
    # prepare awm (should be here to reflect .net file i.e. also discareded onus):
    for ixolt in range(len(self.allolts)):
      #if self.allolts[ixolt]==None: continue
      oltname= "olt%d"%(self.allolts[ixolt]+1)
      for ixonu in range(len(self.allonus[ixolt])):
        #onuaddr= str(self.allonus[ixolt][ixonu].onun)
        onuaddr= str(self.allonus[ixolt][ixonu][1])
        self.awmc.update_cfg(oltname, onuaddr, ixonu+1)
    #if server:
    #  self.dbo= metrdb.metrdb.MetrDB(self.netname)
    #else:
    #  self.dbo= None
  def readConfig(self, netname):
    from . import netfile
    cfgdir= os.getenv("CTP3_CONFIG_DIRECTORY")
    print("readConfig dummy...")
    #self.allolts= [None]*9  # list of OLTs
    #self.allonus= [None]*9  # and corresponding list of ONU lists
    #self.onufromctp= None   # is always None (should be deleted )
    # Netfile: returns allolts: [0,2,4] i.e. olt numbers 0..8
    #                  allonus: [[x,addr,x],...] see netfile.py
    self.waserror= False
    #self.readConfig(netname)
    nf= netfile.NetFile(netname+'.net', self.logger)
    self.allolts= nf.allolts
    self.allonus= nf.allonus
    if nf.waserror:
      self.waserror= True
    else:
      self.oltboard= gbtboard= atbwrap.OpenATBoard(nf.masterbn)
      if gbtboard==None:
        self.logger.critical("Master board not available.")
        self.waserror= True
      self.oltboard.setdbgmode(1)
  def measureConfig(self):
    self.logger.info('measureConfig dummy...')
  def Stop(self):
    self.logger.info('Stop dummy, closing awmc...')
    orc= self.awmc.ws_close()
  def measureSlow(self):
    """
    rc: [tstamp, error_msg]    errmsg "":ok
"""
    self.logger.info('measureSlow dummy...')
    tstamp= time.time()
    errmsg= ""
    data= {'tc74':15, 'fpgatemp':16}
    for ixolt in range(len(self.allolts)):
      #olt= self.allolts[ixolt]
      #if olt==None: continue
      #if olt.sfpin==None: continue
      #oltname= "olt%d"%olt.getoltn()
      oltname= "olt%d"%(self.allolts[ixolt]+1)
      for onu in self.allonus[ixolt]:
        #onuaddr= onu.onun
        onuaddr= onu[1]
        if onuaddr==" ": continue   #ONUless olt
        #errs= olt.onu_errmon_read(onuaddr)   # read status from real board
        #errs: [1, fecS, fecD, sc_crc_detected]
        errs= [1, 5, 6, 7]   # leads to ok state (constant).
        # Use set_dbgchonu() to force
        # the cahnge of ONU state regardless of the values in errs 
        keyname= "%s_%d_dsmon"%(oltname, onuaddr)
        if errs[0]==1:
          data[keyname]= errs[1:]
        else:
          data[keyname]= None
        self.awmc.update(keyname, data[keyname])
        #print "dummy update:", keyname, data[keyname]
    self.awmc.sendawm()
    return(tstamp, errmsg)
class TtcPonNet(object):
  def __init__(self, logger, netname, server=False, init="",bname=None):
    """
bname: None -netname must exist.
       board name -open master board if netname does not exist
"""
    self.netname= netname
    self.logger= logger
    self.logger.info('TtcPonNet %s init:%s'%(netname, init))
    #logging.info('TtcPonNet init '+ netname)
    atbwrap.Init() #ipbuswrap.Init("alice_cf")
    # following vars filled in by readConfig()
    self.oltboard= None # instance of atbwrap.ATBoard -master of ttcpon net(s)
    self.gbts= []
    self.allolts= [None]*9  # list of OLTs
    self.allonus= [None]*9  # and corresponding list of ONU lists
    self.onufromctp= None   # is always None (should be deleted )
    self.waserror= False
    self.dbo= None
    rc= self.readConfig(netname,bname)
    if rc==0:   # master board not opened
      return
    if self.waserror: return
    if len(self.allolts)==0:
      self.logger.critical("No OLT defined in .net file")
      self.waserror= True
    else:
      self.logger.info("OLTs:%s"%repr(self.alloltns()))
    firstolt= None
    for ix in range(len(self.allolts)):
      if self.allolts[ix]!= None:
        firstolt= self.allolts[ix]
        firstoltn= firstolt.getoltn()
        # do we need masterboard?  todo: remove all masterboard uses/comments
        #self.masterboard= self.oltboard   #firstolt.ctrlcon.board
        break
    #
    self.awmc= tri_ws.AWMclient(netname)
    if self.awmc.ws: 
      print("AWM ok")
    else:
      pass #print("AWM not available")
    # throw out all olts (but 1st one) without SFPs included:
    # i.e. even if there is no OLT, .net file contains an olt1 line without onus, e.g. oldttc net:
    # atb_9 s
    # 1
    olts_todiscard= []   # indexes into self.allolts/self.allonus
    for ixolt in range(len(self.allolts)):
      olt= self.allolts[ixolt]
      if olt==None:continue
      oltname= "olt%d"%olt.getoltn()
      vendor= olt.sfpin
      if vendor==None:   # OLT not plugged in`
        if (firstoltn==1) and (ixolt==0):
          # OLT1 exception: can exist even without SFP
          self.logger.info("OLT1 not in, but allocated always, even without SFP.") # why?
        else:
          printError("OLT module %s not plugged in"%oltname)
          olts_todiscard.append(ixolt)
          continue
      # prepare awm (should be here to reflect .net file i.e. also discareded onus):
      for ixonu in range(len(self.allonus[ixolt])):
        onuaddr= str(self.allonus[ixolt][ixonu].onun)
        self.awmc.update_cfg(oltname, onuaddr, ixonu+1)
    print("ttcponnet olts_todiscard:",olts_todiscard)
    for ix in range(len(olts_todiscard)-1, -1, -1):
      ixolt= olts_todiscard[ix]
      self.allolts[ixolt]= None
      self.allonus[ixolt]= None
    if self.waserror: return
    if init=="init":
      rcmsg= self.initATB()     # init PLL
      print("initATB:", rcmsg)
      if rcmsg[0]!=0: self.waserror= True
      rcmsg= self.INIT_OLTS()
      print("INIT_OLTS:", rcmsg)
      # 'OLT not plugged' is not fatal (olttc detectors)
      if rcmsg[0]>1: self.waserror= True
    #
    if server:
      self.dbo= metrdb.metrdb.MetrDB(self.netname)
  def alloltns(self):
    """ rc: [2,5]  -i.e. numbers of active OLTs
"""
    ns= []
    for ix in range(len(self.allolts)):
      olt= self.allolts[ix]
      if olt!= None:
        ns.append(olt.getoltn())
    return ns
  def initATB(self):
    """ Initialise ATB:
-check ltu/ctp logic
-check/load PLL
rc: 0: ok
    4: should be ok
    8,12: see i2c.py Si534x.checkgs
   16: incorrect firmware
"""
    rc= 0; msg= ""
    # default pll (atb):
    #olt.ctrlcon.plldev.checkandload("cfg/ok_ltu_logic.hpy")
    # OLT depends on mode:
    msg= None ; fw= self.oltboard.fwinfo
    #if olt.ctrlcon.board.isfiwa(olt.ctrlcon.board.FW_LTUCTP):
    if fw:
      if ((fw>>24) == 0xb) and ((fw & 0xffffff) < 0x000c00):
        msg= "ATB fw: 0x%x, use ttcpon010 for ATB firmwares < 0xc00"%fw
        rc= 16
      elif ((fw>>24) == 0xb) or ((fw>>24) == 0xc):
        pass   # ltu logic or ltu_logic_itsmft
        msg= "ok ltu_logic_[itsmft]"
      elif (fw>>24) != 0xa:
        msg= "Not an ctp_logic neither ltu_logic..."
        rc= 16
    else:
      msg= "fwinfo: None, is this a ctp or ltu logic ?"
      rc= 16
    self.logger.info("initATB: %d, %s"%(rc, msg))
    return rc,msg
  def olts_list(self, slist):
    """ slist: "1  4")
rc: None in case of error
    (olt_1instance,None,None,olt_4instance) 
"""
    if slist=="":
      return self.allolts
    olts= []
    for ix in range(len(slist.split())):
      try:
        #print "olts_list slist[%d]:"%ix, slist[ix]
        on= int(slist[ix])
      except:
        on= None
      if on==None:
        return None
      while len(olts) < (on-1):
        olts.append(None)
      #olts.append(on)
      olts.append(self.allolts[on-1])
    #print "olts_list rc:", olts
    return olts
  def INIT_OLTS(self, olts=""):
    """ olts: "2 4 5"
rc: 0 ok
    1 OLT module not in
"""
    rc= 0 ; msg= ""
    olts= self.olts_list(olts) # list: (olt1_instance, None, olt3_instance)
    for ixolt in range(len(olts)):
      olt= olts[ixolt]
      if olt==None: continue
      rc1,msg= self.olt1init(olt)
      if rc1 != 0:
        rc= rc1
        if msg != "": msg= msg+"\n"
        msg= "OLT%d init: %s"%(olt.getoltn(), msg)
    #self.logger.info("INIT_OLTS: %d, %s"%(rc, msg))
    return rc,msg
  def INIT_ONUS(self,olts=""):  # list of OLTs whose ONUs will be initialised
    """ olts: "1 4"
todo:
    rcpa,val= onu.txpa("m")
"""
    rc= 0 ; msg= ""
    olts= self.olts_list(olts) # list: (olt1_instance, None, olt3_instance)
    ixoolst= list(range(len(olts)))
    header= False
    for ixoo in ixoolst:
      #print "olt ixoo:", ixoo
      olt= olts[ixoo]
      if olt==None: continue
      onu= self.allonus[ixoo] ; Nonus= len(onu)   # ixoo set
      onulst= list(range(Nonus))
      for onuix in onulst:
        #print "------ OLT%d ONU%d:"%(ixoo+1, onuix+1)
        onun= onuix+1
        onu1= onu[onun-1]
        onu_addr= onu1.onun
        if onu1.ctrlcon==None:
          print("cannot do for ONU%d -CRU"%onun)
          continue
        onu_name= onu1.ctrlcon.board.bname[4:]
        # init:
        if onu1.monionu:
          pload= False
          print("PLL not checked/loaded for monitoring ONU.")
        else:
          pload= True
        if onu1.monionu and (onuix>0):
          msg= "onu %d init (olt%d) NOT DONE for monitoring ONU (must by done first, followed by 'olt reset')"%(onun, olt.getoltn())
          rc= 8
        else:
          onu1.setmux()
          onu1.equalizer_adapt()    # should be done only once, after power up
          init_onu.onu_init(onu1, pllload=pload)
          if onu1.olt2ndlevel:   # only if ATB in role of LTU
            print("LTU role, CDC scan, driven by OLT in ", olt.name)
            fwinfo= onu1.olt2ndlevel.ctrlcon.board.fwinfo
            #print "olt2ndlevel fwinfo:",hex(fwinfo)
            if ((fwinfo>>8)&0xffff)>=0x11:
              print("fi ver >=11, i.e. cdc scan instead of onu2olt...")
              tdomx= tdomux.TDOmux(onu1.olt2ndlevel.ctrlcon.board)
              cdc= cdcscan.CDC(onu1.olt2ndlevel.ctrlcon.board, tdomx)
              cdcphase= cdc.measure(True, 100)
              if cdcphase==None:
                printError("Cannot measure CDC phase")
            else:
              rcapg= init_onu_cascaded.automatic_phase_good_onu2olt(onu1,
                onu1.olt2ndlevel)
              print("[locked,phase_good_onu2olt]:",rcapg)
          elif onu1.monionu:
            print("MONONU,no CDC scan")
          else:
            print("CRU role, no CDC scan, driven by OLT in ", olt.name)
          onu1.txpa("m")
    #self.logger.info("INIT_ONUS: %d, %s"%(rc, msg))
    return rc,msg
  def allonuadds(self, ixolt, onlyvalid=False):
    """ onlyvalid: those responding in last FULLCAL?
rc: list of all onu addreses

"""
    listonus= []
    #olt= olts[ixolt]
    onu= self.allonus[ixolt] ; Nonus= len(onu)
    for ixonun in range(Nonus):
      if onlyvalid and onu[ixonun-1].excluded():
        pass
      else:
        listonus.append(onu[ixonun].onun)
    return listonus
  def getallonusN(self):
    olts= self.allolts
    ixoolst= list(range(len(olts)))   # 0..8
    N= 0
    for ixoo in ixoolst:
      olt= olts[ixoo]
      if olt==None: continue
      for ix in range(len(self.allonus[ixoo])):
        N= N+1
    return N
  def FULLCAL(self, olts=""):
    """ olts: string of OLT numbers "2 5"
rc: 0 ok
4 calib not successfull for some OLT(s)
8 error 

Note: the same code in ttcpon/maina.py
"""
    rc= 0 ; msglines= ""
    olts= self.olts_list(olts) # list: (olt1_instance, None, olt3_instance)
    ixoolst= list(range(len(olts)))
    header= False
    for ixoo in ixoolst:
      #print "olt ixoo:", ixoo
      olt= olts[ixoo]
      if olt==None: continue
      oltonus= self.allonus[ixoo]
      # System Init - Full
      # List of ONU addresses expected to be in the system
      onulist= self.allonuadds(ixoo, onlyvalid=True)
      print("fullcal for ONUs:", onulist, " in:", olt.getuname())
      olt.setmux()
      print("oltreset NOT DONE before the start of fullcal")
      #olt.oltreset()   # may fix 'No position found for SFP_RX_RESET' 
      #                   but shakes ONUs for cca 3 secs!
      onu_list = olt.full_calibration_run(onulist)
      if onu_list==None:
        print("fullcal abandoned, no onus...")
        continue
      #print "fullcal:",len(onu_list), onu_list
      detected= []
      for ix in range(len(onu_list)):
        if onu_list[ix]['detected']==1:
          detected.append(onu_list[ix]['onu_addr'])
      msg= "fullcal at %s.%d fwinfo:0x%x, %d ONUs(out of %d) detected:%s"%\
        (olt.name, olt.getoltn(), olt.ctrlcon.board.fwinfo, len(detected),\
        len(onulist), str(detected))
      if len(onulist) != len(detected): rc= 4
      self.logger.info(msg)
      print(msg)
      csvname= olt.getoltcsvn()
      olt.save_onu_config_csv(onu_list,"onu"+csvname)
      olt.save_olt_config_csv("olt"+csvname)
      print("[olt|onu]"+csvname+" config files saved.")
      print("Clearing sticky bits...")
      for ix in range(len(oltonus)):
        if oltonus[ix].onun in ['detected']==1:
          olt.onu_errmon_clear(oltonus[ix].onun)   # over fibre 
      olt.phymon_clear()
      olt.errmon_clear() 
      for ix in range(len(oltonus)):
        if oltonus[ix].onun in detected:
          olt.onu_phymon_clear(oltonus[ix].onun)
      print("Clearing OLT flags...")
      olt.clear_olt_monitor_status()   # olt part
      print("Clearing remote ONUs flags not done (discouraged from 2021).")
      if False:
        print("Clearing ONUs flags in remote onus...")
        for onuix in range(len(oltonus)):    # onus part
          onu_addr= oltonus[onuix].onun
          if oltonus[onuix].excluded():
            print("  Skipping excluded ONU%d addr%d."%(onuix+1, onu_addr))
            continue
          if oltonus[onuix].monionu:
            print("  Monitoring ONU%d addr%d, flags not cleared."%(onuix+1, onu_addr))
            continue
          muxes= oltonus[onuix].mux ; rcmux= False
          if muxes:
            #print "seti2cmainttcmux(10) on onu%d..."%(onuix+1)
            oltonus[onuix].seti2cmainttcmux("onu")   # has to be made here over ipbus!
            print("set_remotemux on onu%d:"%(onuix+1), muxes)
            rcmux= olt.set_remotemux(onu_addr, muxes)   # atb or KC
          else:
            print("onu%d (onu_%d) is CRU (no mux set)"%((onuix+1), onu_addr))
            rcmux= True   # CRU
          if rcmux:
            print("Clearing flags on onu%d (over olt)..."%(onuix+1))
            olt.clear_onu_monitor_status(onu_addr)
          else:
            msg2= "Error:mux not set?"
            print(msg2)
            msg= msg+", "+msg2
      msglines= msglines+msg+"\n"
    #self.logger.info("FULLCAL: %d, %s"%(rc, msg))
    return rc,msglines[:-1]
  def HEALTH(self, olts=""):
    """ olts: "" -for all available olts
olts "2 4" -only for olts2/4
"""
    rc= 0 ; msg=""
    olts= self.olts_list(olts) # list: (olt1_instance, None, olt3_instance)
    ixoolst= list(range(len(olts)))
    for ixoo in ixoolst:
      #print "olt ixoo:", ixoo
      olt= olts[ixoo]
      if olt==None: continue
      oltn= olt.getoltn()
      oltonus= self.allonus[ixoo]
      onulist= self.allonuadds(ixoo, onlyvalid=True)
      if len(onulist)==0:
        print("No ONUs defined for olt%d..."%oltn)
        continue
      else:
        print("olt%d..."%oltn)
      csvname= "onu"+olt.getoltcsvn()
      # Health check blocks user upstream transmission for a while, to get
      # fresh prbs7_errors/locked values for each onu
      onu_list = olt.read_onu_config_csv(csvname)
      #print "health onu_list (in %s):"%csvname,onu_list
      if onu_list== None:
        print("%s.csv does not exist."%csvname)
        rc= 16
        continue
      onu_list_updated = olt.network_health_check(onu_list)
      # todo: test prbs7_errors, prbs7_locked, possibly more...
      #print("HEALTH olt%d:"%oltn, onu_list_updated)
      #('HEALTH olt1:', [{'onu_addr': 13, 'sfp_en_delay': 4, 'nb_onu_system': 3, 'coarse_roundtrip': 71, 'fine_roundtrip': 18, 'detected': 1, 'prbs7_locked': 1, 'prbs7_errors': 0, 'fine_offset': 0, 'rx_pwr': -12.5337, 'coarse_offset': 0}, {'onu_addr': 35, 'sfp_en_delay': 4, 'nb_onu_system': 3, 'coarse_roundtrip': 71, 'fine_roundtrip': 18, 'detected': 1, 'prbs7_locked': 1, 'prbs7_errors': 0, 'fine_offset': 0, 'rx_pwr': -12.8233, 'coarse_offset': 30}, {'onu_addr': 32, 'sfp_en_delay': 4, 'nb_onu_system': 3, 'coarse_roundtrip': 71, 'fine_roundtrip': 17, 'detected': 1, 'prbs7_locked': 1, 'prbs7_errors': 0, 'fine_offset': 0, 'rx_pwr': -13.3536, 'coarse_offset': 60}])
      # 
      lenonus= len(onulist);
      lenonus_u= 0
      for ixonu in range(len(onu_list_updated)):
        onua= onu_list_updated[ixonu]['onu_addr']
        onul= onu_list_updated[ixonu]['prbs7_locked']
        onue= onu_list_updated[ixonu]['prbs7_errors']
        #print("health olt{} onu[{}]:{} locked:{} prbs7_errors:{}".format(
        #  oltn, ixonu, onua, onul,onue))
        if (onul==1) and (onue==0): 
          lenonus_u= lenonus_u+1
        else:
          self.logger.error("health olt{} onu:{} locked:{} prbs7_errors:{}".format(
            oltn, onua, onul,onue))
      if lenonus!=lenonus_u:  # this test is bad
        rc= 8
      msg= msg+"olt%d: %d/%d\n"%(oltn, lenonus, lenonus_u)
      #print "health onu_list_u (now, prbs7_errors/locked fields updated):",onu_list_updated
    if rc==8:
      msg= msg+"At least 1 ONU not locked or upstream PRBS7 error.\n"
    if msg=="":
      msg="No OLT found.\n"
      rc= 12
    return rc,msg
  def olt1init(self, olt, cdcreset=False):
    """ rc: (0, msg) -ok, 
            (1, errmsg) -error SFP not plugged in
            (>1, errmsg) -error
cdcreset: False from 16.3.2021. todo: checktick after oltinit,
          if failed, apply cdcreset
    """
    rcf= 0 ; msg=""
    if olt.sfpin==None:
      printError("OLT module not plugged in")
      rcf= 1
      return rcf,"OLT module not plugged in"
    olt.config_fine_phase_measurement(0,63,0)      # disable
    #print "olt.config_fine_phase_measurement disabled."
    rcpa= olt.oltreset()
    if (rcpa!=0) and (rc==0): msg="olt reset timeout"
    rcf= rcf+ rcpa
    olt.setmux()
    program_fmc.monitor_sfp(olt,1)
    rcpa,val= olt.txpa("m")
    if (rcpa!=0) and (rc==0): msg="txpa problem"
    rcf= rcf+ rcpa
    rcpa,val= olt.rxpa("m")
    if (rcpa!=0) and (rcf==0): msg="rxpa problem"
    rcf= rcf+ rcpa
    olt.setmux(ipbusaccess=True)   # set back to its default state
    # tick destroyed always by 'olt reset'. cdc reset get it correct.
    # todo: implement it in 'olt reset' (now implemented only here in 'olt init')
    if cdcreset:
      if olt.ctrlcon.board.isfiwa((olt.ctrlcon.board.FW_CTP_LOGIC,)):
        #tdomx= tdomux.CTPTDOmux(olt.ctrlcon.board)
        print("CDC reset not done (ctp)")
      else:   # LTU
        tdomx= tdomux.TDOmux(olt.ctrlcon.board)
        cdc= cdcscan.CDC(olt.ctrlcon.board, tdomx)
        cdc.reset()
        print("CDC reset done")
    return rcf,msg
  def Stop(self):
    self.logger.info('Stop, closing awmc and db...')
    orc= self.awmc.ws_close()
    if self.dbo: self.dbo.Stop()
  def getsfpid(self, f2call, sfpname):
    sfpprop= f2call()   # returned: [rc, property_string]
    if sfpprop[0]==0:
      self.logger.error("%s: vendor or part/serial number cannot be read."%sfpname)
      return None
    else:
      return sfpprop[1]
  def measureConfig(self):
    """ Should be invoked only once, in time of ltud start.
"""
    cfgdata= {}
    olt= None
    if self.onusfp:
      print("measureConfig onu:")
      vps= self.onusfp.getid("vps")
      strvps= ""
      for ix in range(len(vps)):
        strvps= strvps+vps[ix]+","
      cfgdata["onu"]= strvps[:-1]
    print("measureConfig olts:",self.alloltns())
    for ixolt in range(len(self.allolts)):
      oltdef= self.allolts[ixolt]
      if oltdef==None: continue
      olt= oltdef
      oltname= "olt%d"%olt.getoltn()
      vendor= olt.sfpin
      if vendor==None: continue   # olt not in
      # oltserN:"model,partnum,sernum" oltN:[atb:Addr,Addr,...] onusersN:["a,b,c",...]
      # the same # of items in oltN onusersN
      if not olt.setmux(): continue
      partnum= self.getsfpid(olt.get_sfp_part_number, oltname)
      if partnum==None:
        partnum="?"
      sernum= self.getsfpid(olt.get_sfp_serial_number, oltname)
      if sernum==None:
        sertnum="?"
      serial="%s,%s,%s"%(vendor, partnum, sernum)
      cfgdata["oltser%d"%olt.getoltn()]= serial
      #
      onus= [] ; onusers= []
      for onu in self.allonus[ixolt]:
        onuaddr= onu.onun
        onus.append("%s:%d"%(onu.name, onuaddr))
        print()
        if onu.name[:3]=="atb":
          # We should not use ipbus for onus...
          # But this is a spec. case (CRU mimicked by atb) -
          # the address of this ONU has to be set over ipbus
          # see maina.py 'onu vendor N'
          muxes= onu.mux
          onu.seti2cmainttcmux("onu")   # 10:onu -has to be made here over ipbus!
          # at least 1s needed for nonmon ONU! and 2s for mon ONU!
          if onu.monionu:
            tx_mon= "MONONU"
            waits= 2
          else:
            tx_mon= "ONU"
            waits= 1
          # following works when net calibrated:
          print("Setting %s address %d over ttcpon SLC/%s on %s board"%\
            (tx_mon, onuaddr, oltname, olt.ctrlcon.board.bname))
          time.sleep(waits)   # at least 1s needed for nonmon ONU! and 2s for mon ONU!
          rc= olt.set_remotemux(onuaddr, muxes)   # atb
          if rc:
            #print("measureConfig:", olt.onu_get_sfp_vendor(onuaddr))
            serial= "%s,%s,%s"%(olt.onu_get_sfp_vendor(onuaddr)[1],\
              olt.onu_get_sfp_part_number(onuaddr)[1],\
              olt.onu_get_sfp_serial_number(onuaddr)[1])
          else:
            print("remote mux not set (is ttcpon net calibrated?)")
            serial= "?,?,?"
          # here we should set remotemuxes to default state if it exist.
          #rc= olt.set_remotemux(onuaddr, deafult_muxes)   # atb
          onu.seti2cmainttcmux("ipbus") # 11:ipbus -set it back to the default state
        else: # CRU: muxes can not be set
          serial="sfpcru_vend,sfpcru_model,sfpcru_serial"
        onusers.append(serial)
      cfgdata["onusers%d"%olt.getoltn()]= onusers   # ONU serials: list of [vendor,partN,serN]
      cfgdata[oltname]= onus
    if olt: olt.setmux(ipbusaccess=True)   # default state also for a master board with OLTs
    print("measureConfig gbts:",len(self.gbts))
    for ixgbt in range(len(self.gbts)):
      gbt= self.gbts[ixgbt]
      gbtname= gbt.slave
      #print "%s:"%gbtname, gbt.ok
      vps= gbt.sfpinst.getid("vps")
      strvps= ""
      for ix in range(len(vps)):
        strvps= strvps+vps[ix]+","
      cfgdata[gbtname]= strvps[:-1]
    if self.dbo:
      print("ttcponnet dbo update:")
      self.dbo.Update(time.time(), cfgdata)
      print("ttcponnet dbo updated")
  def lst2byte(self, lst):
    byte= 0
    for ix in range(len(lst)):
      if lst[ix]!= 0: byte= byte | (1<<ix)
    return byte
  def measureSticky(self):
    """ Operation:
    1. read 'sticky' bits from PLL, OLTs+all  connected ONUs
    rc: [LOL_si5345, [olt_sticky, onu1_sticky, onu2_sticky,...], ]
    """
    plllol,msg= self.oltboard.plldev.cclosl()
    rc= [plllol]
    #if self.onusfp:
    #  vps= self.onusfp.getmon()
    # 
    for ixolt in range(len(self.allolts)):
      olt= self.allolts[ixolt]
      if olt==None: continue
      if olt.sfpin==None: continue
      oltname= "olt%d"%olt.getoltn()
      #vps= olt.sfpinst.getmon()
      lst= olt.phymon_read_seen()   
      oltonus= [self.lst2byte(lst)]
      for onu in self.allonus[ixolt]:
        onuaddr= onu.onun
        #print "OLT%d onuaddr:%d"%(olt.getoltn(), onuaddr)
        # try
        errs= olt.onu_errmon_read(onuaddr)   # ok:1 fecS fecD sc_crc_detected
        lst= olt.onu_phymon_read_seen(onuaddr)   
        if lst[0]==1:
         oltonus.append(self.lst2byte(lst[1:]))
        else:
          oltonus.append(0xff)
      rc.append(oltonus)
    return rc
  def measureSlow(self):
    """ Operation:
    1. read 'slow' values 
    2. update DB with measured values
    rc: [tstamp, error_msg]    errmsg "":ok
    olt(temps vols alarms...) onu1(...) onu2(...) ...
    onuX: 2 cases: 
          ltud: values acquired over fibre (ttcpon SLC)
          ctpd: values over:
             A) ipbus 
             B) interprocess communication (grpc) from ltud?  or
             C) SLC? 
             Seems B) is least 'critical section locking' 
    """
    #fpgatemp= self.masterboard.ltudevs["fpga"].gettemp()
    #print "fpgatemp:", fpgatemp
    # 1. read OLT + net values as quickly as possible
    # OLT board focus (returns also timestamp):
    #errmsg,tsvals= self.masterboard.getSlow()
    errmsg,tsvals= self.oltboard.getSlow()
    if errmsg!="":
      self.logger.error(errmsg)
    #print "bname:",self.masterboard.bname, tsvals
    data= {'tc74':tsvals[1], 'fpgatemp':tsvals[2]}
    if self.onusfp:
      vps= self.onusfp.getmon()
      data["onu_temp"]= vps[0]   # temperature in C
      data["onu_txpwr"]= vps[1]  # optical output power in dBm (None if not available)
      data["onu_rxpwr"]= vps[2]  # optical inp power in dBm (None if not available)
    # 2A. ttcpon net focus OLTs:
    for ixolt in range(len(self.allolts)):
      olt= self.allolts[ixolt]
      if olt==None: continue
      if olt.sfpin==None: continue
      oltname= "olt%d"%olt.getoltn()
      #print("in measureSlow olt%d.sfpinst:"%olt.getoltn(),olt.sfpinst)
      if olt.sfpinst==None: continue
      vps= olt.sfpinst.getmon()
      data[oltname+"_temp"]= vps[0]   # temperature in C
      data[oltname+"_txpwr"]= vps[1]  # optical output power in dBm (None if not available)
      data[oltname+"_rxpwr"]= vps[2]  # optical inp power in dBm (None if not available)
      # todo:
      # 1. discouraged on LTUs (i2c muxes programming from ctpd+ltud)
      #    instead, check a ctp/upstream onu if available.
      # 2.perhaps will be used when support on CRUs is available
      # 2AA. remote ONUs monitoring
      for onu in self.allonus[ixolt]:
        onuaddr= onu.onun
        #print "OLT%d onuaddr:%d"%(olt.getoltn(), onuaddr)
        # try
        errs= olt.onu_errmon_read(onuaddr)   # ok:1 fecS fecD sc_crc_detected
        # except return "can't read olt"
        # olt1_1_dsmon:(0,0,0)
        #errseen= olt.onu_errmon_read_seen_error(onuaddr)   # just sticky bit, as above
        keyname= "%s_%d_dsmon"%(oltname, onuaddr)
        if errs[0]==1:
          #errs: [1, fecS, fecD, sc_crc_detected]
          data[keyname]= errs[1:]
        else:
          data[keyname]= None
        self.awmc.update(keyname, data[keyname])
        #print "measureSlow:",keyname,":", errs
        # oltX_Y_onu
    # 2B. ttcpon net focus GBTs:
    for ixgbt in range(len(self.gbts)):    
      gbt= self.gbts[ixgbt]
      gbtname= gbt.slave # print "%s:"%gbtname, gbt.ok
      vps= gbt.sfpinst.getmon()
      data[gbtname+"_temp"]= vps[0]   # temperature in C
      data[gbtname+"_txpwr"]= vps[1]  # optical output power in dBm (None if not available)
      data[gbtname+"_rxpwr"]= vps[2]  # optical inp power in dBm (None if not available)
    # also possible to go over SFPs:
    #divajses=self.masterboard.findDeviceSFPS()
    #sfpnames= ""
    #for ix in range(len(divajses)):
    #  sfpnames= sfpnames+" "+divajses[ix].devname+":"+str(divajses[ix].gettemp())
    #print "ttcponnet sfpnames:", sfpnames
    # ttcponnet sfpnames:  SFP2 SFP7 SFP6 SFP5 SFP12 SFP1
    # 
    self.awmc.sendawm()
    # 3. update DB
    if self.dbo:
      rcupd= self.dbo.UpdateSmooth(tsvals[0], data) # update db
      if rcupd!="": self.logger.error(rcupd)
    # todo:
    todo="""
Logged from file ttcponnet.py, line 753
24-03-21 08:58:04 root ERROR: UpdateSmooth exception: 1616572683.94:(<type 'exceptions.IOError'>, IOError(2, 'No such file or directory'), <traceback object at 0x7fd62c482878>)
SFP instance at 0x7fd62d4e0c68>

"""
    rc= [tsvals[0], rcupd]
    return rc
  def readConfig(self, netname, bname=None):
    """ rc: 0: .net file does not exist and bname==None
1. master board open (found in netname or bname)
"""
    cfgdir= os.getenv("CTP3_CONFIG_DIRECTORY")
    fpath= os.path.join(cfgdir,"nets", netname+".net")
    self.onusfp= None
    if not os.path.exists(fpath):
      self.logger.error("%s does not exist",fpath)
      if bname==None:
        self.waserror= True
        return 0
      self.oltboard= atbwrap.OpenATBoard(bname)
      if self.oltboard==None:
        self.logger.critical("Master board not available.")
        self.waserror= True
        return 0
      return 1
    linen= -1
    allocated_olts= 0
    self.maxonus= 0
    fd= open(fpath,"r") ; netcfg= fd.readlines() ; fd.close()
    for ixl in range(len(netcfg)):
      ixhs= netcfg[ixl].find('#')
      if ixhs>-1:
        linenc= netcfg[ixl][:ixhs]
      else:
        linenc= netcfg[ixl]
      line= linenc.strip().split()
      if len(line)==0: continue
      #if netcfg[ixl][0]=='#': continue
      #for ixinl in range(len(line)):
      #  if line[ixinl].find('#')==0:
      #    del(line[ixinl:])
      #    break   #print ixinl,line
      if linen==-1:    # 1st line of netcfg
        #----------------------------------------------------- # 1st line of netcfg
        oltonuboard= line[0] 
        maxgbtn=14 
        self.oltboard= gbtboard= atbwrap.OpenATBoard(oltonuboard)
        if gbtboard==None:
          self.logger.critical("Master board not available.")
          self.waserror= True
          return 1
        linen= 0
        self.atbmode= 's'
        atbmodetx= 'standalone'
        self.onusfp= self.oltboard.findDeviceSFPS("SFP2")   # ONU == SFP2 for all firmwares
        if (len(self.onusfp)==0) or (self.onusfp==None) or (self.onusfp[0].purpose==None):
            # now purpose is "oltonu" when ONU plugged in 
            self.onusfp= None
        else:
            self.onusfp= self.onusfp[0]    # SFP instance if ONU SFP plugged in
        if (len(line) > 1) and ((line[1]=='g') or (line[1]=="global")): 
          printError("global mode has no sense in .net file, use 's' or nothing instead")
          #self.atbmode= 'g'
          #atbmodetx= 'global'
          # special onu instance. -1: do not touch onu address when instantiating
          # needs to be instantiated even without ONU SFP (exd_freeze_cdr_test_mode) ?
          # Let's instantiate only in global mode!
          #
          #  onufromctp abandoned, from 26.6.2019: there is a spec. instance of OLT1
          #  for each onu in superior net
          # for each ONU on ATB board regardless of:
          # - ATB is in role of CRU (debugging ie OLT physically does not have to be present) or
          # - ATB in role of LTU
          # self.onufromctp= OnuMlinkExdsgAlice(oltonuboard, '', -1, False)
          #
          # 21.3.2020: ONU SFP has to be included in global mode. Only SFP instance is enough
          # i.e. no need to instantiate OnuMlinkExdsgAlice.
          if self.onusfp==None:   # todo: this check should be at different place
            self.logger.critical("Error: ONU not plugged in and global mode required")
            self.waserror= True
        continue
      if (len(line[0])>3) and (line[0].find("gbt")==0):   # gbt line
        #----------------------------------------------------- GBT line
        #print "gbt line", line
        try:
          gslot= int(line[0][3:])
        except:
          self.logger.critical("Error: in .net: %s",netcfg[ixl])
          self.waserror= True
          continue
        if gslot > maxgbtn:
          self.logger.critical("Error too high gbt nmuber (max:%d): %s",\
            (maxgbtn,netcfg[ixl]))
          continue
        #for ixg in range(2, len(line)):   # remove comment at the end of line
        gbtname= "gbt%d"%gslot
        if gbtboard.nodExists(gbtname):
          alreadyin= False
          for ixgbts in range(len(self.gbts)):
            if self.gbts[ixgbts].slave == gbtname:
              print("Error: %s already defined in .net file"%gbtname)
              alreadyin= True
              break
          if alreadyin: continue
        if (len(line)<2) or ((line[1]!="vtrx") and (line[1]!="sfp") and (line[1]!="sfpbsr")):
          print("Error in .net (gbtN expected with vtrx sfp or sfpbsr):",\
            netcfg[ixl])
          continue
        #self.gbts.append(Gbt(SFPinst, gslot, line[1]))
        # instead, find corresponding SFP instance pointing to Gbt instance
        if gbtname in gbtboard.fwsfps:   # todo: FSFPs not considered  yet
          sfp= gbtboard.findDevice(gbtboard.fwsfps[gbtname])
          if sfp!= None:
            sfp.purpose.initdest(line[1])   # vtrx sfp sfpbsr
            self.gbts.append(sfp.purpose)
        continue
      #----------------------------------------------------- OLT line
      lane= int(line[0])-1   # lane: an olt slot: 0..8 corresponding to olt1..olt9
      solt= "olt%d"%(lane+1)
      if solt not in gbtboard.fwsfps:
        print("Error: OLT%d not allowed, ignoring line: %s"%((lane+1),netcfg[ixl]))
        continue
      olt= OltMlinkExdsgAlice(oltonuboard, '', lane=lane, mode= self.atbmode,\
        logger= self.logger)
      self.allolts[lane]= olt
      allocated_olts= allocated_olts + 1
      self.allonus[lane]= []   # each OLT line accompanied by a list of ONUs
      self.logger.info("OLT%d: %s %s"%((lane+1), olt.ctrlcon.board.bname, atbmodetx))
      if isinargs("pllcheck"): 
        olt.ctrlcon.plldev.checkgs('s', load=True)
      onus= self.allonus[lane]
      onusnames={}   # check if ONU already defined in an OLT line
      onuadds=[]    # check the uniqueness of an ONU address in an OLT line
      # todo: check if atb appeared in multiple OLT lines (maybe done in netfile.py?)...
      maxonus= 0
      for idaix in range(len(line[1:])):   # start after "OLTN", with list of onus
        ida= line[1+idaix]    # atb_10 atbp_7 atb_8:20 20 kc:1 kcu:4
        if len(onus)>=64:
          print("Error: %s ignored (>64 onus)"%(ida))
          continue 
        if ida in onusnames and (onusnames[ida]==True):
          print("Warning: %s ignored (given already in the same line)"%(ida))
          continue 
        #if type(ida) is int:   # CRU
        self.logger.info("  %s..."%ida)
        if (ida[0]>'0') and (ida[0]<='9'):   #==================== a number, i.e. CRU
          onuadd= int(ida)
          onus.append(OnuMlinkExdsgAlice('', '', onuadd, logger=self.logger))
          print("ONU%d: CRU:%s"%(len(onus), ida))
        elif ida[:4]=="atb_" or ida[:5]=="atbp_":   #============ atb, ONUaddr will be:
          # the board number or
          # number after colon: atb_N:addr
          ida01= ida.split(":")
          # default: atb in role of LTU. 
          # If 3rd param added (eg: atb_11:7:cru), ol2ndlevel is not allocated,
          # i.e. onu2olt good phase NOT done)
          ida00= ida01[0]
          print("ttcponnet ida00:",ida00)
          if ida00[:4]=="atb_":       # let's take atb number for ONU addr
            onuadd= int(ida00[4:])
          else:
            onuadd= int(ida00[5:])
          if len(ida01)>=2:          # atb_20:7   or atb_20:7:cru
            if ida01[1]!="":
              onuadd= int(ida01[1])   # explicitly defined, i.e. atb_20:7
          #pdb.set_trace()
          if onuadd in onuadds:
            print("Error: ONU address %d already used in the same .net line"%onuadd)
            self.waserror= True
            continue
          mononu= False
          mononutx= ""
          if ida00 == oltonuboard:   #===================================  mononu
            # monitoring ONU special: GOOD_PHASE first, and
            # do not load PLL (was loaded for OLT already)!
            if idaix==0: 
              # check if fp clock connected for mononu, 3 times to be sure it is ok:
              for ixcc in range(3):
                #olt.ctrlcon.plldev.clearSticky()
                time.sleep(1)
                if olt.ctrlcon.plldev:
                  rc,msg= olt.ctrlcon.plldev.cclosl()
                else:
                  rc= 8; msg="PLL not available."
                  break
                print("mononu checking LOL loop%d, rc and PLL LOL check message: "%ixcc,rc,msg)
              if rc==0:
                print(msg)
                mononu= True
                mononutx= "Monitoring ONU, connected to "+solt.upper()+'.'
              else:
                print(msg)
                printError("Error: monitoring ONU %s needs external clock (Front Panel BC IN)."%ida)
                self.waserror= True ; return 1
            else: 
              printError("Error: monitoring ONU %s has to be 1st one in the list of ONUs."%ida)
              self.waserror= True ; return 1
          #
          # add 1 special olt instance for onu2olt phase. Not needed if ATB in CRU role,
          # but allocated anyhow: it is differentiated in .net file by using:
          # atb_24:cru  -for atb_24 in role of CRU
          # atb_24      -for atb_24 in role of LTU  (default -normally, atb boards are in LTU role!)
          role= "LTU"
          if mononu:
            olt2ndlevel= None   # cannot come from CTP if connected as monitoring onu
          elif (len(ida01)==3):
            if (ida01[2]!='CRU') and (ida01[2]!='cru'):
              print("Error: cru or CRU expected, (not %s). %s role: LTU"%(ida01[0],ida01[2]))
              olt2ndlevel= True
            else:
              olt2ndlevel= None
              role= "CRU"
          else:
            olt2ndlevel= True
          if olt2ndlevel==True:   #================================ atb role LTU
            # can happen only with role=="LTU"
            olt2ndlevel= OltMlinkExdsgAlice(ida00, '', lane=0, mode= 's',
              logger=self.logger) # lane: 0 corresponds to olt1
            if olt2ndlevel.ctrlcon==None:
              printError("Cannot open ipbus to %s (LTUrole, olt2nd level)."%ida)
              self.waserror= True
              return 1
            #the ATB board in LTU role:
            #  -FP clock must be connected
            #  -at least 1 olt (olt2ndlevel) should be plugged in (does not have
            #   to in case of oldTTC)
            #olt.ctrlcon.plldev.clearSticky()
            #print("ttcponnet clearSticky not done ,0.5s,cclosl:",ida00)
            #olt2ndlevel.ctrlcon.plldev.clearSticky()
            #time.sleep(0.5)
            #rc,msg= olt2ndlevel.ctrlcon.plldev.cclosl()
            for ixcc in range(3):
              time.sleep(1)
              if olt2ndlevel.ctrlcon.plldev:
                rc,msg= olt2ndlevel.ctrlcon.plldev.cclosl()
              else:
                rc= 0; msg="PLL not available (dbg mode?)"
                break
              print("LTUrole loop%d: "%ixcc,rc,msg)
            if rc==0:
              ltu2msg= "LTU %s:"%ida00+msg
              print(ltu2msg)
            else:
              ltu2msg= "LTU %s cannot be driven by CTP, FP clock not ok:"%ida00+msg
              print(ltu2msg)
              self.waserror= True ; return 1
          print("ttcponnet before pllcheck:",ida00)
          if isinargs("pllcheck"):    # check pll config for all atb ONUs
            if role=="LTU":   
              # PLLcfg has to be 'stdalone', but possible load is left to be done in OLT part
              onus[-1].ctrlcon.plldev.checkgs('s', False, True)
            else:
              # PLLcfg has to be 'global' for ATB in CRU-role, let's load it if not required cfg:
              onus[-1].ctrlcon.plldev.checkgs('g', True, True)
          thisonu= OnuMlinkExdsgAlice(ida00, '', onuadd, mononu,olt2ndlevel, logger=self.logger)
          if thisonu.ctrlcon==None:
            printError("Error: cannot open ONU %s."%ida)
            self.waserror= True
            return 1
          onus.append(thisonu)
          print("ONU%d: %s"%(len(onus), ida), mononutx)
        elif ida[:2]=="kc" or ida[:3]=="kcu":   #
          if ida=="kcu":
            onus.append(OnuMlinkExdsgAlice('192.168.1.19', 9001, 4))   # v010
            onuadd= 4
          else:
            onus.append(OnuMlinkExdsgAlice('192.168.1.11', 9001, 1))   # v010
            onuadd= 1
          print("ONU%d: %s onuadd:%d"%(len(onus), ida, onuadd), mononutx)
        else:
          printError("Error: bad ONU: %s in .net file"%ida)
          onuadd= None
          self.waserror= True
        onusnames[ida]= True
        onuadds.append(onuadd)
        maxonus= maxonus+1
      if maxonus> self.maxonus: self.maxonus= maxonus
    if allocated_olts == 0:
      printError(".net file has to define at least 1 OLT even without OLT in (e.g. dummy one: '1') ")
      logging.critical(".net file has to define at least 1 OLT even without OLT in (e.g. dummy one: '1') ")
      self.waserror= True
    return 1
    # .net processed
