#!/bin/bash
if [ $# -eq 0 ] ;then
cat - <<-EOF
N -a number 1,2,3 or 4 expected.

A 'dummy' board ipbus request is served by DummyHardwareTcp.exe
listening on port N+50001. It can be started by this script.

N     Board    Port
1:    dummyhw  50002
2     atb_2    50003  (special treatment, see fwinfo in ipbuswrap.py)  
3     atb_3    50004
4     atb_4    50005

The name of a board (dummyhw, atb_2,atb_3 or atb_4) has to be present
in CFG/alice_cf.xml, e.g.:
<connection id="dummyhw" uri="ipbustcp-2.0://localhost:50002" address_table="file://ltu_logic_v1d.xml"/>
<connection id="atb_2" uri="ipbustcp-2.0://localhost:50003" address_table="file://ltu_logic_v1d.xml"/>

Example: start DummyHardwareTcp.exe for 'dummyhw' and 'atb_3' boards:
dummyhw.sh 1 3

Active dummy boards now:
EOF
ps --columns 120 -C DummyHardwareTcp.exe h o user,pid,args
  exit
fi
bns=$*
for bn in $bns ;do
  #port=let "$bn+50001"
  port=$(($bn+50001))
  echo $bn $port
  /opt/cactus/bin/uhal/tests/DummyHardwareTcp.exe -p $port -v 2 &
done 
ps --columns 120 -C python h o user,pid,args |grep DummyHardwareTcp.exe
ps aux |grep DummyHardwareTcp.exe
