#!/bin/bash
CTP3_SERVER="acsl3.cern.ch"
CTP3_ROOT=`pwd`
CTP3_DBCTP=~/DBCTP
CTP3_CONFIG_DIRECTORY=~/CFG
CTP3_WORK_DIRECTORY=~/WORK
if [ "$1" = "pack" ] ;then
cd $CTP3_ROOT
tar -zcf ~/ecsc.tgz ccm/protos/ctpecs* ccm/ltud/ecs_client.py scripts/bin/ecsc scripts/bin/ecsc_pack.sh
ls -l ~/ecsc.tgz
elif [ "$1" = "unpack" ] ;then
#tar -zxf ecsc.tgz
mkdir -p $CTP3_DBCTP/pd
mkdir -p $CTP3_CONFIG_DIRECTORY/rundefs
mkdir $CTP3_WORK_DIRECTORY
cat - <<-EOF >$CTP3_CONFIG_DIRECTORY/rundefs/example.par
trig
PH_bc 1khz
EOF
cat - <<-EOF >$CTP3_DBCTP/pd/itsmft.pd
bcm TOF 8 
ltg its
bcm TOF enable
hbacc 50%
ltg hmp
hbacc 100%
PH_bc 1khz
trig
cluster clustername its mft
EOF
elif [ "$1" = "setenv" ] ;then
export CTP3_SERVER
export CTP3_ROOT
export CTP3_DBCTP
export CTP3_CONFIG_DIRECTORY
export CTP3_WORK_DIRECTORY
else
cat - <<-EOF
ecsc_pack.sh pack      -tar all necessary files in a file ~/ecsc.tgz

unpack:
tar -zxf ecsc.tgz
scripts/bin/ecsc_pack.sh unpack    -create working,CFG dirs  in current directory

start:
. scripts/bin/ecsc_pack.sh setenv    -set env. variables (necessary before starting)
scripts/bin/ecsc           -start ecsc

requires: py2, grpcio

CTP3_SERVER
CTP3_DBCTP
CTP3_CONFIG_DIRECTORY
CTP3_WORK_DIRECTORY
EOF
fi
