#!/bin/bash
if [ `hostname -s` != 'alictpserverlab' ] ;then
  if [ `hostname -s` != 'acsl3' ] ;then
    echo 'only on acsl[3]...'
    exit 8
  fi
fi
if [ "$USER" != 'trigger' ] ;then
  echo 'only trigger...'
  exit 8
fi
if [ $# -lt 1 ] ;then
cat - <<-EOF
getgitbin.sh  logic [fpgatype]  

where:
logic is one of: l | i | c | t_kaya
         l ->      get ltu_logic              .bin file into boards/cfg/
         i ->      get ltu_logic_itsfmt       .bin file into boards/cfg/
         c ->      get ctp_logic              .bin file into boards/cfg/
         t_kaya -> get test_logic_kaya        .bin file into boards/cfg/

fpgatype (ONLY WITH t_kaya !) is one of: xcku040_2e(ltu) xcku060_2e(ctp) xcku040_1c(proto)

Before adding new git rep, clone it:
git clone ssh://git@gitlab.cern.ch:7999/aliceCTP3/ctp3-fw-ctp_logic.git
EOF
  exit 8
fi
deffpga='xcku040_2e'   #default fpga: 1st batch
fpga=$deffpga   #default fpga: 1st batch
if [ $# -gt 1 ] ;then
  fpga=$2
fi
#
# [trigger@alictpserverlab git]$ git clone ssh://git@gitlab.cern.ch:7999/aliceCTP3/ctp3-fw-ltu_logic_itsmft.git
if [ $1 = 'l' ];then
  logic="ltu_logic"
elif [ $1 = 'i' ];then
  logic="ltu_logic_itsmft"
elif [ $1 = 'c' ];then
  logic="ctp_logic"
elif [ $1 = 't_kaya' ];then
  logic="test_logic_kaya"
else
  echo "l (ltu_logic), i (ltu_logic_itsmft), c (ctp_logic) or t_kaya expected."
  exit 8
fi
#fpgadir='Work_2e'
fpgadir="Work_${fpga}/${logic}.runs/impl_1"
if [ ! -d $fpgadir ] ;then
  echo "$fpgadir does not exist (cd ~/git; git clone ...)"
  exit 8
fi
cd ~/git/ctp3-fw-${logic}
pwd
git pull
git checkout master
git pull origin master
cd $fpgadir
echo "cd $fpgadir..."
git log --oneline -n 5
#read -p "type e.g. 9_07 to get logic_v9_07.bin in ...boards/cfg/:" resp
cat - <<-EOF

Type 
q   -to quit or
commit V_SV   e.g.:

b20622c 9_07 
-> gets ${logic}_v9_07.bin (from a commit b20622c) in ...boards/cfg/"

EOF
read -p ":" resp
echo response:$resp
if [ "$resp" = "q" ] ;then
  echo doing nothing
  exit
fi
if [ "$resp" = "" ] ;then
  lastc=`git log --oneline -n 1`
  declare -a comver=($lastc)
  commit=${comver[0]}
  vers=${comver[1]}
  echo "takinkg latest commit:" $commit $vers
else
  declare -a comver=($resp)
  commit=${comver[0]}
  vers=${comver[1]}
  if [ -z "$resp" ] ;then
    echo "exiting (empty version, commit:$commit)..."
    exit
  fi
  read -p "commit:$commit ver:$vers    type q or ok:" resp
  if [ "$resp" = "q" ] ;then
    echo exiting...
    exit
  fi
  git checkout $commit
fi
echo "now at commit: " $commit
read -p "type q or ok:" resp
if [ "$resp" = "q" ] ;then
  echo doing nothing
  exit
fi
oname=$CTP3_ROOT/boards/cfg/${logic}_v$vers.bin
if [ "$fpga" != "$deffpga" ];then
  oname=$CTP3_ROOT/boards/cfg/${logic}_${fpga}_v$vers.bin
fi
echo
if [ "$resp" = "ok" ] ;then
  #cp -a logic.runs/impl_1/logic.bin $CTP3_ROOT/boards/cfg/logic_v$vers.bin
  echo "${PWD}/${logic}.bin -> $oname"
  cp -a ${logic}.bin $oname
  ls -l $oname
else
  echo "${PWD}/${logic}.bin NOT COPIED to $oname"
fi
