#!/usr/libexec/platform-python
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
from __future__ import print_function
import os,sys
MYBOARDS="myboards.txt"
LTULASTVER= "1d"
CTPLASTVER= "c"
def pingok(ip):
  resp = (os.system("ping -c 1 -w 1 -n -q %s >/dev/null 2>&1"%(ip)))>>8
  if resp==0: 
    return True
  return False
def dolink(origin, lnkname):
  #resp = (os.system("ln -s %s . "%origin))>>8
  if os.path.islink(lnkname):
    #print "WARNING: link %s already exists in CFG"%lnkname
    return False
  if os.path.exists(lnkname):
    print("WARNING: file %s already exists in CFG"%lnkname)
    return False
  resp = (os.system("ln -s %s . >/dev/null 2>&1"%origin))>>8
  if resp==0: 
    print("link:%s -> %s"%(lnkname,origin))
    return True
  print("ERROR: making link ln -s %s %s"%(origin, lnkname))
  return False
def getdefaultxmlname(bn):
  if bn in (10, 13, 40, 43, 16, 20, 25, 30, 26):
    xn= "ltu_logic_itsmft_v"+LTULASTVER
  elif bn >60:
    xn= "ctp_logic_v"+CTPLASTVER
  else:
    xn= "ltu_logic_v"+LTULASTVER
  return xn
def ver_update_ctp(ctpv, emuv=None):
  modname= "ctp_logic_v%s.xml"%ctpv
  dolink(os.path.join(os.getenv("CTP3_ROOT"),"boards",modname), modname)
  if emuv:
    modname= "ctpemu_v%s.xml"%emuv
    dolink(os.path.join(os.getenv("CTP3_ROOT"),"boards",modname), modname)
def ver_update(ltuv, emuv=None):
  modname= "ltu_logic_v%s.xml"%ltuv
  dolink(os.path.join(os.getenv("CTP3_ROOT"),"boards",modname), modname)
  modname= "ltu_logic_itsmft_v%s.xml"%ltuv
  dolink(os.path.join(os.getenv("CTP3_ROOT"),"boards",modname), modname)
  if emuv:
    modname= "ctpemu_v%s.xml"%emuv
    dolink(os.path.join(os.getenv("CTP3_ROOT"),"boards",modname), modname)
def dolink_modules():
  #modname= "ctpemu.xml"
  #dolink(os.path.join(os.getenv("CTP3_ROOT"),"boards",modname), modname)
  #
  ver_update("1c", "19")
  ver_update(LTULASTVER, "1c")    # i.e. 1d_08 includes ctpemu_v1c
  #ver_update_ctp(CTPLASTVER, "1c")    # i.e. 1d_08 includes ctpemu_v1c
#!/usr/bin/python3
def createltucfg(ip,ltu_logic_version):
  name="ltu"+ip+".cfg"
  if os.path.exists(name):
    archname= "ltu"+ip+".cfgprev"
    import shutil
    shutil.copy(name,archname)
    #print name, "copied to", archname
  ltucfg=open(name, "w")
  ltucfg.write("# ip address \n")
  ip="IP "+ip
  ltucfg.write(ip)
  ltucfg.write("\n# address file \n")
  #ltucfg.write("XML ltu_logic_"+version+ "\n")
  ltucfg.write("XML %s \n"%ltu_logic_version)
  # Defaults to be modified by Detector people
  ltucfg.write("# DETMODE: cru=1 ttc=2 trd=3 cpv=4 \n")
  ltucfg.write("DETMODE 1 \n")
  ltucfg.write("#LL protection \n")
  ltucfg.write("LLprotection 300 \n")
  ltucfg.write("#TTC delay (0-5 values)\n")
  ltucfg.write("TTCdelay 3 \n")
  ltucfg.write("#LVDS delay (0-5 values)\n")
  ltucfg.write("LVDSdelay 3 \n")
  ltucfg.write("#BUSY \n")
  ltucfg.write("enableBUSY 0 \n")
  ltucfg.close()
  print("  %s created.\n"%name)
def getip(pl):
  ip= '-'
  if len(pl)>1:
    ip= pl[1]   # IP
  if ip=='-':
    bn= int(pl[0])   # pl[0] has to be number if IP not given
    ip= "192.168.1.%d"%(bn+20)
  return ip
def mymain(version=None):
  #os.chdir(os.getenv("CTP3_CONFIG_DIRECTORY"))
  # TypeError: coercing to Unicode: need string or buffer, NoneType found
  workdir= os.getenv("CTP3_WORK_DIRECTORY")
  if workdir != None:
    if not os.path.exists(workdir):
      os.mkdir(workdir)
      print("\n%s created for .log, .csv,... files"%workdir)
  if os.getenv("CTP3_ROOT")!= None:
    #if not os.path.islink("minimal.xml"):
    dolink(os.path.join(os.getenv("CTP3_ROOT"),"boards/minimal.xml"),"minimal.xml")
  if not os.path.exists(MYBOARDS):
    print("ERROR:",MYBOARDS,"missing")
    sys.exit(8)
  if not os.path.isdir("nets"):
    os.mkdir("nets")
    print("\nnets/ created -put your .net file(s) here...")
  myboards = open(MYBOARDS, "r")
  alice_boards = open("alice_boards.xml", "w")
  alice_boards.write('<connections>\n')
  ethers = open("ethers", "w")
  print("\nCreating alice_boards.xml and ethers ...")
  for lin in myboards.readlines():
    pl= lin.split()   # boardNumber IP [mac] [ltu_logic]
    if len(lin)==0: continue
    if len(pl)==0: continue
    if lin[0]=="#": continue
    try:
      bn= int(pl[0])
    except:
      print("Board name instead of the number in line:", lin)
      bn= None
    ip= getip(pl)
    #createltucfg(ip,version)    see loop below
    #print lin,pl,":",bn,ip
    #if (str(bon) < "7") or (str(bon) > "31"):
    if bn==None:
      atbname= pl[0]
      if len(pl)<3:
        print(("Error: MAC must be given when boardName used instead of boardNumber. Line:",lin))
        continue
      ip= pl[1]   # IP
      mac= pl[2]
      if mac=="-":
        print(("Error: MAC must be given when boardName used instead of boardNumber. Line:",lin))
        continue
      if mac.split(":")!= 6:
        print(("Error: Wrong MAC address. Line:",lin))
        continue
    elif bn==7 or bn==8:
      atbname= "atbp_%d"%bn
      mac= "08:00:30:00:2a:%2.2x"%bn
    else:
      if ((bn < 2) or (bn > 69)) and bn!=2:  # 2: local dbg (virtual board)
        print("board number not in interval <7..69> in line :", lin)
        continue
      atbname= "atb_%d"%bn
      mac= "08:00:30:00:2a:%2.2x"%bn   # we use it, in spite of new mac was assigned
      # for CERN  on 28.9.2018
      # The new prefix 80-D3-36 has been assigned to CERN.
      # You can now use it for your sub-assignment from the old 08-00-30 prefix.
      # 
    if bn<7 and bn>0:
      alice_boards.write('<connection id="%s" uri="ipbustcp-2.0://localhost:5000%d" address_table="file://%s"/>\n'%(atbname, bn+1, "minimal.xml"))
    else:
      alice_boards.write('<connection id="%s" uri="chtcp-2.0://localhost:10203?target=%s:50001" address_table="file://minimal.xml"/>\n'%(atbname,ip))
    ethers.write('%s %s\n'%(mac,ip))
  myboards.close()
  alice_boards.write('</connections>\n')
  alice_boards.close()
  ethers.close()
  myboards.close()
  #
  if version=="check":
    import ibw, findat
  print("\nCreating alice_cf.xml ...")
  myboards = open(MYBOARDS, "r")
  # todo: refuse specific firmware if more boards in MYBOARDS file.
  # Specific firmware update should be allowed only for 1 board!
  alice_cf = open("alice_cf.xml", "w")
  alice_cf.write('<connections>\n')
  for lin in myboards.readlines():
    pl= lin.split()
    if len(lin)==0: continue
    if len(pl)==0: continue
    if lin[0]=="#": continue
    try:
      bn= int(pl[0])
    except:
      #print "Bad board number in line:", lin
      bn= None
    ip= getip(pl)
    xmlname= None
    if bn==None:
      atbname= pl[0]
    elif bn==7 or bn==8:
      atbname= "atbp_%d"%bn
    else:
      atbname= "atb_%d"%bn
    #print atbname,":",lin
    cfgversion= None
    if len(pl)>3:
      xmlname= pl[3]   # without ".xml"
      und= pl[3].split("_")
      if und[-1][0]=='v':
        cfgversion= und[-1]
    #print "und cfgversion:",cfgversion, version
    if (version!=None) and (version!="v") and (version!="check"):
      cfgversion=version     # from cmdline has priority
    if version=="check":
      if xmlname==None:
        if pingok(ip):
          if ibw.manager==None:
            ibw.Init("cwd")
          board= ibw.Board(atbname)
          if board.nodExists("ctrl.fwinfo"):
            fwinfo= board.Read("ctrl.fwinfo")
            fwname= fwinfo>>24 ; fwver= (fwinfo>>8) & 0xffff   # without subversion
            xmlname= findat.FindAT(fwname, fwver)[:-4]
            cfgversion= "v%x"%fwver
            print("%s firmware checked:"%atbname,xmlname)
          else:
            print("The board cannot be checked (ctrl.fwinfo node not available).")
            continue
        else:
          print("Board %s not available, 'cp ethers /etc/ethers' and restart rarpd?"%atbname)
          continue
      else:
          print("%s (myboards.txt):"%atbname, xmlname)
      xmlnamexml= xmlname+".xml"
    else:
      if xmlname==None:
        #print "%s, xmlname missing in myboards.txt, line ignored"%atbname
        #continue
        xmlname= getdefaultxmlname(bn)
        #print "%s, xmlname not given in myboards.txt, using %s..."%(atbname,xmlname)
      #else:
      #  print "DBG:", xmlname, cfgversion
      #  xmlname="%s_%s"%(xmlname,cfgversion)
      xmlnamexml= xmlname+".xml"
      #print "%s, myboards.txt:"%atbname, xmlname
    print("%s:"%atbname, xmlname)
    createltucfg(ip,xmlname)
    if bn<7 and bn>0:
      alice_cf.write('<connection id="%s" uri="ipbustcp-2.0://localhost:5000%d" address_table="file://%s"/>\n'%(atbname, bn+1, xmlnamexml))
    else:
      alice_cf.write('<connection id="%s" uri="chtcp-2.0://localhost:10203?target=%s:50001" address_table="file://%s"/>\n'%(atbname,ip, xmlnamexml))
    #print "%s: no action, counting on ipbcfg.tgz"%xmlnamexml
    if xmlnamexml:
      #if not os.path.islink(xmlnamexml):
      dolink(os.path.join(os.getenv("CTP3_ROOT"),"boards",xmlnamexml), xmlnamexml)
  alice_cf.write('</connections>\n')
  alice_cf.close()
  print("""
The generation of CFG/ files finished.
""")
  dolink_modules()

if __name__ == "__main__":
  #mbexists= "exists in current directory"
  mbexists= "MUST exist in $CTP3_CONFIG_DIRECTORY"
  if len(sys.argv)<=1:
    #if not os.path.exists(MYBOARDS):
    #  mbexists= "does not exist in current dir"
    print("""
Input: myboards.txt (%s)
Output files: ethers, alice_cf.xml, alice_boards.xml, minimal.xml, ltuXX.XX.XX.XX.cfg

makemycfg.py check   -check board(s) for its firmware (FW present in myboards.txt
                      has priority over fwinfo in hw)
             v1d     -use ltu_logic_v1d.xml
             v       -latest version of ltu logic (%s)
                      DO NOT USE THIS for more boards with different firmwares 
                      in myboards.txt
             help    -help on the myboards.txt format
             updatelinks -update only following symlinks in CFG/ 
                            ltu_logic_X.xml 
                            ltu_logic_itsmft_X.xml
                            ctpemu_Y.xml
                          pointing to CTP3_CONFIG_DIRECTORY
"""%(mbexists,LTULASTVER))
    sys.exit(8)
  arg1= sys.argv[1]
  if arg1=="help":
    print("""
Input: myboards.txt file with 1 line/board.
       Lines starting with # are comments. A line:

BN IP MAC FW     

where: BN IP: compulsory items, MAC FW: are optional
BN  -boardNumber or boardName -either of two has to be given
      -boardNumber -mac address will be calculated using this number
      -boardname   -in this case also mac address has to be supplied.
IP  -IP address ( '-': IP calculated automatically: 192.168.1.NN  NN= 20+BN)
MAC -mac address of the board. '-' -> placeholder if boardNumber specified
FW  -one of: ctp_logic ltu_logic_itsmft test_logic
     (default: ltu_logic)

Examples for LTU 16 with IP 192.168.1.36:
16 192.168.1.36
16 -
16 192.168.1.36 - ltu_logic_itsmft_v13
16 - - ltu_logic_itsmft

atb_16 192.168.1.36 08:00:30:00:2a:16 ltu_logic_v13

""")
    sys.exit(8)
  cfgdir=os.getenv("CTP3_CONFIG_DIRECTORY")
  #cfgdir=os.getenv("CTP3_WORK_DIRECTORY")
  print("cfgdir:", cfgdir)
  # 
  os.chdir(cfgdir)
  #os.chdir("CF")
  if arg1=="updatelinks":
    dolink_modules()
  elif (arg1!="check") and (arg1[0]!='v'):
    print("\nBad argument: %s (help, check, updatelinks or vXX expected)"%arg1)
    sys.exit(8)
  else:
    mymain(arg1)
