#!/usr/libexec/platform-python
from __future__ import print_function
from builtins import range
import sys,os
from auxfuns import findProcess,getfile,parseline

class Boards:
  def __init__(self):
    self.ltus= {}
    cfgdir= os.getenv("CTP3_DBCTP")
    if cfgdir==None: return
    netcfg= getfile(os.path.join(cfgdir,"ctpboards.cfg"), errprint=False)
    if netcfg==None: return
    #print("$CTP3_DBCTP dir processing...")
    for ixl in range(len(netcfg)):
      #trd 45 c26t 101 102 lvpecl
      #spare -
      line= parseline(netcfg[ixl])
      if line==None: continue
      if len(line)<2: continue
      if line[1]=='0': continue
      name= line[0]
      if not (name in self.ltus):
        self.ltus[name]= "atb_"+line[1]
      else:
        print("LTU name {} twice in ctpboards.cfg".format(name))
  def getbn(self,ltuname):
    if ltuname in self.ltus:
      return self.ltus[ltuname][4:]
    return None
def getpids(bn):
  pids= []
  ols= findProcess('python').split("\n")
  #print(ols)
  # aj        5799 python /home/aj/git/ctp3-ipbus/cmdpy/ltu/ltuctl.py 2
  for ix in range(len(ols)):
    ll= ols[ix].split()
    if len(ll)<5: continue
    #print(ll)
    if ll[3].find("ltuctl.py")>0:
      if ll[4]==bn:
        pids.append(ll[1])
  return pids
def notify(pids):
  """ SIGQUIT sent to all pids in the pids list
"""
  for pid in pids:
    # little sense, permission denied for different users. todo: check sudo or use 'write user ttyX'.
    os.system("kill -s QUIT "+pid)

if __name__== "__main__":
  if len(sys.argv) < 2 or (len(sys.argv)==2 and sys.argv[1]=="help"):
    print("""
notify.py ltuctp
ltuctp: one of the names in $CTP3_DBCTP/ctpboards.cfg
""")
    sys.exit(4)
  det= sys.argv[1]
  bs= Boards()
  bn= bs.getbn(det)
  if bn:
    pids= getpids(bn)
    print("notifying (SIGQUIT) pids:",pids)
    notify(pids)
