#!/bin/bash
protos="$CTP3_ROOT/ccm/protos"
if [[ $# -gt 0 ]] ;then
  name=$1
else
  cat - <<-EOF
Usage:
pbcomp.bash NAME [old]

- creates .pb2,.pb2_grpc in $protos directory from file
  $protos/NAME.proto

Available NAMEs: ctpd ltud ctpecs

Obsolete: -with 2nd parameter old
- creates .pb2,.pb2_grpc in current directory from file
  $protos/NAME.proto
The compiled files are kept in the server or client directory, i.e.
'cd client_or_server_dir' before starting this.

EOF
  exit 8
fi
#if [[ ! (-e "$name.py") ]] ;then
#  echo $name.py not in current directory
#  exit 8
#fi
read -a vals <<< $(python -V 2>&1)
pyver=${vals[1]:0:1}
echo "name: $name"
if [[ "$pyver" = "2" ]] ;then
  #python -m grpc_tools.protoc -I$protos --python_out=. --grpc_python_out=. $protos/helloworld.proto
  pyout="."
elif [[ "$pyver" = "3" ]] ;then
  if [[ ! (-d "py3") ]] ;then
    mkdir py3
  fi
  pyout="py3"
else
  echo "py version: $vals $pyver"
  exit 8
fi
if [[ "$2" != "old" ]] ;then
  cd $protos
fi
echo "py version: $pyver, pwd:$PWD"
echo "compiling $protos/$name.proto to $pyout/ ..."
python -m grpc_tools.protoc -I$protos --python_out=$pyout --grpc_python_out=$pyout $protos/$name.proto

