#!/usr/libexec/platform-python
#!/usr/bin/python3
#!/usr/bin/python3
from __future__ import print_function
from builtins import input
from builtins import str
from builtins import range
from builtins import object
import time,os,traceback,sys,readline,atexit
#!/usr/bin/python3
#!/usr/bin/python3
from random import randint
import auxfuns, ilogger, maina_utils, colors, extinput
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
import ttcpon_core.driver_comm, ttcpon_board_config.init_onu_fmc as init_onu
import ttcpon_board_config.pon_fmc_i2c_program as program_fmc
import  ttcpon_board_config.init_onu_mlinkolt_cascaded_fmc as init_onu_cascaded

histfile="maina_hist"   # in work directory
logger= None
class Completer(object):
  def __init__(self, words):
    self.words = words
    self.prefix = None
  def complete(self, prefix, index):
    if prefix != self.prefix:
      # new prefix! Find all words that start with this prefix
      self.matching_words = [
        w for w in self.words if w.startswith(prefix)
      ]
      self.prefix = prefix
    try:
      return self.matching_words[index]
    except IndexError:
      return None

tabwords="resetonu N", "fullcal", "lightcal", "netinit", "presence", "health",\
  "onu", "olt"

#!/usr/bin/python3
def main(tpnet, batchlines=[]):
  def printhelp(topic=""):
    if topic=="all" or topic=="olt":
      print("""=== OLT operations
resetolt N msMIN msMAX
         N: number of repetitions (default:1)
         msMIN msMAX: min/max time in secs between 2 resets
                      (default: 1 3)
olt toggle      -toggle olt MGT_TX_POLARITY[0] 
                 Note: has to be 1 for Ligent OLT, 0:GoPhoton OLT
olt toggle m    -toggle olt EN_TX_MATCH_FLAG bit (0x4) in olt_userreg[2]
                 note: ONU: always active

olt N              -choose OLT from list of available OLTs (N: 1,2,...)
olt init           -init ttpon_fmc (clkmux,si570:240.471 mhz,leds,monitor)
                    if ATB: 
                    -check+load Si5345 (stdalone or global -according to olt mode from .net file)
                    -do olt reset
                    -check SFP (program_fmc.monitor_sfp(olt,1))
                    -TX phase alignment
                    -RX phase alignment
                    -CDC reset
olt initncr        -like init but NoCdc Reset done
    reset          -reset olt (i.e. OLT_CORE_RESET bit0 user reg 1->0)
    status [h]     -show user[3][7..0] bits  (should be 11111111)
                    and PLL status
    pllreset       -PLL reset + load ok_fp_clock.hpy (stdalone mode) loaded in PLL
    txpa [g]       - measure+set TX phase aligner.   g: get value set int he past, i.e. do NOT measure
    rxpa [g]                     RX
olt init240        -init ttpon_fmc (clkmux,si570:240     mhz,leds,monitor)
                    *** NOT IMPLEMENTED YET FOR CTPLTU BOARD ***
olt si570r         -read registers 7..12 from si570
olt c|u            -show shortened (only >0) OLT Core|User regs  (now using OLT%d)
    cf | uf        -show full (all regs) regs
    c ADDR [VALUE] -read/set Core register ADDR to VALUE  (read when VALUE missing)
    u ADDR [VALUE] -read/set User register ADDR to VALUE
    prbs7          -set SEL_TX_PATTERN to 0:prbs7, 1:prbs23,...
    prbs23          (for dwnstream errors, only prbs7 available in ONUs)
    const
    count

olt tdomux         -TDOMUX status/control
olt vendor         -use ttcponi2c
olt vendor N       -use remote ttcponi2c: olt---fibre---onu---ttcponi2c on onu target N

olt disable N      -ONU laser off (using ttcpon SLC over downstream)
olt enable N       -ONU laser on

olt detect N       -detect onu N. better: use presence/netinit
olt upr            -read  upstream BBERT cnts (start beforehand: ups N)

fullcal            -only after topology/cables change. Config files written in work dir
lightcal 
netinit            -init OLT and ONUs(over fibre) from config files
presence           -uses .csv file from last calibration
health [olts]      -check PRBS7 pattern coming from ONUs (upstream)
                    olts: list of olts (e.g. 1 3 5), default: all olts
                    BLOCKS USER UPSTREAM TRANSMISSION
"""%olt.multiolt)
    if topic=="all" or topic=="onu":
      print("""=== ONU operations (ONU connected over ipbus/ublaze)
resetonus          -reset+set addr for all ONUs
clearonucs         -clear prbs + errmon counters
getonucs           -print all onus counters
onus               -print the list of all used onus (ONU number, corresponding 
                    ONU address. If applicable, also ATB name is shown)

   In following cmds, if * (or **) used instead of N, command is executed for ALL available ONUs.
   E.g. 
     onu * init   -initializes all available ONUs on current OLT
     onu ** init  -initializes all available ONUs on all available OLTs
     onu ** status -show status of all ONUs on all available OLTs

onu N c|u          -show ONU CORE or USER LOGIC registers (shortened, i.e. only values >0)
    N cf|uf        -show full (all) regs
    N status [h]   -show user[3][7..0] bits  (should be 11111111)
                    and PLL status
    N prbs7|prbs23|const|count -set ONU user register SEL_TX_PATTERN

onu N reset        -just reset (addres not set)
onu N seta         -set addr (addr given in startup cmd: ublaze OLT addr1 addr2...)
onu N exclude      -exclude ONU (set 0 in ONU_MODE core reg0)
onu N include      -include ONU back (set 0xe9 in ONU_MODE core reg0)
    N txpa [g]     -measure+set TX phase aligner.   g: get only what is set (i.e. do NOT measure)
    N rxeq [val]   -check/ set val in RX_EQUALIZER_COTROL core reg using ext_phase_offset40()

onu N init         -eqadapt + [load LHC pll] + set ONUaddr + onu2olt_goodphase + txpa
      pllreset     -reset PLL + load ok_ltu_logic.hpy=pll_in0_global.hpy  
                    not allowed for monitoring onu
onu N si570r       -read regs from si570
onu N rpll 0xppaa  -read 1 byte Si5345 register 0xppaa (pp:page aa:rel. address) 
onu N eyescan      -> WORK/eyeonu_ATBOLT_OLT_ATBONU.csv    more: 'h eyscan'
onu N vendor       -use ttcponi2c
      getmux       -testing ttcponi2c single read (does not work,1 byte i2c rd not available in fi)
onu N mon          -use ttcponi2c
onu N mond         -read fecS,fecD,sc_crc directly(i2c) from onuN
""")
    if topic=="all" or topic=="eyescan":
      print("""=== drawing an eye diagram from data acquired by 'onu N eyescan'
eyeonu_ATBOLT_OLT_ATBONU.csv created in WORK directory:
  ATBOLT -the ATB number serving as a master in ttcpon network
  OLT    -the OLT number used on ATBOLT board
  ATBONU -the ATB number whose ONU was measured

cd $CTP3_CTP3_WORK_DIRECTORY    (or a directory where .csv file(s) are placed)
$CTP3_ROOT/ublaze/plot_eye.py csvname
-> csvname.png file is created in the same directory, 
   x/y (horizontal/vertical apperture of the eye is printed on stdout
""")
    if topic=="all" or topic=="tests":
      print("""=== Downstream test:
cfgds          -set OLT mux to TTCPON,PRBS7 + 
                clear prbs + errmon counters on all onus
clearonucs     -clear prbs + errmon counters on all onus
getonucs       -print all onus counters

=== Upstream test:
ups N          -PRBS7 upstream test of ONU N, upstream counters in OLT cleared
                (start 'olt upr' after this cmd)
upsnc N        -detto, but upstream counters are not cleared
olt upr        -read counters (were cleared by ups N command)
""")
    if topic=="all" or topic=="mon":
      print("""=== Monitoring. A 'mon...' command communicates only with OLT over ipbus, 
                ONUs are accessed over ttcpon slow control.
                clear: corresponding counters/sticky bits are cleared before reading
mond   [clear]  -ONUs downstream monitor.
       fecS fecD sc_crc_detected counters on each ONU
       Note: 'onu X reset' adds 3 fecD errors (rev010).
mondph [clear]  -OLT phy monitor (sticky bits).
       seen_: missing_burst mgt_tx_nready mgt_rx_nready mgt_pll_nlock rx_nlock
monu   [clear]  -OLT upstream monitor (8b10b error detection -sticky bit/ONU). 
       1:errseen/0:ok followed by the list of ONU addrs with the sticky bit ON
monucs [clear]  -read ONU errdet (using OLT core 8B10B_ERRDET_CNTR_ONU reg) registers
                 Behaviour not understood, e.g. 'onu X reset' increases errdet counter
                 for all ONUs, even not existing ones
monuph [clear]  -ONUs phy monitor (sticky bits). 
       success(1:ok) tx_nready rx_nready txpll_nlock rxpll_nlock rx_nlock seen_phase_ngood
       Note: seems only this one reliable for upstream monitoring:
             'onu X reset' raises all sticky bits
monall [clear]  -do all above

monrun olt   [clear] -olt diagnostic
monrun [N|*] [clear] -ONU diagnostic (*: all onus)
monrun [N|*] [key key...]     -ONU diagnostic print only values for given keys
monrun [N|*] dbg [key key...] -ONU debug. Only 1 ONU enabled. See h monrun.
                               Print olt/onu status + fine phases (10x each
                               avereged over 16measurements)

fineph N [avrg]  - measure fine phase (round trip) in ps for ONU N.
                   avrg: default,maximum: 63
""")
    if topic=="all" or topic=="monrun":
      print("""=== monrun:
monrun olt   [clear] -olt diagnostic
monrun [N|*] [clear] -ONU diagnostic (*: all onus)
monrun [N|*] [key key...]     -ONU diagnostic print only values for given keys
monrun [N|*] dbg [key key...] -ONU debug. Only 1 ONU enabled.
  Print olt/onu status + fine phases (10x each avereged over 16measurements).
  Possible problems:
  1. OLT sfp_rx_pwr (-30dBm or so):
    - ONU module transmitter problem. SLC not functional.

  2. OLT sfp_rx_pwr ok (-15dBm or so) -ONU downstream ok:
    - ONU not detected:
      -2 onus with the same address?
      -ONU output not stable (reset?)
    - ONU detected:
      -phase not constant (sync problem, i.e. ONU clock recovery?)
      -onu phase constant: weird -check other pars
""")
    if topic=="all" or topic=="pll":
      print("""=== pll:
pll -status [h]   -> the same as 'olt status [h]'
""")
    if topic=="all" or topic=="net":
      print("""=== net:
$CTP3_CONFIG_DIRECTORY/nets/symname.net  file format:
oltname [s | g]
N onu1 onu2 ...
gbtX [sfp | vtrx]

where:
symname: symbolic name of ttcpon network
oltname: name of an ATB board cotrolling ttcpon network (over OLT)
         optionally followed by mode s:standalone (default) or g:global
         standalone: OLT clock taken from on-board oscilator or front panel (BC_IN)
         global:     OLT clock recovered from ONU SFP connected to CTP
N:       OLT number (1..9) used in ATB board
onu1 ..: connected ONUs can be specified by one of the following:
         atb_30        -ONU in ATB board, ONU address: 30, LTU role (default)
         atb_30:20     -ONU in ATB board, ONU address: 20, LTU role
         15            -ONU in CRU, ONU address: 15
         atb_30:20:cru -ONU in ATB board, ONU address: 20, CRU role (i.e. ATB
                        emulates a CRU -no need of onu2olt clock adjustment)
         not present   -for 'only GBT' setups, without ttcpon network

gbtX [sfp | vtrx]
Optional lines for GBT links connected to GBT1 or GBT2 SFP slots.

""")
    if topic=="all" or topic=="dbg":
      print("""=== dbg:
oltbertc N  -bert clear (before clear, set ONU N in BBERT_SELECT_CHANNEL)
oltbertl    -bert latch
dprt        -print (ON/OFF) addresses

fifoin      -read cmds from extinput.FIFO_PATH instead of stdin (see
             script fifosend.py)
fifoin fn   -read cmds from file WORK/fn instead of stdin
stdin       -finish commands reading from fifo/file (this cmd 
             recognized only in 'fifoin mode' when read from ext. input)              
wfat fname line   -append line to the file 'fname' adding olt-board temperature (tc74)

sleep secs  -sleep secs (int)

""")
    if topic=="all" or topic=="gbt":
      print("""=== gbt:
gbt N help   -more detailed help on GBT comds

""")
    if topic=="all" or topic=="init":
      print("""=== init cmd is used to initialise PLL+main OLT controlling the .net 
                   (can be used directly as a ttcpon parameter: 'ttcpon xxx.net init')
Following actions are executed:
    olt.ctrlcon.plldev.checkgs(olt.gsmode, True) # load PLL if not correct configuration
    --- rev101 ... to be added 
    olt.oltreset()                  # OltExdsg.exd_core_reset(): OLT_CORE_RESET reg: 1->0
    olt.setmux()                    # I2C access to a SFP in the corresponding OLT slot
    program_fmc.monitor_sfp(olt,1)  # program SFP + show SFP status

""")
    if topic=="all" or topic=="obsolete":
      print("""=== obsolete (replaced by ups N):
onu N cfgup        -configure for PRBS7 upstream (use olt ups/upr then)
olt upstart N      -start upstream test for onu N (clear BBERT+SUM regs, use 'onu N cfgup' before)

=== following replaced by onu X init (for ATB in LTU role)
gonu init   -start onu2olt good phase 
""")
    if topic=="":
      print("""=== available helps:
h olt     -olt operation
h onu     -onu operation
h gbt     -gbt operation
h eyescan -drawing eye diagram using data acquired by 'onu N eyescan'
h tests   -downstream, upstream testing
h mon     -Monitoring (only OLT accessed over ipbus)
h net     -format of .net file defining ttcpon net
h init    -'init' cmd is used to initialise a .net from command line (i.e.: 'ttcpon xxx.net init')
h all     -all helps

h dbg     -debugging
h obsolete   -obsolete cmds
q   -quit       h   -this help text
""")
  def allonuadds(onlyvalid=False):
    """rc: list of all onu addreses """
    listonus= []
    #von for ix in range(Nonus):
    #von   onulist.append(onu[ix].onun)
    for ixonun in range(len(onu)):
      if onlyvalid and onu[ixonun-1].excluded():
        pass
      else:
        listonus.append(onu[ixonun].onun)
    return listonus
  def getonuix(cmds):
    n= int(cmds) ; 
    if (n > 0) and (n <= Nonus): return n
    print("Bad ONU number: %d. Expected: 1..%d"%(n, Nonus))
    return None
  def findGBT(ngbt):
    #print "findGBT:",len(gbts)
    for ig in range(len(gbts)):
      if gbts[ig].slave == "gbt%d"%(ngbt):
        return ig
    return None
  def DELMEequalizer_adapt(onu):
    oad= onu.onun
    if oad==-1:
      oadtx="fromctp"
      print("Error hen calling equalizer_adapt with 'fromctp' onu, should never happen")
    else:
      oadtx="_%d"%oad
    onu.setmux() 
    lem= onu.get_lpm_equalizer_monitor()
    print("ONU%s equalizer before adaptation:"%oadtx,lem)
    onu.rx_equalizer_force(1, 0, 0, 0, 0, 0, 0, 0, 0, 0)
    onu.onureset() # reset hangs without ONU inserted
    [RXLPMHF, RXLPMLF, RXLPMOS, RXLPMAGC]= onu.get_lpm_equalizer_monitor()
    print("  new setting: [RXLPMHF, RXLPMLF, RXLPMOS, RXLPMAGC]:",RXLPMHF, RXLPMLF, RXLPMOS, RXLPMAGC)
    onu.set_lpm_equalizer_parameters(RXLPMHF, RXLPMLF, RXLPMOS, RXLPMAGC)
    onu.rx_equalizer_force(1, 1, 1, 1, 1, 0, 0, 0, 0, 0)
    #onu.setmux() 
    onu.onureset()
  def cmdarg(n):
    if len(cmd)>n: 
      return(cmd[n])
    else:
      return("")
  def atbinit(olt, cdcreset=True): # 'ttcpon my.net init' invokes this function
    tpnet.olt1init(olt, cdcreset)
    #todo: for all olts...
  olts= tpnet.allolts
  onus= tpnet.allonus
  gbts= tpnet.gbts
  onufromctp= tpnet.onufromctp  # to be deleted, obsolete
  ixolt= None
  for ix in range(len(olts)):
    if olts[ix]!= None:
      ixolt= ix
      break
  if ixolt==None:
    printError("No OLT.")
    return
  olt= olts[ixolt] ;  onu= onus[ixolt] ; Nonus= 0
  if onu!= None: Nonus= len(onu)
  ixoo= ixolt   # active olt (0..8)
  prompt= colors.color(tpnet.netname+">", "bold")   #prompt=">"
  ixbatchline= 0 ; extinp=None
  while True:
    if extinp and (len(extinp.inputsstack)>0):
      line= extinp.readline()
    else:
      if len(batchlines)>0:
        line= batchlines[ixbatchline]
        ixbatchline= ixbatchline+1
      else:
        line= input(prompt); 
    if line=="": continue
    #sys.stdout.write("\033[0m")  # ok, no NL neither space added
    try:   #if True: #try:
      cmd= line.split()
      if len(cmd) == 0: printhelp()
      elif line[0] == '#': 
        print(line)
      elif cmd[0] == 'h': 
        if len(cmd)>1: topic= cmd[1]
        else: topic= ""
        printhelp(topic)
      elif cmd[0] == 'fifoin':
        if extinp:   # nested fifoin call, check and add on stack
          extinp.fifoin(cmd, olt.name)
        else:
          extinp= extinput.ExtInput(cmd, olt.name)
          if len(extinp.inputsstack)==0:
            extinp= None
      elif cmd[0] == 'wfat':  # wfat fname line
        # append the line to a file adding board temperature
        if len(cmd) <2:
          print("wfa fname line...")
          print("ERROR: fname missing.")
          continue
        fname= cmd[1]
        wfatline= " ".join(cmd[2:])
        #olt.ctrlcon.board.Write("i2cmainttc.mux", 11)
        olt.setmux(ipbusaccess=True)
        temp= olt.ctrlcon.tc74.gettemp()
        #print "tc74 temp:", temp
        olt.setmux()   # restore mux
        # + olt temp:
        olt_list= olt.full_olt_monitor_run()
        if "sfp_temp" in olt_list:
          olttemp= str(olt_list["sfp_temp"])
        else:
          olttemp="0"
        print(wfatline,temp, olttemp)
        f= open(fname,"a"); f.write(wfatline+" "+str(temp)+" "+olttemp+"\n") ; 
      elif cmd[0] == 'q': 
        break
      elif cmd[0] == 'sleep':
        secs= 1
        if len(cmd)>1: secs= eval(cmd[1])
        print("sleep %.2f secs..."%secs)
        time.sleep(secs)
      elif cmd[0] == 'gbt':
        if len(cmd)>1: 
          if cmd[1]=='*':
            forgbts= gbts
          else:
            try:
              ngbt= int(cmd[1])
            except:
              print("Error: gbt * or N ... expected")
              continue
            ixgbt= findGBT(ngbt)
            if ixgbt==None:
              print("Error: gbt %d does not exist"%ngbt)
              continue
            forgbts= [gbts[ixgbt]]
          for ixgbt in range(len(forgbts)):
            cmd[1]= str(forgbts[ixgbt].gbtn)
            if len(cmd)>2:
              forgbts[ixgbt].excmd(cmd[1:])
            else:
              forgbts[ixgbt].showstatus()
        else:
          print("Error: gbt N ... expected")
          continue
      elif cmd[0] == 'gbts':
        for ig in range(len(gbts)):
          if ig==0:
            gbts[ig].showstatus(False, True)  # + header
          else:
            gbts[ig].showstatus(False)
      elif cmd[0] == 'oltreset':
        olt.oltreset()
        print("Check tick (outcnts checktick + crc r if needed)")
      elif cmd[0] == 'init': atbinit(olt)
      elif cmd[0] == 'INIT_OLTS': 
         print(str(tpnet.INIT_OLTS()))
      elif cmd[0] == 'INIT_ONUS':
         print(str(tpnet.INIT_ONUS()))
      elif cmd[0] == 'FULLCAL':
         print(str(tpnet.FULLCAL()))
      elif cmd[0] == 'pll': 
        if len(cmd)>1:
          print(olt.getoltstatus("h"))
        else:
          val= olt.getoltstatus()
          rc,loslmsg= olt.ctrlcon.plldev.cclosl()
          print("OLT:", bin(val)[2:].zfill(8), loslmsg)
      elif cmd[0] == 'olt': 
        wregs="cu"
        if len(cmd)==1:
          print("%s OLT%d"%(olt.name,olt.getoltn()))
          if len(olts)>1:
            prtline= "Defined OLTs:"
            for ixolt in range(len(olts)):
              if olts[ixolt]==None: continue
              if olts[ixolt].sfpin==None:
                in_nc="not in"
              else:
                in_nc="in"
              prtline= prtline+" %d(%s)"%(olts[ixolt].getoltn(), in_nc)
            print(prtline)
        elif (len(cmd)==2) and (cmd[1]>="1") and (cmd[1]<=('9')):
          ixolt= int(cmd[1])-1
          #oltok= False   delme
          #for ix in range(len(olts)):
          #  if olts[ix]==None: continue
          #  if olts[ix].getoltn() == ixolt+1:
          #    olt= olts[ix] ; onu= onus[ix] ; Nonus= len(onu); ixoo= ix
          #    oltok= True
          #    print "OLT%d"%(ixolt+1), "ix:", ix
          #    break
          # also ok (better):
          if olts[ixolt]!=None:
            oltN= olts[ixolt].getoltn()
            if oltN!= (ixolt+1):
              auxfuns.printError("Internal error olt%d.getoltn():%d"%(ixolt+1,oltN))
            else:
              olt= olts[ixolt] ; onu= onus[ixolt] ; Nonus= len(onu); ixoo= ixolt
              #oltok= True
              print("OLT%d"%(ixolt+1))
          else:   #if not oltok:
            print("OLT%c not present in .net file"%cmd[1])
        elif cmd[1]=='reset': 
          olt.oltreset()
          print("Check tick (outcnts checktick + crc r if needed)")
        elif cmd[1]=='pllreset': olt.pllreset()
        elif cmd[1]=='tdomux':
          if len(cmd)==2:
            olt.ctrlcon.board.atbdevs["tdomux"].prtStatus()
          else:
            olt.ctrlcon.board.atbdevs["tdomux"].excmd(cmd[1:])
        elif cmd[1]=='status':
          if len(cmd)>2:
            print(olt.getoltstatus("h"))
          else:
            val= olt.getoltstatus()
            rc,loslmsg= olt.ctrlcon.plldev.cclosl()
            print("OLT:", bin(val)[2:].zfill(8), loslmsg)
        elif cmd[1]=='disable':
          n= getonuix(cmd[2])
          onuaddr= onu[n-1].onun
          olt.onu_mode_disable(onuaddr)
          print("ONU%d disabled (ONU laser off)"%n)
        elif cmd[1]=='enable':
          n= getonuix(cmd[2])
          onuaddr= onu[n-1].onun
          olt.onu_mode_operational(onuaddr)
          print("ONU%d enabled (ONU laser on)"%n)
        #elif cmd[1]=='calib':
        #  n= getonuix(cmd[2])
        #  onuaddr= onu[n-1].onun
        #  olt.onu_mode_calib(onuaddr)
        #  print "ONU%d calib mode..."%n
        elif cmd[1] == 'toggle': 
          if (len(cmd) > 2) and (cmd[2]=="m"):
            olt.toggle_tx_match()
          else:
            olt.toggle_tx_pol()
        elif cmd[1]=='vendor':
          if len(cmd)==2:   # olt vendor
            olt.setmux()
            print(olt.get_sfp_vendor(), olt.get_sfp_part_number(), olt.get_sfp_serial_number())
          elif len(cmd)==3:   # olt vendor N     -look for onuN's SFP
            n= getonuix(cmd[2])
            onuaddr= onu[n-1].onun
            if (n==None): break
            #if (n= getonuix(cmd[2])) == None: break   nebavi
            muxes= onu[n-1].mux
            if muxes:
               onu[n-1].seti2cmainttcmux("onu")   # 10:onu -has to be made here over ipbus!
               rc= olt.set_remotemux(onuaddr, muxes)   # atb or KC
            else:
               rc= True   # CRU: muxes not needed
            if rc:
              print(olt.onu_get_sfp_vendor(onuaddr), olt.onu_get_sfp_part_number(onuaddr), olt.onu_get_sfp_serial_number(onuaddr))
              #print olt.onu_get_sfp_temp(onuaddr)
            else:
              print("Error: mux not set?")
          elif len(cmd)==4:   # olt vendor N M   -look for oltM's SFP connected over onuN
            print("olt vendor N M   -not implemented yet")
          else:
            print("Bad command:", line)
            print("Expected: olt vendor [N [M]]   where N: onuN M: oltM")
        elif cmd[1]=='txpa':    
          action='m'
          if len(cmd)>2: action= cmd[2]
          olt.txpa(action)
        elif cmd[1]=='rxpa':
          action='m'
          if len(cmd)>2: action= cmd[2]
          # CDR_freeze not needed: 
          # 1. 'olt rxpa' does not recover clock from upstream data!
          # 2. in STDALONE: clock taken from independent clock (pllin1)
          #    in GLOBAL: clock taken from: CTP -> MGT ONUrx -> CDR ->
          #               MMCM -> pllin0, i.e. CDR shoud be enabled all the time
          #               
          #onulst= range(Nonus)  
          #for onuix in onulst:
          #  onun= onuix+1 ; onu1= onu[onuix]
          #  #onu1= onu[onun-1] ; onu_addr= onu1.onun
          #  print "ONU%d: freeze_cdr_test_mode:enabling..."%onun
          #  onu1.exd_freeze_cdr_test_mode(1)
          olt.rxpa(action)
          #for onuix in onulst:
          #  onun= onuix+1 ; onu1= onu[onuix]
          #  #onu1= onu[onun-1] ; onu_addr= onu1.onun
          #  onu1.exd_freeze_cdr_test_mode(0)
          #  print "ONU%d: freeze_cdr:disabled."%onun
        elif len(cmd)<3:   # show c/u
          seltx= auxfuns.getseltx(cmd[1])   # prbs7 const count prbs23
          if seltx!=None:
            olt.setseltx(seltx)
            continue
          only1flag= True
          if cmd[1]=="cf" or cmd[1]=="uf" or cmd[1]=="ucf" :
            wregs= cmd[1][:-1]
            olt.printRegs(wregs, False)
          elif cmd[1]=="c" or cmd[1]=="u" or cmd[1]=="uc" :
            wregs= cmd[1]
            olt.printRegs(wregs, True)
          elif cmd[1]=='upr':
            cs= olt.getUpCounts()
            onuadr1= olt.getr("u", 10, False) + 1   # reads only 4bits in v010 (i.e. max onuaddr:16)
            print("OLT ONU_%d BITS: %10d %5d ERRS:%10d %5d PCKLOST:%10d %5d"%\
              (onuadr1, cs[0], cs[1], cs[2], cs[3], cs[4], cs[5]))
          elif cmd[1]=='si570r':
            if olt.conver == "ublaze":
              program_fmc.read_si570(olt)
            else:
              print("Not KC/KCU board, no action.")
          elif (cmd[1]=='init') or (cmd[1]=='init240'):
            if olt.conver == "ublaze":
              lhcfrekv= True
              if cmd[1]=='init240': lhcfrekv= False
              program_fmc.program_clkmux(olt, 0xFF)
              program_fmc.program_si570(olt, 1, lhcfrekv)
              olt.exd_core_reset()
              program_fmc.program_leds(olt, 0x00)		
              program_fmc.monitor_sfp(olt,1)
            else:
              atbinit(olt)
          elif cmd[1]=='initncr':
            atbinit(olt, False)
          else:
            print("Bad parameter: %s (see 'h olt')"%cmd[1])
        elif len(cmd)==3:   # detect or show c/u reg, i.e.: olt c|u ADDR
          if cmd[1]=='detect':   # olt detect N
            n= getonuix(cmd[2])
            onuaddr= onu[n-1].onun
            index_trial = 1
            while(index_trial <= olt.c_MAX_TRIALS_ONU_DETECT):
              onu_was_detected= olt.detect_onu(onuaddr, 
                olt.c_CONSECUTIVE_SUCCESS_DETECT, olt.c_IDLE_BYTE_ADDR)   # 3 31
              print("Trial:%d ONU%d (ONU_%d) detected:"%(index_trial, n, onuaddr), onu_was_detected)
              index_trial+= 1
              if onu_was_detected: break
          elif cmd[1]=='upstart':
            n= getonuix(cmd[2])
            onuaddr= onu[n-1].onun
            olt.bertClear(onuaddr, Nonus)
            print("BBERT PRBS7 test started (clear done) for ONU%d (ONU_%d)..."%(n,onuaddr))
          else:   # olt c|u ADDDR
            cu= cmd[1]
            olt.getr(cu, eval(cmd[2]))
        elif (cmd[1]=='c') or (cmd[1]=='u'):
          # update c/u reg, i.e.: olt c/u ADDR VAL
          cu= cmd[1]
          olt.putr(cu, eval(cmd[2]), eval(cmd[3]))
        else:
          print("? (h olt)")
      elif cmd[0][:3]=='mon':
       if cmd[0]=='mond' or cmd[0]=='monall':   # downstream
        if len(cmd)>1:
          if cmd[1]=='clear':
            for ix in range(len(onu)):
              olt.onu_errmon_clear(onu[ix].onun)
        print("Downstream: success(1:ok) fecS fecD sc_crc_detected")
        for ix in range(len(onu)):
          onuaddr= onu[ix].onun
          errs= olt.onu_errmon_read(onuaddr)   # fecS fecD sc_crc_detected
          errseen= olt.onu_errmon_read_seen_error(onuaddr)
          print("ONU_%d errs:"%onuaddr, errs, "seen:",errseen)
       if cmd[0]=='mondph' or cmd[0]=='monall':   # OLTs bits
        if len(cmd)>1:
          if cmd[1]=='clear':
              olt.phymon_clear()
        print("Downstream (sticky): seen_missing_burst mgt_tx_nready mgt_rx_nready mgt_pll_nlock rx_nlock")
        lst= olt.phymon_read_seen()   
        # seen_missing_burst mgt_tx_nready mgt_rx_nready mgt_pll_nlock rx_nlock
        print("OLT:", lst)
        olt.logger.debug("mondph OLT:%s"%(str(lst)))
       if cmd[0]=='monu' or cmd[0]=='monall':   # upstream
        if len(cmd)>1:
          if cmd[1]=='clear':
            olt.errmon_clear() 
        print("Upstream 8b10b: List of ONU addrs with the sticky bit ON:")
        lst= olt.errmon_read_seen_error()   # 8b10b error detection 
        # olt.errmon_cntr_config() 
        # olt.errmon_get_error_cntr() 
        print(lst)
       if cmd[0]=='monucs' or cmd[0]=='monall':   # upstream errors
        if len(cmd)>1:
          if cmd[1]=='clear':
            olt.errmon_clear() 
        if False:
          for onuaddr in range(1,35):
            olt.errmon_cntr_config(onuaddr)
            val= olt.errmon_get_error_cntr()
            print("ONU_%d: %d"%(onuaddr, val))
        else:
          print("errmon_get_error_cntr() returns 0 for any onu (even for the one not existing), to be investigated, skipped for now...")
       if cmd[0]=='monuph' or cmd[0]=='monall':   # ONUs bits over SC
        if len(cmd)>1:
          if cmd[1]=='clear':
            for ix in range(len(onu)):
              olt.onu_phymon_clear(onu[ix].onun)
        print("Upstream (sticky): success(1:ok) tx_nready rx_nready txpll_nlock rxpll_nlock rx_nlock seen_phase_ngood")
        for ix in range(len(onu)):
          onuaddr= onu[ix].onun   
          lst= olt.onu_phymon_read_seen(onuaddr)   
        # success(1:ok) tx_nready rx_nready txpll_nlock rxpll_nlock rx_nlock seen_phase_ngood
          print("ONU_%d:"%onuaddr, lst)
          olt.logger.debug("monuph ONU_%d:%s"%(onuaddr, str(lst)))
       if cmd[0]=='monrun':
         keys= None ; clear= "" # "clear" or "dbg"
         if len(cmd)<2:
           print("olt or N (1...) missing")
           continue
         if len(cmd)>2:
           if cmd[2]=='clear' or cmd[2]=='dbg':
             clear= cmd[2]
             if len(cmd)>2:
               keys= cmd[3:]
           else:
             keys= cmd[2:]
         olt.setmux()
         if cmd[1]=='olt':
           if clear=='clear': olt.clear_olt_monitor_status()
           if clear=='dbg':
             print("dbg option allowed only with ONU (i.e. the number of ONU left active)")
             continue
           olt_list= olt.full_olt_monitor_run()
           if keys:
             print("olt%d:  "%olt.multiolt, keys)
             values=""
             for k in keys:
               values=values+" \t"+str(olt_list[k])
             print(values)
           else:
             print(olt_list)
         elif (cmd[1]=='*') or ((cmd[1]>="1") and ((cmd[1]<="64"))):
           if cmd[1]=='*':
             only1=-1 
           else:
             only1= int(cmd[1])-1
           if keys:
             print("              ", keys)
           for ix in range(len(onu)):
             if only1==-1:
               onuix= ix
             elif only1==-2:
               continue
             else:
               onuix= only1
               only1= -2
             onu_addr= onu[onuix].onun
             if onu[onuix].excluded():
               print("Skipping excluded ONU%d addr%d."%(onuix+1, onu_addr))
               continue
             muxes= onu[onuix].mux
             if muxes:
               onu[onuix].seti2cmainttcmux("onu")   # 10:onu -has to be made here over ipbus!
               rc= olt.set_remotemux(onu_addr, muxes)   # atb or KC
             else:
               rc= True   # no need to set remote mux on CRU
             if rc:
               if clear=='clear': olt.clear_onu_monitor_status(onu_addr)
               if clear=='dbg':
                 olt_list,onu_list,phase_list = olt.debug_onu(onu_addr)
                 print("OLT:")
                 print(olt_list)
                 print("ONU%d addr:%d phases:"%(onuix+1, onu_addr))
                 print(phase_list)
               else:
                 onu_list = olt.full_onu_monitor_run(onu_addr)
               if keys:
                 values=""
                 for k in keys:
                   values=values+" \t"+str(onu_list[k])
                 print("ONU%d addr:%d:"%(onuix+1, onu_addr), values)
               else:
                 print("ONU%d addr:%d:"%(onuix+1, onu_addr))
                 print(onu_list)
             else:
               print("Error: remote ONU%d mux not set poperly"%onuix)
         else:
           print("Error: got %s but olt or N (1...) expected"%(cmd[1]))
      elif cmd[0]=='fineph':
        onulst= list(range(Nonus))
        if len(cmd)>1:
          if cmd[1]!='*':
            onuix= int(cmd[1])
            onulst= [onuix-1]
        avrg= 63
        if len(cmd)>2:
          avrg= int(cmd[2])
          if (avrg<1) or (avrg>63):
            print("avrg set to 63")
            avrg= 63
        print("onulst:",onulst)
        for onuix in onulst:
          onun= onuix+1 ; onu1= onu[onuix]
          onu_addr= onu[onuix].onun
          olt.config_fine_phase_measurement(1,avrg,onu_addr)      # enable
          #time.sleep(0.1) seems works without sleep, although recommended in debug_onu()
          fp= olt.get_fine_phase_measurement()
          print("fine_phase_measurement ONU%d: "%onun, fp, " [1, ps]")
          olt.config_fine_phase_measurement(0,avrg,onu_addr)      # disable
      elif (cmd[0]=='ups') or (cmd[0]=='upsnc'):
        n= getonuix(cmd[1])
        onu[n-1].cfg_upstream()
        nadr= onu[n-1].onun
        #if nadr>16:
        #  print "ONU addr:%d >16, counters on OLT should be available (rev101)..."
        if cmd[0]=='ups':
          olt.bertClear(nadr, Nonus)
          print("BBERT PRBS7 test started, OLT cnts were cleared for ONU%d (ONU_%d)..."%(n,nadr))
        else:
          print("BBERT PRBS7 test started, OLT cnts NOT cleared for ONU%d (ONU_%d)..."%(n,nadr))
      elif cmd[0] == 'oltbertc': 
        if len(cmd)<2:
          print("give onu number (1,...,%d)"%Nonus)
        else:
          olt.bertClear(int(cmd[1]), Nonus)
      elif cmd[0] == 'oltbertl': 
        olt.bertLatch()
      elif cmd[0] == 'dprt': 
        ttcpon_core.driver_comm.DBGPRT= not ttcpon_core.driver_comm.DBGPRT
        print("DBGPRT:", ttcpon_core.driver_comm.DBGPRT)
      elif cmd[0] == 'cfgds':
        olt.cfg_downstream()
        for ix in range(Nonus):
          onu[ix].clrDownCounts()
      elif cmd[0] == 'clearonucs':
        for ix in range(Nonus):
          onu[ix].clrDownCounts()
      elif cmd[0] == 'getonucs':
        for ix in range(Nonus):
          if onu[ix].conver != "ipbus": continue
          cs= onu[ix].getDownCounts()
          print("ONU%d BITS: %10d %5d BERT_ERRS:%10d %5d FEC_S:%10d %5d FEC_D:%10d %5d FSE:%3d FDE:%3d SCE:%3d"%\
            (ix+1,cs[0], cs[1], cs[2], cs[3], cs[4], cs[5], cs[6], cs[7],
             cs[8], cs[9], cs[10]))
      elif cmd[0] == 'onus': maina_utils.printonus(onu)
      elif cmd[0] == 'exec': 
        eval(cmd[1])
      elif cmd[0] == 'resetolt':
        N= 1 ; msMIN= 1 ; msMAX= 3
        if len(cmd) > 1: N= eval(cmd[1])
        if len(cmd) > 2: msMIN= eval(cmd[2])
        if len(cmd) > 3: msMAX= eval(cmd[3])
        for ix in range(N):
          olt.oltreset()
          time.sleep(randint(msMIN, msMAX)*1)
        print("Check tick (outcnts checktick + crc r if needed)")
      elif cmd[0] == 'gonu':   # special (onu we receive the clock through)
        if onufromctp==None:
          print("ONU not available (anyhow gonu is obsolete)...")
          continue
        if len(cmd) > 1:
          if cmd[1]=='init':
            rc= init_onu_cascaded.automatic_phase_good_onu2olt(onufromctp, olt)
            print("[locked,phase_good_onu2olt]:",rc)
        else:
          print("gonu init -not needed, was done in superior network (onu X init)")
      elif cmd[0] == 'onu': 
        # onu 1 c|u|prbs7|prbs23|const|count
        if len(cmd) < 2:
          for ix in range(Nonus):
            onu[ix].printRegs(); print(" ")
        else:
          if cmd[1] == '**': 
            ixoolst= list(range(len(olts)))
          else:
            ixoolst= [ixoo]
          header= False
          for ixoo in ixoolst:
            #print "olt ixoo:", ixoo
            if olts[ixoo]==None: continue
            olt= olts[ixoo] ; onu= onus[ixoo] ; Nonus= len(onu)   # ixoo set
            if (cmd[1] == '*') or (cmd[1] == '**') : 
              onulst= list(range(Nonus))
            else:
              try:
                onn= int(cmd[1])
              except:
                print("%d >= N > 0 expected"%Nonus)
                break
              if (onn<=0) or (onn>Nonus):
                print("%d >= N > 0 expected"%Nonus)
                break
              onulst= [onn-1]
            for onuix in onulst:
              #print "------ OLT%d ONU%d:"%(ixoo+1, onuix+1)
              onun= onuix+1
              onu1= onu[onun-1]
              onu_addr= onu1.onun
              if onu1.ctrlcon==None:
                print("cannot do for ONU%d -CRU"%onun)
                continue
              onu_name= onu1.ctrlcon.board.bname[4:]
              cu="cu"
              if len(cmd) > 2:
                cu= cmd[2]
                only1flag= True
                if cu=="cf" or cu=="uf":
                  cu= cu[:-1]
                  only1flag= False
                if cu=="c" or cu =="u":
                  #onu[onun-1].printRegs(cu, only1flag)
                  onu[onun-1].printRegs(cu, only1flag)
                elif cu=='txpa':
                  action='m'
                  if len(cmd)>3: action= cmd[3]
                  onu1.txpa(action)
                elif cu=='rxeq':
                  if onu1.ctrlcon==None:
                    print("cannot do rxeq for CRU")
                  ph= (onu1.read_ctrl_reg(0x12) & 0x7fffffff)>>18
                  if len(cmd)>3:
                    phase=int(cmd[3])
                    onu1.exd_phase_offset40(phase)
                    print("rxeq phase: %d, set to: %d"%(ph, phase))
                  else:
                    print("rxeq phase: %d"%ph)
                elif cu=='status':
                  onu1.setmux()
                  if header==False:
                    print("RX/TX_PLL_LOCK RX/TX_READY OPERATIONAL RX_LOCKED PHASE_GOOD RX40_LOCKED")
                    header= True
                  if onu1.conver == "ipbus":
                    if len(cmd)>3:   # onu X status h
                      print(onu1.getonustatus("h"))
                    else:
                      val= onu1.getonustatus()
                      rc,loslmsg= onu1.ctrlcon.plldev.cclosl()
                      print("ONU%d addr:%d:"%(onun, onu_addr),\
                        bin(val)[2:].zfill(8), loslmsg)
                  else:
                    print("ONU%d addr:%d: CRU"%(onun, onu_addr))
                elif cu=='init':   # or cu=="init240":
                  if cmd[1]=='**':
                    print("'onu ** init' is obsolete, use INIT_ONUS instead...")
                    time.sleep(1)
                  # following code replaced by call above
                  if onu1.monionu:
                    pload= False
                    print(colors.color("PLL not checked/loaded for monitoring ONU.", "fg_red"))
                  else:
                    pload= True
                  #lhcfrekv= True
                  #if cu=='init240': lhcfrekv= False
                  if onu1.monionu and (len(onulst)>1):
                    print("onu * init NOT DONE for monitoring ONU (must by done separately before others, followed by 'olt reset')")
                  elif onu[onuix].conver != "ipbus":
                    print("ONU%d addr:%d (in CRU ?) not available over ipbus, init NOT DONE"%(onun, onu_addr))
                  else:
                    onu1.setmux()
                    #equalizer_adapt(onu1)    # should be done only once, after power up
                    onu1.equalizer_adapt()    # should be done only once, after power up
                    init_onu.onu_init(onu1, pllload=pload)
                    if onu1.olt2ndlevel:   # only if ATB in role of LTU
                      print("LTU role, driven by OLT in ", olt.name)
                      fwinfo= onu1.olt2ndlevel.ctrlcon.board.fwinfo
                      #print "olt2ndlevel fwinfo:",hex(fwinfo)
                      if ((fwinfo>>8)&0xffff)>=0x11:
                        import atb.tdomux as tdomux
                        import atb.cdcscan as cdcscan
                        print("fi ver >=11, i.e. cdc scan instead of onu2olt...")
                        tdomux= tdomux.TDOmux(onu1.olt2ndlevel.ctrlcon.board)
                        cdc= cdcscan.CDC(onu1.olt2ndlevel.ctrlcon.board, tdomux)
                        cdcphase= cdc.measure(100)
                        if cdcphase==None:
                          auxfuns.printError("Cannot measure CDC phase")
                        else:
                          cdc.setphase(cdcphase)
                          print("CDC phase %d set."%cdcphase)
                      else:
                        rc= init_onu_cascaded.automatic_phase_good_onu2olt(onu1,
                          onu1.olt2ndlevel)
                        print("[locked,phase_good_onu2olt]:",rc)
                    elif onu1.monionu:
                      print("MONONU,no CDC scan")
                    else:
                      print("CRU role,no CDC scan, driven by OLT in ", olt.name)
                    onu1.txpa("m")
                elif cu=='eqadapt':
                  #onu1.setmux() ; equalizer_adapt(onu1)
                  onu1.setmux() ; onu1.equalizer_adapt()
                elif cu=='reset':
                  onu1.setmux() ; onu[onun-1].onureset()
                elif cu=='getmux':
                  onu[onun-1].getmux()
                elif cu=='vendor':
                  onu1.setmux()
                  print(onu1.get_sfp_vendor(), onu1.get_sfp_part_number(), onu1.get_sfp_serial_number())
                elif cu=='mon':
                  onu1.setmux()
                  print("--- OLT%d ONU%d: T:"%(ixoo+1, onuix+1), onu[onun-1].get_sfp_temp())
                  print("VCC TX_BIAS:", onu[onun-1].get_sfp_vcc(), onu[onun-1].get_sfp_tx_bias())
                  print("TX_PWR RX_PWR:", onu[onun-1].get_sfp_tx_pwr(), onu[onun-1].get_sfp_rx_pwr())
                elif cu=='mond':
                  print("Downstream errors: fecS fecD sc_crc_detected")
                  onuaddr= onu[onun-1].onun
                  errs= onu[onun-1].errmon_read()   # fecS fecD sc_crc_detected
                  errseen= onu[onun-1].errmon_read_seen_error()
                  print("ONU_%d errs:"%onuaddr, errs, "seen:",errseen)
                elif cu=='seta':
                  onu[onun-1].onuseta()
                elif cu=='si570r':
                  program_fmc.read_si570(onu[onun-1])
                elif cu=='rpll':
                  #init_onu.get_pll_reg(onu[onun-1], )
                  onu[onun-1].get_pll_reg(eval(cmd[3]))
                elif cu=='pllreset':
                  onu[onun-1].pllreset()
                elif cu=='eyescan':
                  import ttcpon_core.pon_ku_gth_eyescan as pon_ku_gth_eyescan
                  #if onu[onun-1].onun==1:   # kc7
                  #  import ttcpon_core.pon_k7_gtx_eyescan as pon_k7_gtx_eyescan
                  #  pon_k7_gtx_eyescan.rx_eye_scan(onu[onun-1], "eyeonu%d"%onu[onun-1].onun)
                  #else:   # kcu 105
                  if onu[onun-1].monionu:
                    print("eyescan for monitoring onu, kc105 way...")
                  else:
                    print("onu eyescan kc105 way...")
                  olt_name= olt.ctrlcon.board.bname[4:]
                  pon_ku_gth_eyescan.rx_eye_scan(onu[onun-1],\
                    "eyeonu_%s_%d_%s"%(olt_name, olt.getoltn(), onu_name))
                elif cu=='cfgup':
                  onu[onun-1].cfg_upstream()
                elif cu=='exclude':
                  onu[onun-1].exclude()
                elif cu=="include":
                  onu[onun-1].include()
                else:
                  seltx= auxfuns.getseltx(cu)
                  if seltx!=None:
                    onu[onun-1].setseltx(seltx)
                  else:
                    print("expected: onu N c|u|prbs7|prbs23|const|count")
              else:
                onu[onun-1].printRegs(cu)
      elif cmd[0] == 'resetonus':
        for ix in range(Nonus):
          onu[ix].onureset()
          onu[ix].onuseta()
      elif cmd[0] == 'fullcal':   # see also pywrap/ttcpon/ttcponnet.py  FULLCAL()
        # System Init - Full
        # List of ONU addresses expected to be in the system
        onulist= allonuadds( onlyvalid=True)
        print("fullcal for ONUs:", onulist, " in:", olt.name+'_olt_config')
        print("oltreset NOT DONE before the start of fullcal")
        olt.setmux()
        #olt.oltreset()   # may fix 'No position found for SFP_RX_RESET' 
        #                   but shakes ONUs for cca 3 secs!
        onu_list = olt.full_calibration_run(onulist)
        if onu_list==None:
          print("fullcal abandoned...")
          continue
        #print "fullcal:",len(onu_list), onu_list
        detected= []
        for ix in range(len(onu_list)):
          if onu_list[ix]['detected']==1:
            detected.append(onu_list[ix]['onu_addr'])
        msg= "fullcal at %s.%d fwinfo:0x%x, %d ONUs(out of %d) detected:%s"%\
          (olt.name, olt.getoltn(), olt.ctrlcon.board.fwinfo, len(detected),\
          len(onulist), str(detected))
        logger.info(msg)
        print(msg)
        csvname= olt.getoltcsvn()
        olt.save_onu_config_csv(onu_list,"onu"+csvname)
        olt.save_olt_config_csv("olt"+csvname)
        print("[olt|onu]"+csvname+" config files saved.")
        print("Clearing sticky bits...")
        for ix in range(len(onu)):
          if onu[ix].onun in ['detected']==1:
            olt.onu_errmon_clear(onu[ix].onun)
        olt.phymon_clear()
        olt.errmon_clear() 
        for ix in range(len(onu)):
          if onu[ix].onun in detected:
            olt.onu_phymon_clear(onu[ix].onun)   # over fibre
        print("Clearing flags on olt...")
        olt.clear_olt_monitor_status()   # olt part
        print("Clearing remote ONUs flags not done (discouraged from 2021)...")
        if False:
          for onuix in range(len(onu)):    # onus part
            onu_addr= onu[onuix].onun
            #olt.clear_onu_monitor_status(onu_addr)  later, when mux set for atb board
            if onu[onuix].excluded():
              print("  Skipping excluded ONU%d addr%d."%(onuix+1, onu_addr))
              continue
            muxes= onu[onuix].mux ; rcmux= False
            if muxes:
              #print "seti2cmainttcmux(onu) on onu%d..."%(onuix+1)
              onu[onuix].seti2cmainttcmux("onu")   # has to be made here over ipbus!
              print("set_remotemux on onu%d:"%(onuix+1), muxes,"...")
              rcmux= olt.set_remotemux(onu_addr, muxes)   # atb or KC
            else:
              print("onu%d (onu_%d) is CRU (no mux set)"%((onuix+1), onu_addr))
              rcmux= True   # CRU
            if rcmux:
              print("Clearing flags on onu%d (over olt%d)..."%((onuix+1), olt.getoltn()))
              olt.clear_onu_monitor_status(onu_addr)
            else:
              print("Error:mux not set?")
      elif cmd[0] == 'lightcal':
        # System Re-Init with light calibration
        csvname= olt.getoltcsvn()
        #onu_list = olt.read_onu_config_csv(olt.name+'_onu_config')
        onu_list = olt.read_onu_config_csv("onu"+csvname)
        #olt.load_olt_config_csv(olt.name+'_olt_config')
        olt.load_olt_config_csv("olt"+csvname)
        onu_list_updated = olt.light_calibration_run(onu_list)
      elif cmd[0] == 'netinit':
        # System Re-Init with network init
        csvname= olt.getoltcsvn()
        #onu_list = olt.read_onu_config_csv(olt.name+'_onu_config')
        onu_list = olt.read_onu_config_csv("onu"+csvname)
        #olt.load_olt_config_csv(olt.name+'_olt_config')
        olt.load_olt_config_csv("olt"+csvname)
        olt.network_init(onu_list)
      elif cmd[0] == 'presence':
	# Presence check
        csvname= olt.getoltcsvn()
        #onu_list = olt.read_onu_config_csv(olt.name+'_onu_config')
        onu_list = olt.read_onu_config_csv("onu"+csvname)
        onu_list_updated = olt.network_presence_check(onu_list)
      elif cmd[0] == 'health':
        if len(cmd)==1:   # for all olts
          health4olts=""
        else:
          health4olts= " ".join(cmd[1:])
        print(str(tpnet.HEALTH(health4olts)))
        continue
        onulist= allonuadds( onlyvalid=True)
        if len(onulist)==0:
          print("No ONUs...")
          continue
        csvname= "onu"+olt.getoltcsvn()
	# Health check blocks user upstream transmission for a while, to get
        # fresh prbs7_errors/locked values for each onu
        onu_list = olt.read_onu_config_csv(csvname)
        #print "health onu_list (in %s):"%csvname,onu_list
        onu_list_updated = olt.network_health_check(onu_list)
        #print "health onu_list_u (now, prbs7_errors/locked fields updated):",onu_list_updated
      else: printhelp()
    except Exception as e:
      print(traceback.format_exc())
  logger.info('Finished TTC-PON maina.py')

if __name__ == '__main__':
  auxfuns.cdworkdir()
  histfile="maina_hist"
  if os.path.exists(histfile):
    try:
      readline.read_history_file(histfile)
      # default history len is -1 (infinite), which may grow unruly
      readline.set_history_length(100) #lines
      completer = Completer(tabwords)
      readline.parse_and_bind("tab: complete")
      readline.set_completer(completer.complete)
    except IOError:
      print(traceback.format_exc())
  else:
    print("Commands history not available (no file %s in working directory)"%histfile)
  atexit.register(readline.write_history_file, histfile)
  #logger=  maina_utils.ilogger(olt.board.bname+"_"+"maina.log")
  oltname= maina_utils.getarg1()
  fhlevel="info"
  if auxfuns.isinargs("debug"): fhlevel= "detailed"   # debug level for messages in .log file
  logger=  ilogger.ilogger("maina_%s.log"%oltname, dbglog=fhlevel)
  #olt,onu,gbts,onufromctp,args2= maina_utils.getpars(logger)
  tpnet,args2= maina_utils.getpars(logger)   # tpnet: instance of TtcPonNet.atb
  if tpnet==None: sys.exit(8)
  #if olt==None or onu==None: sys.exit(8)   # we can run only with gbt
  if auxfuns.isinargs("reset"):   # todo: over all onus (all lists)
    for ix in range(len(onu)):
      onu[ix].onureset()
  print("Use x (i.e. ONUx in 1st column) for ONUaddress in CLI...")
  #main(olt, onu, gbts, onufromctp, args2)
  main(tpnet, args2)
