#!/usr/libexec/platform-python

#!/usr/bin/python3
from __future__ import division
from __future__ import print_function
from builtins import str
from builtins import range
from past.utils import old_div
from builtins import object
import os,sys,logging
import ipbuswrap, maina_utils, ilogger, auxfuns
import time,decimal
#!/usr/bin/python3
decimal.getcontext().prec=16

NREP=13           # 13 cycles i.e. 13 hours with 4 LTUs
SLEEPSECS= 15*60  # 15 mins, i.e. 1h/cycle with 4 ONUs
NREP=1
SLEEPSECS= 4  # in seconds

class TPlink(object):
  def __init__(self, firsttime, firstcs):
    self.firsttime= firsttime
    self.firstcs= [0,0]   # [ bs32, bs16 ]
    self.firstcs[0]= firstcs[0]
    self.firstcs[1]= firstcs[1]
    self.time= firsttime
    #self.cs= firstcs   # BAD, need deep copy
    self.cs= [0,0] ; self.cs[0]= firstcs[0]; self.cs[1]= firstcs[1];
  def update(self, tim, cs, relval):
    # 1. use (cs-self.cs) to calculate errratio
    # 2. self.cs= cs   (stored for next calculation)
    self.tim= tim
    #print "newcs2:",cs, self.cs
    cdiff= self.diff(cs, self.cs, relval)
    self.cs[0]= cs[0]   # deep copy!
    self.cs[1]= cs[1]
    return cdiff
  def diff(self, n, b, relval):      # [bs32,bs16] nOW bEFORE (i.e. calculate: n-b)
    n16= n[1]
    b16= b[1]
    now= decimal.Decimal(str(n16))
    if n16 < b16:     # bs16 overflow
      now= decimal.Decimal(str((2**32)*0x10000)) + now*(2**32) + n[0]
    else:
      now= now*(2**32) + n[0]
    bef= decimal.Decimal(str(b16))
    bef= bef*(2**32) + b[0]
    if relval:   # calculate difference
      cdiff= now-bef
    else:
      cdiff= now
    #print self.tim,":", n, '-', b, '=', cdiff     
    return cdiff
class UDlink(object):                  # combined: bits+errors  (1 link)
  """ 
v4:[bits32 bits16 err32 err16]  -for up and also for down stream
v010:[bits32 bits16 err32 err16 fecs32 fecs16 fecd32 fecd16] - downstream
     [bits32 bits16 err32 err16 pcklost32 pcklost16        ] - upstream
      sent          errors      fecs          fecd          
      sent          errors      pcklost
"""
  def __init__(self, berts, ud):   # ud: 'u':upstream, 'd':downstream
    self.ud= ud
    self.errat= None
    self.cnts= []
    self.cnts.append(TPlink(None, (berts[0], berts[1]) ))  # 0: sent
    self.cnts.append(TPlink(None, (berts[2], berts[3]) ))  # 1: errors detected
    # v010:
    self.cnts.append(TPlink(None, (berts[4], berts[5]) ))  # 2: fecsingle or pcklost
    if self.ud=='d':
      self.cnts.append(TPlink(None, (berts[6], berts[7]) ))  # 3: fecdouble
  def update(self, berts, relval=True):
    """
relval: True -> relative values (i.e. calculate now-before)
        
"""
    self.bitdif= self.cnts[0].update(None, (berts[0],berts[1]),relval)
    self.errdif= self.cnts[1].update(None, (berts[2],berts[3]),relval)
    if self.ud=='d':   # update fecsingle/double resp. pcklost
      self.fecsdif= self.cnts[2].update(None, (berts[4],berts[5]),relval)
      self.fecddif= self.cnts[3].update(None, (berts[6],berts[7]),relval)
    else:
      self.pcklostdif= self.cnts[2].update(None, (berts[4],berts[5]),relval)
    if self.bitdif == 0:
      self.errat= "-"
    else:
      self.errat= old_div(self.errdif*decimal.Decimal("1.0"),self.bitdif)
  def getstat(self):
    if self.errat=='-': return "-"
    #return "%d,%d,%.3e"%(self.errdif, self.bitdif, self.errat)
    if self.ud=='d':
      return "%d,%d,%.3e,\t%d,\t%d"%(self.errdif, self.bitdif, self.errat,self.fecsdif,self.fecddif)
    else:
      return "%d,%d,%.3e,\t%d"%(self.errdif, self.bitdif, self.errat,self.pcklostdif)
timdbg= 0
dbg_d= [0,0,0,0,0,0,0,0]
dbg_u= [0,0,0,0,0,0]
def getdbg_du(ud, tim, ixonu):
  global timdbg, dbg_d,dbg_u
  if tim!= timdbg:
    timdbg= tim
    for ix in range(len(dbg_d)):
      if ix%2 == 0:
        dbg_d[ix]= dbg_d[ix]+100
    for ix in range(len(dbg_u)):
      if ix%2 == 0:
        dbg_u[ix]= dbg_u[ix]+1
  if ud=='d':
    return dbg_d
  else:
    return dbg_u
def getcounts(olt, onu, rats, uponun=None):
  # rats: output array of numbers rewritten here
  # fyv2: rats[(d1,d2,e1,e2),(u1,u2,e1,e2),...]  -N*2 tupples
  # fyv4: rats[(d1,d2,e1,e2),(d1,d2,e1,e2),...(u1,u2,e1,e2)]   N+1 tupples
  tim= time.time()
  # fyv2:
  #latch= True
  #for ixonu in range(len(onu)):
  #  rats[2*ixonu]= onu[ixonu].getDownCounts()  # bs32 bs16 err32 err16  downstream
  #  rats[2*ixonu+1]= olt.getUpCounts(ixonu+1, latch)      # upstream
  #  latch= False
  # fyv4:
  for ixonu in range(len(onu)):
    ##rats[ixonu]= onu[ixonu].getDownCounts()  # bs32 bs16 err32 err16  downstream
    # 010: sum32,16 err32,16 fec_sing32,16 fec_doub32,16    fec_scor8 fec_dcor8 sc_crcdetected8
    #   fec_scor8 fec_dcor8 sc_crcdetected8: used only during calibration
    if auxfuns.isinargs("upsonly"):
      rats[ixonu]= (0,0,0,0,0,0,0,0)
    else:
      #rat1= getdbg_du('d', tim, ixonu)
      rat1= onu[ixonu].getDownCounts()
      #print "gcs:ds  ONU%d "%(ixonu+1), rat1
      #rats[ixonu]= (rat1[0], rat1[1], rat1[2], rat1[3])   # only sum err
      rats[ixonu]= (rat1[0], rat1[1], rat1[2], rat1[3], rat1[4], rat1[5], rat1[6], rat1[7])   # v
  # get counters for uponun (maybe we should dcheck with olt setting?):
  selchan= olt.getr("u", 10, False) & 0xf
  #rat1= getdbg_du('u',tim, uponun)
  rat1= olt.getUpCounts()      # 010: sum32,16 err32,16 pcklost32,16 
  #print "gcs:ups ONU%d selchan:%d "%(uponun+1, selchan), rat1
  #rats[len(onu)]= (rat1[0], rat1[1], rat1[2], rat1[3])   # only sum err
  rats[len(onu)]= (rat1[0], rat1[1], rat1[2], rat1[3], rat1[4], rat1[5])   # pcklost
  #print "getcounts:",tim, rats
  return tim   #, rats
def main(tpnet, dataname):
  #print onu[0].getDownCounts()
  #onu[0].printRegs()
  #time.sleep(1)
  #print onu[0].getDownCounts()
  #onu[0].printRegs()
  #return
  allrats= [] ; maxonus= tpnet.maxonus ; alldl= [] ; onuactives= []
  for ixolts in range(len(tpnet.allolts)):
    olt= tpnet.allolts[ixolts]
    onu= tpnet.allonus[ixolts]
    if olt==None:
      allrats.append(None)
      alldl.append(None)
      onuactives.append(None)
      continue
    else:
      allrats.append([])
      alldl.append([])
      onuactives.append(0)
    lenonu=len(onu)
    #if lenonu> maxonus: maxonus= lenonu
    rats= allrats[ixolts]
    for ix in range(lenonu):   # downstream
      rats.append([0,0,0,0,0,0,0,0]) 
    rats.append([0,0,0,0,0,0])               # upstream- just 1 onu
    # rats: [ds_onu1, ds_onu2, ..., ds_onulast, upstream_onuN]
    #init: 'pd_c' ; 'pu_c a' ; 'pu_c olt 1' ; ix= 1 pd_r ix ; pu_r (ix)
    if auxfuns.isinargs("upsonly"):
      print("NO cfg downstram/upstream")
    else:
      # todo: cfg_downstream when LTU always for OLT1.
      #       even if olt1 not present?
      #       - Marian says we should never run without OLT1
      olt.cfg_downstream()   # pd_c + set tdomux to ttcpon
      for ixl in range(lenonu):   # pu_c a
        onu[ixl].cfg_upstream()   # set PRBS7 
    dl= alldl[ixolts]   # prepare 1 downstream instance for each ONU + 1 upstream instance for OLT:
    #
    for ixl in range(lenonu):
      dl.append(UDlink(rats[ixl],'d'))
    dl.append(UDlink(rats[lenonu],'u'))
    #f="""
  for ixolts in range(len(tpnet.allolts)):
    olt= tpnet.allolts[ixolts]
    if olt==None: continue
    print("First readings ixolts:%d..."%ixolts)
    #oltn= olt.getoltn()
    onu= tpnet.allonus[ixolts]
    lenonu=len(onu)
    rats= allrats[ixolts]
    dl= alldl[ixolts]
    onuactive= onuactives[ixolts]
    tim= getcounts(olt,onu,rats, onuactive)
    if onuactive >= (lenonu-1):
      nextixonu= 0
    else:
      nextixonu= onuactive+1
    olt.bertClear(onu[nextixonu].onun, lenonu)
    for ixl in range(lenonu):
        dl[ixl].update(rats[ixl])
    dl[lenonu].update(rats[lenonu], relval=False)
    onuactives[ixolts]= nextixonu
  print("writing data (%d cycles x %dsecs x %d ONUs = %.3f hours) to %s.csv"%\
    (NREP,SLEEPSECS,maxonus,(NREP*maxonus*SLEEPSECS/3600.),dataname))
  dfile= open("%s.csv"%dataname,"w");
  csvheader= "time"
  #csvheader= csvheader + ",onuN,errs_dN,bits_dN,ratio_dN,errs_uN,bits_uN,ratio_uN"
  if auxfuns.isinargs("upsonly"):
    csvheader= csvheader + ",oltN,onuA,,errs_uN,bits_uN,ratio_uN,pcklost_uN"
  else:
    csvheader= csvheader + ",oltN,onuA,errs_dN,bits_dN,ratio_dN,fecS_dN,fecD_dN,errs_uN,bits_uN,ratio_uN,pcklost_uN"
  try:
    dfile.write(csvheader+"\n")
    for ix in range(NREP*maxonus):
      time.sleep(SLEEPSECS)
      for ixolts in range(len(tpnet.allolts)):
        olt= tpnet.allolts[ixolts]
        if olt==None: continue
        oltn= olt.getoltn()
        onu= tpnet.allonus[ixolts]
        lenonu=len(onu)
        rats= allrats[ixolts]
        dl= alldl[ixolts]
        onuactive= onuactives[ixolts]
        #print "=== NREP:%d ONU%d data"%(ix,onuactive+1)
        tim= getcounts(olt,onu,rats, onuactive)   # pd_r ix ; pu_r (ix)
        # let's start next ONU upstream before we print acquired counters:
        if onuactive >= (lenonu-1):
          nextixonu= 0
        else:
          nextixonu= onuactive+1
        olt.bertClear(onu[nextixonu].onun, lenonu)
        print("=== N:%d +ups data for ONU%d.%d, ups started for ONU%d"%(ix,oltn,onuactive+1, nextixonu+1))
        #print "                        ups started for ONU%d"%(nextixonu+1)
        for ixl2 in range(lenonu):
          dl[ixl2].update(rats[ixl2])
        dl[lenonu].update(rats[lenonu], relval=False)  # False: each UPS starts with clear counters
        # write data
        if auxfuns.isinargs("upsonly"):
          for ixonu in range(lenonu):
            ixonu_addr= onu[ixonu].onun
            line= str(tim)+","+ str(oltn)+","+ str(ixonu_addr)
            if ixonu== onuactive:
              line= line + "," + dl[lenonu].getstat()
              print(line)
              dfile.write(line+"\n")
        else:
          for ixonu in range(lenonu):
            ixonu_addr= onu[ixonu].onun
            #print "        ixonu:%d ixonu_addr:%d"%(ixonu, ixonu_addr)
            line= str(tim)
            line= line + ","+ str(oltn)+"," + str(ixonu_addr) + "," + dl[ixonu].getstat()
            if ixonu== onuactive:
              line= line + "," + dl[lenonu].getstat()
            print(line)
            dfile.write(line+"\n")
        dfile.flush()
        onuactives[ixolts]= nextixonu
  finally:
    if dfile is not None: 
      print("closing .csv...")
      dfile.close()
  
if __name__ == '__main__':
  if len(sys.argv)<2:
    #maina_utils.ublazeHelp()
    print("""
Start: erates aj.net cycles sleep [upsonly]

aj.net  -ttcpon net definition in $CTP_CONFIG_DIRECTORY/nets/
cycles  -number of cycles (default:1). 1 cycle does an upstream measurement
         once for each ONU (i.e. 1 cycle takes Nonus*sleep seconds)
sleep   -time [secs] between 2 measurements (default: %ds)
upsonly -read only upstream counters (i.e. .csv: time,onuN,errorsU,bits_sentU,ratioU,pcklostU)

Output:
time,onu1,errorsD,bits_sentD,ratioD,fecS_D,fecD_D
time,onu2,errorsD,bits_sentD,ratioD,fecS_D,fecD_D, errorsU,bits_sentU,ratioU,pcklostU
...
where:
onuX: the ONU address set for Upstream test in last time interval
D -> downstream -counted during interval between 2 lines (for the same ONU)
U -> upstream
ratioX = errorsX/bits_sentX
fecS/D = Single/Double Forward Error Corrections (downstream only)
pcklostU = number of lost packets between 2 lines (for the same ONU, upstream only)

Operation (when upsonly parameter not present):
Downstream: going on all the time in parallel for all ONUs
Upstream: multiplexed (only 1 ONU sending data, while in fyv2 upt to 16 ONUs
          could send upstream data in parallel)

init: set PRBS7 down-stream on all OLTs
      set PRBS7 up-stream test on all ONUs (PRBS7 pattern)
      configure OLT to count up-stream errors from ONU1
repeat %d*MAXONUS times (MAXONUS -number of ONUs for a OLT with max. connected ONUs)
  sleep %ds secs
  for each OLT:
    read down-stream counters from all ONUs (over ipbus)
    read up-stream counters for ONUix (from OLT)

    ONUix= next_ix_from(List_of_all_ONUs):
    configure OLT to count up-stream errors from ONUix
    write .csv: downstream counters for each ONU + upstream counters for ONUix
end_of_loop

"""%(SLEEPSECS, NREP, SLEEPSECS))
    exit(8)
  if len(sys.argv)>=3: NREP= int(sys.argv[2])
  if len(sys.argv)>=4: SLEEPSECS= int(sys.argv[3])
  os.chdir(os.getenv('CTP3_WORK_DIRECTORY'))
  netname= maina_utils.getarg1()
  logger= ilogger.ilogger("rates_%s.log"%netname)
  #olt,onu,gbts,onufromctp,args2= maina_utils.getpars(logger)
  tpnet,args2= maina_utils.getpars(logger)
  nonus= tpnet.maxonus
  print("cycle time:%donus * %dsecs, i.e. * %d = %.1f minutes for all cycles"%\
    (nonus,SLEEPSECS,NREP, NREP*SLEEPSECS*nonus/60.))
  main(tpnet,"rates_"+netname)
