#!/usr/bin/python3

from __future__ import print_function
from builtins import range
import os,os.path,sys,logging
import ttcpon.ttcponnet
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3

myargv= []
def getarg1():
  if len(sys.argv) < 2: return None
  p1= sys.argv[1].split('.')
  if (len(p1)==2) and (p1[1]=="net"):
    return p1[0]
  else:
    return sys.argv[1]
def printonus(onus):
  for ix in range(len(onus)):
    if onus[ix].ctrlcon==None:
      contyp= "cru"
    else:
      contyp= onus[ix].conver
    if contyp=="ipbus":
      note= onus[ix].ctrlcon.board.bname
    elif contyp=="cru":
      note= "cru"
    elif contyp=="ublaze":
      note= "ublaze "+onus[ix].ctrlcon.ip
    else:
      note="??? (unknown ONU)"
    excl=""
    if onus[ix].excluded(): excl= "\t EXCLUDED"
    if onus[ix].monionu:
      excl= excl+"\t MON"
    elif onus[ix].olt2ndlevel:
      excl= excl+"\t LTU"
    else:
      excl= excl+"\t CRU"
    print("ONU%d: %d \t%s\t%s"%(ix+1, onus[ix].onun, note, excl))
def ublazeHelp():
  print("""Usage:

ttcpon  MYNAME.net [pllcheck] [debug]

At least 1 arg expected: the name of the ttcpon net defined in
$CTP3_CONFIG_DIRECTORY/nets/MYNAME.net

pllcheck: the PLL config of all ATB boards are checked and loaded (in Si5345) if necessary. 
debug:  detailed log in maina_MYNAME.log file

*** IPBUS BOARDS HAVE TO BE DEFINED IN $CTP3_CONFIG_DIRECTORY/alice_cf.xml CONNECTION FILE ***
""")
def getpars(logger):
  if len(sys.argv)<2:
    ublazeHelp() ; exit(8)
  args2= []   # statements executed in batch
  gbts= []
  allolts= []  # list of OLTs (
  allonus= []  # and corresponding list of ONU lists
  onufromctp= None
  mainpy= os.path.basename(sys.argv[0])
  cfgdir= os.getenv("CTP3_CONFIG_DIRECTORY")
  p1= sys.argv[1].split('.')
  netp= os.path.join(cfgdir, "nets")
  if (len(p1)==2) and (p1[1]=="net"):
    fpath= os.path.join(netp, sys.argv[1])
    if not os.path.exists(fpath):
      #logger.critical("ERROR: net config does not exist:%s", fpath)
      #logger.info("Available .net files:%s", os.listdir(netp))
      print("ERROR: net config does not exist:%s"%fpath)
      print("Available .net files in %s:%s"%(netp,os.listdir(netp)))
      ublazeHelp() ; exit(8)
    # retrieve args from .net file. This way should replace the old one processing args from cmdline
    # netname.net file:
    # atb_30
    # 1 atb_15 atb_18 atb_19 atb_21
    aargs= ""   # sys.argv[1] + optional args
    for ix in range(2,len(sys.argv)):
      arg= sys.argv[ix]
      aargs= aargs+" "+ arg
      if (arg=="pllcheck") or (arg=="debug"):
        continue
      # everything after "ttcpon my.net" (but kw excluded above) is to be executed in batch
      if ix>1: args2.append(sys.argv[ix])
    if len(args2)>0: args2.append("q")
    logger.info('Start '+mainpy + " " + sys.argv[1]+ " " + aargs)
    tpnet= ttcpon.ttcponnet.TtcPonNet(logger, sys.argv[1].split('.')[0])
  else:
    print("Available .net files:", os.listdir(netp))
    #return None,None,None,None,None
    return None,args2
  #if len(onus)==0:
  if tpnet.getallonusN==0:
    print("No ONUs, only GBT SFP(s)?")
    #ublazeHelp()
    #exit(8)
  #print "Working with ONUs:"
  #printonus(onus)
  if tpnet.waserror:
    return None,args2
  else:
    # allolts: list of olts, allonus: list of lists of ONUs
    #return allolts,allonus,gbts,onufromctp,args2
    return tpnet,args2

