#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
oltc_regs_fiv101= (
("HB_PERIOD_TRX",        1,0xffff,0,"RW","LSB=8.33ns. Heartbeat period, set to Number_ONU's x 125ns/4.16ns = Number_ONUs*30ns"),
("SLOW_CTRL_MSG_ONU",    2,0x1fffffff,0,"RW","ONU manager is not necessary. OLT can write to the ONU register bank.r010: The frame format:(OPE-4b / ONU_REGISTER_BYTE_ADDR - 9b / ONU_REGISTER_VALUE - 8b / ONU_ADDRESS - 8b) where OPE can be: READ=0001, WRITE=1111, WRITE WITH ACKNOWLEDGMENT=1110"), 
("CAL_ONU_ADDR",         3,0xff,0,"RW","Address of ONU which is in calibration mode"),
("CAL_ON",               3,1,8,"RW","Keep 1 during calibration"),
("ONU_POSITION_LATCH",   3,1,10,"RW","Take measurement of ONU position during calibration"), 
("RX_LOCK_ENABLE",       3,1,11,"RW","Enable Rc lock logic"), 
("BERT_ONU_A_ADDR",      4, 0xff,0,"RW","ONU_A addr for internal BBERT"),
("BERT_ONU_B_ADDR",      4, 0xff,8,"RW","ONU_B addr..."),
("BERT_CLEAR",           4, 1, 16,"RW",),
("BERT_LATCH",           4, 1, 17,"RW","latch error number BBERT"),
("BURST_LENGTH-1",       5,0x3f,0,"RW","LSB=4.16ns. Set to 29 for CBM125"),
("SFP_RESET_RX_POS",     5,0x3f,6,"RW","OLT Burst Mode Rx reset position (mod 30)"),
("SFP_RESET_RX_ENABLE",  5,1,12,"RW","enable OLT Burst Mode Rx reset"),
("SLOW_CTRL_FROM_ONU",   6,0x3fffffff,0,"R","Received message from ONU (response: WR_ACK, READ, RCVD_ERROR)"),
("RONDTRIP_FINE_DELAY",  7,0x7f,0,"R","LSB=0.104ns. Measured fine position ONU"),
("RONDTRIP_COARSDELAY",  7,0xffff,7,"R","LSB=8.33ns. Measured coarse position ONU"),
("ERROR_SUM_ONU_A",      8,0xffff,0,"R",),
("ERROR_SUM_ONU_B",      8,0xffff,16,"R",),
("BERT_LOCKED_ONU_A",    9,1,0,"R",),
("BERT_LOCKED_ONU_B",    9,1,1,"R",),
("BERT_FINISHED_ONU_A",  9,1,2,"R",),
("BERT_FINISHED_ONU_B",  9,1,3,"R",),
("MGT_TX_POLARITY",      10,1,0,"RW",),
("MGT_RX_POLARITY",      10,1,1,"RW",),
("PHY_MONITOR_CLEAR",    10,1,2,"RW","Clear PHY sticky bits monitor"),
("PHY_MGT_SEEN_TXNRDY",  10,1,16,"R","Sticky bit MGT TX NOT READY"),
("PHY_MGT_SEEN_RXNRDY",  10,1,17,"R","Sticky bit"),
("PHY_MGT_SEEN_PLLNLOCK",10,1,18,"R","Sticky bit"),
("RX_SEEN_NLOCK",        10,1,19,"R","Sticky bit rX not locked"),
("SD_STAT_CLEAR",        11,1,0,"RW","Clear signal detect failing/raising edge to statistics"), 
("SD_STAT_LATCH",        11,1,1,"RW","Latch signal detect failing/raising edge to statistics"), 
("SD_COMMA_CORR_CLEAR",  11,1,2,"RW","Clear signal detect x comma correlation statistics"), 
("SD_COMMA_CORR_LATCH",  11,1,3,"RW","Latch signal detect x comma correlation statistics"), 
("SD_MASK_OSRX",         11,1,4,"RW","Enable OSRX masking with signal detect"), 
("SD_MASK_OSRX_DELAY",   11,0xf,5,"RW","Delay to signal detect for OSRX masking (unit:TX_CLK_PERIOD)"), 
("SD_STAT",              12,0x3fffffff,0,"R","Signal detect falling/rising edge counter statistics used for calibration in order to find optimal reset position and implement missing burst functions"), 
("I2C_MASTER_CTL",       13,0xffffffff,0,"RW",), 
("I2C_MASTER_STAT",      14,0xffffffff,0,"R",), 
("8B10B_ERRDET_CLEAR",   15,1,    0,"RW","Clear err. detect monitor"),
("8B10B_ERRDET_LATCH",   15,1,    1,"R","Latch err. detect monitor"),
("8B10B_ERRDET_PAGESEL", 15,0x1f, 2,"RW","Page sel. for 8b10b error det. seen. It chooses which ONUs will be in the 8B10B_ERRDET_SEEN_ONU reg. 0:ONU7-0, 1:ONU15-8, ..."),
("8B10B_ERRDET_CNTR_ADD",15,0xff, 7,"RW","ONU addr for 8b10b err detect counter"),
("8B10B_ERRDET_SEEN_ANY",15,1,    15,"R","Sticky bit if any 8x10b error detect seen"),
("8B10B_ERRDET_SEEN_ONU",15,0xff, 16,"R","Sticky bit if 8x10b error detect seen for ONU addresses selected by reg 8B10B_ERRDET_PAGESEL"),
("8B10B_ERRDET_CNTR_ONU",15,0xff, 24,"R","Counter for 8b10b err detection of a given ONU (selected by 8B10B_ERRDET_CNTR_ADD)"),
("INTERRUPT_CTRL",       16,0x7fffffff,0,"RW","Interrupt mask control"), 
("INTERRUPT",            16,1,31,"R","Interrupt value"), 
("DRPACCESS",            17,0x7ffffff,0,"R",),
("RX_PHASE_ALIGNER",     18,0xffffffff,0,"R","MGT Rx phase aligner (Xilinx only)"),
("RX_FINEPHASE_CTRL",    19,0xffffffff,0,"R","MGT Rx fine phase    (Xilinx only)"),
("RX_FINEPHASE_STAT",    20,0xffffffff,0,"R","MGT RX fine phase    (Xilinx only)"),
("RX_FINEPHASE_STAT",    21,0xffffffff,0,"R","MGT Rx fine phase    (Xilinx only)"),
("TX_PHASE_ALIGNER",     22,0xffffffff,0,"R","MGT Tx phase aligner (Xilinx only)")
)
oltu_regs_fiv010= (
("OLT_CORE_RESET",                0x0,1,0,"RW","0->1: RESET OLT CORE"),
("CLEAR_STICKY_BITS",             0x0,1,1,"RW","CLEAR STICKY BITS OF REGISTER 0x3"),
("RX_BBERT_CLEAR",                0x1,1,0,"RW","CLEAR BBERT"),
("RX_BBERT_LATCH",                0x1,1,1,"RW","LATCH RESULTS BBERT"),
("RX_BBERT_HEARTBEAT_PERIOD",     0x1,0xffff,2,"RW","NUMBER_ONUS*(125ns/8.33ns)"),
("SEL_TX_PATTERN",                0x2,3,0,"RW","00=PRBS7 / 01=PRBS23 / 10=CONSTANT / 11=BYTE COUNTER"),
("MUX_TX_DATA_FROM_ONU_RX",       0x2,1, 2,"RW","0=SEND DATA FROM LOCAL DATA GEN (SELECTED WITH BITS 1-0).  1=SEND DATA THAT IS RECEIVED FROM ONU IN THE FIRST PON LAYER"),
("EN_TX_MATCH_FLAG",              0x2,1,3,"RW", "Enable TX match flag for latency measurements"),
("OLT_MGT_PLL_LOCK",              0x3,1,0,"R","STATUS"),
("OLT_MGT_TX_READY",              0x3,1,1,"R","STATUS"),
("OLT_MGT_RX_READY",              0x3,1,2,"R","STATUS"),
("PHASE_GOOD_ONU2OLT",            0x3,1,3,"R","STATUS - PHASE BETWEEN onu_clk_rxusr240_i and olt_clk_txusr240_i is in a good position. Recommended to perform a phase scanning with the sticky bit"),
("phase_lead_nlag_onu2olt_i",     0x3,1,4,"R","if ONU and OLT clock are in a lead/lag relation, not used by CTP (phase scanning not used)"),
("OLT_MGT_PLL_LOCK_STICKY",       0x3,1,16,"R","STATUS - STICKY BIT"),
("OLT_MGT_TX_READY_STICKY",       0x3,1,17,"R","STATUS - STICKY BIT"),
("OLT_MGT_RX_READY_STICKY",       0x3,1,18,"R","STATUS - STICKY BIT"),
("PHASE_GOOD_ONU2OLT_STICKY",     0x3,1,19,"R","STATUS - STICKY BIT"),
("BBERT_ONU_BITSUM(31:0)",        0x4,0xffffffff,0,"R","LINK QUALITY EVALUATION"),
("BBERT_ONU_BITSUM(47:32)",       0x5,0xffff,0,"R","LINK QUALITY EVALUATION"),
("BBERT_ONU_ERRORSUM(31:0)",      0x6,0xffffffff,0,"R","LINK QUALITY EVALUATION"),
("BBERT_ONU_ERRORSUM(47:32)",     0x7,0xffff,0,"R","LINK QUALITY EVALUATION"),
("BBERT_ONU_PACKETLOSSSUM(31:0)", 0x8,0xffffffff, 0,"R","LINK QUALITY EVALUATION"),
("BBERT_ONU_PACKETLOSSSUM(47:32)",0x9,0xffff,0,"R","LINK QUALITY EVALUATION"),
("BBERT_SELECT_CHANNEL(7:0)",     0xA,0xff,0,"RW","LINK QUALITY EVALUATION - This revision contains only a single BBERT per OLT user logic. Checked address is in this reg, 0 corresponds to ONU1, 1 to ONU2 and so on ... This reg has to be set BEFORE the BBERT is cleared")
)
onuc_regs_fiv101= (
("ONU_MODE",                   0x0, 0xff, 0,      "RW","ONU - MODES: ONU doesn't transmit any info (avoid ONUs overlap). 233 to be written here to allow user operation."),
("HEARTBEAT_PERIOD-1",         0x1, 0xffff, 0,    "RW","LSB=4.16ns. Heartbeat period, set to Number_ONU's*125/4.16-1"),
("COARSE_OFFSET_TDM",          0x1, 0xffff, 16,   "RW","Coarse offset in TDM. For a symmetrical network (all fiber lengths are the same), set this value to 1+ONU_ADDR*125/4.16. For asymmetric network calculated by calibration."),
("SFP_ENABLE_DELAY",           0x2, 0xf, 0,       "RW","Adjust this value such the burst is in the middle of the window (will be implemented automatically -> calib)"),
("FINE_OFFSET_TDM",            0x2, 0x1f,8,       "RW","Fine offset in TDM (LSB=0.416ns). For a symmetrical network, set to 0"),
("CLEAR_FEC_CRC_ERROR",        0x3, 1, 0,         "RW","Clear FEC and CRC error counters/sticky bits statistics (wr 1+0)"),
("LATCH_FEC_CRC_ERROR",        0x3, 1, 1,         "RW","Latch FEC and CRC error counters/sticky bits statistics"),
("SLOW_CONTROL_FRAMING_LOCKED",0x3, 1, 7,         "R", "Indicates if slow control framing is locked"),
("FEC_SINGLE_ERROR_CNTR",      0x3, 0xff, 8,       "R", "FEC single error counter"),  # 3 8bits counters used only during fullcal
("FEC_DOUBLE_ERROR_CNTR",      0x3, 0xff,16,       "R", "FEC double error counter"),
("CRC_ERROR_CNTR",             0x3, 0xff,24,       "R", "CRC error detected counter (increments every time an error is detected in the slow control frame)"),
("FEC_SINGLE_ERROR_SEEN",      0x4, 1, 0,         "R", "FEC single error counter seen"),
("FEC_DOUBLE_ERROR_SEEN",      0x4, 1, 1,         "R", "FEC double error counter seen"),
("CRC_ERROR_DETECT_SEEN",      0x4, 1, 2,         "R", "CRC error detected seen"),
("PHY_MONITOR_CLEAR",          0x5, 1, 0,         "RW","Clear PHY sticky bits monitor (wr 1+0)"),
("PHY_MGT_SEEN_TX_NREADY",     0x5, 1, 8,         "R", "Sticky bit corresponding to MGT TX not ready"),
("PHY_MGT_SEEN_RX_NREADY",     0x5, 1, 9,         "R", "Sticky bit corresponding to MGT RX not ready"),
("PHY_MGT_SEEN_TXPLL_NLOCK",   0x5, 1, 10,        "R", "Sticky bit corresponding to MGT TX PLL not locked"),
("PHY_MGT_SEEN_RXPLL_NLOCK",   0x5, 1, 11,        "R", "Sticky bit corresponding to MGT TX PLL not locked"),
("PHY_SEEN_RX_NLOCK",          0x5, 1, 12,        "R", "Sticky bit corresponding to downstream framing not locked"),
("PHY_SEEN_PHASE_NGOOD",       0x5, 1, 13,        "R", "Sticky bit corresponding to a phase not good for the RX->TX CDC"),
("INTERUPT_MASK",              0x6, 0x7fffffff, 0,"RW","Interrupt mask"),
("INTERRUPT",                  0x6, 1, 31,        "R", "Interrupt"),
("I2C_MASTER_CONTROL",         0x0D,0xffffffff, 0,"RW","I2C master control"),
("I2C_MASTER_STAT",            0x0E,0xffffffff, 0,"R", "I2C master stat"),
("OLT_COMM_DISABLE (DEBUG!)",  0xF, 1, 0,         "RW","manager only. Disable OLT slow control communication with the ONU (only controllable by local manager)"),
("DRP ACCESS",                 0x11,0x7ffffff, 0, "RW","Only available for Xilinx devices"),
("RX_EQUALIZER_CTRL",          0x12,0x7ffffff, 0, "RW","Only available for Xilinx devices"),
("RX_CLK_PHASE_CTRL",          0x12,0x3,       0, "RW","Altera only. 00:40Mhz, 01:120Mhz, 10 240Mhz"),
("TX_PHASE_ALIGNER",           0x13,0x7ffffff, 0, "RW","Only available for Xilinx devices")
)
onuu_regs_fiv010= (
("ONU_CORE_RESET",            0x0, 1, 0,   "RW",    "RESET ONU CORE"),
("ONU_ADDRESS",               0x0, 0xff,1, "RW",    "ONU ADDRESS"),
("RX_BERT_CLEAR",             0x1, 1, 0,   "RW",    "CLEAR RESULTS BERT"),
("RX_BERT_LATCH",             0x1, 1, 1,   "RW",    "LATCH RESULTS BERT"),
("SEL_TX_PATTERN",            0x2, 0x3,0,  "RW",    "00=PRBS7 / 01=PRBS23 / 10=CONSTANT / 11=BYTE COUNTER"),
("TX_INTERFACING_MODE",       0x2, 1, 2,   "RW",    "TX INTERFACING"),
("TX_INJECT_ERROR",           0x2, 1, 3,   "RW",    "KEEP TO '1' FOR AR LEAST ONE HB PERIOD TO INSERT A SINGLE ERROR in TX data"),
("ONU_RX40_LOCKED",           0x3, 1, 0,   "R",     "STATUS"),
("ONU_PHASE_GOOD",            0x3, 1, 1,   "R",     "STATUS"),
("ONU_RX_LOCKED",             0x3, 1, 2,   "R",     "STATUS"),
("ONU_OPERATIONAL",           0x3, 1, 3,   "R",     "STATUS"),
("ONU_MGT_TX_READY",          0x3, 1, 4,   "R",     "STATUS"),
("ONU_MGT_RX_READY",          0x3, 1, 5,   "R",     "STATUS"),
("ONU_MGT_TXPLL_LOCK",        0x3, 1, 6,   "R",     "STATUS"),
("ONU_MGT_RXPLL_LOCK",        0x3, 1, 7,   "R",     "STATUS"),
("BERT_BITSUM(31:0)",         0x4, 0xffffffff,0,"R","LINK QUALITY EVALUATION"),
("BERT_BITSUM(47:32)",        0x5, 0xffff,0,"R",    "LINK QUALITY EVALUATION"),
("BERT_ERRORSUM(31:0)",       0x6, 0xffffffff,0,"R","LINK QUALITY EVALUATION"),
("BERT_ERRORSUM(47:32)",      0x7, 0xffff,0,"R",    "LINK QUALITY EVALUATION"),
("FEC_SINGLE_ERRORSUM(31:0)", 0x8, 0xffffffff,0,"R","LINK QUALITY EVALUATION"),
("FEC_SINGLE_ERRORSUM(47:32)",0x9, 0xffff,0,"R",    "LINK QUALITY EVALUATION"),
("FEC_DOUBLE_ERRORSUM(31:0)", 0xA, 0xffffffff,0,"R","LINK QUALITY EVALUATION"),
("FEC_DOUBLE_ERRORSUM(47:32)",0xB, 0xffff,0,"R",    "LINK QUALITY EVALUATION")
)
def printTable(oo, table, coru, poss=30,only1flags=True):
    """
    coru: 
    """
    ralast= -1
    for ir in range(len(table)):
      ra= table[ir][1]   # rel. words
      if ralast!= ra: 
        ralast= ra
        msg="%2d:"%ra
        valueword= oo.read_ctrl_reg(ra | coru)
      else: msg="  :"
      bitm= table[ir][2]
      value= (valueword>>table[ir][3]) & bitm
      if only1flags and ((bitm>0xffff) or (value==0)): continue
      fmt= " %%%d.%ds >%%2d 0x%%8x:0x%%8x"%(poss,poss)
      msg= msg + fmt%(table[ir][0], 
        table[ir][3], bitm, value)
      print(msg)

