#!/usr/bin/python3

from __future__ import print_function
from __future__ import absolute_import
from builtins import range
import time
import atbwrap,symbreg, colors
#!/usr/bin/python3
from .ttcpon_exdsg import (OltMlinkExdsg)
#!/usr/bin/python3
from .driver_comm import (DriverComm)

#!/usr/bin/python3
I2C_FMC_SWITCH_SLAVE_ADDRESS   = 0x74
I2C_FMC_SEL_SFP                = 0x20

class OltMlinkExdsgAlice(OltMlinkExdsg):
  """
OltMlinkExdsgAlice
OltMlinkExdsg
OltExdsg
OltCore
DriverComm
"""
  tdo_mux_docsbrief= {0:"ttcpon", 1:"emu", 2:"emutrd", 4:"tdg"}
  def __init__(self, ip='192.168.1.2', port=9001, lane=0, mode="s",
    logger=None): #, nonus=0):
    OltMlinkExdsg.__init__(self, ip, port, lane)
    if self.ctrlcon==None: return
    self.logger= logger
    self.sfpin= None   # SFP not in. !=None (vendor): SFP inserted 
    # self.nonus= nonus ; self.bbert= (nonus*15)<<2   seems not used 
    self.setolt(lane+1)
    #print "multiolt:",self.multiolt
    self.gsmode= mode   # 's' or 'g'
    # set MUX_TX_DATA_FROM_ONU_RX bit in olt_u:
    val= self.read_ctrl_reg(self.Asel_tx_pattern)
    if mode=='g':
      val= val | 0x4
    else:
      val= val & 0xfffffffb
    self.write_ctrl_reg(self.Asel_tx_pattern, val)
    # check if SFP in:
    self.setmux()
    vendor= self.get_sfp_vendor()
    #print "olt vendor:", self.getoltn(), vendor
    if vendor[0]==1: self.sfpin= vendor[1]
  def setolt(self, nolt):   # 1..9
    # define muxes (different for kc/atb and oltX/onu):
    #print "setolt:",nolt, self.conver
    if self.conver=="ipbus":
      # ltu_logic: 1..9, # itsmft: 1 only
      solt= "olt%d"%nolt
      #if nolt==1: self.mux=(0x74,0, 0x76,1<<4)
      #elif nolt==2: self.mux=(0x74,0, 0x76,1<<5)
      #elif nolt==3: self.mux=(0x74,0, 0x76,1<<6)
      #elif nolt==4: self.mux=(0x74,0, 0x76,1<<7)
      #elif nolt==5: self.mux=(0x76,0, 0x74,1<<6)
      #elif nolt==6: self.mux=(0x76,0, 0x74,1<<7)
      #elif nolt==7: self.mux=(0x74,0, 0x76,1<<2)
      #elif nolt==8: self.mux=(0x74,0, 0x76,1<<3)
      #elif nolt==9: self.mux=(0x76,0, 0x74,1<<2)
      if solt in self.ctrlcon.board.fwsfps:
        self.mux= self.ctrlcon.board.i2cgmuxes[self.ctrlcon.board.fwsfps[solt]]
      else:
        print("Error: OLT%d not possible")   #, using OLT1"%nolt
        return
        nolt=1; self.mux=(0x74,0, 0x76,1<<4)
    elif self.conver=="ublaze":
      if nolt!=1:
        print("Bad OLT%d, using OLT1 on ublaze board"%nolt)
        nolt=1 
      self.mux=(I2C_FMC_SWITCH_SLAVE_ADDRESS,I2C_FMC_SEL_SFP)   # FMC switch
    else:
      print("setolt: Bad OLT%d, only ulaze or ipbus boards supported"%nolt)
      return
    # mozno toto netreba: self.lane_offset= 128*(nolt-1)
    uroffset= self.addr_offset #+ (nolt-1)*0x80
    self.Arx_bbert= 1 + uroffset
    self.Amux_select= 16 + uroffset
    self.Asel_tx_pattern= 2 + uroffset
    self.Astatus= 3 + uroffset
    self.Abbert_sel_chan= 10 + uroffset
    DriverComm.setolt(self, nolt)
  def setmux(self, ipbusaccess=False) :  
    """ rc: True: mux set
            False: problem setting mux
"""
    rc= True
    if self.conver=="ublaze":
      print("OLT setmux: set fmc mux on kcu/kc board (ublaze connection): nothing done.")
      return rc
    if ipbusaccess==True:
      i2cmainttcmux= 11
      #print "olt.setmux i2cmainttc.mux:11(ipbus)"
      # when on ipbus, setmux called from i2c. methods for given device? 
      # -seems valid for atb methods only, not for ttcpon methods.
      # E.g. olt.full_calibration_run() makes an acccess to its SFP...
      #return rc     -commented 19.6.2019
    else:
      i2cmainttcmux= self.multiolt
    try:
      self.ctrlcon.board.Write("i2cmainttc.mux", i2cmainttcmux)
    except:
      print("olt.setmux i2cmainttc.mux:%d not set."%i2cmainttcmux)
      rc= False
    if ipbusaccess==True: return rc
    if self.mux: 
      print("olt setmux: olt%d i2cmainttcmux:%d..."%(self.multiolt,i2cmainttcmux))
      for ix in range(0,len(self.mux),2):
        ma= self.mux[ix] ; val= self.mux[ix+1]
        # like in ttcpon_board_config/pon_fmc_i2c_program.py 
        print("   olt.setmux 0x%x:0x%x ..."%(ma, val))
        rc= self.i2c_write(ma, val, val)   # set mux
        if rc!= 1:
          print("olt%d setmux 0x%x:0x%x failed..."%(self.multiolt, ma, val))
          rc= False
          return rc
        else:
          pass
          #print "         mux 0x%x:0x%x ok."%(ma, val)
    else:
      print("olt setmux: no mux ?, seems internal error")
      rc= False
    return rc
  def set_remotemux(self, onuaddr, rmmuxes):
    """using olt_core.onu_i2c_write to set remote mux over ttcpon downstream SLC: 
Assuming i2cttpon.mux is set already to 10:onu -can be set 
ONLY through ipbus access!
Cases:
1. remote ONU/atb
  (0x74,0, 0x76,1<<4) # fixed, only 1 ONU (SFP2) on each alice board
2. remote OLT/atb -not implemented?
3. remote ONU/kc[u] or OLT/kc[u] on TTCPON FMC card
   (0x74,0x20) ublaze FMC (olt or onu)
4. remote CRU: do nothing (no mux)
"""
    #print "set_remotemux: onuaddr:%d (%s)..."%(onuaddr, rmmuxes)
    for ix in range(0,len(rmmuxes),2):
      ma= rmmuxes[ix] ; val= rmmuxes[ix+1]
      # like in ttcpon_board_config/pon_fmc_i2c_program.py 
      rc= self.onu_i2c_write(ma, val, val, onuaddr)
      if rc!= 1:
        print("Error in set_remotemux: olt%d setmux 0x%x:0x%x failed..."%(self.multiolt, ma, val))
        return False
      else:
        pass #print "             : olt%d remotemux 0x%x:0x%x ok..."%(self.multiolt, ma, val)
    return True  
  def get_tdomux(self):
    # this is a copy of pywrap/atb/tdomux.py TDOmux.getmux()
    fwinfo= self.ctrlcon.board.Read("ctrl.fwinfo")
    if ((((fwinfo>>8) & 0xffff) == 9) and ((fwinfo & 0xff) <= 6)) or\
      (((fwinfo>>8) & 0xffff) < 9):
      val= self.ctrlcon.board.Read("ttcponolt_u1.uregs", 128)&7
    else:
      val= self.ctrlcon.board.Read("ctrl.tdo_mux")&7   # from fi 9_07
    return self.tdo_mux_docsbrief[val]
  def waitready(self, wmsk=0x6):   # 0x4:rxReady 0x2: txReady
    """ rc: 0: ok, i.e. all wmsk bits ON after some time
            1: timeout when waiting for all wmsk bits ON
"""
    nloops= 0 ; slt= 0.5
    while nloops<20:
      val= self.read_ctrl_reg(self.Astatus)
      if (val & wmsk) == wmsk:
        print("  oltreset ok, (%.2f s): waitmask: 0x%x status:0x%x"%(slt*nloops, wmsk, val))  
        return 0
      time.sleep(slt)
      nloops= nloops+1
    print("  oltreset timeout (%.2f s): waitmask: 0x%x status:0x%x"%(slt*nloops, wmsk, val))  
    return 1
  def oltreset(self, wmsk=0x6):
    """ rc: 0: ok, i.e. all wmsk bits ON after some time
            1: timeout when waiting for all wmsk bits ON
"""
    #tdomux= self.get_tdomux()     commented 16.12.2020
    #print "OLT%d reset tdomux:%s ..."%(self.getoltn(), tdomux)
    #
    # following was valid before ltu_logic_v10_01. From v10_01 is ok
    #if tdomux!="ttcpon":
    #  print colors.color("""Warning: olt reset with tdomux!=ttcpon leads to a downstream 40mhz clock shift change.
    #Observed in fw ltu_logic e_01 (very likely in other versions too).
    #Hint: if 40 mhz clock shift needs to be kept, do an oltreset only when tdomux set to ttcpon. ""","fg_red")
    self.exd_core_reset()
    # Eduardo's note:
    # exd_core_reset() is the MGT reset which disables Tx optical transceiver for a while
    return self.waitready(wmsk)
  def pllreset(self):
    print("OLT pllreset...")
    if self.ctrlcon.plldev:
      self.ctrlcon.plldev.hwreset()
      time.sleep(1)
      self.ctrlcon.plldev.checkgs(self.gsmode,load=True, checkbefore=False)
  def setseltx(self, seltx):
    #Aseltx= 2 | self.uroffset
    val= self.read_ctrl_reg(self.Asel_tx_pattern)
    val= (val & 0xfffffffc) | seltx
    self.write_ctrl_reg(self.Asel_tx_pattern, val)
  def bertClear(self, onuaddr1=None, Nonus=None):
    if (onuaddr1==None) or (onuaddr1==0):
      print("onuN has to be >1")
      return
    if Nonus!=None: 
      self.exd_bert_set_heartbeat(Nonus)
    else:
      print("bertClear: exd_bert_set_heartbeat(Nonus) not called (Nonus:None)")
    # channel has to be set before bert_clear:
    #self.write_ctrl_reg(self.Abbert_sel_chan, onuaddr1-1)
    # let's use ttcpon original one:
    self.exd_bert_select_channel(onuaddr1-1)
    self.exd_bert_clear()
    #print "bertClear:"+self.name+" for onu:", onun
    #print "bertClear:"+self.name+" for ONU_%d"%onuaddr1
  def bertLatch(self):
    self.exd_bert_latch()
  def cfg_downstream(self):
    #self.write_ctrl_reg(self.Aolt_core_reset, 1)
    #time.sleep(1)
    #self.write_ctrl_reg(self.Aolt_core_reset, 0)
    #time.sleep(1)
    self.exd_core_reset()
    self.write_ctrl_reg(self.Amux_select, 0)
    self.write_ctrl_reg(self.Asel_tx_pattern, 0)   # PRBS7
    tdomux= self.ctrlcon.board.atbdevs["tdomux"]   #.excmd(cmd[1:])
    if self.ctrlcon.board.isfiwa((self.ctrlcon.board.FW_CTP_LOGIC,)):
      n19= self.getoltn()   # 1 to  max 9 or 6 ?
      tdomux.setcmd('p', n19)   # ttcpon
    else:
      tdomux.setmux(0)   # ttcpon
  def getUpCounts(self):
    self.bertLatch()
    Abs= 4 | self.addr_offset #+ (self.getoltn()-1)*0x80
    #print "getUpCounts Abs:", Abs, self.getoltn()
    rc= []
    for ix in range(3):
      bs2= self.read_ctrl_reg(Abs+2*ix+1) & 0xffff
      bs1= self.read_ctrl_reg(Abs+2*ix) 
      rc.append(bs1); rc.append(bs2)
    return rc   # sum32,16 errsum32,16 pcklost32,16
  def getr(self, cu, addr, desc=True):
    if cu=='u':
      #coru= self.addr_offset + (self.getoltn()-1)*0x80
      coru= self.addr_offset
    elif cu=='c':
      #coru= (self.getoltn()-1)*0x80
      coru= 0
    else:
      return None
    value= self.read_ctrl_reg(addr | coru)
    if desc:
      print("getr %c 0x%x | 0x%x: 0x%x"%(cu, addr, coru, value))
      self.prtDesc(cu, addr, value)
    return value
  def getoltstatus(self, rc=None):
    if rc==None:    
      return self.read_ctrl_reg(self.Astatus)
    else:
      return """....PRTL  -8 bits (taken from ver 0.1.0)
       OLT_MGT_PLL_LOCK
      OLT_MGT_TX_READY
     OLT_MGT_RX_READY
    PHASE_GOOD_ONU2OLT - PHASE BETWEEN onu_clk_rxusr240_i and olt_clk_txusr240_i is in a good position
"""
  def putr(self, cu, addr, value, desc=True):
    if cu=='u':
      coru= self.addr_offset + 0 #(self.getoltn()-1)*0x80
    elif cu=='c':
      coru= 0 #(self.getoltn()-1)*0x80
    else:
      return None
    self.write_ctrl_reg(addr | coru, value)
    if desc:
      print("putr %c %d: 0x%x"%(cu, addr, value))
      self.prtDesc(cu, addr, value)
    return value
  def prtDesc(self, cu, addr, val):
    if cu=='c':
      rd= regnames.oltc_regs_fiv101
    else:
      rd= regnames.oltu_regs_fiv010
    # "name" addr, mask, bit_from_to_the_left,"RW","description"
    #  0     1     2     3                    4     5
    for ix in range(len(rd)):
      if rd[ix][1]==addr:
        desc= ""
        if len(rd[ix])>5: desc= rd[ix][5]
        print("%30s: 0x%x %s"%(rd[ix][0], ((val>>rd[ix][3]) & rd[ix][2]), desc))
  def printRegs(self, wregs="cu", only1flags=True):
    if self.getoltn()==0:
      print("mulitolt:0")
      return
    fiinfo= "fi > v4 (multiolt), using OLT%d."%self.getoltn()
    oltc_regs= regnames.oltc_regs_fiv101
    oltu_regs= regnames.oltu_regs_fiv010
    if wregs.find('c')>=0:
      print("OLT CORE:", fiinfo)
      #self.printTable(oltc_regs, (self.getoltn()-1)*0x80, 21)
      #printTable(self, oltc_regs, (self.getoltn()-1)*0x80, 21, only1flags)
      regnames.printTable(self, oltc_regs, 0, 21, only1flags)
    if wregs.find('u')>=0:
      print("OLT USER:")
      #self.printTable(oltu_regs, self.uroffset, 30)
      #printTable(self, oltu_regs, self.addr_offset + (self.getoltn()-1)*0x80, 30, only1flags)
      regnames.printTable(self, oltu_regs, self.addr_offset + 0, 30, only1flags)
      if not only1flags:
        cs= self.getUpCounts()
        print("BITSUM: %d %d   ERRSUM:%d %d   PACKETLOSS:%d %d"%(cs[0], cs[1], cs[2], cs[3], cs[4], cs[5]))
  def txpa(self, action="m", newval=None):
    """ rc from get_tx_phase_aligner: [phase, 0.5]  0.5: should be >0
        phase: in [pi] pi= 1.6ps, period 64 for OLT (for ONU: very likely different)
               i.e.: 33 == 33+64
               if abs(phase - prev_phase) > 20: reload new value
    g - read phase from phase aligner (returned in rc)
    m - realigne phase aligner to a new value (returned in rc)
    s - set a given value newval (returned in rc)
rc: ok: 0, gms   gms: see above
    timeout after reset: 1, gms
"""
    if action=='g':
      prev_phase= self.get_tx_phase_aligner_status()
      print("OLT get_tx_phase_aligner:", prev_phase)
      return 0,prev_phase
    elif action=='m':
      prev_phase= self.get_tx_phase_aligner_status()
      self.set_tx_phase_aligner(0, 0)
      print("OLT set_tx_phase_aligner(0, 0) done, was:", prev_phase)
      rsrc= self.oltreset(0x6)   # rxReady txReady
      phase= self.get_tx_phase_aligner_status()
      print("OLT get_tx_phase_aligner_status:", phase)
      return rsrc,phase
    elif action=='s':
      print("OLT set_tx_phase_aligner(",newval,", 1)...")
      self.set_tx_phase_aligner(newval, 1)
      return 0,newval
  def rxpa(self, action="m", newval=None):
    if action=='g':
      prev_phase= self.get_rx_phase_aligner_status()
      print("OLT get_rx_phase_aligner:", prev_phase)
      return 0,prev_phase
    elif action=='m':
      prev_phase= self.get_rx_phase_aligner_status()
      self.set_rx_phase_aligner(0, 0)
      print("OLT set_rx_phase_aligner(0, 0) done, was:", prev_phase)
      rsrc= self.oltreset(0x6)   # rxReady txReady
      phase= self.get_rx_phase_aligner_status()
      print("OLT get_rx_phase_aligner_status:", phase)
      return rsrc,phase
    elif action=='s':
      print("OLT set_rx_phase_aligner(",newval,", 1)...")
      self.set_rx_phase_aligner(newval, 1)
      return 0,newval

#!/usr/bin/python3
