#!/usr/libexec/platform-python
"""
v010
"""
#!/usr/bin/python3
#!/usr/bin/python3
import string,time,os,traceback,sys,readline,atexit
#!/usr/bin/python3
#!/usr/bin/python3
from random import randint
ipbpath= os.getenv("CTP3_ROOT")
p010= os.path.join(ipbpath,"ublaze","rev_0_1_0")
if not (p010 in sys.path): sys.path.append(p010)
import auxfuns, ilogger,maina_utils, colors, extinput
#!/usr/bin/python3
import ttcpon_core.driver_comm, ttcpon_board_config.init_onu_fmc as init_onu
import ttcpon_board_config.pon_fmc_i2c_program as program_fmc
import  ttcpon_board_config.init_onu_mlinkolt_cascaded_fmc as init_onu_cascaded

histfile="maina_hist"   # in work directory
logger= None
class Completer:
  def __init__(self, words):
    self.words = words
    self.prefix = None
  def complete(self, prefix, index):
    if prefix != self.prefix:
      # new prefix! Find all words that start with this prefix
      self.matching_words = [
        w for w in self.words if w.startswith(prefix)
      ]
      self.prefix = prefix
    try:
      return self.matching_words[index]
    except IndexError:
      return None

tabwords="resetonu N", "fullcal", "lightcal", "netinit", "presence", "health",\
  "onu", "olt"

#!/usr/bin/python3
def main(tpnet, batchlines=[]):
  def printhelp(topic=""):
    if topic=="all" or topic=="olt":
      print """=== OLT operations
resetolt N msMIN msMAX
         N: number of repetitions (default:1)
         msMIN msMAX: min/max time in milisecs between 2 resets
                      (default: 10 100)
toggle      -toggle olt MGT_TX_POLARITY[0] 
             Note: has to be 1 for Ligent OLT, 0:GoPhoton OLT
toggle m    -toggle olt EN_TX_MATCH_FLAG

olt N              -choose OLT from list of available OLTs (N: 1,2,...)
olt init           -init ttpon_fmc (clkmux,si570:240.471 mhz,leds,monitor)
                    if ATB: 
                    -check+load Si5345 (stdalone or global -according to olt mode from .net file)
                    -do olt reset
                    -check SFP (program_fmc.monitor_sfp(olt,1))
    reset          -reset olt (i.e. OLT_CORE_RESET bit0 user reg 1->0)
    pllreset       -PLL reset + load ok_fp_clock.hpy (stdalone mode) loaded in PLL
olt init240        -init ttpon_fmc (clkmux,si570:240     mhz,leds,monitor)
                    *** NOT IMPLEMENTED YET FOR CTPLTU BOARD ***
olt si570r         -read registers 7..12 from si570
olt c|u            -show shortened (only >0) OLT Core|User regs  (now using OLT%d)
    cf | uf        -show full (all regs) regs
    c ADDR [VALUE] -read/set Core register ADDR to VALUE  (read when VALUE missing)
    u ADDR [VALUE] -read/set User register ADDR to VALUE
    prbs7          -set SEL_TX_PATTERN to 0:prbs7, 1:prbs23,...
    prbs23          (for dwnstream errors, only prbs7 available in ONUs)
    const
    count

olt vendor         -use ttcponi2c
olt vendor N       -use remote ttcponi2c: olt---fibre---onu---ttcponi2c on onu target N

olt disable N      -disable ONU N
olt calib N        -calib ONU N

olt detect N       -detect onu N. better: use presence/netinit
olt upr            -read  upstream BBERT cnts (start beforehand: ups N)

fullcal            -only after topology/cables change. Config files written in work dir
lightcal 
netinit            -init OLT and ONUs(over fibre) from config files
presence 
health
"""%olt.multiolt
    if topic=="all" or topic=="onu":
      print """=== ONU operations (ONU connected over ipbus/ublaze)
resetonus          -reset+set addr for all ONUs
clearonucs         -clear prbs + errmon counters
getonucs           -print all onus counters
onus               -print the list of all used onus (ONU number, corresponding 
                    ONU address. If applicable, also ATB name is shown)

   In following cmds, if * (or **) used instead of N, command is executed for ALL available ONUs.
   E.g. 
     onu * init   -initializes all available ONUs on current OLT
     onu ** init  -initializes all available ONUs on all available OLTs
     onu ** status -show status of all ONUs on all available OLTs

onu N c|u          -show ONU CORE or USER LOGIC registers (shortened, i.e. >0)
    N cf|uf        -show full (all) regs
    N status       -show user[3][7..0] bits  (should be 11111111)

    N prbs7|prbs23|const|count -set ONU user register SEL_TX_PATTERN

onu N reset        -just reset (addres not set)
onu N seta         -set addr (addr given in startup cmd: ublaze OLT addr1 addr2...)
onu N exclude      -exclude ONU (set 0 in ONU_MODE core reg0)
onu N include      -include ONU back (set 0xe9 in ONU_MODE core reg0)

onu N init         -init si570 with lhc freq, [load LHC pll] + automatic phase_good measurement
      init240                  with 240mhz freq, ...
      pllreset     -reset PLL + load ok_ltu_logic.hpy=pll_in0_global.hpy  
                    not allowed on monitoring onu
onu N si570r       -read regs from si570
onu N rpll 0xppaa  -read 1 byte Si5345 register 0xppaa (pp:page aa:rel. address) 
onu N eyescan      -> WORK/eyeonu_ATBOLT_OLT_ATBONU.csv    more: 'h eyscan'
onu N vendor       -use ttcponi2c
      getmux       -testing ttcponi2c single read (does not work,1 byte i2c rd not available in fi)
onu N mon          -use ttcponi2c
"""
    if topic=="all" or topic=="eyescan":
      print """=== drawing an eye diagram from data acquired by 'onu N eyescan'
eyeonu_ATBOLT_OLT_ATBONU.csv created in WORK directory:
  ATBOLT -the ATB number serving as a master in ttcpon network
  OLT    -the OLT number used on ATBOLT board
  ATBONU -the ATB number whose ONU was measured

cd $CTP3_CTP3_WORK_DIRECTORY    (or a directory where .csv file(s) are placed)
$CTP3_ROOT/ublaze/plot_eye.py csvname
-> csvname.png file is created in the same directory, 
   x/y (horizontal/vertical apperture of the eye is printed on stdout
"""
    if topic=="all" or topic=="tests":
      print """=== Downstream test:
clearonucs     -clear prbs + errmon counters on all onus
getonucs       -print all onus counters

=== Upstream test:
ups N          -PRBS7 upstream test of ONU N (start 'olt upr' after this cmd)
olt upr        -read counters (were cleared by ups N command)
"""
    if topic=="all" or topic=="mon":
      print """=== Monitoring. A 'mon...' command communicates only with OLT over ipbus, 
                ONUs are accessed over ttcpon slow control.
                clear: corresponding counters/sticky bits are cleared before reading
mond   [clear]  -ONUs downstream monitor.
       fecS fecD sc_crc_detected counters on each ONU
       Note: 'onu X reset' adds 3 fecD errors.
mondph [clear]  -OLT phy monitor (sticky bits).
       seen_missing_burst tx_nready rx_nready pll_nlock
monu   [clear]  -OLT upstream monitor (8b10b error detection -sticky bit/ONU). 
       1:errseen/0:ok followed by the list of ONU addrs with the sticky bit ON
monucs [clear]  -read ONU errdet (using OLT core 8B10B_ERRDET_CNTR_ONU reg) registers
                 Behaviour not understood, e.g. 'onu X reset' increases errdet counter
                 for all ONUs, even not existing ones
monuph [clear]  -ONUs phy monitor (sticky bits). 
       success(1:ok) tx_nready rx_nready txpll_nlock rxpll_nlock rx_nlock seen_phase_ngood
       Note: seems only this one reliable for upstream monitoring:
             'onu X reset' raises all sticky bits
monall [clear]  -do all above

monrun olt   [clear] -olt diagnostic
monrun [N|*] [clear] -ONU diagnostic (*: all onus)
monrun [N|*] [key key...]   -ONU diagnostic print only values for given keys
"""
    if topic=="all" or topic=="net":
      print """=== net:
$CTP3_CONFIG_DIRECTORY/nets/symname.net  file format:
oltname [s | g]
N onu1 onu2 ...
gbtX [sfp | vtrx]

where:
symname: symbolic name of ttcpon network
oltname: name of an ATB board cotrolling ttcpon network (over OLT)
         optionally followed by mode s:standalone (default) or g:global
         standalone: OLT clock taken from on-board oscilator or front panel (BC_IN)
         global:     OLT clock recovered from ONU SFP connected to CTP
N:       OLT number (1..9) used in ATB board
onu1 ..: connected ONUs can be specified by one of the following:
         atb_30      - ONU in ATB board, ONU address: 30
         atb_30:20   - ONU in ATB board, ONU address: 20
         15          - ONU in CRU, ONU address: 15
         not present - if only OLT number given, it is assumed GBT connection(s)
                       is used

gbtX [sfp | vtrx]
Optional lines for GBT links connected to GBT1 or GBT2 SFP slots.

"""
    if topic=="all" or topic=="dbg":
      print """=== dbg:
oltbertc N  -bert clear (before clear, set ONU N in BBERT_SELECT_CHANNEL)
oltbertl    -bert latch
dprt        -print (ON/OFF) addresses

fifoin      -read cmds from FIFO_PATH instead of stdin (see script fifosend.py)
fifoin fn   -read cmds from file WORK/fn instead of stdin
stdin       -finish commands reading from fifo/file (this cmd 
             recognized only in 'fifoin mode' when read from ext. input)              
wfat fname line   -append line to the file 'fname' adding olt-board temperature (tc74)

sleep secs  -sleep secs (int)
gonu init   -start onu2olt good phase (should be done before fullcal?)

"""
    if topic=="all" or topic=="gbt":
      print """=== gbt:
gbt N reset [cpu|rx|tx] -reset GBT link. N: 1 for fi version v5
             N: 1 or 2 for fi version v6
      help [pattern] -show bits defs
      status
      sfp | vtrx   -destination opt.component (sfp/bidirectional  or
                    vtrx/downstream)
      lb0 | lb1    -loopback off or set loopback1 in .rxctrl
      bsr0 | bsr1  -BitSlipRst bit off/on in .rxctrl

"""
    if topic=="all" or topic=="init":
      print """=== init cmd is used to initialise PLL+main OLT controlling the .net 
                   (can be used directly as a ttcpon parameter: 'ttcpon xxx.net init')
Following actions are executed:
    olt.ctrlcon.plldev.checkgs(olt.gsmode, True) # load PLL if not correct configuration
    olt.oltreset()                  # OltExdsg.exd_core_reset(): OLT_CORE_RESET reg: 1->0
    olt.setmux()                    # I2C access to a SFP in the corresponding OLT slot
    program_fmc.monitor_sfp(olt,1)  # program SFP + show SFP status
"""
    if topic=="all" or topic=="obsolete":
      print """=== obsolete (replaced by ups N):
onu N cfgup        -configure for PRBS7 upstream (use olt ups/upr then)
olt upstart N      -start upstream test for onu N (clear BBERT+SUM regs, use 'onu N cfgup' before)
"""
    if topic=="":
      print """=== available helps:
h olt     -olt operation
h onu     -onu operation
h eyescan -drawing eye diagram using data acquired by 'onu N eyescan'
h tests   -downstream, upstream testing
h mon     -Monitoring (only OLT accessed over ipbus)
h net     -format of .net file defining ttcpon net
h init    -'init' cmd is used to initialise a .net from command line (i.e.: 'ttcpon xxx.net init')
h all     -all helps

h dbg     -debugging
h obsolete   -obsolete cmds
q   -quit       h   -this help text
"""
  def allonuadds(onlyvalid=False):
    """rc: list of all onu addreses """
    listonus= []
    #von for ix in range(Nonus):
    #von   onulist.append(onu[ix].onun)
    for ixonun in range(len(onu)):
      if onlyvalid and onu[ixonun-1].excluded():
        pass
      else:
        listonus.append(onu[ixonun].onun)
    return listonus
  def getseltx(cmd):
    seltx=None 
    if cmd=="prbs7":
      seltx= 0
    elif cmd=="prbs23":
      seltx= 1
    elif cmd=="const":
      seltx= 2
    elif cmd=="count":
      seltx= 3
    else:
      pass
    return seltx
  def getonuix(cmds):
    n= int(cmds) ; 
    if (n > 0) and (n <= Nonus): return n
    print "Bad ONU number: %d. Expected: 1..%d"%(n, Nonus)
    return None
  def atbinit(olt):   # 'ttcpon my.net init' invokes this function
    # default pll (atb):
    #olt.ctrlcon.plldev.checkandload("cfg/ok_ltu_logic.hpy")
    # OLT depends on mode:
    olt.ctrlcon.plldev.checkgs(olt.gsmode, True)   # True:load if not correct
    olt.oltreset()
    olt.setmux()
    program_fmc.monitor_sfp(olt,1)
  olts= tpnet.allolts
  onus= tpnet.allonus
  gbts= tpnet.gbts
  onufromctp= tpnet.onufromctp
  olt= olts[0] ;  onu= onus[0] ; Nonus= len(onu) ; ixoo= 0
  prompt= colors.color(tpnet.netname+">", "bold")   #prompt=">"
  ixbatchline= 0 ; extinp=None
  while True:
    if extinp and (len(extinp.inputsstack)>0):
      line= extinp.readline()
    else:
      if len(batchlines)>0:
        line= batchlines[ixbatchline]
        ixbatchline= ixbatchline+1
      else:
        line= raw_input(prompt); 
    if line=="": continue
    #sys.stdout.write("\033[0m")  # ok, no NL neither space added
    try:   #if True: #try:
      cmd= string.split(line)
      if len(cmd) == 0: printhelp()
      elif line[0] == '#': 
        print line
      elif cmd[0] == 'h': 
        if len(cmd)>1: topic= cmd[1]
        else: topic= ""
        printhelp(topic)
      elif cmd[0] == 'fifoin':
        if extinp:   # nested fifoin call, check and add on stack
          extinp.fifoin(cmd, olt.name)
        else:
          extinp= extinput.ExtInput(cmd, olt.name)
          if len(extinp.inputsstack)==0:
            extinp= None
      elif cmd[0] == 'wfat':  # wfat fname line
        # append the line to a file adding board temperature
        if len(cmd) <2:
          print "wfa fname line..."
          print "ERROR: fname missing."
          continue
        fname= cmd[1]
        wfatline= string.join(cmd[2:])
        #olt.ctrlcon.board.Write("i2cmainttc.mux", 11)
        olt.setmux(ipbusaccess=True)
        temp= olt.ctrlcon.tc74.gettemp()
        #print "tc74 temp:", temp
        olt.setmux()   # restore mux
        # + olt temp:
        olt_list= olt.full_olt_monitor_run()
        if olt_list.has_key("sfp_temp"):
          olttemp= str(olt_list["sfp_temp"])
        else:
          olttemp="0"
        print wfatline,temp, olttemp
        f= open(fname,"a"); f.write(wfatline+" "+str(temp)+" "+olttemp+"\n") ; 
      elif cmd[0] == 'q': 
        break
      elif cmd[0] == 'sleep':
        secs= 1
        if len(cmd)>1: secs= eval(cmd[1])
        print "sleep %.2f secs..."%secs
        time.sleep(secs)
      elif cmd[0] == 'gbt':
        if len(cmd)>1: 
          try:
            ngbt= int(cmd[1])
          except:
            print "Error: gbt N ... expected"
            continue
          if len(gbts)==1:
            availablegbts= (1,)
          elif len(gbts)==2:
            availablegbts= (1,2)
          else:
            print "Int. error (sw ok for v5 or v6 only)"
            continue
          if not ( ngbt in availablegbts ):
            print "Only %d GBTs available"%len(gbts)
            continue
        else:
            print "Error: gbt N ... expected"
            continue
        if len(cmd)>2:
          if cmd[2] == 'reset': 
            bitx="cpu"
            if len(cmd)>3:  # gbt N reset rx
              bitx= cmd[3]
            gbts[ngbt-1].reset(bitx)
            print "gbt%d reset done"%ngbt
          elif cmd[2] == 'init':
            gbts[ngbt-1].init()
          elif cmd[2] == 'status': 
            gbts[ngbt-1].showstatus()
          elif cmd[2] == 'help': 
            if len(cmd)>3: bits= eval(cmd[3])
            else: bits= None
            gbts[ngbt-1].showbitdefs(bits)
          elif (cmd[2] == 'sfp') or (cmd[2] == 'vtrx') or (cmd[2]=='lb0') or\
            (cmd[2] == 'lb1') or (cmd[2] == 'bsr0') or (cmd[2]=='bsr1'): 
            gbts[ngbt-1].settxrx(cmd[2])
          else:
            print "Bad cmd:", line
        else:
          gbts[ngbt-1].showstatus()
      elif cmd[0] == 'oltreset': olt.oltreset()
      elif cmd[0] == 'init': atbinit(olt)
      elif cmd[0] == 'olt': 
        wregs="cu"
        if len(cmd)==1:
          print "%s OLT%d"%(olt.name,olt.getoltn())
          if len(olts)>1:
            prtline= "Available OLTs:"
            for ixolt in range(len(olts)):
              prtline= prtline+" %d"%olts[ixolt].getoltn()
            print prtline
        elif cmd[1]=='reset': olt.oltreset()
        elif cmd[1]=="pllreset":
          olt.pllreset()
        elif cmd[1]=='disable':
          n= getonuix(cmd[2])
          onuaddr= onu[n-1].onun
          olt.onu_mode_disable(onuaddr)
          print "ONU%d disabled"%n
        elif cmd[1]=='calib':
          n= getonuix(cmd[2])
          onuaddr= onu[n-1].onun
          olt.onu_mode_calib(onuaddr)
          print "ONU%d calib mode..."%n
        elif cmd[1]=='vendor':
          if len(cmd)==2:   # olt vendor
            olt.setmux()
            print olt.get_sfp_vendor(), olt.get_sfp_part_number(), olt.get_sfp_serial_number()
          elif len(cmd)==3:   # olt vendor N     -look for onuN's SFP
            n= getonuix(cmd[2])
            onuaddr= onu[n-1].onun
            if (n==None): break
            #if (n= getonuix(cmd[2])) == None: break   nebavi
            muxes= onu[n-1].mux
            if muxes:
               onu[n-1].seti2cmainttcmux(10)   # 10:onu -has to be made here over ipbus!
               rc= olt.set_remotemux(onuaddr, muxes)   # atb or KC
            else:
               rc= True   # CRU: muxes not needed
            if rc:
              print olt.onu_get_sfp_vendor(onuaddr), olt.onu_get_sfp_part_number(onuaddr), olt.onu_get_sfp_serial_number(onuaddr)
              #print olt.onu_get_sfp_temp(onuaddr)
            else:
              print "Error: mux not set?"
          elif len(cmd)==4:   # olt vendor N M   -look for oltM's SFP connected over onuN
            print "olt vendor N M   -not implemented yet"
          else:
            print "Bad command:", line
            print "Expected: olt vendor [N [M]]   where N: onuN M: oltM"
        elif len(cmd)<3:   # show c/u
          seltx= getseltx(cmd[1])   # prbs7 const count prbs23
          if seltx!=None:
            olt.setseltx(seltx)
            continue
          only1flag= True
          if cmd[1]=="cf" or cmd[1]=="uf" or cmd[1]=="ucf" :
            wregs= cmd[1][:-1]
            olt.printRegs(wregs, False)
          elif cmd[1]=="c" or cmd[1]=="u" or cmd[1]=="uc" :
            wregs= cmd[1]
            olt.printRegs(wregs, True)
          elif cmd[1]=='upr':
            cs= olt.getUpCounts()
            onuadr1= olt.getr("u", 10, False) + 1   # reads only 4bits in v010 (i.e. max onuaddr:16)
            print "OLT ONU_%d BITS: %10d %5d ERRS:%10d %5d PCKLOST:%10d %5d"%\
              (onuadr1, cs[0], cs[1], cs[2], cs[3], cs[4], cs[5])
          elif cmd[1]=='si570r':
            if olt.conver == "ublaze":
              program_fmc.read_si570(olt)
            else:
              print "Not KC/KCU board, no action."
          elif (cmd[1]=='init') or (cmd[1]=='init240'):
            if olt.conver == "ublaze":
              lhcfrekv= True
              if cmd[1]=='init240': lhcfrekv= False
              program_fmc.program_clkmux(olt, 0xFF)
              program_fmc.program_si570(olt, 1, lhcfrekv)
              olt.exd_core_reset()
              program_fmc.program_leds(olt, 0x00)		
              program_fmc.monitor_sfp(olt,1)
            else:
              atbinit(olt)
          elif (len(cmd)==2) and (cmd[1]>="1") and (cmd[1]<=(str(len(olts)))):
            ixolt= int(cmd[1])-1
            olt= olts[ixolt] ; onu= onus[ixolt] ; Nonus= len(onu); ixoo= ixolt
            print "OLT%d"%olt.getoltn()
          else:
            print "Bad parameter: %s (see 'h olt')"%cmd[1]
        elif len(cmd)==3:   # detect or show c/u reg, i.e.: olt c|u ADDR
          if cmd[1]=='detect':   # olt detect N
            n= getonuix(cmd[2])
            onuaddr= onu[n-1].onun
            index_trial = 1
            while(index_trial <= olt.c_MAX_TRIALS_ONU_DETECT):
              onu_was_detected= olt.detect_onu(onuaddr, 
                olt.c_CONSECUTIVE_SUCCESS_DETECT, olt.c_IDLE_BYTE_ADDR)   # 3 31
              print "Trial:%d ONU%d (ONU_%d) detected:"%(index_trial, n, onuaddr), onu_was_detected
              index_trial+= 1
              if onu_was_detected: break
          elif cmd[1]=='upstart':
            n= getonuix(cmd[2])
            onuaddr= onu[n-1].onun
            olt.bertClear(onuaddr, Nonus)
            print "BBERT PRBS7 test started (clear done) for ONU%d (ONU_%d)..."%(n,onuaddr)
          else:   # olt c|u ADDDR
            cu= cmd[1]
            print "getr... ",cu,cmd[2], eval(cmd[2])
            olt.getr(cu, eval(cmd[2]))
        else:   # update c/u reg, i.e.: olt c/u ADDR VAL
          cu= cmd[1]
          olt.putr(cu, eval(cmd[2]), eval(cmd[3]))
      elif cmd[0][:3]=='mon':
       if cmd[0]=='mond' or cmd[0]=='monall':   # downstream
        if len(cmd)>1:
          if cmd[1]=='clear':
            for ix in range(len(onu)):
              olt.onu_errmon_clear(onu[ix].onun)
        print "Downstream: success(1:ok) fecS fecD sc_crc_detected"
        for ix in range(len(onu)):
          onuaddr= onu[ix].onun
          errs= olt.onu_errmon_read(onuaddr)   # fecS fecD sc_crc_detected
          errseen= olt.onu_errmon_read_seen_error(onuaddr)
          print "ONU_%d errs:"%onuaddr, errs, "seen:",errseen
       if cmd[0]=='mondph' or cmd[0]=='monall':   # OLTs bits
        if len(cmd)>1:
          if cmd[1]=='clear':
              olt.phymon_clear()
        print "Downstream (sticky): seen_missing_burst tx_nready rx_nready pll_nlock"
        lst= olt.phymon_read_seen()   
        # seen_missing_burst tx_nready rx_nready pll_nlock
        print "OLT:", lst
       if cmd[0]=='monu' or cmd[0]=='monall':   # upstream
        if len(cmd)>1:
          if cmd[1]=='clear':
            olt.errmon_clear() 
        print "Upstream 8b10b: List of ONU addrs with the sticky bit ON:"
        lst= olt.errmon_read_seen_error()   # 8b10b error detection 
        # olt.errmon_cntr_config() 
        # olt.errmon_get_error_cntr() 
        print lst
       if cmd[0]=='monucs' or cmd[0]=='monall':   # upstream errors
        if len(cmd)>1:
          if cmd[1]=='clear':
            olt.errmon_clear() 
        if False:
          for onuaddr in range(1,35):
            olt.errmon_cntr_config(onuaddr)
            val= olt.errmon_get_error_cntr()
            print "ONU_%d: %d"%(onuaddr, val)
        else:
          print "errmon_get_error_cntr() returns 0 for any onu (even for the one not existing), to be investigated, skipped for now..."
       if cmd[0]=='monuph' or cmd[0]=='monall':   # ONUs bits over SC
        if len(cmd)>1:
          if cmd[1]=='clear':
            for ix in range(len(onu)):
              olt.onu_phymon_clear(onu[ix].onun)
        print "Upstream (sticky): success(1:ok) tx_nready rx_nready txpll_nlock rxpll_nlock rx_nlock seen_phase_ngood"
        for ix in range(len(onu)):
          onuaddr= onu[ix].onun   
          lst= olt.onu_phymon_read_seen(onuaddr)   
        # success(1:ok) tx_nready rx_nready txpll_nlock rxpll_nlock rx_nlock seen_phase_ngood
          print "ONU_%d:"%onuaddr, lst
       if cmd[0]=='monrun':
         clear= False ; keys= None
         if len(cmd)<2:
           print "olt or N (1...) missing"
           continue
         if len(cmd)>2:
           if cmd[2]=='clear':
             clear= True
           else:
             keys= cmd[2:]
         olt.setmux()
         if cmd[1]=='olt':
           if clear: olt.clear_olt_monitor_status()
           olt_list= olt.full_olt_monitor_run()
           if keys:
             print "olt%d:  "%olt.multiolt, keys
             values=""
             for k in keys:
               values=values+" \t"+str(olt_list[k])
             print values
           else:
             print olt_list
         elif (cmd[1]=='*') or ((cmd[1]>="1") and ((cmd[1]<="64"))):
           if cmd[1]=='*':
             only1=-1 
           else:
             only1= int(cmd[1])-1
           if keys:
             print "              ", keys
           for ix in range(len(onu)):
             if only1==-1:
               onuix= ix
             elif only1==-2:
               continue
             else:
               onuix= only1
               only1= -2
             onu_addr= onu[onuix].onun
             if onu[onuix].excluded():
               print "Skipping excluded ONU%d addr%d."%(onuix+1, onu_addr)
               continue
             muxes= onu[onuix].mux
             if muxes:
               onu[onuix].seti2cmainttcmux(10)   # 10:onu -has to be made here over ipbus!
               rc= olt.set_remotemux(onu_addr, muxes)   # atb or KC
             else:
               rc= True   # no need to set remote mux on CRU
             if rc:
               if clear: olt.clear_onu_monitor_status(onu_addr)
               onu_list = olt.full_onu_monitor_run(onu_addr)
               if keys:
                 values=""
                 for k in keys:
                   values=values+" \t"+str(onu_list[k])
                 print "ONU%d addr:%d:"%(onuix+1, onu_addr), values
               else:
                 print "ONU%d addr:%d:"%(onuix+1, onu_addr)
                 print onu_list
             else:
               print "Error: remote ONU%d mux not set poperly"%onuix
         else:
           print "Error: got %s but olt or N (1...) expected"%(cmd[1])
      elif cmd[0]=='ups':
        n= getonuix(cmd[1])
        onu[n-1].cfg_upstream()
        nadr= onu[n-1].onun
        if nadr>16:
          print "ONU addr:%d >16, counters on OLT will not be available."
        olt.bertClear(nadr, Nonus)
        print "BBERT PRBS7 test started, OLT cnts were cleared for ONU%d (ONU_%d)..."%(n,nadr)
      elif cmd[0] == 'oltbertc': 
        if len(cmd)<2:
          print "give onu number (1,...,%d)"%Nonus
        else:
          olt.bertClear(int(cmd[1]), Nonus)
      elif cmd[0] == 'oltbertl': 
        olt.bertLatch()
      elif cmd[0] == 'dprt': 
        ttcpon_core.driver_comm.DBGPRT= not ttcpon_core.driver_comm.DBGPRT
        print "DBGPRT:", ttcpon_core.driver_comm.DBGPRT
      elif cmd[0] == 'clearonucs':
        for ix in range(Nonus):
          onu[ix].clrDownCounts()
      elif cmd[0] == 'getonucs':
        for ix in range(Nonus):
          if onu[ix].conver != "ipbus": continue
          cs= onu[ix].getDownCounts()
          print "ONU%d BITS: %10d %5d BERT_ERRS:%10d %5d FEC_S:%10d %5d FEC_D:%10d %5d FSE:%3d FDE:%3d SCE:%3d"%\
            (ix+1,cs[0], cs[1], cs[2], cs[3], cs[4], cs[5], cs[6], cs[7],
             cs[8], cs[9], cs[10])
      elif cmd[0] == 'onus': maina_utils.printonus(onu)
      elif cmd[0] == 'toggle': 
        if (len(cmd) > 1) and (cmd[1]=="m"):
          olt.toggle_tx_match()
        else:
          olt.toggle_tx_pol()
      elif cmd[0] == 'exec': 
        eval(cmd[1])
      elif cmd[0] == 'resetolt':
        N= 1 ; msMIN= 1 ; msMAX= 3
        if len(cmd) > 1: N= eval(cmd[1])
        if len(cmd) > 2: msMIN= eval(cmd[2])
        if len(cmd) > 3: msMAX= eval(cmd[3])
        for ix in range(N):
          olt.oltreset()
          time.sleep(randint(msMIN, msMAX)*1)
      elif cmd[0] == 'gonu':   # special (onu we receive the clock through)
        if onufromctp==None:
          print "ONU not available..."
          continue
        if len(cmd) > 1:
          if cmd[1]=='init':
            rc= init_onu_cascaded.automatic_phase_good_onu2olt(onufromctp, olt)
            if rc==0:
              print "failed."
      elif cmd[0] == 'onu': 
        # onu 1 c|u|prbs7|prbs23|const|count
        if len(cmd) < 2:
          for ix in range(Nonus):
            onu[ix].printRegs(); print " "
        else:
          if cmd[1] == '**': 
            ixoolst= range(len(olts))
          else:
            ixoolst= [ixoo]
          header= False
          for ixoo in ixoolst:
            #print "olt ixoo:", ixoo
            olt= olts[ixoo] ; onu= onus[ixoo] ; Nonus= len(onu)   # ixoo set
            if (cmd[1] == '*') or (cmd[1] == '**') : 
              onulst= range(Nonus)
            else:
              try:
                onn= int(cmd[1])
              except:
                print "%d >= N > 0 expected"%Nonus
                break
              if (onn<=0) or (onn>Nonus):
                print "%d >= N > 0 expected"%Nonus
                break
              onulst= [onn-1]
            for onuix in onulst:
              #print "------ OLT%d ONU%d:"%(ixoo+1, onuix+1)
              onun= onuix+1
              onu1= onu[onun-1]
              onu_addr= onu1.onun
              if onu1.ctrlcon==None:
                print "ONU%d addr:%d: CRU, no action..."%(onun, onu_addr)
                continue
              onu_name= onu1.ctrlcon.board.bname[4:]
              cu="cu"
              if len(cmd) > 2:
                cu= cmd[2]
                only1flag= True
                if cu=="cf" or cu=="uf":
                  cu= cu[:-1]
                  only1flag= False
                if cu=="c" or cu =="u":
                  #onu[onun-1].printRegs(cu, only1flag)
                  onu[onun-1].printRegs(cu, only1flag)
                elif cu=='status':
                  onu1.setmux()
                  if header==False:
                    print "RX/TX_PLL_LOCK RX/TX_READY OPERATIONAL RX_LOCKED PHASE_GOOD RX40_LOCKED"
                    header= True
                  if onu1.conver == "ipbus":
                    val= onu1.getonustatus()
                    loslmsg= onu1.ctrlcon.plldev.cclosl()
                    print "ONU%d addr:%d:"%(onun, onu_addr),\
                      bin(val)[2:].zfill(8), loslmsg
                  else:
                    print "ONU%d addr:%d: CRU"%(onun, onu_addr)
                elif cu=='init' or cu=="init240":
                  #if (len(cmd) > 3) and (cmd[3]=="pll"):
                  #  pload= True
                  if onu1.monionu:
                    pload= False
                    print colors.color("PLL not checked/loaded for monitoring ONU.", "fg_red")
                  else:
                    pload= True
                  lhcfrekv= True
                  if cu=='init240': lhcfrekv= False
                  if onu[onuix].monionu and (len(onulst)>1):
                    print "onu * init NOT DONE for monitoring ONU (must by done first, followed by 'olt reset')"
                  elif onu[onuix].conver != "ipbus":
                    print "ONU%d addr:%d (in CRU ?) not available over ipbus, init NOT DONE"%(onun, onu_addr)
                  else:
                    onu1.setmux()
                    init_onu.onu_init(onu1, pllload=pload, lhc=lhcfrekv)
                elif cu=="reset":
                  onu1.setmux()
                  onu[onun-1].onureset()
                elif cu=="getmux":
                  onu[onun-1].getmux()
                elif cu=="vendor":
                  onu1.setmux()
                  print onu1.get_sfp_vendor(), onu1.get_sfp_part_number(), onu1.get_sfp_serial_number()
                elif cu=="mon":
                  onu1.setmux()
                  print "--- OLT%d ONU%d: T:"%(ixoo+1, onuix+1), onu[onun-1].get_sfp_temp()
                  print "VCC TX_BIAS:", onu[onun-1].get_sfp_vcc(), onu[onun-1].get_sfp_tx_bias()
                  print "TX_PWR RX_PWR:", onu[onun-1].get_sfp_tx_pwr(), onu[onun-1].get_sfp_rx_pwr()
                elif cu=="seta":
                  onu[onun-1].onuseta()
                elif cu=="si570r":
                  program_fmc.read_si570(onu[onun-1])
                elif cu=="rpll":
                  #init_onu.get_pll_reg(onu[onun-1], )
                  onu[onun-1].get_pll_reg(eval(cmd[3]))
                elif cu=="pllreset":
                  onu[onun-1].pllreset()
                elif cu=="eyescan":
                  import ttcpon_core.pon_ku_gth_eyescan as pon_ku_gth_eyescan
                  #if onu[onun-1].onun==1:   # kc7
                  #  import ttcpon_core.pon_k7_gtx_eyescan as pon_k7_gtx_eyescan
                  #  pon_k7_gtx_eyescan.rx_eye_scan(onu[onun-1], "eyeonu%d"%onu[onun-1].onun)
                  #else:   # kcu 105
                  if onu[onun-1].monionu:
                    print "eyescan for monitoring onu, kc105 way..."
                  else:
                    print "onu eyescan kc105 way..."
                  olt_name= olt.ctrlcon.board.bname[4:]
                  pon_ku_gth_eyescan.rx_eye_scan(onu[onun-1], "eyeonu_%s_%d_%s"%(olt_name, olt.getoltn(), onu_name))
                elif cu=="cfgup":
                  onu[onun-1].cfg_upstream()
                elif cu=='exclude':
                  onu[onun-1].exclude()
                elif cu=="include":
                  onu[onun-1].include()
                else:
                  seltx= getseltx(cu)
                  if seltx!=None:
                    onu[onun-1].setseltx(seltx)
                  else:
                    print "expected: onu N c|u|prbs7|prbs23|const|count"
              else:
                onu[onun-1].printRegs(cu)
      elif cmd[0] == 'resetonus':
        for ix in range(Nonus):
          onu[ix].onureset()
          onu[ix].onuseta()
      elif cmd[0] == 'fullcal':
        # System Init - Full
        # List of ONU addresses expected to be in the system
        onulist= allonuadds( onlyvalid=True)
        print "fullcal for ONUs:", onulist, " in:", olt.name+'_olt_config'
        print "oltreset NOT DONE before the start of fullcal"
        #olt.oltreset()   # may fix 'No position found for SFP_RX_RESET' 
        #                   but shakes ONUs for cca 3 secs!
        olt.setmux()
        onu_list = olt.full_calibration_run(onulist)
        if onu_list==None:
          print "fullcal abandoned..."
          continue
        csvname= olt.getoltcsvn()
        olt.save_onu_config_csv(onu_list,'onu'+csvname)
        olt.save_olt_config_csv("olt"+csvname)
        print "[olt|onu]"+csvname+" config files saved."
        print "Clearing sticky bits..."
        for ix in range(len(onu)):
          olt.onu_errmon_clear(onu[ix].onun)
        olt.phymon_clear()
        olt.errmon_clear() 
        for ix in range(len(onu)):
          olt.onu_phymon_clear(onu[ix].onun)
        print "Clearing flags on olt..."
        olt.clear_olt_monitor_status()   # olt part
        print "ONUs flags not cleared..."   # seems bug in 
        continue                            #olt.clear_onu_monitor_status(onu_addr)
        for onuix in range(len(onu)):    # onus part
          onu_addr= onu[onuix].onun
          if onu[onuix].excluded():
            print "  Skipping excluded ONU%d addr%d."%(onuix+1, onu_addr)
            continue
          muxes= onu[onuix].mux
          if muxes:
            print "seti2cmainttcmux(10) on onu%d..."%(onuix+1)
            onu[onuix].seti2cmainttcmux(10)   # 10:onu -has to be made here over ipbus!
            print "set_remotemux on onu%d:"%(onuix+1), muxes
            rc= olt.set_remotemux(onu_addr, muxes)   # atb or KC
          else:
            rc= True   # CRU
          if rc:
            print "Clearing flags on onu%d (over olt)..."%(onuix+1)
            olt.clear_onu_monitor_status(onu_addr)
          else:
            print "Error:mux not set?"
      elif cmd[0] == 'lightcal':
        # System Re-Init with light calibration
        csvname= olt.getoltcsvn()
        #onu_list = olt.read_onu_config_csv(olt.name+'_onu_config')
        onu_list = olt.read_onu_config_csv('onu'+csvname)
        #olt.load_olt_config_csv(olt.name+'_olt_config')
        olt.load_olt_config_csv("olt"+csvname)
        onu_list_updated = olt.light_calibration_run(onu_list)
      elif cmd[0] == 'netinit':
        # System Re-Init with network init
        csvname= olt.getoltcsvn()
        #onu_list = olt.read_onu_config_csv(olt.name+'_onu_config')
        onu_list = olt.read_onu_config_csv('onu'+csvname)
        #olt.load_olt_config_csv(olt.name+'_olt_config')
        olt.load_olt_config_csv("olt"+csvname)
        olt.network_init(onu_list)
      elif cmd[0] == 'presence':
	# Presence check
        csvname= olt.getoltcsvn()
        #onu_list = olt.read_onu_config_csv(olt.name+'_onu_config')
        onu_list = olt.read_onu_config_csv('onu'+csvname)
        onu_list_updated = olt.network_presence_check(onu_list)
      elif cmd[0] == 'health':
        csvname= 'onu'+olt.getoltcsvn()
	# Health check blocks user upstream transmission for a while, to get
        # fresh prbs7_errors/locked values for each onu
        onu_list = olt.read_onu_config_csv(csvname)
        #print "health onu_list (in %s):"%csvname,onu_list
        onu_list_updated = olt.network_health_check(onu_list)
        #print "health onu_list_u (now, prbs7_errors/locked fields updated):",onu_list_updated
      else: printhelp()
    except Exception, e:
      print(traceback.format_exc())
  logger.info('Finished TTC-PON maina.py')

if __name__ == '__main__':
  auxfuns.cdworkdir()
  histfile="maina_hist"
  if os.path.exists(histfile):
    try:
      readline.read_history_file(histfile)
      # default history len is -1 (infinite), which may grow unruly
      readline.set_history_length(100) #lines
      completer = Completer(tabwords)
      readline.parse_and_bind("tab: complete")
      readline.set_completer(completer.complete)
    except IOError:
      print(traceback.format_exc())
  else:
    print "Commands history not available (no file %s in working directory)"%histfile
  atexit.register(readline.write_history_file, histfile)
  #logger=  maina_utils.ilogger(olt.board.bname+"_"+"maina.log")
  oltname= maina_utils.getarg1()
  logger=  ilogger.ilogger("maina_%s.log"%oltname)
  #olt,onu,gbts,onufromctp,args2= maina_utils.getpars(logger)
  tpnet,args2= maina_utils.getpars(logger)   # tpnet: instance of TtcPonNet.atb
  if tpnet==None: sys.exit(8)
  #if olt==None or onu==None: sys.exit(8)   # we can run only with gbt
  if auxfuns.isinargs("reset"):   # todo: over all onus (all lists)
    for ix in range(len(onu)):
      onu[ix].onureset()
  print "Use x (i.e. ONUx in 1st column) for ONUaddress in CLI..."
  #main(olt, onu, gbts, onufromctp, args2)
  main(tpnet, args2)
