#!/usr/libexec/platform-python
import sys, os
import csv
import matplotlib.pyplot as plt
import matplotlib.cm as cm
import numpy as np
import math,string

#!/usr/bin/python3
#!/usr/bin/python3
ystep=2.8       # mV/div
y_step_div=-4
y_init = 127
y_end  = -125
yaxis_min = y_init*ystep
yaxis_max = y_end*ystep
number_y =int(1.0*(y_end-y_init)/y_step_div) + 1

#!/usr/bin/python3
xstep = 1.0/64.0 #1/64 of the UI
x_step_div = 1
x_init=-32
x_end=31
xaxis_min = x_init*xstep
xaxis_max = x_end*xstep
number_x =int(1.0*(x_end-x_init)/x_step_div) + 1

class eye_scan:
  def __init__(self, eyescan_file, annot):
    # Matrix to plot
    self.ber_matrix = []
    for i in range(0,number_y):
        self.ber_matrix.append([])
        for j in range(0,number_x):
            self.ber_matrix[-1].append(0)
    # Read data curve
    j=0
    #with open(os.path.join(os.getenv("CTP3_WORK_DIRECTORY"),eyescan_file)+'.csv')
    #with open(os.path.join(os.getcwd(),eyescan_file)+'.csv'):
    with open(eyescan_file+'.csv') as csvfile:
        reader = csv.DictReader(csvfile)
        for row in reader:
            for i in range(0, number_x):
              try:
                self.ber_matrix[j][i] = np.log10(float(row['%20s' % ('hor' + str(i))]))
              except:
                print "plot_eye_scan except:",j,i
            j=j+1
    self.minerrs= self.ber_matrix[number_y/2][number_x/2]
    #print "minerrs:",self.minerrs    	
    maxy= self.find_yapp(number_y/2, number_x/2)
    maxx= self.findmaxx_app()
    print "%s x/y:"%eyescan_file, maxx,maxy
    Z=self.ber_matrix
    X,Y=np.meshgrid(np.linspace(xaxis_min,xaxis_max,number_x),np.linspace(yaxis_min,yaxis_max,number_y))
    
    #im = plt.pcolormesh(X,Y,Z, cmap='RdYlGn_r', shading='flat')
    im = plt.pcolormesh(X,Y,Z, cmap='jet', shading='flat')
    plt.colorbar(im, orientation='vertical', label='log10(BER)')
    plt.xlabel('X offset - UI')
    plt.ylabel('Y offset - mV')
    plt.axis([xaxis_min, xaxis_max, yaxis_min, yaxis_max])
    plt.title('ONU Rx-Eye Sweep %s%s: %d %d'%(annot,eyescan_file, maxx, maxy))
    #plt.show()
    #plt.savefig(os.path.join(os.getenv("CTP3_WORK_DIRECTORY"),eyescan_file+".png"))
    plt.savefig(eyescan_file+".png")
    plt.gcf().clear()
  def find_yapp(self, mp, xc):
    """mp: starting point inside -search will be done in both directions
       xc: x coordinate
    """
    high= low= -1
    for irow in range(mp, number_y, 1):    # examine upper rows
      if self.ber_matrix[irow][xc] == self.minerrs:
        high= irow
      else:
        break
    for irow in range(mp-1, -1, -1):    # examine lower rows
      if self.ber_matrix[irow][xc] == self.minerrs:
        low= irow
      else:
        break
    #print "low,high:",low,high
    return high-low+1
  def findmaxx_app(self):
    left=right=-1 ; maxx= 0
    for irow in range(0, number_y):    # all rows
      left=right=-1
      for iy in range(0, number_x):
        if self.ber_matrix[irow][iy] == self.minerrs:
          if left==-1:
            left= iy ; right= iy
          else:
            right= iy
        else:
          if left!=-1: break
      if left!=-1:
        xapp= right+1-left
        #print "row %d: %d - %d %d"%(irow, left,right, right+1-left)
        if xapp>maxx: maxx= xapp
    return maxx
if __name__ == '__main__':
  if len(sys.argv)<2:
    print """ name.csv -> name.png
plot_eye.py name [annotation]

where:
name   -file in current directory without .csv suffix. 
        (all -do all .csv files)

annotation -optional annotation added in the title of the picture.

"""
    sys.exit()
  annot= ""
  if len(sys.argv)==3:
    annot= sys.argv[2]+"/"
  if sys.argv[1]=='all':
    import glob
    lst= glob.glob('*.csv')
    for csvn in lst:
      name= string.split(csvn,'.')[0]
      p= eye_scan(name, annot)
  else:
    p= eye_scan(sys.argv[1], annot)

