#!/usr/libexec/platform-python

#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3

#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
import logging
import time

#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
from ttcpon_core.ttcpon_exdsg import (OltMlinkExdsg, OnuMlinkExdsg)

#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
import ttcpon_core.pon_ku_gth_eyescan as pon_ku_gth_eyescan

#!/usr/bin/python3
#!/usr/bin/python3
#!/usr/bin/python3
import ttcpon_board_config.pon_fmc_i2c_program as program_fmc
import ttcpon_board_config.init_onu_fmc as init_onu_fmc
import ttcpon_board_config.init_onu_mlinkolt_cascaded_fmc as init_onu_mlinkolt

def main(olt, onu):

    ####################################################
    ###          Parameters for Application          ###
    ####################################################
    INIT_OLT                        = 1  # possible values: 1 or 0
    INIT_ONU                        = 1  # possible values: 1 or 0
    PERFORM_ONU_EYE_SCAN            = 0  # possible values: 1 or 0

    ####################################################
    ###        Start TTC-PON Ex. Application         ###
    ####################################################
    logger_pon.info('Started TTC-PON TEST application')

    ####################################################
    ###          Initialization of OLT               ###
    ####################################################
    # Program OLT
    if(INIT_OLT):	
        logger_pon.info('---------------------------------------------------------')	
        logger_pon.info('------------------- PROGRAM OLT-FMC --------------------')	
        olt.exd_core_reset()
        program_fmc.program_leds(olt,0x00)		
        program_fmc.monitor_sfp(olt,1)
        logger_pon.info('                                                         ')
        time.sleep(1)

    ### INIT - ONU_1 - Mounted on FMC - KCU105 board (Kintex Ultrascale)
    if(INIT_ONU):		
        logger_pon.info('---------------------------------------------------------')		
        logger_pon.info('------------------- PROGRAM ONU4-FMC --------------------')
        logger_pon.info('---------------------------------------------------------')	
        init_onu_fmc.onu_init(onu[0])
        logger_pon.info('                                                         ')		
        time.sleep(1)
    if(PERFORM_ONU_EYE_SCAN):	
        logger_pon.info('---------------------- Eye Scan ONU4 --------------------')
        pon_ku_gth_eyescan.rx_eye_scan(onu[0],'./calibration_config/eyescan_onu4', 1)
        logger_pon.info('                                                         ')	
        time.sleep(1)

    ####################################################
    ###  Switch between cascaded mode and standalone ###
    ####################################################
    # Uncomment lines below if using standalone mode:	
    ## Standalone:	
    #init_onu_mlinkolt.onu2olt_mode(onu[0], olt, 0)
    #program_fmc.monitor_sfp(onu[0],1)

    # Uncomment lines below if using cascaded mode:
    # Cascaded:	
    #init_onu_mlinkolt.onu2olt_mode(onu[0], olt, 1)
    #init_onu_mlinkolt.automatic_phase_good_onu2olt(onu[0], olt)
    #program_fmc.monitor_sfp(onu[0],1)

if __name__ == '__main__':
    # Logger TTC-PON CORE definition:
    # create logger with 'ttc_pon' application
    logger_pon = logging.getLogger('ttc_pon')
    logger_pon.setLevel(logging.DEBUG)
    # create file handler which logs even debug messages
    fh = logging.FileHandler('/home/trigger/WORK/kcu105.log')
    fh.setLevel(logging.DEBUG)
    # create console handler with a higher log level
    ch = logging.StreamHandler()
    ch.setLevel(logging.INFO)
    # create formatter and add it to the handlers
    formatter = logging.Formatter(
        '%(asctime)s - %(name)s - %(levelname)s: %(message)s',
        datefmt='%d-%m-%y %H:%M:%S')
    fh.setFormatter(formatter)
    ch.setFormatter(formatter)
    # add the handlers to the logger
    logger_pon.addHandler(fh)
    logger_pon.addHandler(ch)

    # Logger TTC-PON EXDSG definition:
    # create logger with 'ttc_pon' application
    logger_exd_pon = logging.getLogger('ttc_pon_tests')
    logger_exd_pon.setLevel(logging.DEBUG)
    # add the handlers to the logger
    logger_exd_pon.addHandler(fh)
    logger_exd_pon.addHandler(ch)

    # Open sockets
    # open OLT socket
    olt = OltMlinkExdsg('192.168.1.19', 9001,0)

    # open ONU socket
    onu = [	
        OnuMlinkExdsg('192.168.1.19', 9001, 4)] # replace 4 by the address desired

    main(olt, onu)
